if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Personal_NumbersInfo_Get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Personal_NumbersInfo_Get]
GO

Create  Procedure [dbo].[A_Personal_NumbersInfo_Get]
As
Begin

declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), reactid uniqueidentifier )
declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), oldrid uniqueidentifier, newrid uniqueidentifier )

Insert Into @t
	Select np.Id, np.Prefix, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id


declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) )
Insert into @groups
	Select Id, Name 
	From A_Groups
Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', ' ' )


declare @cnt int
set @cnt = 0


while ( @@rowcount > 0 ) and ( @cnt < 10 )
begin
	Set @cnt = @cnt + 1
	
	--    @cnt - 
	Insert Into @temp
		Select t.nid, t.prefix, t.reactid, t1.reactid
		From @t t
			Inner join @t t1 on t.Reactid = t1.nId
		Where t.ReactId != t.Nid
	
	--    
	Delete From @t
		From @temp
	Where nid = id and reactid = oldrid

	-- 
	Insert Into @t ( nid, prefix, reactid )
		Select id, prefix, newrid From @temp

	-- 
	Delete From @temp	
end

--Select @cnt

--    
Delete From @t
	From A_NumberPlan np
Where reactid = np.Id

--Select @@rowcount

declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ), groupid uniqueidentifier, groupname nvarchar ( 255 ), isline bit )
Insert Into @output
	Select nid, Prefix, GroupId, GroupName, min ( IsLine ) as IsLine FROM 
	(
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as IsLine
		From @t t
			Inner join A_Users u on t.ReactId = u.Id
			Inner join @groups g on u.ParentGroupId = g.GroupId
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
		From @t t
			Inner join A_ServerIntLines l on t.ReactId = l.Id
			Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
		From @t t
			Inner join A_ServerUsbLines l on t.ReactId = l.Id
			Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
	) a
	Group By Prefix, GroupId, nid, groupname


declare @og table ( id uniqueidentifier, cnt int )
Insert into @og
	Select * From
	(
		Select nid, count ( * ) as cnt
		From @output
		Group By nid
	)a

Update @output 
Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = ' '
From @output o, @og og
Where o.nid = og.id and og.cnt > 1

Select nid, prefix, groupid, groupname, isline
From @output
Group By nid, prefix, groupid, groupname, isline

End