ALTER    procedure [dbo].[A_Clients__GetJournal]
	@idclient	uniqueidentifier,
	@dstart		datetime,
	@dstop		datetime,
	@tstart		datetime,
	@tstop		datetime,
	@idoperator	uniqueidentifier,
	@iduser		uniqueidentifier
as
begin
	
	Declare @tstartfloat float
	Declare @tstopfloat float
	Set @tstartfloat =  Convert ( float, @tstart ) - FLOOR ( Convert ( float, @tstart ) )
	Set @tstopfloat =  Convert ( float, @tstop ) - FLOOR ( Convert ( float, @tstop ) )


	Declare @usersdenied table ( Id uniqueidentifier )
	Insert into @usersdenied
		Select Id 
		From A_Users
		Where 	Id != @iduser and 
			Id not in ( 	Select UserB 
					From A_UserControls 
					Where UserA = @iduser )


	Select * FROM 
	(
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length, 
			AStr as OperatorStr, 
			case when ( u.Id is null ) then sc.IsRecorded else 0 end as IsRecorded, 
			sc.ARecFile, 
			sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id		
			Left join @usersdenied u on sc.AUserId = u.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union All
	
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null ) then sc.IsRecorded else 0 end as IsRecorded, 
			sc.ARecFile, 
			sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id		
			Left join @usersdenied u on sc.BUserId = u.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )
	) a

	Order By TimeStart Desc

		
end
GO






ALTER       procedure [dbo].[D_Get_Task_Abonents_Stat]
@taskID uniqueidentifier
as 
begin


declare @listID uniqueidentifier
set @listID = (select listid from A_taskManager_Tasks where id=@taskID)

declare @tname nvarchar(50)

set @tname = (select 'T_LocalList' + cast(Number as nvarchar(10)) from dbo.T_LocalListDef where ListId = @listID)
if @tname is null return


declare @sql nvarchar(4000)
set @sql = N'

declare @temp2 table ( [Id] uniqueidentifier, lasttime DateTime, cnt int )
	Insert Into @temp2
	  	select st.IdInList, max(ste.EffortDateTime) as lasttime, count(ste.EffortResult) as cnt
		from A_TaskManager_SubTaskEfforts ste 
			inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id
		Where st.TaskId = @taskid_
		Group By st.IdInList

Select AbId, IsNull ( [], ' + Char(39) + Char(39) + ' ) as Name, [] as Phone, data1.lasttime as LastTime, data1.cnt as Attempts, IsNull ( ste.EffortInfo, ' + Char(39) + Char(39) + ' ) as Comment
From ' + @tname + ' list 
	left join @temp2 data1 on list.AbId = data1.[id]
	left join A_TaskManager_SubTasks st on list.AbId = st.IdInList and st.TaskId = @taskid_
	left join A_TaskManager_SubTaskEfforts ste on ste.EffortDateTime = data1.LastTime
Order by lasttime Desc'

	

exec sp_executesql @sql, N'@taskid_ uniqueidentifier', @taskid_ = @taskid

end
GO










ALTER    procedure [dbo].[C_CallCenter_GetTaskJournal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@showefforts	int


As
Begin
-------------------------------------------------------------------------------------------------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare	@taskid 	uniqueidentifier
declare	@number 	nvarchar ( 50 )
declare	@operatorid	uniqueidentifier
declare	@showefforts	int


set @dstart = '2006/05/01'
set @dstop = '2006/06/15'
set @tstart = '01:11:00'
set @tstop = '22:29:00'
select @taskid = id from A_TaskManager_Tasks where name like ''
set @number = ''
set @operatorid ='00000000-0000-0000-0000-000000000000'
set @showefforts = 1
*/




declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )



declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id
		Where TaskId = @taskid
			and EffortDateTime > @dstart 
			and EffortDateTime < @dstop
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
			and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
		Where TaskId = @taskid
			and CallTimeStart > @dstart 
			and CallTimeStart < @dstop
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
			and Number like '%' + @number + '%'


if ( @showefforts <= 0 )
	Delete 
	From @te 
	Where IdChain = '00000000-0000-0000-0000-000000000000'



declare @type int
Select @type = Type FROM A_TaskManager_Tasks Where Id = @taskid

if ( @type < 4 )
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile
	From
	(
		Select te.Number ,'IVR' as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeStart, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain
	)a
	Order By CallTime
else
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsRecorded, ARecFile, BRecFile
	From
	(
		Select te.Number ,u.Name as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeStart, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			inner join A_TaskManager_UserInTask ut on ut.EffortId = te.EffortId
			inner join A_Users u on ut.UserId = u.Id
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and ( AUserId = ut.UserId or BUserId = ut.UserId )
	)a
	Order By CallTime


end
GO