if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_UserOutcomingLines]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_UserOutcomingLines] (
	[IdUser] [uniqueidentifier] NULL ,
	[IdLine] [uniqueidentifier] NULL ,
	[LineIndex] [int] NULL 
) ON [PRIMARY]

GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_UserControlLines]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_UserControlLines] (
	[UserA] [uniqueidentifier] NULL ,
	[IdLine] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO





ALTER       procedure [dbo].[A_Clients__GetJournal]
	@idclient	uniqueidentifier,
	@dstart		datetime,
	@dstop		datetime,
	@tstart		datetime,
	@tstop		datetime,
	@idoperator	uniqueidentifier,
	@iduser		uniqueidentifier
as
begin
	
	Declare @tstartfloat float
	Declare @tstopfloat float
	Set @tstartfloat =  Convert ( float, @tstart ) - FLOOR ( Convert ( float, @tstart ) )
	Set @tstopfloat =  Convert ( float, @tstop ) - FLOOR ( Convert ( float, @tstop ) )

	--    

	Declare @userspermitted table ( Id uniqueidentifier )
	Insert into @userspermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @userspermitted ( Id ) Values ( @iduser )

/*
	Declare @usersdenied table ( Id uniqueidentifier )
	Insert into @usersdenied
		Select Id 
		From A_Users
		Where 	Id != @iduser and 
			Id not in ( 	Select UserB 
					From A_UserControls 
					Where UserA = @iduser )
*/

	Declare @linespermitted table ( Id uniqueidentifier )
	Insert into @linespermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @linespermitted
		Select Id 
		From A_ServerExtLines

	---  

	Select * FROM 
	(
/*
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length, 
			AStr as OperatorStr, 
			case when ( u.Id is null ) then sc.IsRecorded else 0 end as IsRecorded, 
			sc.ARecFile, 
			sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @usersdenied u on sc.AUserId = u.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null ) then sc.IsRecorded else 0 end as IsRecorded, 
			sc.ARecFile, 
			sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @usersdenied u on sc.BUserId = u.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )
*/

		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length, 
			AStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			sc.ARecFile, 
			sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @userspermitted u on sc.AUserId = u.Id
			Left join @linespermitted l on sc.ALineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			sc.ARecFile, 
			sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @userspermitted u on sc.BUserId = u.Id
			Left join @linespermitted l on sc.BLineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )		

			
	) a

	Order By TimeStart Desc

		
end


GO


ALTER               PROCEDURE [dbo].[A_DB_FREEALL] AS
begin
	Delete from dbo.A__Extra_OneLine_Settings
	Delete from dbo.A_ActualBase
	Delete from dbo.A_CallBackOrders
	Delete from dbo.A_CallBackRecievers
	Delete from dbo.A_CallCenter_Counters
	Delete from dbo.A_ClientContacts
	Delete from dbo.A_ClientContactTypes
	Delete from dbo.A_ClientGroups
	Delete from dbo.A_ClientHistory
	Delete from dbo.A_Clients
	Delete from dbo.A_Clients_Groups
	Delete from dbo.A_ExtNumbers
	Delete from dbo.A_Groups
	Delete from dbo.A_LineCodes
	Delete from dbo.A_LinesReactors
	Delete from dbo.A_MobileControlMaskDenied
	Delete from dbo.A_MobileControlMaskFree
	Delete from dbo.A_Monopoly
	Delete from dbo.A_NumberPlan
	Delete from dbo.A_NumberPlanAction
	Delete from dbo.A_Personal_ListInfo
	Delete from dbo.A_Rules
	Delete from dbo.A_RuleRecords
	Delete from dbo.A_ServerExtLines
	Delete from dbo.A_ServerGSMLines
	Delete from dbo.A_ServerIntLines
	Delete from dbo.A_ServerNumbers
	Delete from dbo.A_ServerUSBLines
	Delete from dbo.A_Settings
	Delete from dbo.A_Streams
	Delete from dbo.A_User_NotifyLog
	Delete from dbo.A_UserControlLines
	Delete from dbo.A_UserControls
	Delete from dbo.A_UserOutcomingLines
	Delete from dbo.A_UserPermissions
	Delete from dbo.A_UserPermissionsLines
	Delete from dbo.A_UserRights
	Delete from dbo.A_Users
	Delete from dbo.A_UserStateHistory
	Delete from dbo.A_VoiceMail
	Delete from dbo.A_WorkPlace_Address
	Delete from dbo.A_WorkPlaces

	Delete from dbo.A_TaskManager_Tasks
	Delete from dbo.A_TaskManager_Operators
	Delete from dbo.A_TaskManager_RunPeriods
	Delete from dbo.A_TaskManager_SubTaskEfforts
	Delete from dbo.A_TaskManager_SubTasks
	Delete from dbo.A_TaskManager_TaskExtLines
	Delete from dbo.A_TaskManager_Task_IncomingCalls
	Delete from dbo.A_TaskManager_UserInTask

	Delete from dbo.A_Stat_Connections_1x1
	Delete from dbo.A_Stat_Talk_Algorythms
	Delete from dbo.A_Stat_Talk_Card_Check
	Delete from dbo.A_Stat_Talk_Card_Radio
	Delete from dbo.A_Stat_Talk_Card_Text
	Delete from dbo.A_Stat_Talk_StopInfo
	
	Delete from dbo.C_GroupOperators
	Delete from dbo.C_Groups
	Delete from dbo.C_MonopolyForTaskChanging
	Delete from dbo.C_OperatorControlEvents
	Delete from dbo.C_OperatorTimeTable
	Delete from dbo.C_TaskControlEvents
	Delete from dbo.C_UserParams
	
	Delete from dbo.P_ListView
	Delete from dbo.T_LastCallPhoneNumber
	

	Delete from dbo.T_LocalListDef

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList1]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList1]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList2]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList2]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList3]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList3]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList4]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList4]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList5]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList5]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList6]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList6]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList7]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList7]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList8]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList8]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList9]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList9]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList10]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList10]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList11]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList11]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList12]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList12]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList13]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList13]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList14]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList14]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList15]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList15]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList16]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList16]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList17]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList17]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList18]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList18]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList19]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList19]

	if exists (select * from dbo.sysobjects 
	where id = object_id(N'[dbo].[T_LocalList20]') 
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [dbo].[T_LocalList20]



end


GO



ALTER    procedure [dbo].[A_Admin_UserGroup_User_Delete]
	@id		uniqueidentifier	
as
begin

	Delete 
	From A_UserControls
	Where UserA = @id or UserB = @id

	Delete 
	From A_UserControlLines
	Where UserA = @id

	Delete
	From A_UserOutcomingLines
	Where IdUser = @id
		
	Delete 
	From A_Users
	Where Id = @id	
	
	exec A_DB_RemoveTails
end




GO



ALTER                procedure [dbo].[D_Stat_Report_TimeScale2]
	@startdate 	DateTime, 
	@stopdate 	DateTime, 
	@starttime 	DateTime, 
	@stoptime 	DateTime,
	@length 	float 			= 0, 
	@conntype 	int 			= -1, 
	@task 		uniqueidentifier 	= null, 
	@operator 	uniqueidentifier 	= null,
	@inner 		nvarchar ( 20 )		='', 
	@outer 		nvarchar ( 20 )		='',
	@iduser		uniqueidentifier,
	@minvalue 	int 			output, 
	@maxvalue 	int 			output
as

	declare @tstartfloat float 
	declare @tstopfloat float
	
	set @tstartfloat = Convert ( float, @starttime )
	set @tstopfloat  = Convert ( float, @stoptime )
	set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
	set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )

	-- 

	Declare @ulpermitted table ( Id uniqueidentifier )
	Insert into @ulpermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @ulpermitted ( Id ) Values ( @iduser )

	Insert into @ulpermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @ulpermitted
		Select Id 
		From A_ServerExtLines

	--

	Declare @min_ int, @max_ int;
	Declare @emptyguid uniqueidentifier

	Set @emptyguid = '00000000-0000-0000-0000-0000000000000000'

	Select @minvalue = isnull ( min ( c ), 0 ), @maxvalue = isnull ( max ( c ), 0 ) from
	(
		Select count ( * ) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
		Where ( timestart >= @startdate and timestart < @stopdate + 1 )
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat
		  	--and (( convert ( varchar ( 8 ), timestart, 8 ) >= @starttime and convert ( varchar ( 8 ), timestart,8)<@stoptime))  
		 	and (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5) ) or (@conntype = 2 and connectiontype in (1,6,7)) 
 		 	or (@conntype = 3 and connectiontype in (2,3,8)))
		  	and (timestop - timestart) >= @length 
		  	and (@outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
		 	and (@operator in (@emptyguid,AUserID,BUserID))
	 	Group By convert ( varchar(10), timestart, 104 ), datepart ( hour, timestart )
	) a;

	Select @min_ = isnull ( min ( c ), 0 ), @max_ = isnull ( max ( c ), 0 ) from
	(
 		Select count ( * ) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
	 	Where ( timestart >= @startdate and timestart < @stopdate + 1 ) 
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat
			--and (( convert ( varchar ( 8 ), timestart, 8) < @starttime )) 
			and (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or (@conntype = 3 and connectiontype in (2,3,8))) 
			and ( timestop - timestart ) >= @length
  			and ( @outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
  			and ( @operator in ( @emptyguid, AUserID, BUserID))
  		Group By convert ( varchar ( 10 ), timestart, 104 )
	) a;

	if ( @min_ = 0 )
  		set @min_ = 1;
	if ( @min_ < @minvalue )
  		set @minvalue = @min_;
	if ( @max_ > @maxvalue )
  		set @maxvalue = @max_;

	Select @min_ = isnull ( min ( c ), 0 ), @max_ = isnull ( max ( c ), 0 ) From
	(
  		Select count(*) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
  		Where ( timestart >= @startdate and timestart < @stopdate + 1 ) 
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstopfloat
			--and ((convert(varchar(8),timestart,8)>=@stoptime))  
  			and ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8))) and
  			(timestop-timestart)>=@length
  			and ( @outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
  			and ( @operator in ( @emptyguid, AUserID, BUserID ))
  		Group By convert ( varchar ( 10 ), timestart, 104 )
	) a;

	if (@min_ = 0)
  		set @min_ = 1;
	if (@min_<@minvalue)
  		set @minvalue = @min_;
	if (@max_>@maxvalue)
  		set @maxvalue = @max_;


	Select 	cdate,
     		sum ( c0 ) as c0, 
    	 	sum ( c1 ) as c1,
     		sum ( c2 ) as c2,
	     	sum ( c3 ) as c3,
     		sum ( c4 ) as c4,
     		sum ( c5 ) as c5, 
     		sum ( c6 ) as c6,
     		sum ( c7 ) as c7,
     		sum ( c8 ) as c8,
     		sum ( c9 ) as c9,
     		sum ( c10 ) as c10, 
     		sum ( c11 ) as c11, 
     		sum ( c12 ) as c12,
     		sum ( c13 ) as c13,
     		sum ( c14 ) as c14,
     		sum ( c15 ) as c15,
     		sum ( c16 ) as c16,
     		sum ( c17 ) as c17,
     		sum ( c18 ) as c18,
	     	sum ( c19 ) as c19,
	     	sum ( c20 ) as c20,
	     	sum ( c21 ) as c21,
	     	sum ( c22 ) as c22,  
	     	sum ( c23 ) as c23,
	     	sum ( cbefore ) as cbottom,
	     	sum ( cafter ) as ctop  

	From 

	(
     		Select  
			convert ( varchar(10), timestart, 126 ) cdate,
			--timestart cdate,
			--cast ( convert ( varchar(10), timestart, 126 ) as DateTime ) cdate,
			--cast ( convert ( varchar(10), timestart, 104 ) as DateTime ) cdate,
          		case ( DatePart ( hour, timestart ) ) when 0 then 1 else 0 end as c0,
         		case ( DatePart ( hour, timestart ) ) when 1 then 1 else 0 end as c1,
          		case ( DatePart ( hour, timestart ) ) when 2 then 1 else 0 end as c2,
          		case ( DatePart ( hour, timestart ) ) when 3 then 1 else 0 end as c3,
          		case ( DatePart ( hour, timestart ) ) when 4 then 1 else 0 end as c4,
          		case ( DatePart ( hour, timestart ) ) when 5 then 1 else 0 end as c5,
          		case ( DatePart ( hour, timestart ) ) when 6 then 1 else 0 end as c6,
          		case ( DatePart ( hour, timestart ) ) when 7 then 1 else 0 end as c7,
          		case ( DatePart ( hour, timestart ) ) when 8 then 1 else 0 end as c8,
          		case ( DatePart ( hour, timestart ) ) when 9 then 1 else 0 end as c9,
          		case ( DatePart ( hour, timestart ) ) when 10 then 1 else 0 end as c10,
          		case ( DatePart ( hour, timestart ) ) when 11 then 1 else 0 end as c11,
          		case ( DatePart ( hour, timestart ) ) when 12 then 1 else 0 end as c12,
          		case ( DatePart ( hour, timestart ) ) when 13 then 1 else 0 end as c13,
	          	case ( DatePart ( hour, timestart ) ) when 14 then 1 else 0 end as c14,
	          	case ( DatePart ( hour, timestart ) ) when 15 then 1 else 0 end as c15,
	          	case ( DatePart ( hour, timestart ) ) when 16 then 1 else 0 end as c16,
	          	case ( DatePart ( hour, timestart ) ) when 17 then 1 else 0 end as c17,
	          	case ( DatePart ( hour, timestart ) ) when 18 then 1 else 0 end as c18,
	          	case ( DatePart ( hour, timestart ) ) when 19 then 1 else 0 end as c19,
	          	case ( DatePart ( hour, timestart ) ) when 20 then 1 else 0 end as c20,
	          	case ( DatePart ( hour, timestart ) ) when 21 then 1 else 0 end as c21,
	          	case ( DatePart ( hour, timestart ) ) when 22 then 1 else 0 end as c22,
	          	case ( DatePart ( hour, timestart ) ) when 23 then 1 else 0 end as c23,
			
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat then 1 else 0 end as cbefore,
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) > @tstopfloat then 1 else 0 end as cafter
		  	--case when cast(convert(varchar(8),timestart,8) as DateTime)<@starttime then 1 else 0 end as cbefore,
	 	  	--case when cast(convert(varchar(8),timestart,8) as DateTime)>@stoptime then 1 else 0 end as cafter


     		From A_Stat_Connections_1x1  sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
		Where ( TimeStart >= @startdate ) and ( TimeStop < @stopdate + 1 ) 
			and ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8)))
          		and ( timestop - timestart ) >= @length
          		and (@outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
          		and (@operator in (@emptyguid,AUserID,BUserID))
	)a

	Group by cdate
	Order by cdate

/*
Declare @d DateTime, @s nvarchar (50)
Set @d = GetDate ( )
Select @s = convert( varchar(10), @d, 104)
Select @s
Select cast( @s as DateTime )
*/
/*
Declare @d DateTime, @s nvarchar (50)
Set @d = GetDate ( )
Select @s = convert( varchar(10), @d, 126)
Select @s
Select cast( @s as DateTime )
*/




GO
