SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO







ALTER                 procedure [dbo].[D_Stat_Report_TimeScale2]
	@startdate 	DateTime, 
	@stopdate 	DateTime, 
	@starttime 	DateTime, 
	@stoptime 	DateTime,
	@length 	float 			= 0, 
	@conntype 	int 			= -1, 
	@task 		uniqueidentifier 	= null, 
	@operator 	uniqueidentifier 	= null,
	@inner 		nvarchar ( 20 )		='', 
	@outer 		nvarchar ( 20 )		='',
	@iduser		uniqueidentifier,
	@minvalue 	int 			output, 
	@maxvalue 	int 			output
as
/*
----------------------------------------------------------
------- debug --------------------------------------------
----------------------------------------------------------
	declare @startdate 	DateTime 
	declare @stopdate 	DateTime 
	declare @starttime 	DateTime 
	declare @stoptime 	DateTime
	declare @length 	float
	declare @conntype 	int 
	declare @task 		uniqueidentifier
	declare @operator 	uniqueidentifier
	declare @inner 		nvarchar ( 20 )
	declare @outer 		nvarchar ( 20 )
	declare @iduser		uniqueidentifier
	declare @minvalue 	int
	declare @maxvalue 	int
	
	set @startdate = ' 14 2006 12:00AM' 
	set @stopdate = ' 14 2006 12:00AM' 
	set @starttime = ' 14 2006  8:00AM'
	set @stoptime = ' 14 2006  6:00PM' 
	set @length = 1.157407407407407e-005 
	set @conntype = -1
	set @task = N'00000000-0000-0000-0000-000000000000'
	set @operator = N'00000000-0000-0000-0000-000000000000'
	set @inner = N'' 
	set @outer = N''
	set @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
----------------------------------------------------------
------- end debug ----------------------------------------
----------------------------------------------------------
*/
	declare @tstartfloat float 
	declare @tstopfloat float
	
	set @tstartfloat = Convert ( float, @starttime )
	set @tstopfloat  = Convert ( float, @stoptime )
	set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
	set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )

	-- 

	Declare @ulpermitted table ( Id uniqueidentifier )
	Insert into @ulpermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @ulpermitted ( Id ) Values ( @iduser )

	Insert into @ulpermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @ulpermitted
		Select Id 
		From A_ServerExtLines

	Declare @tasks table ( ConnectionChainId uniqueidentifier )
	declare @usetask bit
	set @usetask = 0
	if ( @task != '00000000-0000-0000-0000-000000000000' )
	  begin
		set @usetask = 1
		Insert into @tasks
			Select ConnectionChainId FROM A_TaskManager_Task_IncomingCalls
			Where TaskId = @task

		Insert into @tasks
			Select ConnectionId 
			from A_TaskManager_SubTasks st 
				inner join A_TaskManager_SubTaskEfforts ste on ste.SubTaskId = st.Id
			Where TaskId = @task
	  end

	--

	Declare @min_ int, @max_ int;
	Declare @emptyguid uniqueidentifier

	Set @emptyguid = '00000000-0000-0000-0000-0000000000000000'

	Select @minvalue = isnull ( min ( c ), 0 ), @maxvalue = isnull ( max ( c ), 0 ) from
	(
		Select count ( * ) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
		Where ( timestart >= @startdate and timestart < @stopdate + 1 )
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat
		 	and (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5) ) or (@conntype = 2 and connectiontype in (1,6,7)) or (@conntype = 3 and connectiontype in (2,3,8)))
		  	and (timestop - timestart) >= @length 
		  	and (@outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
		 	and (@operator in (@emptyguid,AUserID,BUserID))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))
	 	Group By convert ( varchar(10), timestart, 104 ), datepart ( hour, timestart )
	) a;

	Select @min_ = isnull ( min ( c ), 0 ), @max_ = isnull ( max ( c ), 0 ) from
	(
 		Select count ( * ) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
	 	Where ( timestart >= @startdate and timestart < @stopdate + 1 ) 
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat
			and (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or (@conntype = 3 and connectiontype in (2,3,8))) 
			and ( timestop - timestart ) >= @length
  			and ( @outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
  			and ( @operator in ( @emptyguid, AUserID, BUserID))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))
  		Group By convert ( varchar ( 10 ), timestart, 104 )
	) a;

	if ( @min_ = 0 )
  		set @min_ = 1;
	if ( @min_ < @minvalue )
  		set @minvalue = @min_;
	if ( @max_ > @maxvalue )
  		set @maxvalue = @max_;

	Select @min_ = isnull ( min ( c ), 0 ), @max_ = isnull ( max ( c ), 0 ) From
	(
  		Select count(*) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
  		Where ( timestart >= @startdate and timestart < @stopdate + 1 ) 
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstopfloat
  			and ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8))) and
  			(timestop-timestart)>=@length
  			and ( @outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
  			and ( @operator in ( @emptyguid, AUserID, BUserID ))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))
  		Group By convert ( varchar ( 10 ), timestart, 104 )
	) a;

	if (@min_ = 0)
  		set @min_ = 1;
	if (@min_<@minvalue)
  		set @minvalue = @min_;
	if (@max_>@maxvalue)
  		set @maxvalue = @max_;

	declare @empty table ( cdate varchar ( 10 ), c0 int, c1 int, c2 int, c3 int, c4 int, c5 int, c6 int, c7 int, c8 int, c9 int, c10 int, 
		c11 int, c12 int, c13 int, c14 int, c15 int, c16 int, c17 int, c18 int, c19 int, c20 int, c21 int, c22 int, c23 int, cbottom int, ctop int )
	declare @tempdate datetime 
	set @tempdate = @startdate
	while @tempdate <= @stopdate
	begin
		Insert into @empty ( cdate, c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20, c21, c22, c23, cbottom, ctop )
		Values ( convert ( varchar(10), @tempdate, 126 ), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 )		
			
		set @tempdate = DateAdd ( d, 1, @tempdate )
	end
	

	Select 	cdate,
     		sum ( c0 ) as c0, 
    	 	sum ( c1 ) as c1,
     		sum ( c2 ) as c2,
	     	sum ( c3 ) as c3,
     		sum ( c4 ) as c4,
     		sum ( c5 ) as c5, 
     		sum ( c6 ) as c6,
     		sum ( c7 ) as c7,
     		sum ( c8 ) as c8,
     		sum ( c9 ) as c9,
     		sum ( c10 ) as c10, 
     		sum ( c11 ) as c11, 
     		sum ( c12 ) as c12,
     		sum ( c13 ) as c13,
     		sum ( c14 ) as c14,
     		sum ( c15 ) as c15,
     		sum ( c16 ) as c16,
     		sum ( c17 ) as c17,
     		sum ( c18 ) as c18,
	     	sum ( c19 ) as c19,
	     	sum ( c20 ) as c20,
	     	sum ( c21 ) as c21,
	     	sum ( c22 ) as c22,  
	     	sum ( c23 ) as c23,
	     	sum ( cbefore ) as cbottom,
	     	sum ( cafter ) as ctop  

	From 

	(
     		Select  
			convert ( varchar(10), timestart, 126 ) cdate,
          		case ( DatePart ( hour, timestart ) ) when 0 then 1 else 0 end as c0,
         		case ( DatePart ( hour, timestart ) ) when 1 then 1 else 0 end as c1,
          		case ( DatePart ( hour, timestart ) ) when 2 then 1 else 0 end as c2,
          		case ( DatePart ( hour, timestart ) ) when 3 then 1 else 0 end as c3,
          		case ( DatePart ( hour, timestart ) ) when 4 then 1 else 0 end as c4,
          		case ( DatePart ( hour, timestart ) ) when 5 then 1 else 0 end as c5,
          		case ( DatePart ( hour, timestart ) ) when 6 then 1 else 0 end as c6,
          		case ( DatePart ( hour, timestart ) ) when 7 then 1 else 0 end as c7,
          		case ( DatePart ( hour, timestart ) ) when 8 then 1 else 0 end as c8,
          		case ( DatePart ( hour, timestart ) ) when 9 then 1 else 0 end as c9,
          		case ( DatePart ( hour, timestart ) ) when 10 then 1 else 0 end as c10,
          		case ( DatePart ( hour, timestart ) ) when 11 then 1 else 0 end as c11,
          		case ( DatePart ( hour, timestart ) ) when 12 then 1 else 0 end as c12,
          		case ( DatePart ( hour, timestart ) ) when 13 then 1 else 0 end as c13,
	          	case ( DatePart ( hour, timestart ) ) when 14 then 1 else 0 end as c14,
	          	case ( DatePart ( hour, timestart ) ) when 15 then 1 else 0 end as c15,
	          	case ( DatePart ( hour, timestart ) ) when 16 then 1 else 0 end as c16,
	          	case ( DatePart ( hour, timestart ) ) when 17 then 1 else 0 end as c17,
	          	case ( DatePart ( hour, timestart ) ) when 18 then 1 else 0 end as c18,
	          	case ( DatePart ( hour, timestart ) ) when 19 then 1 else 0 end as c19,
	          	case ( DatePart ( hour, timestart ) ) when 20 then 1 else 0 end as c20,
	          	case ( DatePart ( hour, timestart ) ) when 21 then 1 else 0 end as c21,
	          	case ( DatePart ( hour, timestart ) ) when 22 then 1 else 0 end as c22,
	          	case ( DatePart ( hour, timestart ) ) when 23 then 1 else 0 end as c23,			
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat then 1 else 0 end as cbefore,
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) > @tstopfloat then 1 else 0 end as cafter


     		From A_Stat_Connections_1x1  sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
		Where ( TimeStart >= @startdate ) and ( TimeStop < @stopdate + 1 ) 
			and ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8)))
          		and ( timestop - timestart ) >= @length
          		and (@outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
          		and (@operator in (@emptyguid,AUserID,BUserID))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))

		Union all

		Select *
		FROM @empty
	)a

	Group by cdate
	Order by cdate

/*
Declare @d DateTime, @s nvarchar (50)
Set @d = GetDate ( )
Select @s = convert( varchar(10), @d, 104)
Select @s
Select cast( @s as DateTime )
*/
/*
Declare @d DateTime, @s nvarchar (50)
Set @d = GetDate ( )
Select @s = convert( varchar(10), @d, 126)
Select @s
Select cast( @s as DateTime )
*/








GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

