SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



ALTER   procedure [dbo].[A_TalkResults_Text_Simple]
	@taskid uniqueidentifier,
	@cardid uniqueidentifier,@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@number 	nvarchar ( 50 ),
	@userid		uniqueidentifier
as

begin

declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
	Where st.TaskId = @taskid
		and EffortDateTime > @dstart 
		and EffortDateTime < @dstop
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
		and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
	Where tic.TaskId = @taskid
		and CallTimeStart > @dstart 
		and CallTimeStart < @dstop
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
		and Number like '%' + @number + '%'


	Select ChosenResult
	From
	(
		Select ChosenResult
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Text tct on tct.IdAlgVisit = sta.IdAlgVisit
			inner join @te te on sta.IdConnection = te.IdChain
		Where sta.IdTask = @taskid
			and tct.IdCard = @cardid
			and not ltrim ( ChosenResult ) like ''
		Group By ChosenResult, tct.IdCard
	)a
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO







SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


ALTER  procedure [dbo].[A_TalkResults_Radio_Simple]
	@taskid uniqueidentifier,
	@cardid uniqueidentifier,

	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@number 	nvarchar ( 50 ),
	@userid	uniqueidentifier
as

begin


declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
	Where st.TaskId = @taskid
		and EffortDateTime > @dstart 
		and EffortDateTime < @dstop
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
		and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
	Where tic.TaskId = @taskid
		and CallTimeStart > @dstart 
		and CallTimeStart < @dstop
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
		and Number like '%' + @number + '%'




	Select ChosenResult, Count ( * ) as cnt 
	From
	(
		Select ChosenResult, tcr.IdCard
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Radio tcr on tcr.IdAlgVisit = sta.IdAlgVisit
			inner join @te te on sta.IdConnection = te.IdChain
		Where sta.IdTask = @taskid
			and tcr.IdCard = @cardid
		Group By ChosenResult, tcr.IdCard
	)a
	Group By ChosenResult

end


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO





SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


ALTER  procedure [dbo].[A_TalkResults_Check_Simple]
	@taskid uniqueidentifier,
	@cardid uniqueidentifier,

	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@number 	nvarchar ( 50 ),
	@userid		uniqueidentifier
as

begin

declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
	Where st.TaskId = @taskid
		and EffortDateTime > @dstart 
		and EffortDateTime < @dstop
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
		and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
	Where tic.TaskId = @taskid
		and CallTimeStart > @dstart 
		and CallTimeStart < @dstop
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
		and Number like '%' + @number + '%'



	Select I, Count ( * ) as cnt 
	From
	(
		Select big.I, tcc.IdCard
		From A_Stat_Talk_Algorythms sta 
			inner join A_Stat_Talk_Card_Check tcc on tcc.IdAlgVisit = sta.IdAlgVisit
			inner join A_BigInt big on big.K & ChosenResult = big.K
			inner join @te te on sta.IdConnection = te.IdChain
		Where sta.IdTask = @taskid
			and tcc.IdCard = @cardid	
		Group By big.I, tcc.IdCard
	)a
	Group By I
end

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

