ALTER  Procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
     @id      uniqueidentifier
as
begin
     Select Top 15 * 
     FROM A_User_NotifyLog 
     where IDuser = @id and WasShown = 0
     Order by NotifyDateTime Desc

     Update A_User_NotifyLog 
          Set WasShown = 1 
          Where IdUser = @id
end

GO




ALTER       procedure [dbo].[C_CallCenter_GetTaskJournal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@showefforts	int


As
Begin
-------------------------------------------------------------------------------------------------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare	@taskid 	uniqueidentifier
declare	@number 	nvarchar ( 50 )
declare	@operatorid	uniqueidentifier
declare	@showefforts	int


set dateformat dmy
set @dstart = '2006/05/01'
set @dstop = '2006/06/15'
set @tstart = '01:11:00'
set @tstop = '22:29:00'
select @taskid = id from A_TaskManager_Tasks where name like ''
set @number = ''
set @operatorid ='00000000-0000-0000-0000-000000000000'
set @showefforts = 1

*/



declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )



declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id
		Where TaskId = @taskid
			and EffortDateTime > @dstart 
			and EffortDateTime < @dstop
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
			and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
		Where TaskId = @taskid
			and CallTimeStart > @dstart 
			and CallTimeStart < @dstop
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
			and Number like '%' + @number + '%'


if ( @showefforts <= 0 )
	Delete 
	From @te 
	Where IdChain = '00000000-0000-0000-0000-000000000000'


declare @type int
Select @type = Type FROM A_TaskManager_Tasks Where Id = @taskid

if ( @type < 4 )
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile
	From
	(
		Select te.Number ,'IVR' as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain
	)a
	Order By CallTime
else
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsRecorded, ARecFile, BRecFile
	From
	(
		Select te.Number ,u.Name as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			inner join A_TaskManager_UserInTask ut on ut.EffortId = te.EffortId
			inner join A_Users u on ut.UserId = u.Id
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and ( AUserId = ut.UserId or BUserId = ut.UserId )
		Where sc.AUserId = @operatorid
			or sc.BUserId = @operatorid 
			or @operatorid = '00000000-0000-0000-0000-000000000000'
	)a
	Order By CallTime


end


GO






ALTER   procedure [dbo].[A_TalkResults_Filter_Journal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@ResultValue int = NULL,
	@ResultMask int = NULL,
	@ResultText nvarchar(500) = NULL,
	@CardId uniqueidentifier,
	@showefforts	int
as


declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )



declare @tmp_card_result table(TaskId  uniqueidentifier, IdChain uniqueidentifier)

if @ResultValue is not null
	Insert into @tmp_card_result(TaskId,IdChain)	
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Radio stcr on sta.IdAlgVisit=stcr.IdAlgVisit
		Where IdCard=@CardId and ChosenResult=@ResultValue


if @ResultMask is not null 
	delete 	@tmp_card_result
	Insert into @tmp_card_result(TaskId,IdChain)		
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Check stcc on sta.IdAlgVisit=stcc.IdAlgVisit
		Where IdCard=@CardId and ChosenResult=@ResultValue

if @ResultText is not null 
	delete 	@tmp_card_result
	Insert into @tmp_card_result(TaskId,IdChain)		
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Text stct on sta.IdAlgVisit=stct.IdAlgVisit
		Where IdCard=@CardId and ChosenResult=@ResultValue

--select * from @tmp_card_result

declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
		inner join @tmp_card_result tcr on tcr.IdChain=ste.ConnectionId and tcr.TaskId=st.TaskId
		Where st.TaskId = @taskid
			and EffortDateTime > @dstart 
			and EffortDateTime < @dstop
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
			and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
		inner join @tmp_card_result tcr on tcr.IdChain=tic.ConnectionChainId and tcr.TaskId=tic.TaskId
		Where tic.TaskId = @taskid
			and CallTimeStart > @dstart 
			and CallTimeStart < @dstop
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
			and Number like '%' + @number + '%'


if ( @showefforts <= 0 )
	Delete 
	From @te 
	Where IdChain = '00000000-0000-0000-0000-000000000000'


declare @type int
Select @type = Type FROM A_TaskManager_Tasks Where Id = @taskid

if ( @type < 4 ) -- 1,2,3 - IVR 
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile
	From
	(
		Select te.Number ,'IVR' as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain
	)a
	Order By CallTime
else 		-- 4,5 - Operator
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsRecorded, ARecFile, BRecFile
	From
	(
		Select te.Number ,u.Name as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			inner join A_TaskManager_UserInTask ut on ut.EffortId = te.EffortId
			inner join A_Users u on ut.UserId = u.Id
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and ( AUserId = ut.UserId or BUserId = ut.UserId )
	        Where sc.AUserId = @operatorid
	               or sc.BUserId = @operatorid 
	               or @operatorid = '00000000-0000-0000-0000-000000000000'
	)a
	Order By CallTime


GO