ALTER   procedure [dbo].[A_TalkResults_Radio_Simple]
	@taskid uniqueidentifier,
	@cardid uniqueidentifier,

	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@number 	nvarchar ( 50 ),
	@userid	uniqueidentifier
as

begin


declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
	Where st.TaskId = @taskid
		and EffortDateTime > @dstart 
		and EffortDateTime < @dstop
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
		and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
	Where tic.TaskId = @taskid
		and CallTimeStart > @dstart 
		and CallTimeStart < @dstop
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
		and Number like '%' + @number + '%'





	Select ChosenResult, Count ( * ) as cnt 
	From A_Stat_Talk_Algorythms sta
		inner join A_Stat_Talk_Card_Radio tcr on tcr.IdAlgVisit = sta.IdAlgVisit
		inner join @te te on sta.IdConnection = te.IdChain
	Where sta.IdTask = @taskid
		and tcr.IdCard = @cardid
	Group By ChosenResult

/*
	Select ChosenResult, Count ( * ) as cnt 
	From
	(
		Select ChosenResult, tcr.IdCard
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Radio tcr on tcr.IdAlgVisit = sta.IdAlgVisit
			inner join @te te on sta.IdConnection = te.IdChain
		Where sta.IdTask = @taskid
			and tcr.IdCard = @cardid
		Group By ChosenResult, tcr.IdCard
	)a
	Group By ChosenResult
*/

end



GO






ALTER   procedure [dbo].[A_TalkResults_Check_Simple]
	@taskid uniqueidentifier,
	@cardid uniqueidentifier,

	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@number 	nvarchar ( 50 ),
	@userid		uniqueidentifier
as

begin

declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
	Where st.TaskId = @taskid
		and EffortDateTime > @dstart 
		and EffortDateTime < @dstop
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
		and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
	Where tic.TaskId = @taskid
		and CallTimeStart > @dstart 
		and CallTimeStart < @dstop
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
		and Number like '%' + @number + '%'

	Select I, Count ( * ) as cnt 	
	From A_Stat_Talk_Algorythms sta 
		inner join A_Stat_Talk_Card_Check tcc on tcc.IdAlgVisit = sta.IdAlgVisit
		inner join A_BigInt big on big.K & ChosenResult = big.K
		inner join @te te on sta.IdConnection = te.IdChain
	Where sta.IdTask = @taskid
		and tcc.IdCard = @cardid	
	Group By I

/*
	Select I, Count ( * ) as cnt 
	From
	(
		Select big.I, tcc.IdCard
		From A_Stat_Talk_Algorythms sta 
			inner join A_Stat_Talk_Card_Check tcc on tcc.IdAlgVisit = sta.IdAlgVisit
			inner join A_BigInt big on big.K & ChosenResult = big.K
			inner join @te te on sta.IdConnection = te.IdChain
		Where sta.IdTask = @taskid
			and tcc.IdCard = @cardid	
		Group By big.I, tcc.IdCard
	)a
	Group By I
*/
end


GO







ALTER    procedure [dbo].[A_TalkResults_Text_Simple]
	@taskid uniqueidentifier,
	@cardid uniqueidentifier,@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@number 	nvarchar ( 50 ),
	@userid		uniqueidentifier
as

begin

declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, st.TaskId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id	
	Where st.TaskId = @taskid
		and EffortDateTime > @dstart 
		and EffortDateTime < @dstop
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
		and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
		and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, tic.TaskId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
	Where tic.TaskId = @taskid
		and CallTimeStart > @dstart 
		and CallTimeStart < @dstop
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
		and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
		and Number like '%' + @number + '%'


	Select ChosenResult
	From A_Stat_Talk_Algorythms sta
		inner join A_Stat_Talk_Card_Text tct on tct.IdAlgVisit = sta.IdAlgVisit
		inner join @te te on sta.IdConnection = te.IdChain
	Where sta.IdTask = @taskid
		and tct.IdCard = @cardid
		and not ltrim ( ChosenResult ) like ''

/*
	Select ChosenResult
	From
	(
		Select ChosenResult
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Text tct on tct.IdAlgVisit = sta.IdAlgVisit
			inner join @te te on sta.IdConnection = te.IdChain
		Where sta.IdTask = @taskid
			and tct.IdCard = @cardid
			and not ltrim ( ChosenResult ) like ''
		Group By ChosenResult, tct.IdCard
	)a
*/
end




GO





Delete 
From A_TaskManager_Task_IncomingCalls
Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

GO



Create Table [dbo].[A_Redirect] ( 
	Id uniqueidentifier NOT NULL,
	IdUser uniqueidentifier,
	PriorityIndex int,
	CreationDate datetime,
	Caption nvarchar ( 100 ),
	Description nvarchar ( 255 ),
	RedirectStateOnly bit,
	CascadeRedirect bit,
	Enabled bit,
	DestinationNumber nvarchar ( 50 )
)

GO


Create Table [dbo].[A_Redirect_TimeTable] (
	IdRedir uniqueidentifier,
	DayOfWeek int,
	StartTime datetime,
	StopTime datetime
)

GO



Create Table [dbo].[A_Redirect_Abonents] (
	IdRedir uniqueidentifier,
	IdAbonent uniqueidentifier,
	Number nvarchar ( 50 )
)

GO


ALTER TABLE [dbo].[A_Redirect] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Redirect_TimeTable] ADD 
	CONSTRAINT [FK_A_Redirect_TimeTable_A_Redirect] FOREIGN KEY 
	(
		[IdRedir]
	) REFERENCES [dbo].[A_Redirect] (
		[Id]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[A_Redirect_Abonents] ADD 
	CONSTRAINT [FK_A_Redirect_Abonents_A_Redirect] FOREIGN KEY 
	(
		[IdRedir]
	) REFERENCES [dbo].[A_Redirect] (
		[Id]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO
	


Create procedure [dbo].[A_Redirect_Save]
	@id uniqueidentifier,
	@iduser uniqueidentifier,
	@priorityindex int,
	@creationdate datetime,
	@caption nvarchar ( 100 ),
	@redirectstateonly bit,
	@cascaderedirect bit,
	@destinationnumber nvarchar ( 50 )	
as
begin
	Declare @cnt int
	
	Select @cnt = Count ( * ) 
	From A_Redirect 
	Where Id = @id


	if ( @cnt > 0 )
		Update A_Redirect			
		Set 	IdUser = @iduser,
			PriorityIndex = @priorityindex,
			CreationDate = @creationdate,
			Caption = @caption,
			RedirectStateOnly = @redirectstateonly,
			CascadeRedirect = @cascaderedirect,
			DestinationNumber = @destinationnumber
		Where
			Id = @id
	else
	begin
		Update A_Redirect 
		Set PriorityIndex = PriorityIndex + 1
		Where PriorityIndex >= @priorityindex


		Insert Into A_Redirect 
			( Id, IdUser, PriorityIndex, CreationDate, Caption, RedirectStateOnly, CascadeRedirect, Enabled, DestinationNumber )
		Values
			( @id, @iduser, @priorityindex, @creationdate, @caption, @redirectstateOnly, @cascaderedirect, 0, @destinationnumber )
	end
	
end

GO



Create procedure [dbo].[A_Redirect_Delete]
	@id uniqueidentifier
as
begin
	declare @pr int
	set @pr = -1

	Select @pr = PriorityIndex
	From A_Redirect
	Where Id = @id

	if ( @pr >= 0 )
	begin
		Delete 
		From A_Redirect
		Where Id = @id
		
		Update A_Redirect
		Set PriorityIndex = PriorityIndex - 1
		Where PriorityIndex >= @pr
	end
end

GO



Create procedure [dbo].[A_Redirect_TimeTable_DeleteById]
	@id uniqueidentifier
as
begin
	Delete 
	From A_Redirect_TimeTable
	Where IdRedir = @id
end

GO


Create procedure [dbo].[A_Redirect_Abonents_DeleteById]
	@id uniqueidentifier
as
begin
	Delete 
	From A_Redirect_Abonents	
	Where IdRedir = @id
end

GO

Create procedure [dbo].[A_Redirect_SetEnable]
	@id uniqueidentifier,
	@enabled bit
as
begin
	Update A_Redirect
	Set Enabled = @enabled
	Where Id = @id
end

GO

		



ALTER                    PROCEDURE [dbo].[A_DB_RemoveTails] AS
begin

		
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (LineId in (Select [ID] From A_ServerIntLines union all Select ID From A_ServerUSBLines))
		Delete FROM A_ServerExtLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerIntLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerGSMLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerUSBLines where not [ServerID] in (Select [id] from A_WORKPLACES)
	
		Delete FROM A_ServerUSBLines where not [id] in (Select LineID from A_WORKPLACES)
		Delete FROM A_LinesReactors where not [WPID] in (Select [id] from A_WORKPLACES)
		Delete From A_LinesReactors where not LineID in (Select [ID] from A_ServerExtLines 
								union Select [ID] from A_ServerIntLines
								union Select [ID] from A_ServerGSMLines
								union Select [ID] from A_ServerUSBLines)
		delete from A_ServerNumbers where not [id] in (Select [ID] FROM A_WorkPlaces Where type=5)
		delete from A_ServerNumbers where [id] in (Select [ID] from A_WorkPlaces where hasdatabase>0)



		declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] from A_WORKPLACES union 
			Select [id] from A_Users union
			Select [id] from A_ServerExtLines union
			Select [id] from A_ExtNumbers union
			Select [id] from A_ServerIntLines union
			Select [id] from A_ServerUSBLines 

			Delete FROM A_USERPERMISSIONSLINES where not [IDofRec] in (Select id_ from @t)
		
		Delete From A_RuleRecords where not RuleID in (Select ID from A_Rules)

		Delete from A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ from @t ))

		Delete from A_NumberPlanAction where numtype=0 and extraid not in (Select ID from A_Rules)
		delete from A_NumberPlan where id not in (Select numid from A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID from A_NumberPlan)
		Delete From A_Rules	Where not id in ( select ruleid from A_RuleRecords )		

		delete from A_TaskManager_TaskExtLines where not ExtLineId in ( Select id from A_ServerExtLines )
		delete from A_TaskManager_Operators where not OperatorId in ( Select id from A_Users union Select Id from C_Groups )


		-----------------------------------------------------
		--   -----------
		-----------------------------------------------------
		declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory

		Select 	newid(), ush.UserId, 0, @lastpingtime, ' ', 0
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		Update A_TaskManager_UserInTask
		Set TimeStop = @lastpingtime 
		Where TimeStop is null

		Update A_TaskManager_UserInTask
		Set TimeStopPriorHandling = TimeStop
		Where TimeStopPriorHandling is null


		Delete From A_Monopoly
		Delete From C_MonopolyForTaskChanging

		declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id from @uidt)
			or not UserB in (Select id from @uidt)
		-----------------------------------------------------
		-----------------------------------------------------

		/*    =   -  */
		declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		/*Null  0  ID   */
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		/* 0    */
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id from A_Users)

		/*       */
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit
		Declare defusercur Cursor For
			Select Id, DefaultUserId
			From A_ServerIntLines
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'
		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 from @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id


		
		--  ,   -    
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'


		--   
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )


		-- 
		exec A_Admin_UserGroup_Group_SiftEmpty



end



GO



Alter table C_UserParams Add IsRedirect bit

GO




Update C_UserParams Set IsRedirect = 0

GO