if Exists (Select * From sysobjects where id = object_id ( 'PK_A_TaskManager_Task_IncomingCalls' ))
ALTER TABLE dbo.A_TaskManager_Task_IncomingCalls
	DROP CONSTRAINT PK_A_TaskManager_Task_IncomingCalls
GO

if Exists ( Select * From sysobjects where name like 'idx_A_TaskManager_Task_IncomingCalls' and id = object_id ( 'idx_A_TaskManager_Task_IncomingCalls' ) )
ALTER TABLE dbo.A_TaskManager_Task_IncomingCalls
	DROP CONSTRAINT idx_A_TaskManager_Task_IncomingCalls
GO

declare @tablename varchar(500)
declare @sql nvarchar(1000)
set @tablename='dbo.A_TaskManager_Task_IncomingCalls'

DECLARE tcursor CURSOR FOR 
select name from sysindexes where id=object_id(@tablename) and status!=0 and name not like '_WA%'

declare @ind_name varchar(500)

OPEN tcursor
FETCH NEXT FROM tcursor INTO @ind_name

WHILE @@FETCH_STATUS = 0
BEGIN

set @sql='drop index '+@tablename+'.'+@ind_name
exec sp_executesql @stmt =@sql

FETCH NEXT FROM tcursor INTO @ind_name
END

CLOSE tcursor
DEALLOCATE tcursor

GO


CREATE TABLE [dbo].[Tmp_A_TaskManager_Task_IncomingCalls] (
	[Id] [uniqueidentifier] NOT NULL ,
	[TaskId] [uniqueidentifier] NOT NULL ,
	[Number] [nvarchar] (50) COLLATE database_default NULL ,
	[CallTimeStart] [datetime] NULL ,
	[CallTimeStop] [datetime] NULL ,
	[CallResult] [int] NULL ,
	[CallInfo] [nvarchar] (500) COLLATE database_default NULL ,
	[ConnectionChainId] [uniqueidentifier] NULL 
) 
GO
Select * FROM A_TaskManager_Task_IncomingCalls


IF EXISTS(SELECT * FROM dbo.A_TaskManager_Task_IncomingCalls)
	 EXEC('INSERT INTO dbo.Tmp_A_TaskManager_Task_IncomingCalls
		SELECT * FROM dbo.A_TaskManager_Task_IncomingCalls TABLOCKX')
GO

DROP TABLE dbo.A_TaskManager_Task_IncomingCalls
GO

EXECUTE sp_rename N'dbo.Tmp_A_TaskManager_Task_IncomingCalls', N'A_TaskManager_Task_IncomingCalls', 'OBJECT'
GO

Delete From A_TaskManager_Task_IncomingCalls
Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'
GO

Create Clustered Index [idxTaskIdChainId] on dbo.A_TaskManager_Task_IncomingCalls ( TaskId, ConnectionChainId )

ALTER TABLE dbo.A_TaskManager_Task_IncomingCalls ADD CONSTRAINT
	PK_A_TaskManager_Task_IncomingCalls PRIMARY KEY NONCLUSTERED 
	(
	Id
	)

GO

if not exists ( select * from dbo.sysindexes where name like 'idxConnectionChainId' and id = object_id ( N'[dbo].[A_TaskManager_Task_IncomingCalls]' ) )
CREATE INDEX [idxConnectionChainId] ON [dbo].[A_TaskManager_Task_IncomingCalls]([ConnectionChainId]) WITH FILLFACTOR = 60
GO





if Exists ( Select * From sysobjects where name like 'cidxLine' and id = object_id ( 'cidxLine' ) )
ALTER TABLE dbo.A_UserControlLines
	DROP CONSTRAINT cidxLine
GO

if not exists ( select * from dbo.sysindexes where name like 'idxTimeStartTimeStop' and id = object_id ( N'[dbo].[A_Stat_Connections_1x1]' ) )
CREATE  INDEX [idxTimeStartTimeStop] ON [dbo].[A_Stat_Connections_1x1]([TimeStart] DESC ) WITH  FILLFACTOR = 80
GO

if not exists ( select * from dbo.sysindexes where name like 'idxSubTaskId' and id = object_id ( N'[dbo].[A_TaskManager_SubTaskEfforts]' ) )
CREATE  INDEX [idxSubTaskId] ON [dbo].[A_TaskManager_SubTaskEfforts]([SubTaskId]) WITH  FILLFACTOR = 80
GO

if not exists ( select * from dbo.sysindexes where name like 'idxLineUserA' and id = object_id ( N'[dbo].[A_UserControlLines]' ) )
CREATE  INDEX [idxLineUserA] ON [dbo].[A_UserControlLines]([IdLine], [UserA]) WITH  FILLFACTOR = 80
GO





CREATE PROCEDURE [dbo].[A_Stat_Service_FillTempByFilter]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL  --Out Number defined
AS
--Prepare @A_Stat_Connections_1x1_tmp
Declare @A_Stat_Connections_1x1_tmp1 table( Id uniqueidentifier PRIMARY KEY) 
Declare @A_Stat_Connections_1x1_tmp table( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, BUSerId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier) 
declare @tstartfloat float  declare @tstopfloat float 
set @tstartfloat = Convert ( float, @tstart )  
set @tstopfloat  = Convert ( float, @tstop )  
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  


--Date & Time Intervals-------------------------------------------------------------------------------
Insert into @A_Stat_Connections_1x1_tmp 
select Id, AUSerId , BUSerId , ALineId , BLineId 
from A_Stat_Connections_1x1 sc
where 
	 ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
	and ( CONVERT ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 
		Convert ( float, @lentime ) - Floor ( Convert ( float, @lentime ) ) ) 
-------------------------------------------------------------------------------


--Permissions-------------------------------------------------------------------------------
--Users-------------------------------------------------------------------------------
declare @upermitted table ( Id uniqueidentifier Primary Key )
Insert into @upermitted
	Select UserB
	From A_UserControls auc
	Where UserA = @iduser

if not exists (select UserB from  A_UserControls where UserA = @iduser and UserB = @iduser)
	Insert into @upermitted (Id) Values (@iduser)

Declare @commpermitted table ( Id uniqueidentifier PRIMARY KEY)  	 -- Id Connection
Insert into @commpermitted
	Select  sc.ID --auc.UserB   	
	From @upermitted up
		inner join @A_Stat_Connections_1x1_tmp sc on up.Id = sc.AUserId

Insert into @commpermitted
	Select  sc.ID --auc.UserB   	
	From @upermitted up
		inner join @A_Stat_Connections_1x1_tmp sc on up.Id=sc.BUserId
	Where not exists(select id from @commpermitted where Id=sc.ID)


--Lines-------------------------------------------------------------------------------
declare @lpermitted table ( Id uniqueidentifier Primary Key )
Insert into @lpermitted
     Select IdLine
     From A_UserControlLines
     Where UserA = @iduser
          and IdLine != '11111111-1111-1111-1111-111111111111'       

declare @canlistenext int       
Select @canlistenext = Count ( * ) 
From A_UserControlLines 
Where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

if ( @canlistenext > 0 )
     Insert into @lpermitted
          Select Id 
          FROM A_ServerExtLines sel
          Where not exists(select id from @lpermitted where Id = sel.ID)
     
Insert into @commpermitted
     Select sc.ID            
     From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on sc.ALineId=l.Id
     Where not exists(select id from @commpermitted where Id = sc.ID)

Insert into @commpermitted            
     Select sc.ID            
     From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on  sc.BLineId=l.Id
     Where not exists(select id from @commpermitted where Id = sc.ID)


delete @A_Stat_Connections_1x1_tmp 
	where id not in (select Id from @commpermitted )

-------------------------------------------------------------------------------

--Numbers------------------------------------------------------------------------------- 
--Inner
if @innerprefix is not null begin
	declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
	declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
	Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id

		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1

			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid

			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid 
				From @temp

			/* */
			Delete From @temp	
		end --\MakePrefixTableAnyWay condition

/*
		declare @tusers table ( id uniqueidentifier ) 
		insert into @tusers 
			Select reactid FROM @t where addrtype = 0 and prefix like @innerprefix

		declare @tlines table ( id uniqueidentifier ) 
		insert into @tlines 
			Select reactid FROM @t where addrtype = 1 and prefix like @innerprefix
*/
	
		
		

		--Users
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		--Lines
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)
		
		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
		
end --\NUmbers
-------------------------------------------------------------------------------

--Outer NUMBVERS-------------------------------------------------------------------------------
if @OutNumber is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc
		where  AOutNumber like '%'+@OutNumber+'%'

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc
		where  BOutNumber like '%'+@OutNumber+'%'
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1

end
--\Outer NUMBVERS-------------------------------------------------------------------------------

--operatorid-------------------------------------------------------------------------------
if @operatorid is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
		where  AUserId=@operatorid

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id 
		from @A_Stat_Connections_1x1_tmp sc
		where  BUserId=@operatorid
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
end

--\operatorid-------------------------------------------------------------------------------

--@taskid-------------------------------------------------------------------------------
if @taskid is not null begin
		Declare @tasks table ( TaskId uniqueidentifier, ConnectionChainId uniqueidentifier PRIMARY KEY (ConnectionChainId) )  
		Insert into @tasks  
		Select  TaskId, ConnectionChainId
		FROM A_TaskManager_Task_IncomingCalls  
		Where TaskId = @taskid  
		
		Insert into @tasks  
		Select distinct TaskId, ConnectionId   
		from A_TaskManager_SubTasks st   
			inner join A_TaskManager_SubTaskEfforts ste on ste.SubTaskId = st.Id  
		Where TaskId = @taskid  

		Insert into @A_Stat_Connections_1x1_tmp1 
			select Id 
			from A_Stat_Connections_1x1 sc
				inner join @tasks  t on sc.IdChain = t.ConnectionChainId

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
end
-------------------------------------------------------------------------------

Select sc.*--.Id, IdChain, IdPrev, IdNext, TimeStart, TimeAnswer, TimeStop, ReasonStart, ReasonStop, StopSide, sc.ALineId, sc.BLineId, AOutNumber, BOutNumber, ALineNum, BLineNum, sc.AUserId, sc.BUserId, ANumberDialed, BNumberDialed, IsRecorded, ARecFile, BRecFile, ConnectionType, Astr, Bstr, TimeStop - TimeAnswer as Length, TimeAnswer - TimeStart as AnswerLength 
FROM A_Stat_Connections_1x1 sc--,@ulpermitted ul,@tasks t
		Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		--Inner Join @commpermitted cp on sc.ID=cp.ID


GO


