if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_GetJournal]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_GetJournal]
GO

CREATE procedure [dbo].[A_Stat_Office_GetJournal]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL  --Out Number defined
as
begin	
	Select top 0 * into #t from A_Stat_Connections_1x1
	Insert into #t Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@operatorid,
		@innerprefix,
		@outnumber

	Select top 1000 t.*, TimeStop - TimeAnswer as Length, TimeStart - TimeStart as AnswerLength
	From #t t
	Order By TimeStart Desc
end


GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_Diagramm_AllCalls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_Diagramm_AllCalls]
GO


create procedure [dbo].[A_Stat_Office_Diagramm_AllCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 4
--------------------------------------------------------------------
*/
		

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@operatorid,
		@innerprefix,
		@outnumber

	
	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain

			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )							
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			declare @lines2 table ( lineid uniqueidentifier )
			insert into @lines2
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
	

			Select uid, sum ( count_ ) count_ from
			(
				select AUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join A_Users u on u.Id = ts.AUserId
				Group by AUserId
			
				union all
			
				select BUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join A_Users u on u.Id = ts.BUserId
				Group By BUserId

				union

				select AUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines2 l on l.lineid = ts.BLineId
				Where ( ALineNum like 'IVR' )
				Group by AUserId

				union all
					
				select BUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines2 l on l.lineid = ts.ALineId
				Where ( BLineNum like 'IVR' )
				Group By BUserId
	
			)a
			group by uid
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier )
			insert into @lines3
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines


			Select linenum, sum ( count_ ) count_ from
			(
				select ALineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId	
				Group by ALineNum
			
				union all

				select BLineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.BLineId
				Group By BLineNum

				union all

				select ALineNum as linenum, count ( * ) as count_
				from #tempstatistics ts 
					inner join @lines3 l on l.lineid = ts.BLineId
				where ALineNum like 'IVR' 
				Group by ALineNum

				union all

				select BLineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId
				where BLineNum like 'IVR'
				Group by BLineNum
			)a
			group by linenum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

		declare @lines4 table ( lineid uniqueidentifier )
		insert into @lines4
			Select ID from A_ServerIntLines
			union 
			Select ID from A_ServerUSBLines

		Select prefix, sum ( count_ ) count_ from
		(
			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				inner join A_Users u on u.id = AUserId
			Group by prefix

			union all

			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				inner join A_Users u on u.id = BUserId
			Group by prefix

			union all

			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
				inner join @lines4 l on l.lineid = ALineId
			Group by prefix

			union all
		
			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
				inner join @lines4 l on l.lineid = BLineId
			Group by prefix
		)a
		Group by prefix
	end	

	delete from #tempstatistics

end


GO






if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_Diagramm_HandledCalls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_Diagramm_HandledCalls]
GO

create procedure [dbo].[A_Stat_Office_Diagramm_HandledCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/		

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@operatorid,
		@innerprefix,
		@outnumber

	Delete from #tempstatistics
	Where not ConnectionType in ( 4, 5 )

	Delete From #tempstatistics
	Where ConnectionType = 4 and ( not IdNext is null )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain


			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )						
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
				select BUserId, count ( * ) as count_
				from #tempstatistics
				group by BUserId													
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			select BLineNum, count ( * ) as count_
			from #tempstatistics
			group by BLineNum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatistics t inner join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = BUserId
				Group by prefix

				union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatistics t inner join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix
	end	

	delete from #tempstatistics

end


GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_Diagramm_FlashedCalls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
GO


create procedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 0
--------------------------------------------------------------------
*/	

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@operatorid,
		@innerprefix,
		@outnumber


	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsflash') )
		select top 0 sc1.*, sc2.ALineId A2LineId, sc2.BLineId B2LineId into #tempstatisticsflash From A_Stat_Connections_1x1 sc1 inner join A_Stat_Connections_1x1 sc2 on sc1.IDNext = sc2.Id
	else
		delete from #tempstatisticsflash

	insert into #tempstatisticsflash
		Select ts1.*, ts2.ALineId A2LineId, ts2.BLineId B2LineId
		FROM #tempstatistics ts1 inner join 
			#tempstatistics ts2 on ts1.idnext = ts2.id
		where not ( ts1.ALineId = ts2.ALineId and ts1.BLineID = ts2.BLineId ) 
			and not ( ts1.ALineId = ts2.BLineId and ts1.BLineID = ts2.ALineId )
			and not ( ts1.AUserId = 'AB000000-0000-0000-0000-000000000000' )
			and not ( ts1.BUserId = 'AB000000-0000-0000-0000-000000000000' )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From #tempstatisticsflash
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )											
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From #tempstatisticsflash
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			select uid, count ( * ) as count_
			From
			( 
				Select AUserId as uid, TimeStop
				from #tempstatisticsflash
				where StopSide = 0 and 
					(AUserId != '00000000-0000-0000-0000-000000000000')
		
				union all

				Select BUserId as uid, TimeStop
				from #tempstatisticsflash
				where StopSide = 1 and
					(BUserId != '00000000-0000-0000-0000-000000000000')
			)a
			Group by uid								
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines

			select linenum, count ( * ) as count_
			from
			(
				select BLineNum linenum, TimeStop
				from #tempstatisticsflash ts 
				inner join @lines l on ts.BLineId = l.lineid

				union

				select ALineNum linenum, TimeStop
				from #tempstatisticsflash ts 
				inner join @lines l on ts.ALineId = l.lineid
			)a

			group by linenum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end

			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = AUserId
				Group by prefix
					
				union all

					Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = BUserId
				Group by prefix
					
				union all

					Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = ALineId
				Group by prefix
					
				union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix

		end	

	delete from #tempstatisticsflash
	delete from #tempstatistics

end


GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_Diagramm_CallTime]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_Diagramm_CallTime]
GO

create procedure [dbo].[A_Stat_Office_Diagramm_CallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@operatorid,
		@innerprefix,
		@outnumber


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdate') ) 
				select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDdate 
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDdate

			insert into #tempstatisticsYMDdate
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, m, d, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From #tempstatisticsYMDdate

			delete from #tempstatisticsYMDdate										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdate') )
				select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDHdate 
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDHdate

			insert into #tempstatisticsYMDHdate
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From #tempstatisticsYMDHdate

			delete from #tempstatisticsYMDHdate
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin			
			Select uid, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b			
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines


			Select linenum, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select ALineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines l on l.lineid = ts.ALineId
	
					union all
	
					Select BLineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines l on l.lineid = ts.BLineId
				)a
				Group by linenum
			)b
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
	

			Select prefix, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = AUserId

					union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = BUserId
	
					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)b
				Group by prefix
			)c

		end	

	delete from #tempstatistics

end

GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_Diagramm_AverageCallTime]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
GO


create procedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@operatorid,
		@innerprefix,
		@outnumber


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdateInt') )
				select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDdateInt
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDdateInt

			insert into #tempstatisticsYMDdateInt
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, Count ( * ) as count_
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, m, d, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From #tempstatisticsYMDdateInt

			delete from #tempstatisticsYMDdateInt										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdateInt') )
				select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDHdateInt
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDHdateInt

			insert into #tempstatisticsYMDHdateInt
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From #tempstatisticsYMDHdateInt

			delete from #tempstatisticsYMDHdateInt
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin	
			Select uid, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier )
			insert into @lines3
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines


			Select linenum, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select ALineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId
	
					union all
	
					Select BLineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.BLineId
				)a
				Group by linenum
			)b

		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines


			Select prefix, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = AUserId

					union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = BUserId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)a
				Group by prefix
			)b

		end	

	delete from #tempstatistics

end


GO



Update A_Stat_Connections_1x1 
Set AUserId = 'AB000000-0000-0000-0000-000000000000' 
Where ALineId = '00000000-0000-0000-0000-000000000000'

GO


Update A_Stat_Connections_1x1 
Set BUserId = 'AB000000-0000-0000-0000-000000000000' 
Where BLineId = '00000000-0000-0000-0000-000000000000'

GO


Update sc
Set AUserId = 'BF000000-0000-0000-0000-000000000000' 
From A_Stat_Connections_1x1 sc, A_ServerExtLines el
Where sc.ALineId = el.Id

GO


Update sc
Set BUserId = 'BF000000-0000-0000-0000-000000000000' 
From A_Stat_Connections_1x1 sc, A_ServerExtLines el
Where sc.BLineId = el.Id

GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Office_TimeScale]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Stat_Office_TimeScale]
GO

Create                   procedure [dbo].[A_Stat_Office_TimeScale]
	@startdate 	DateTime, 
	@stopdate 	DateTime, 
	@starttime 	DateTime, 
	@stoptime 	DateTime,
	@length 	float 			= 0, 
	@conntype 	int 			= -1, 
	@task 		uniqueidentifier 	= null, 
	@operator 	uniqueidentifier 	= null,
	@inner 		nvarchar ( 20 )		='', 
	@outer 		nvarchar ( 20 )		='',
	@iduser		uniqueidentifier,
	@minvalue 	int 			output, 
	@maxvalue 	int 			output
as
/*
----------------------------------------------------------
------- debug --------------------------------------------
----------------------------------------------------------
	declare @startdate 	DateTime 
	declare @stopdate 	DateTime 
	declare @starttime 	DateTime 
	declare @stoptime 	DateTime
	declare @length 	float
	declare @conntype 	int 
	declare @task 		uniqueidentifier
	declare @operator 	uniqueidentifier
	declare @inner 		nvarchar ( 20 )
	declare @outer 		nvarchar ( 20 )
	declare @iduser		uniqueidentifier
	declare @minvalue 	int
	declare @maxvalue 	int
	
	set @startdate = ' 14 2006 12:00AM' 
	set @stopdate = ' 14 2006 12:00AM' 
	set @starttime = ' 14 2006  8:00AM'
	set @stoptime = ' 14 2006  6:00PM' 
	set @length = 1.157407407407407e-005 
	set @conntype = -1
	set @task = N'00000000-0000-0000-0000-000000000000'
	set @operator = N'00000000-0000-0000-0000-000000000000'
	set @inner = N'' 
	set @outer = N''
	set @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
----------------------------------------------------------
------- end debug ----------------------------------------
----------------------------------------------------------
*/
	declare @tstartfloat float 
	declare @tstopfloat float
	
	set @tstartfloat = Convert ( float, @starttime )
	set @tstopfloat  = Convert ( float, @stoptime )
	set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
	set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )

	-- 

	Declare @ulpermitted table ( Id uniqueidentifier )
	Insert into @ulpermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @ulpermitted ( Id ) Values ( @iduser )

	Insert into @ulpermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @ulpermitted
		Select Id 
		From A_ServerExtLines

	Declare @tasks table ( ConnectionChainId uniqueidentifier )
	declare @usetask bit
	set @usetask = 0
	if ( @task != '00000000-0000-0000-0000-000000000000' )
	  begin
		set @usetask = 1
		Insert into @tasks
			Select ConnectionChainId FROM A_TaskManager_Task_IncomingCalls
			Where TaskId = @task

		Insert into @tasks
			Select ConnectionId 
			from A_TaskManager_SubTasks st 
				inner join A_TaskManager_SubTaskEfforts ste on ste.SubTaskId = st.Id
			Where TaskId = @task
	  end

	--

	Declare @min_ int, @max_ int;
	Declare @emptyguid uniqueidentifier

	Set @emptyguid = '00000000-0000-0000-0000-0000000000000000'

	Select @minvalue = isnull ( min ( c ), 0 ), @maxvalue = isnull ( max ( c ), 0 ) from
	(
		Select count ( * ) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
		Where ( timestart >= @startdate and timestart < @stopdate + 1 )
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat
		 	and (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5) ) or (@conntype = 2 and connectiontype in (1,6,7)) or (@conntype = 3 and connectiontype in (2,3,8)))
		  	and (timestop - timestart) >= @length 

		  	and (@outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
		 	and (@operator in (@emptyguid,AUserID,BUserID))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))
	 	Group By convert ( varchar(10), timestart, 104 ), datepart ( hour, timestart )
	) a;

	Select @min_ = isnull ( min ( c ), 0 ), @max_ = isnull ( max ( c ), 0 ) from
	(
 		Select count ( * ) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
	 	Where ( timestart >= @startdate and timestart < @stopdate + 1 ) 
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat
			and (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or (@conntype = 3 and connectiontype in (2,3,8))) 
			and ( timestop - timestart ) >= @length
  			and ( @outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
  			and ( @operator in ( @emptyguid, AUserID, BUserID))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))
  		Group By convert ( varchar ( 10 ), timestart, 104 )
	) a;

	if ( @min_ = 0 )
  		set @min_ = 1;
	if ( @min_ < @minvalue )
  		set @minvalue = @min_;
	if ( @max_ > @maxvalue )
  		set @maxvalue = @max_;
			

	Select @min_ = isnull ( min ( c ), 0 ), @max_ = isnull ( max ( c ), 0 ) From
	(
  		Select count(*) c 
		From a_stat_connections_1x1 sc
			Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
			Left join @tasks t on sc.IdChain = t.ConnectionChainId
	  	Where ( timestart >= @startdate and timestart < @stopdate + 1 ) 
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstopfloat
  			and ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8))) 
			and ( timestop - timestart ) >= @length
			and ( @outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
  			and ( @operator in ( @emptyguid, AUserID, BUserID ))
			and ((@usetask = 0) or (t.ConnectionChainId != NULL))		
  		Group By convert ( varchar ( 10 ), timestart, 104 )

	) a

	if (@min_ = 0)
  		set @min_ = 1;
	if (@min_<@minvalue)
  		set @minvalue = @min_;
	if (@max_>@maxvalue)
  		set @maxvalue = @max_;

	declare @empty table ( cdate varchar ( 10 ), c0 int, c1 int, c2 int, c3 int, c4 int, c5 int, c6 int, c7 int, c8 int, c9 int, c10 int, 
		c11 int, c12 int, c13 int, c14 int, c15 int, c16 int, c17 int, c18 int, c19 int, c20 int, c21 int, c22 int, c23 int, cbottom int, ctop int )
	declare @tempdate datetime 
	set @tempdate = @startdate
	while @tempdate <= @stopdate
	begin
		Insert into @empty ( cdate, c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20, c21, c22, c23, cbottom, ctop )
		Values ( convert ( varchar(10), @tempdate, 126 ), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 )		
			
		set @tempdate = DateAdd ( d, 1, @tempdate )
	end
	

	Select 	cdate,
     		sum ( c0 ) as c0, 
    	 	sum ( c1 ) as c1,
     		sum ( c2 ) as c2,
	     	sum ( c3 ) as c3,
     		sum ( c4 ) as c4,
     		sum ( c5 ) as c5, 
     		sum ( c6 ) as c6,
     		sum ( c7 ) as c7,
     		sum ( c8 ) as c8,
     		sum ( c9 ) as c9,
     		sum ( c10 ) as c10, 
     		sum ( c11 ) as c11, 
     		sum ( c12 ) as c12,
     		sum ( c13 ) as c13,
     		sum ( c14 ) as c14,
     		sum ( c15 ) as c15,
     		sum ( c16 ) as c16,
     		sum ( c17 ) as c17,
     		sum ( c18 ) as c18,
	     	sum ( c19 ) as c19,
	     	sum ( c20 ) as c20,
	     	sum ( c21 ) as c21,
	     	sum ( c22 ) as c22,  
	     	sum ( c23 ) as c23,
	     	sum ( cbefore ) as cbottom,
	     	sum ( cafter ) as ctop  

	From 

	(

     		Select  
			convert ( varchar(10), timestart, 126 ) cdate,
          		case ( DatePart ( hour, timestart ) ) when 0 then 1 else 0 end as c0,
         		case ( DatePart ( hour, timestart ) ) when 1 then 1 else 0 end as c1,
          		case ( DatePart ( hour, timestart ) ) when 2 then 1 else 0 end as c2,
          		case ( DatePart ( hour, timestart ) ) when 3 then 1 else 0 end as c3,
          		case ( DatePart ( hour, timestart ) ) when 4 then 1 else 0 end as c4,
          		case ( DatePart ( hour, timestart ) ) when 5 then 1 else 0 end as c5,
          		case ( DatePart ( hour, timestart ) ) when 6 then 1 else 0 end as c6,
          		case ( DatePart ( hour, timestart ) ) when 7 then 1 else 0 end as c7,
          		case ( DatePart ( hour, timestart ) ) when 8 then 1 else 0 end as c8,
          		case ( DatePart ( hour, timestart ) ) when 9 then 1 else 0 end as c9,
          		case ( DatePart ( hour, timestart ) ) when 10 then 1 else 0 end as c10,
          		case ( DatePart ( hour, timestart ) ) when 11 then 1 else 0 end as c11,
          		case ( DatePart ( hour, timestart ) ) when 12 then 1 else 0 end as c12,
          		case ( DatePart ( hour, timestart ) ) when 13 then 1 else 0 end as c13,
	          	case ( DatePart ( hour, timestart ) ) when 14 then 1 else 0 end as c14,
	          	case ( DatePart ( hour, timestart ) ) when 15 then 1 else 0 end as c15,
	          	case ( DatePart ( hour, timestart ) ) when 16 then 1 else 0 end as c16,
	          	case ( DatePart ( hour, timestart ) ) when 17 then 1 else 0 end as c17,
	          	case ( DatePart ( hour, timestart ) ) when 18 then 1 else 0 end as c18,
	          	case ( DatePart ( hour, timestart ) ) when 19 then 1 else 0 end as c19,
	          	case ( DatePart ( hour, timestart ) ) when 20 then 1 else 0 end as c20,
	          	case ( DatePart ( hour, timestart ) ) when 21 then 1 else 0 end as c21,
	          	case ( DatePart ( hour, timestart ) ) when 22 then 1 else 0 end as c22,
	          	case ( DatePart ( hour, timestart ) ) when 23 then 1 else 0 end as c23,			
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat then 1 else 0 end as cbefore,
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) > @tstopfloat then 1 else 0 end as cafter


     		From 
		(
			Select sc.Id, sc.TimeStart		
			From A_Stat_Connections_1x1  sc
				Inner join @ulpermitted ul on sc.AUserId = ul.Id or sc.BUserId = ul.Id or sc.ALineId = ul.Id or sc.BLineId = ul.Id
				Left join @tasks t on sc.IdChain = t.ConnectionChainId
			Where ( TimeStart >= @startdate ) and ( TimeStop < @stopdate + 1 ) 
				and ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8)))
	          		and ( timestop - timestart ) >= @length
        	  		and (@outer = '' or (AOutNumber like @outer or BOutNumber like @outer))
          			and (@operator in (@emptyguid,AUserID,BUserID))
				and ((@usetask = 0) or (t.ConnectionChainId != NULL))
			Group By sc.Id, TimeStart
		)b

		Union all

		Select *
		FROM @empty
	)a

	Group by cdate
	Order by cdate


GO




if exists (Select * FROM dbo.sysobjects where id = object_id (N'[dbo].[D_Stat_Report_TimeScale2]'  ) )
	drop procedure dbo.D_Stat_Report_TimeScale2

GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Redirect_SetUserState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[A_Redirect_SetUserState]
GO

Create procedure [dbo].[A_Redirect_SetUserState]
	@userid uniqueidentifier,
	@isset bit
as
begin
	Update C_UserParams
	Set IsRedirect = @isset
	Where IdUser = @userid
end


GO



Alter table A_Redirect_Abonents Add [Description] nvarchar ( 255 )

GO