
ALTER  procedure [dbo].[A_Redirect_Save]
	@id uniqueidentifier,
	@iduser uniqueidentifier,
	@priorityindex int,
	@creationdate datetime,
	@caption nvarchar ( 100 ),
	@redirectstateonly bit,
	@cascaderedirect bit,
	@destinationnumber nvarchar ( 50 )	
as
begin
	Declare @cnt int
	
	Select @cnt = Count ( * ) 
	From A_Redirect 
	Where Id = @id


	if ( @cnt > 0 )
		Update A_Redirect			
		Set 	IdUser = @iduser,
			PriorityIndex = @priorityindex,
			CreationDate = @creationdate,
			Caption = @caption,
			RedirectStateOnly = @redirectstateonly,
			CascadeRedirect = @cascaderedirect,
			DestinationNumber = @destinationnumber
		Where
			Id = @id
	else
	begin
		Update A_Redirect 
		Set PriorityIndex = PriorityIndex + 1
		Where PriorityIndex >= @priorityindex


		Insert Into A_Redirect 
			( Id, IdUser, PriorityIndex, CreationDate, Caption, RedirectStateOnly, CascadeRedirect, Enabled, DestinationNumber )
		Values
			( @id, @iduser, @priorityindex, @creationdate, @caption, @redirectstateOnly, @cascaderedirect, 0, @destinationnumber )
	end
	
end


GO








ALTER      procedure [dbo].[A_Admin_UserGroup_User_Save]
	@id		uniqueidentifier,
	@name		nvarchar ( 200 ),
	@info		nvarchar ( 1000 ),
	@parentgroupid	uniqueidentifier,
	@login		nvarchar ( 50 ),
	@password	nvarchar ( 50 ),
	@isoperator	int,
	@type		int,
	
	@p01		bit,
	@p02		bit,
	@p03		bit,
	@p04		bit,
	@p05		bit,
	@p06		bit,
	@p07		bit,
	@p08		bit,
	@p09		bit,
	@p10		bit,
	@p11		bit,
	@p12		bit,
	@p13		bit,
	@p14		bit,
	@p15		bit,
	@p16		bit,
	@p17		bit,
	@p18		bit,
	@p19		bit,
	@p20		bit,
	@p21		bit,
	@p22		bit,
	@p23		bit,
	@p24		bit,
	@p25		bit,
	@p26		bit,
	@p27		bit,
	@p28		bit,
	@p29		bit,
	@p30		bit,
	@p31		bit,
	@p32		bit,
	@p33		bit,
	@p34		bit,
	@p35		bit,
	@p36		bit,
	@p37		bit,
	@p38		bit,
	@p39		bit,
	@p40		bit

as
begin

	Update A_Users
	Set 	
		Name 		= @name,
		Info 		= @info,
		ParentGroupId 	= @parentgroupid,
		Login		= @login,
		Password 	= @password,
		Type		= @type
	Where 
		Id 		= @id
	
	if ( @@rowcount = 0 )
	begin
		Insert 
		Into A_Users 
			( Id, Name, Info, ParentGroupId, Login, Password, Type, Enabled )
		Values
			( @id, @name, @info, @parentgroupid, @login, @password, @type, 1 )
	end

	Update A_UserRights
	Set 
		P01 = @p01,
		P02 = @p02,
		P03 = @p03,
		P04 = @p04,
		P05 = @p05,
		P06 = @p06,
		P07 = @p07,
		P08 = @p08,
		P09 = @p09,
		P10 = @p10,
		P11 = @p11,
		P12 = @p12,
		P13 = @p13,
		P14 = @p14,
		P15 = @p15,
		P16 = @p16,
		P17 = @p17,
		P18 = @p18,
		P19 = @p19,
		P20 = @p20,
		P21 = @p21,
		P22 = @p22,
		P23 = @p23,
		P24 = @p24,
		P25 = @p25,
		P26 = @p26,
		P27 = @p27,
		P28 = @p28,
		P29 = @p29,
		P30 = @p30,
		P31 = @p31,
		P32 = @p32,
		P33 = @p33,
		P34 = @p34,
		P35 = @p35,
		P36 = @p36,
		P37 = @p37,
		P38 = @p38,
		P39 = @p39,
		P40 = @p40
	Where 	UserId = @id

	if ( @@rowcount = 0 )
	begin
		Insert 
		Into A_UserRights
			( UserId, P01, P02, P03, P04, P05, P06, P07, P08, P09, P10,
				P11, P12, P13, P14, P15, P16, P17, P18, P19, P20,
				P21, P22, P23, P24, P25, P26, P27, P28, P29, P30,
				P31, P32, P33, P34, P35, P36, P37, P38, P39, P40 )
		Values
			( @id,	@p01, @p02, @p03, @p04, @p05, @p06, @p07, @p08, @p09, @p10, 
				@p11, @p12, @p13, @p14, @p15, @p16, @p17, @p18, @p19, @p20, 
				@p21, @p22, @p23, @p24, @p25, @p26, @p27, @p28, @p29, @p30, 
				@p31, @p32, @p33, @p34, @p35, @p36, @p37, @p38, @p39, @p40 )
	end


	Delete
	From C_UserParams
	Where IDuser = @id
	
	Insert 
	Into C_UserParams
		( IDuser, IsOperator, IsRedirect )
	Values
		( @id, @isoperator, 0 )


	if ( @isoperator = 0 )
	  begin
		Delete 
		From C_GroupOperators
		Where IDoperator = @id

		Delete 
		From C_OperatorTimeTable
		Where IDoperator = @id		
	  end


	exec A_Admin_UserGroup_Group_SiftEmpty
end



GO
