
ALTER    procedure [dbo].[A_Redirect_Save]
	@id uniqueidentifier,
	@iduser uniqueidentifier,
	@priorityindex int,
	@creationdate datetime,
	@caption nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@redirectstateonly bit,
	@cascaderedirect bit,
	@destinationnumber nvarchar ( 50 )	
as
begin
	Declare @cnt int
	
	Select @cnt = Count ( * ) 
	From A_Redirect 
	Where Id = @id


	if ( @cnt > 0 )
	begin
		declare @prlast int

		Select @prlast = PriorityIndex
		From A_Redirect
		Where Id = @id

		Update A_Redirect
		Set PriorityIndex = PriorityIndex + 1 
		Where PriorityIndex >= @priorityindex 
			and PriorityIndex < @prlast
			and IdUser = @iduser

		Update A_Redirect
		Set PriorityIndex = PriorityIndex - 1
		Where PriorityIndex > @prlast
			and PriorityIndex <= @priorityindex
			and IdUser = @iduser

		Update A_Redirect			
		Set 	IdUser = @iduser,
			PriorityIndex = @priorityindex,
			CreationDate = @creationdate,
			Caption = @caption,
			Description = @description,
			RedirectStateOnly = @redirectstateonly,
			CascadeRedirect = @cascaderedirect,
			DestinationNumber = @destinationnumber
		Where
			Id = @id

	end
	else
	begin
		Update A_Redirect 
		Set PriorityIndex = PriorityIndex + 1
		Where PriorityIndex >= @priorityindex
			And IdUser = @iduser


		Insert Into A_Redirect 
			( Id, IdUser, PriorityIndex, CreationDate, Caption, Description, RedirectStateOnly, CascadeRedirect, Enabled, DestinationNumber )
		Values
			( @id, @iduser, @priorityindex, @creationdate, @caption, @description, @redirectstateOnly, @cascaderedirect, 0, @destinationnumber )
	end
	
end

GO



ALTER  procedure [dbo].[A_Redirect_Delete]
	@id uniqueidentifier
as
begin
	declare @pr int
	set @pr = -1

	declare @iduser uniqueidentifier

	Select @pr = PriorityIndex, @iduser = IdUser
	From A_Redirect
	Where Id = @id

	if ( @pr >= 0 )
	begin
		Delete 
		From A_Redirect
		Where Id = @id
		
		Update A_Redirect
		Set PriorityIndex = PriorityIndex - 1
		Where PriorityIndex >= @pr
			and IdUser = @iduser
	end
end


GO








select distinct * 
into #t
from A_UserControlLines

delete A_UserCOntrolLines

insert A_UserControlLines
select * from  #t

drop table #t

GO

select distinct * 
into #t
from A_UserControls

delete A_UserControls

insert A_UserControls
select * from  #t

drop table #t

GO



select distinct * 
into #t
from A_UserOutcomingLines

delete A_UserOutcomingLines

insert A_UserOutcomingLines
select * from  #t

drop table #t

GO








CREATE TABLE dbo.Tmp_A_UserControls
	(
	UserA uniqueidentifier NOT NULL,
	UserB uniqueidentifier NOT NULL
	)
GO
IF EXISTS(SELECT * FROM dbo.A_UserControls)
	 EXEC('INSERT INTO dbo.Tmp_A_UserControls (UserA, UserB)
		SELECT UserA, UserB FROM dbo.A_UserControls TABLOCKX')
GO
DROP TABLE dbo.A_UserControls
GO
EXECUTE sp_rename N'dbo.Tmp_A_UserControls', N'A_UserControls', 'OBJECT'

GO
ALTER TABLE dbo.A_UserControls ADD CONSTRAINT
	PK_A_UserControls PRIMARY KEY CLUSTERED 
	(
	UserA,
	UserB
	)

GO



if not exists ( select * from dbo.sysindexes where name like 'idxUserA' and id = object_id ( N'[dbo].[A_UserControls]' ) )
CREATE  INDEX [idxUserA] ON [dbo].[A_UserControls]([UserA]) WITH  FILLFACTOR = 80
GO


if not exists ( select * from dbo.sysindexes where name like 'idxUserB' and id = object_id ( N'[dbo].[A_UserControls]' ) )
CREATE  INDEX [idxUserB] ON [dbo].[A_UserControls]([UserB]) WITH  FILLFACTOR = 80
GO








CREATE TABLE dbo.Tmp_A_UserControlLines
	(
	UserA uniqueidentifier NOT NULL,
	IdLine uniqueidentifier NOT NULL
	)
GO
IF EXISTS(SELECT * FROM dbo.A_UserControlLines)
	 EXEC('INSERT INTO dbo.Tmp_A_UserControlLines (UserA, IdLine)
		SELECT UserA, IdLine FROM dbo.A_UserControlLines TABLOCKX')
GO
DROP TABLE dbo.A_UserControlLines
GO
EXECUTE sp_rename N'dbo.Tmp_A_UserControlLines', N'A_UserControlLines', 'OBJECT'
GO
ALTER TABLE dbo.A_UserControlLines ADD CONSTRAINT
	PK_A_UserControlLines PRIMARY KEY CLUSTERED 
	(
	UserA,
	IdLine
	)
GO







CREATE TABLE dbo.Tmp_A_UserOutcomingLines
	(
	IdUser uniqueidentifier NOT NULL,
	IdLine uniqueidentifier NOT NULL,
	LineIndex int
	)
GO


IF EXISTS(SELECT * FROM dbo.A_UserOutcomingLines)
	 EXEC('INSERT INTO dbo.Tmp_A_UserOutcomingLines (IdUser, IdLine, LineIndex)
		SELECT IdUser, IdLine, LineIndex FROM dbo.A_UserOutcomingLines TABLOCKX')
GO

DROP TABLE dbo.A_UserOutcomingLines
GO

EXECUTE sp_rename N'dbo.Tmp_A_UserOutcomingLines', N'A_UserOutcomingLines', 'OBJECT'
GO

ALTER TABLE dbo.A_UserOutcomingLines ADD CONSTRAINT
	PK_A_UserOutcomingLines PRIMARY KEY CLUSTERED 
	(
	IdUser,
	IdLine
	)

GO


