ALTER         procedure [dbo].[C_CallCenter_GetTaskJournal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@showefforts	int


As
Begin
-------------------------------------------------------------------------------------------------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare	@taskid 	uniqueidentifier
declare	@number 	nvarchar ( 50 )
declare	@operatorid	uniqueidentifier
declare	@showefforts	int


set dateformat dmy
set @dstart = '2006/05/01'
set @dstop = '2006/06/15'
set @tstart = '01:11:00'
set @tstop = '22:29:00'
select @taskid = id from A_TaskManager_Tasks where name like ''
set @number = ''
set @operatorid ='00000000-0000-0000-0000-000000000000'
set @showefforts = 1

@dstart = ' 16 2006 12:00AM', @dstop = ' 16 2006 11:59PM', @tstart = N'8:00', @tstop = N'20:00', @taskid = 'A6EE1A23-00A7-494E-9A9F-78B3C2AF8FCA', @number = N'', @operatorid = '00000000-0000-0000-0000-000000000000', @showefforts = 0

*/



declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )



declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id
		Where TaskId = @taskid
			and EffortDateTime > @dstart 
			and EffortDateTime < @dstop
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
			and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
		Where TaskId = @taskid
			and CallTimeStart > @dstart 
			and CallTimeStart < @dstop
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
			and Number like '%' + @number + '%'


if ( @showefforts <= 0 )
	Delete 
	From @te 
	Where IdChain = '00000000-0000-0000-0000-000000000000'


declare @type int
Select @type = Type FROM A_TaskManager_Tasks Where Id = @taskid


declare @u table ( Id uniqueidentifier, Name nvarchar ( 100 ) )
	Insert into @u
		Select Id, Name 
		From A_Users
	Insert into @u 
		(Id, Name)
		Values
		('AB000000-0000-0000-0000-000000000000', 'IVR')

	
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, isnull ( IsRecorded, 0 ) as IsRecorded, isnull ( ARecFile, '' ) as ARecFile, isnull ( BRecFile, '' ) as BRecFile
	From
	(
		Select te.Number, isnull ( ua.Name, isnull ( ub.Name, '' ) )as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te			
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and te.CallTime <= sc.TimeStart
			left join @u ua on sc.AUserId = ua.Id
			left join @u ub on sc.BUserId = ub.Id
		Where sc.AUserId = @operatorid
			or sc.BUserId = @operatorid 
			or @operatorid = '00000000-0000-0000-0000-000000000000'
	)a
	Order By CallTime


/*
if ( @type < 4 )
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile
	From
	(
		Select te.Number ,'IVR' as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain
	)a
	Order By CallTime
else
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsRecorded, ARecFile, BRecFile
	From
	(
		Select te.Number ,u.Name as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			inner join A_TaskManager_UserInTask ut on ut.EffortId = te.EffortId
			inner join A_Users u on ut.UserId = u.Id
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and ( AUserId = ut.UserId or BUserId = ut.UserId )
		Where sc.AUserId = @operatorid
			or sc.BUserId = @operatorid 
			or @operatorid = '00000000-0000-0000-0000-000000000000'
	)a
	Order By CallTime
*/




end


GO
