
if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_TaskManager_TaskAuto_List' ) )
Drop table [dbo].[A_TaskManager_TaskAuto_List]
GO

Create Table [dbo].[A_TaskManager_TaskAuto_List]
(
	Id int not null identity ( 1, 1 ) primary key,
	Phone nvarchar ( 20 ) not null,
	CreationDate DateTime not null
)
GO

if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_TaskManager_ListAuto_InsertRow' ) )
Drop procedure [dbo].[A_TaskManager_ListAuto_InsertRow]
GO

Create procedure [dbo].[A_TaskManager_ListAuto_InsertRow]
	@number nvarchar ( 20 )
as
begin
	Insert into A_TaskManager_TaskAuto_List ( Phone, CreationDate ) Values ( @number, GetDate() )
	Select @@identity
end
GO

if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_TaskManager_ListAuto_DeleteRow' ) )
Drop procedure [dbo].[A_TaskManager_ListAuto_DeleteRow]
GO


Create procedure [dbo].[A_TaskManager_ListAuto_DeleteRow]
	@id int
as
begin
	Delete 
	From A_TaskManager_TaskAuto_List
	Where Id = @id
end
GO




if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_Indicators' ) )
Drop table [dbo].[A_CallCenter_Indicators]
GO

Create Table [dbo].[A_CallCenter_Indicators]
(
	Id uniqueidentifier not null primary key,
	Stream image
)
GO



if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_Indicator_Save' ) )
Drop procedure [dbo].[A_CallCenter_Indicator_Save]
GO

Create Procedure dbo.[A_CallCenter_Indicator_Save]
     @id uniqueidentifier,
     @stream image
as
begin
     if exists ( Select id From A_CallCenter_Indicators Where Id = @id )
          Update A_CallCenter_Indicators
          Set Stream = @stream
          Where Id = @id
     else           
          Insert into A_CallCenter_Indicators ( Id, Stream )
          Values ( @id, @stream )
end
GO



if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_Indicator_GetAll' ) )
Drop procedure [dbo].[A_CallCenter_Indicator_GetAll]
GO

Create Procedure dbo.[A_CallCenter_Indicator_GetAll]
as
begin
     Select Id, DataLength(Stream) as Length, Stream 
     From A_CallCenter_Indicators
end
GO



if exists ( Select Id From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_Indicator_Delete' ) )
Drop procedure [dbo].[A_CallCenter_Indicator_Delete]
GO

Create Procedure dbo.[A_CallCenter_Indicator_Delete]
	@id uniqueidentifier
as
begin
     	Delete 
	From A_CallCenter_Indicators
	Where Id = @id
end
GO

