if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_DB_InitOnStart' ) )
DROP PROCEDURE dbo.A_DB_InitOnStart
GO


Create  PROCEDURE [dbo].[A_DB_InitOnStart]
As
begin

		-----------------------------------------------------
		--    -----------
		-----------------------------------------------------
		
		declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------

		Update A_TaskManager_UserInTask
		Set TimeStopPost = @lastpingtime 
		Where TimeStopPost is null

		Update A_TaskManager_UserInTask
		Set TimeStopDialog = @lastpingtime 
		Where TimeStopDialog is null

		Update A_TaskManager_UserInTask
		Set TimeStopPrior = @lastpingtime
		Where TimeStopPrior is null

		Update A_TaskManager_UserInTask
		Set TimeStopWaitCall = @lastpingtime 
		Where TimeStopWaitCall is null

		Update A_TaskManager_UserInTask
		Set TimeStopBackCall = @lastpingtime 
		Where TimeStopBackCall is null

		-----------------------------------------------------
		--        ,   
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory
		Set 	TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		--  
		-----------------------------------------------------

		Delete From A_Monopoly
		Delete From C_MonopolyForTaskChanging

		-----------------------------------------------------
		--   ,  -    
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		--    
		-----------------------------------------------------

		DECLARE tcursor CURSOR FOR 
			Select name, Id  FROM sysobjects 
			Where type = 'U' and name like 'A_TaskManager_LocalList%'
		declare @llid int
		declare @llname nvarchar ( 1000 )
		declare @ltid uniqueidentifier
		declare @ltids nvarchar ( 50 )
		declare @sql nvarchar ( 500 )

		OPEN tcursor
		FETCH NEXT FROM tcursor INTO @llname, @llid

		WHILE @@FETCH_STATUS = 0
		BEGIN
			set @llname = 'dbo.[' + @llname + ']'

			--   (id    Id  ) (      -       . N-1  )	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			--      JoinedTable  
			if not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname )
			begin
				set @sql = ' DROP TABLE ' + @llname
				--print @sql
				exec sp_executesql @stmt =@sql
			end

		FETCH NEXT FROM tcursor INTO @llname, @llid
		END

		CLOSE tcursor
		DEALLOCATE tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		--   ??
		--         ?
		--     ?
		--   ..   ,     ..
		Exec A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
end
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_DB_UserLogoff' ) )
DROP PROCEDURE dbo.A_DB_UserLogoff
GO


CREATE  PROCEDURE [dbo].[A_DB_UserLogoff] 
	@iduser uniqueidentifier
AS
begin

		declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'


		-----------------------------------------------------
		-- Monopoly     
		-----------------------------------------------------		
		delete from C_MonopolyForTaskChanging where IdUser = @iduser

		-----------------------------------------------------
		--     -
		-----------------------------------------------------
		exec A_CallCenter_UserStateChange @start = 0, @idoperator = @iduser, @state = 0, @info = '', @selfinfo = 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------
		Update A_TaskManager_UserInTask
		Set TimeStopPost = @lastpingtime 
		Where TimeStopPost is null 
			and UserId = @iduser

		Update A_TaskManager_UserInTask
		Set TimeStopDialog = @lastpingtime 
		Where TimeStopDialog is null
			and UserId = @iduser

		Update A_TaskManager_UserInTask
		Set TimeStopPrior = @lastpingtime
		Where TimeStopPrior is null
			and UserId = @iduser

		Update A_TaskManager_UserInTask
		Set TimeStopWaitCall = @lastpingtime 
		Where TimeStopWaitCall is null
			and UserId = @iduser

		Update A_TaskManager_UserInTask
		Set TimeStopBackCall = @lastpingtime 
		Where TimeStopBackCall is null
			and UserId = @iduser


		/*
		-----------------------------------------------------
		--     -     
		-----------------------------------------------------		
		Declare @dtnow DateTime 
		Set @dtnow = GetDate ( )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set 	p0 = 0, p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 0,
				LastDT = @dtnow
			Where Id = @iduser
		*/
end
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_DB_RemoveTails' ) )
DROP PROCEDURE dbo.A_DB_RemoveTails
GO


CREATE  PROCEDURE [dbo].[A_DB_RemoveTails] AS
begin

		-----------------------------------------------------
		--    ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (LineId in (Select [ID] From A_ServerIntLines union all Select ID From A_ServerUSBLines))
		Delete FROM A_ServerExtLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerIntLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerGSMLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerUSBLines where not [ServerID] in (Select [id] from A_WORKPLACES)
	
		Delete FROM A_ServerUSBLines where not [id] in (Select LineID from A_WORKPLACES)
		Delete FROM A_LinesReactors where not [WPID] in (Select [id] from A_WORKPLACES)
		Delete From A_LinesReactors where not LineID in (Select [ID] from A_ServerExtLines 
								union Select [ID] from A_ServerIntLines
								union Select [ID] from A_ServerGSMLines
								union Select [ID] from A_ServerUSBLines)
		delete from A_ServerNumbers where not [id] in (Select [ID] FROM A_WorkPlaces Where type=5)
		delete from A_ServerNumbers where [id] in (Select [ID] from A_WorkPlaces where hasdatabase>0)



		declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] from A_WORKPLACES union 
			Select [id] from A_Users union
			Select [id] from A_ServerExtLines union
			Select [id] from A_ExtNumbers union
			Select [id] from A_ServerIntLines union
			Select [id] from A_ServerUSBLines 

		
		Delete From A_RuleRecords where not RuleID in (Select ID from A_Rules)

		Delete from A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ from @t ))

		Delete from A_NumberPlanAction where numtype=0 and extraid not in (Select ID from A_Rules)
		delete from A_NumberPlan where id not in (Select numid from A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID from A_NumberPlan)
		Delete From A_Rules	Where not id in ( select ruleid from A_RuleRecords )		

		delete from A_TaskManager_TaskExtLines where not ExtLineId in ( Select id from A_ServerExtLines )
		delete from A_TaskManager_Operators where not OperatorId in ( Select id from A_Users union Select Id from C_Groups )

		-----------------------------------------------------
		--     =   -   
		-----------------------------------------------------
		declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null  0  ID    ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		--  0     -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id from A_Users)

		-----------------------------------------------------
		--         --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit
		Declare defusercur Cursor For
			Select Id, DefaultUserId
			From A_ServerIntLines
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'
		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 from @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		--    ------------------
		-----------------------------------------------------
		Delete From A_TaskManager_UserInTask
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id from C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id from @uidt)
			or not UserB in (Select id from @uidt)

		-----------------------------------------------------
		--     --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		--   ------------------------------------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------
		Delete From A_UserRoles 
		Where creationtype != 0 
			and not exists ( Select IdRole FROM A_UserParams up Where up.IdRole = A_UserRoles.Id )
		Delete From A_UserRolesExt 
		Where not exists ( Select Id From A_UserRoles a where a.Id = IdRole )

		
		

end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_CallCenter_UserStateChange' ) )
DROP PROCEDURE dbo.A_CallCenter_UserStateChange
GO


CREATE procedure dbo.[A_CallCenter_UserStateChange]
	@start bit,
	@idoperator uniqueidentifier,
	@state int,
	@info nvarchar ( 100 ) = null,
	@selfinfo bit = null
as
begin
	declare @dtnow datetime
	set @dtnow = GetDate()

	update A_CallCenter_UserStateHistory
	Set TimeLeave = @dtnow,
		LengthSec = Cast ( (@dtnow - TimeEnter) as float ) * 86400
	Where OperatorId = @idoperator 
		and State = @state
		and TimeLeave is null

	if ( @start > 0 )
	  begin
		if ( @state in ( 2, 3, 4 ) )
			update A_CallCenter_UserStateHistory
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow - TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and State in ( 2, 3, 4 )
				and TimeLeave is null

		Insert into A_CallCenter_UserStateHistory 
		Values ( NewId ( ), @idoperator, @state, @dtnow, null, null, @info, @selfinfo )

		if ( @state = 1 )
			Insert into A_CallCenter_UserStateHistory 
			Values ( NewId ( ), @idoperator, 2, @dtnow, null, null, '', 0 )
	  end
	else
	  begin
		if ( @state = 0 )
			update A_CallCenter_UserStateHistory
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow- TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and TimeLeave is null
		else if ( @state = 1 )
			update A_CallCenter_UserStateHistory
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow- TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and TimeLeave is null
				and State != 0
	  end
end
GO
