if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_Items' ) )
Exec A_DB_ClearConstraints 'A_RecordRules_Items'
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules' ) )
DROP table dbo.A_RecordRules
GO

Create Table dbo.A_RecordRules 
(
	Id uniqueidentifier not null primary key,
	Priority int not null,
	Direction int not null,
	ToRecord bit not null
)
GO

if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_Items' ) )
DROP table dbo.A_RecordRules_Items
GO

Create Table dbo.A_RecordRules_Items
(
	IdRecordRule uniqueidentifier not null,
	Side bit not null,
	Type int not null,
	IdItem	uniqueidentifier
)
GO

ALTER TABLE dbo.A_RecordRules_Items WITH NOCHECK ADD CONSTRAINT
	FK_A_RecordRules_Items_A_RecordRules FOREIGN KEY
	(
	IdRecordRule
	) REFERENCES dbo.A_RecordRules
	(
	Id
	) ON UPDATE CASCADE
	 ON DELETE CASCADE
	
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_ClearAll' ) )
DROP procedure dbo.A_RecordRules_ClearAll
GO

Create procedure dbo.A_RecordRules_ClearAll
as
begin
	Delete From A_RecordRules
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_Add' ) )
DROP procedure dbo.A_RecordRules_Add
GO


Create procedure dbo.A_RecordRules_Add
	@id uniqueidentifier,
	@index int,
	@direction int,
	@torecord bit
as
begin
	Insert into A_RecordRules ( Id, Priority, Direction, ToRecord )
	Values ( @id, @index, @direction, @torecord )
end
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_Item_Add' ) )
DROP procedure dbo.A_RecordRules_Item_Add
GO


Create procedure dbo.A_RecordRules_Item_Add
	@idrule uniqueidentifier,
	@side bit,
	@type int,
	@iditem uniqueidentifier
as
begin
	Insert into A_RecordRules_Items ( IdRecordRule, Side, Type, IdItem )
	Values ( @idrule, @side, @type, @iditem )
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_GetAll' ) )
DROP procedure dbo.A_RecordRules_GetAll
GO

Create procedure dbo.A_RecordRules_GetAll
as
begin
	Select Id, Priority, Direction, ToRecord
	From A_RecordRules
	Order by Priority
end
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_RecordRules_Item_GetAll' ) )
DROP procedure dbo.A_RecordRules_Item_GetAll
GO

Create procedure dbo.A_RecordRules_Item_GetAll
as
begin
	Select ri.IdRecordRule, ri.Side, ri.Type, ri.IdItem
	From A_RecordRules_Items ri 
		Inner join A_RecordRules rr on rr.Id = ri.IdRecordRule
	Order by rr.Priority, ri.Side
end
GO