
if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_UserSettings' ) )
DROP TABLE dbo.A_UserSettings
GO

CREATE TABLE dbo.A_UserSettings
(
	IdUser uniqueidentifier NOT NULL,
	KeyString nvarchar ( 200 ) Not null,
	ValImage image not null
)
GO

ALTER TABLE dbo.A_UserSettings ADD CONSTRAINT
	PK_A_UserSettings PRIMARY KEY CLUSTERED 
	(
	IdUser,
	KeyString
	)
GO

ALTER TABLE dbo.A_UserSettings WITH NOCHECK ADD CONSTRAINT
	FK_A_UserSettings_A_Users FOREIGN KEY
	(
	IdUser
	) REFERENCES dbo.A_Users
	(
	Id
	) ON UPDATE CASCADE
	 ON DELETE CASCADE
	
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_UserSetting_Save' ) )
DROP PROCEDURE dbo.A_UserSetting_Save
GO

CREATE PROCEDURE dbo.A_UserSetting_Save
	@iduser uniqueidentifier,
	@keystring nvarchar ( 200 ),
	@valimage image
as
begin
	Update dbo.A_UserSettings
	Set ValImage = @valimage
	Where 	IdUser = @iduser 
		and KeyString = @keystring

	if ( @@rowcount = 0 )
		Insert into dbo.A_UserSettings ( IdUser, KeyString, ValImage )
		Values ( @iduser, @keystring, @valimage )
end
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_UserSetting_Get' ) )
DROP PROCEDURE dbo.A_UserSetting_Get
GO

CREATE PROCEDURE dbo.A_UserSetting_Get
	@iduser uniqueidentifier,
	@keystring nvarchar ( 200 )
as
begin
	Select DataLength(ValImage) as Length, ValImage 
	From dbo.A_UserSettings
	Where IdUser = @iduser and KeyString = @keystring
end
GO

