
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_Tasks' ) )
if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Tasks' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SaveDB' )
Alter Table A_TaskManager_Tasks
Add SaveDB bit not null default 1
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TaskManager_AllTask_Get' ) )
DROP PROCEDURE dbo.A_TaskManager_AllTask_Get
GO

CREATE Procedure dbo.A_TaskManager_AllTask_Get
as

begin
	select 	
		Id,
		IdProject,
		Name,
		Active,
		Done,
		Type,
		IvrName,
		StopReason,
		TalkScript,
		PauseWhenBusy,
		PauseWhenNotRespond,
		MaxEffortCountBusy,
		MaxEffortCountNotRespond,
		MinTimeToCheckDone,
		TryConnectTime,
		ChoiceOperator,
		DeleteAfterSuccess,
		IsExtNumber,
		IsOutputTask,
		Resulted,
		ResultType,
		ResultInfo,
		ResultDateTime,
		CreationUserId,
		CreationType,
		CreationDateTime,
		StartRunDateTime,
		StopRunDateTime,
		CanAddDynamically,
		TagDouble,
		ListId,
		OperatorShowQuery,
		OperatorShowNotify,
		ProgressCall,
		ProgressCallMaxCount,
		ProgressCallKeepQueue,
		PredictCall,
		PredictCallOffsetSec,
		QueueUse,
		QueueMaxCount,
		QueueMusic,
		QueueLoyality,
		ChoiceAbonent,
		ChoiceNumber,
		ChoiceTable,
		ChoiceProgress,
		DontSetDone,
		PauseSyncListWaitingNewAbonent,
		IncomingCallsMaxCount,
		ServiceScript,
		DialCallerId,
		IncomingUpdateIfExists,
		ActiveOnHolidays,
		Code,
		PauseSyncListForcedSec,
		QueueMaxTimeMinutes,
		PredictCallErrProbability,
		QueueRandomFromPath,
		SaveDB
	
	from A_TaskManager_Tasks
end

GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TaskManager_Task_Update' ) )
DROP PROCEDURE dbo.A_TaskManager_Task_Update
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TaskManager_Task_Save' ) )
DROP PROCEDURE dbo.A_TaskManager_Task_Save
GO


Create Procedure dbo.A_TaskManager_Task_Save

	@id 				uniqueidentifier,
	@idproject			uniqueidentifier,
	@name				nvarchar(500),
	@active				int,
	@done				int,
	@type				int,
	@ivrname			nvarchar(500),
	@stopreason			int,
	@talkscript			nvarchar(500),
	@pausewhenbusy			float,
	@pausewhennotrespond		float,
	@maxeffortcountbusy		int,
	@maxeffortcountnotrespond	int,
	@mintimetocheckdone		int,
	@tryconnecttime			int,
	@choiceoperator			int,
	@deleteaftersuccess		int,
	@isextnumber			int,
	@isoutputtask			int,
	@resulted			int,
	@resulttype			int,
	@resultinfo			nvarchar(500),
	@resultdatetime			datetime,
	@creationuserid			uniqueidentifier,
	@creationtype			int,
	@creationdatetime		datetime,
	@startrundatetime		datetime,
	@stoprundatetime		datetime,
	@canadddynamically		int,
	@tagdouble			float,
	@listid				uniqueidentifier,
	@operatorshowquery		bit,
	@operatorshownotify		bit,
	@progresscall			bit,
	@progresscallmaxcount		int,
	@progresscallkeepqueue		bit,
	@predictcall			bit,
	@predictcalloffsetsec		int,
	@queueuse			bit,
	@queuemaxcount			int,
	@queuemusic			nvarchar ( 500 ),
	@queueloyality			int,
	@choiceabonents			int,
	@choicenumber			int,
	@choicetable			int,
	@choiceprogress			int,
	@dontsetdone			bit,
	@pausesynclistwaitingnewabonent int,
	@incomingcallsmaxcount		int,
	@servicescript			nvarchar ( 200 ),
	@dialcallerid			nvarchar ( 20 ),
	@incomingupdateifexists		bit,
	@activeonholidays		bit,
	@code				nvarchar ( 30 ),
	@pausesynclistforcedsec		int,
	@queuemaxtimeminutes		int,
	@predictcallerrprobability	int,
	@queuerandomfrompath		nvarchar ( 200 ),
	@savedb				bit

as

begin
	select name from A_TaskManager_Tasks where id = @id

	if ( @@rowcount > 0 )
	begin
		update A_TaskManager_Tasks
		   Set 
			IdProject			= @idproject,
			Name 				= @name, 			
			Active 				= @active, 
			Done 				= @done, 
			Type 				= @type, 
			IvrName 			= @ivrname, 
			StopReason 			= @stopreason, 
			TalkScript 			= @talkscript, 
			PauseWhenBusy 			= @pausewhenbusy, 
			PauseWhenNotRespond 		= @pausewhennotrespond, 
			MaxEffortCountBusy 		= @maxeffortcountbusy, 
			MaxEffortCountNotRespond 	= @maxeffortcountnotrespond, 
			MinTimeToCheckDone 		= @mintimetocheckdone, 
			TryConnectTime 			= @tryconnecttime, 
			ChoiceOperator			= @choiceoperator,
			DeleteAfterSuccess 		= @deleteaftersuccess, 
			IsExtNumber 			= @isextnumber, 
			IsOutputTask			= @isoutputtask,
			Resulted 			= @resulted, 
			ResultType 			= @resulttype, 
			ResultInfo 			= @resultinfo, 
			ResultDateTime 			= @resultdatetime, 
			CreationUserId 			= @creationuserid, 
			CreationType 			= @creationtype, 
			CreationDateTime 		= @creationdatetime,
			StartRunDateTime		= @startrundatetime,
			StopRunDateTime			= @stoprundatetime,
			CanAddDynamically		= @canadddynamically,	
			TagDouble			= @tagdouble,	
			ListId				= @listid,
			OperatorShowQuery		= @operatorshowquery,
			OperatorShowNotify		= @operatorshownotify,
			ProgressCall			= @progresscall,
			ProgressCallMaxCount		= @progresscallmaxcount,
			ProgressCallKeepQueue		= @progresscallkeepqueue,
			PredictCall			= @predictcall,
			PredictCallOffsetSec		= @predictcalloffsetsec,
			QueueUse 			= @queueuse,
			QueueMaxCount			= @queuemaxcount,
			QueueMusic			= @queuemusic,
			QueueLoyality			= @queueloyality,
			ChoiceAbonent			= @choiceabonents,
			ChoiceNumber			= @choicenumber,
			ChoiceTable			= @choicetable,
			ChoiceProgress			= @choiceprogress,
			DontSetDone			= @dontsetdone,
			PauseSyncListWaitingNewAbonent	= @pausesynclistwaitingnewabonent,
			IncomingCallsMaxCount		= @incomingcallsmaxcount,
			ServiceScript			= @servicescript,
			DialCallerId			= @dialcallerid,
			IncomingUpdateIfExists		= @incomingupdateifexists,
			ActiveOnHolidays		= @activeonholidays,
			Code				= @code,
			PauseSyncListForcedSec		= @pausesynclistforcedsec,
			QueueMaxTimeMinutes		= @queuemaxtimeminutes,
			PredictCallErrProbability	= @predictcallerrprobability,
			QueueRandomFromPath		= @queuerandomfrompath,
			SaveDB				= @savedb
 		   Where
			Id 				= @id
	end
	else
	begin
		insert into A_TaskManager_Tasks
		(
			Id, 
			IdProject,
			Name, 
			Active, 
			Done, 
			Type, 
			IvrName, 
			StopReason, 
			TalkScript, 
			PauseWhenBusy, 
			PauseWhenNotRespond, 
			MaxEffortCountBusy, 
			MaxEffortCountNotRespond, 
			MinTimeToCheckDone, 
			TryConnectTime, 
			ChoiceOperator, 
			DeleteAfterSuccess, 
			IsExtNumber, 
			IsOutputTask, 
			Resulted, 
			ResultType, 
			ResultInfo, 
			ResultDateTime, 
			CreationUserId, 
			CreationType, 
			CreationDateTime, 
			StartRunDateTime, 
			StopRunDateTime, 
			CanAddDynamically, 
			TagDouble, 
			ListId,
			OperatorShowQuery,
			OperatorShowNotify,
			ProgressCall,
			ProgressCallMaxCount,
			ProgressCallKeepQueue,
			PredictCall,
			PredictCallOffsetSec,
			QueueUse,
			QueueMaxCount,
			QueueMusic,
			QueueLoyality,
			ChoiceAbonent,
			ChoiceNumber,
			ChoiceTable,
			ChoiceProgress,
			DontSetDone,			
			PauseSyncListWaitingNewAbonent,
			IncomingCallsMaxCount,
			ServiceScript,
			DialCallerId,
			IncomingUpdateIfExists,
			ActiveOnHolidays,
			Code,
			PauseSyncListForcedSec,
			QueueMaxTimeMinutes,
			PredictCallErrProbability,
			QueueRandomFromPath,
			SaveDB
		) 
		Values  
		(
			@id,
			@idproject,
			@name,
			@active,
			@done,
			@type,
			@ivrname,
			@stopreason,
			@talkscript,
			@pausewhenbusy,
			@pausewhennotrespond,
			@maxeffortcountbusy,
			@maxeffortcountnotrespond,
			@mintimetocheckdone,
			@tryconnecttime,
			@choiceoperator,
			@deleteaftersuccess,
			@isextnumber,
			@isoutputtask,
			@resulted,
			@resulttype,
			@resultinfo,
			@resultdatetime,
			@creationuserid,
			@creationtype,
			@creationdatetime,
			@startrundatetime,
			@stoprundatetime,
			@canadddynamically,
			@tagdouble,
			@listid,
			@operatorshowquery,
			@operatorshownotify,
			@progresscall,
			@progresscallmaxcount,
			@progresscallkeepqueue,
			@predictcall,
			@predictcalloffsetsec,
			@queueuse,
			@queuemaxcount,
			@queuemusic,
			@queueloyality,
			@choiceabonents,
			@choicenumber,
			@choicetable,
			@choiceprogress,
			@dontsetdone,
			@pausesynclistwaitingnewabonent,
			@incomingcallsmaxcount,
			@servicescript,
			@dialcallerid,
			@incomingupdateifexists,
			@activeonholidays,
			@code,
			@pausesynclistforcedsec,
			@queuemaxtimeminutes,
			@predictcallerrprobability,
			@queuerandomfrompath,
			@savedb
		)		
	end
end


GO


