if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterCallResult' ) )
DROP PROCEDURE dbo.A_CallCenter_Temp_UpdateAfterCallResult
GO


CREATE  procedure [dbo].[A_CallCenter_Temp_UpdateAfterCallResult]
	@idchain uniqueidentifier,
	@ideffort uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@callresult int,
	@callresultinfo nvarchar ( 100 ),
	@lenqueue float,
	@timestart datetime,
	@idextline uniqueidentifier
	
as 
begin	
/*	----------------------------------------
	declare @idchain uniqueidentifier
	declare @ideffort uniqueidentifier
	declare @idinlist int
	declare @idtask uniqueidentifier
	declare @number nvarchar ( 20 )
	declare @callresult int
	declare @callresultinfo nvarchar ( 100 )
	declare @lenqueue int
	declare @timestart datetime
	declare @idextline uniqueidentifier
	Select @idchain = 'FD024817-A629-49E6-B550-19EC14787AC8', @ideffort = '1C3468C3-A6FE-4B36-9393-B813CFFB2815', 
		@idinlist = 63, @idtask = 'D48D5F57-6B93-4529-A205-A6B5063320A4', 
		@number = '  ', @callresult = 5, @callresultinfo = '', @lenqueue = 15, @timestart = '26.02.2007 12:04:57',
		@idextline = '00000000-0000-0000-0000-000000000000'
	-----------------------------------------
*/

	declare @idproject uniqueidentifier
	Select @idproject = IdProject From A_TaskManager_Tasks Where Id = @idtask

	-------------------------------------------------------------
	----     -------------------------------
	-------------------------------------------------------------

	--  
	Declare @isoutput bit
	Declare @idlist uniqueidentifier
	Select 	@isoutput = IsOutputTask,
		@idlist = ListId
	From A_TaskManager_Tasks Where Id = @idtask

	--  
	Declare @temp table 
	( 
		IdProject	uniqueidentifier,	--1
		IdTask 		uniqueidentifier,	--1
		IsOutput	bit,			--1
		IdEffort	uniqueidentifier,	--1
		IdOperator 	uniqueidentifier,	--3
		IdInList	int,			--1
		AbonentNumber 	nvarchar ( 20 ),	--1
		CallResult	int,			--1
		CallResultInfo	nvarchar ( 100 ),	--1
		DateTimeStart 	DateTime, 		--
		DateStart 	DateTime, 		--
		TimeStart 	DateTime,		--
		DateTimeStop	DateTime,
		IdConn		uniqueidentifier,	--
		IdChain 	uniqueidentifier,	--
		IdAUser		uniqueidentifier,	--
		IdBUser		uniqueidentifier,	--
		IdExtLine 	uniqueidentifier,	--2
		LenTime 	float, 			--
		LenQueue 	float,			--1
		IsBetweenOp	bit,			--3
		OpponentInfo 	nvarchar ( 100 ),	--6
		IsHandled 	bit,			--4
		IsSuccess	bit,			--5
		IsRecorded	bit,			--
		IdRecDir	int,			--
		ARecFile	nvarchar ( 100 ),	--
		BRecFile 	nvarchar ( 100 )	--
	)

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'


	--     (0, 1)
	Insert Into @temp ( IdProject, IdTask, IsOutput, IdEffort, IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop, IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, IsRecorded, IdRecDir, ARecFile, BRecFile )
	Select @idproject, @idtask, @isoutput, @ideffort, @idinlist, @number, @callresult, @callresultinfo, 
		TimeStart, 
		Cast ( Floor ( Cast ( TimeStart as Float ) ) as DateTime ),
		Cast ( Cast ( TimeStart as Float ) - FLOOR ( Cast ( TimeStart as Float ) ) as DateTime ),
		TimeStop,		
		Id, IdChain, AUserId, BUserId, 
		@idextline,
		Cast ( ( TimeStop - TimeAnswer ) as float ) * 86400 as LenTime, @lenqueue,
		IsRecorded, IdRecDir, ARecFile, BRecFile
	FROM A_Stat_Connections_1x1
	Where IdChain = @idchain

	--      ?
	If ( @@rowcount = 0 )
	   begin		
		declare @dtnow datetime
		set @dtnow = GetDate ( )

		Insert Into @temp 
		( IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 
			--IsBetweenOp, 
			IsHandled, IsSuccess
			--IsRecorded, IdRecDir, ARecFile, BRecFile 
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @dtnow,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @dtnow - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0
			--0, 0, '', ''
		)
	   end
	else
	   begin
	
		--       (3)---------
		Declare @users table ( Id uniqueidentifier )
		Insert into @users
		Select Id From A_Users
		Insert into @users Values ( 'AB000000-0000-0000-0000-000000000000' )

		Update t
		Set 	IdOperator = case when ( @isoutput > 0 ) then IdAUser else IdBUser end, 
			IsBetweenOp = 0
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id or t.IDBUser = u2.Id

		Update t
		Set 	IdOperator = IdAUser, 
			IsBetweenOp = 1
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id and t.IdBUser = u2.Id
		

		--  ? (4)--------------------------------
		Declare @cnt int
		Select @cnt = Count ( * ) FROM @temp t Where DateTimeStart > @timestart
		
		Update t
		Set IsHandled = case when ( @cnt > 0 ) then 1 else 0 end
		From @temp t

		--  ? (5)---------------------------------------
		Update t
		Set IsSuccess = case When ( @callresult = 5 ) then 1 else 0 end
		From @temp t
	   end

	--    (6)----------------
	Declare @opinfo nvarchar ( 255 )
	Select @opinfo = ''
	Update t
	Set OpponentInfo = @opinfo
	From @temp t

	--   ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]
	Select * FROM @temp

	--     
	
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name From A_TaskManager_Tasks Where Id = @idtask	

	--     
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject

	-------------------------------------------------------------
	----    -------------------------------
	-------------------------------------------------------------
	--     DBProvider


end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TaskManager_Task_ClearStatistics' ) )
DROP PROCEDURE dbo.A_TaskManager_Task_ClearStatistics
GO


Create Procedure dbo.A_TaskManager_Task_ClearStatistics
	@id uniqueidentifier
as
begin
	Delete 
	From A_TaskManager_SubTasks
	Where TaskId = @id

	Delete 
	From A_TaskManager_SubTaskEfforts
	Where TaskId = @id

	Delete 
	From A_TaskManager_SubTaskNumber
	Where TaskId = @id

	Update A_TaskManager_Tasks
	Set Done = 0
	Where Id = @id	
end
GO