----------------------------------------------------------------------------------------------------
--   (, , )   DBAutoUpdate ----------------------------
----------------------------------------------------------------------------------------------------
If not Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
Create database oktell_cc_temp
GO

If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
( 
	IdProject	uniqueidentifier NOT NULL,
	IdTask 		uniqueidentifier NOT NULL,
	IsOutput	bit NOT NULL,
	IdEffort	uniqueidentifier NOT NULL,
	IdOperator 	uniqueidentifier,
	IdInList	int NOT NULL,
	AbonentNumber 	nvarchar ( 20 ) NOT NULL,
	CallResult	int NOT NULL,
	CallResultInfo	nvarchar ( 100 ) Not NULL,
	DateTimeStart 	DateTime NOT NULL, 
	DateStart 	DateTime NOT NULL, 
	TimeStart 	DateTime NOT NULL,
	DateTimeStop	DateTime Not NULL,
	IdConn		uniqueidentifier,
	IdChain 	uniqueidentifier,	
	IdAUser		uniqueidentifier,
	IdBUser		uniqueidentifier,
	IdExtLine 	uniqueidentifier NOT NULL,
	LenTime 	float NOT NULL, 
	LenQueue 	float NOT NULL,
	IsBetweenOp	bit,
	OpponentInfo 	nvarchar ( 100 ),
	IsHandled 	bit NOT NULL,
	IsSuccess	bit Not NULL,
	IsRecorded	bit,
	IdRecDir	int,
	ALineNum	nvarchar ( 5 ),
	BLineNum	nvarchar ( 5 )
	--ARecFile	nvarchar ( 100 ),
	--BRecFile 	nvarchar ( 100 )
)
GO


if Exists ( Select * From oktell_cc_temp.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Cube_CC_EffortConnections' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'ARecFile' )

Alter Table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
Drop Column ARecFile, BRecFile
GO

if not Exists ( Select * From oktell_cc_temp.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Cube_CC_EffortConnections' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'ALineNum' )
Alter Table A_TaskManager_Tasks
Add ALineNum nvarchar ( 5 ), BLineNum nvarchar ( 5 )
GO



if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DateTimeStart' )
CREATE CLUSTERED INDEX idxCubeConnections_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	DateTimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DTStart' )
CREATE NONCLUSTERED INDEX idxCubeConnections_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	DateStart,
	TimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DateTimeStop' )
CREATE NONCLUSTERED INDEX idxCubeConnections_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	DateTimeStop
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdConn' )
CREATE NONCLUSTERED INDEX idxCubeConnections_IdConn ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	IdConn
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdChain' )
CREATE NONCLUSTERED INDEX idxCubeConnections_IdChain ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	IdChain
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdTask' )
CREATE NONCLUSTERED INDEX idxCubeConnections_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	IdTask
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdOperator' )
CREATE NONCLUSTERED INDEX idxCubeConnections_IdOperator ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	IdOperator
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdProject' )
CREATE NONCLUSTERED INDEX idxCubeConnections_IdProject ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	IdProject
) WITH FILLFACTOR = 80
GO




If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
GO

--Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
( 
	Id		int identity ( 1, 1 ) not null primary key,
	IdTask 		uniqueidentifier,
	IsOutput	bit,	
	IdOperator 	uniqueidentifier NOT NULL,
	CallResult	int,
	State		int Not Null,
	DateTimeStart 	DateTime NOT NULL, 
	DateStart 	DateTime NOT NULL, 
	TimeStart 	DateTime NOT NULL,
	DateTimeStop 	DateTime NOT NULL, 
	LenTime 	float NOT NULL	
)
GO


if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DateTimeStart' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	DateTimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DTStart' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	DateStart,
	TimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DateTimeStop' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	DateTimeStop
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_IdOperator' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_IdOperator ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	IdOperator
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_IdTask' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	IdTask
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_CallResult' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_CallResult ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	CallResult
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_State' )
CREATE NONCLUSTERED INDEX idxCubeOperatorStates_State ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
(
	State
) WITH FILLFACTOR = 80
GO



If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
( 
	IdTask 		uniqueidentifier NOT NULL,
	IdProject	uniqueidentifier Not NULL,
	DateTimeStart 	DateTime NOT NULL, 
	DateStart 	DateTime NOT NULL, 
	TimeStart 	DateTime NOT NULL,
	CountQueue	int Not Null,
	CountOperator	int Not Null,
	CountTalking	int Not Null,
	elt1WaitStart	DateTime NOT NULL,
	elt1WaitSec	int Not null,
)
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_DateTimeStart' )
CREATE CLUSTERED INDEX idxCubeQueue_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
(
	DateTimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_DTStart' )
CREATE NONCLUSTERED INDEX idxCubeQueue_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
(
	DateStart,
	TimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_DateTimeStop' )
CREATE NONCLUSTERED INDEX idxCubeQueue_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
(
	DateTimeStart
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_IdTask' )
CREATE NONCLUSTERED INDEX idxCubeQueue_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
(
	IdTask
) WITH FILLFACTOR = 80
GO

if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_IdProject' )
CREATE NONCLUSTERED INDEX idxCubeQueue_IdProject ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
(
	IdProject
) WITH FILLFACTOR = 80
GO



If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
(
	Id int not null primary key,
	Name nvarchar ( 100 ) not null
)
GO


If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
(
	Id int not null primary key,
	Name nvarchar ( 100 ) not null
)
GO


If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
(
	Id uniqueidentifier not null primary key,
	Name nvarchar ( 100 ) not null
)
GO



If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
(
	Id uniqueidentifier not null primary key,
	Name nvarchar ( 100 ) not null
)
GO


If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
Drop table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
GO

If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
(
	Id uniqueidentifier not null primary key,
	Name nvarchar ( 100 ),
	p0 int,	p1 int, p2 int, p3 int, p4 int, p5 int,
	s0 int,	s1 int, s2 int, s3 int, s4 int, s5 int,
	LastDT DateTime
)
GO

----------------------------------------------------------------------------------------------------
--       -------------------------------------------------------------
----------------------------------------------------------------------------------------------------

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_CreateDB' ) )
drop procedure dbo.A_CallCenter_Temp_CreateDB
GO

Create procedure [dbo].[A_CallCenter_Temp_CreateDB]
as 
begin
	If not Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	Create database oktell_cc_temp
end
GO


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_CreateTables' ) )
drop procedure dbo.A_CallCenter_Temp_CreateTables
GO

Create Procedure [dbo].[A_CallCenter_Temp_CreateTables]
as
begin
	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
	( 
		IdProject	uniqueidentifier NOT NULL,
		IdTask 		uniqueidentifier NOT NULL,
		IsOutput	bit NOT NULL,
		IdEffort	uniqueidentifier NOT NULL,
		IdOperator 	uniqueidentifier,
		IdInList	int NOT NULL,
		AbonentNumber 	nvarchar ( 20 ) NOT NULL,
		CallResult	int NOT NULL,
		CallResultInfo	nvarchar ( 100 ) Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop	DateTime Not Null,
		IdConn		uniqueidentifier,
		IdChain 	uniqueidentifier,	
		IdAUser		uniqueidentifier,
		IdBUser		uniqueidentifier,
		IdExtLine 	uniqueidentifier NOT NULL,
		LenTime 	float NOT NULL, 
		LenQueue 	float NOT NULL,
		IsBetweenOp	bit,
		OpponentInfo 	nvarchar ( 100 ),
		IsHandled 	bit NOT NULL,
		IsSuccess	bit Not NULL,
		IsRecorded	bit,
		IdRecDir	int,
		ALineNum	nvarchar ( 5 ),
		BLineNum	nvarchar ( 5 )
		--ARecFile	nvarchar ( 100 ),
		--BRecFile 	nvarchar ( 100 )
	)	
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
	( 
		Id		int identity ( 1, 1 ) not null primary key,
		IdTask 		uniqueidentifier NOT NULL,
		IsOutput	bit NOT NULL,	
		IdOperator 	uniqueidentifier NOT NULL,
		CallResult	int NOT NULL,
		State		int Not Null,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop 	DateTime NOT NULL,
		LenTime 	float NOT NULL	
	)
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
	( 
		IdTask 		uniqueidentifier NOT NULL,
		IdProject	uniqueidentifier Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		CountQueue	int Not Null,
		CountOperator	int Not Null,
		CountTalking	int Not Null,
		elt1WaitStart	DateTime NOT NULL,
		elt1WaitSec	int Not null,
	)
	end



	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ),
		p0 int,	p1 int, p2 int, p3 int, p4 int, p5 int,
		s0 int,	s1 int, s2 int, s3 int, s4 int, s5 int,
		LastDT DateTime
	)

end
GO



If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_FillTables' ) )
drop procedure dbo.A_CallCenter_Temp_FillTables
GO

Create Procedure [dbo].[A_CallCenter_Temp_FillTables]
as
begin
	--------      ---------------------------------------------------
	/*
	PriorHandle		= 1,
	WaitingCall		= 2,
	BackRing		= 3,
	TalkAbonent		= 4,
	TalkInside		= 5,
	WaitingInside		= 6,
	PostHandle		= 7,
	TalkOther		= 8,
	CCLunch			= 9,
	CCReady			= 10
	*/
	declare @cnt int
	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	if ( @cnt < 10 )
	   begin
		Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 1, ' ' )
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 2, '  ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 3, ' ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 4, '  ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 5, '  ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 6, '  ' )-- '  Call-'

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 7, ' ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 8, ' ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 9, '' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 10, '' )
	   end
	

	--------    ---------------------------------------------------

	/*
		Success						= 5,	//    .       
		NoSuccess					= 18,	// (   -   ).   ,      
		// 
		Undefined					= 1,	//  .   - . (    ,      -,    )
		AbonentHangOff				= 13,	//           .      
		AbortCalling				= 15,	//     (   ) (?)
		AbortQueue					= 19,	//    , ( ?)
		// 
		StopCallNumber				= 16,	//    (   ).     
		StopCallAbonent				= 17,	//   (   ).     
		ListChanged					= 12,	//    
		RemovedByOperator			= 20,	//      .       
		// 
		Busy						= 2,	//.   ,       (     ).   
		NotRespond					= 3,	// .   ,       (     ).   
		TimeNotSufficient			= 4,	//   .    ivr.     .                     .   ,  
		NeedLater					= 8,	//  (   ).     
		OperatorSkipCall			= 6,	//      "".     .
		// 
		// 
		lrOperatorAbsent			= 7,		
	*/

	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	if ( @cnt < 16 )
	   begin
		Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 5, '' )--success
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 18, '' )--nosuccess

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 1, '' )--undefined

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 13, '    ' )--abonenthangoff

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 15, '  ' )--abortcalling

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 19, '  ' )--abortqueue

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 16, '   ' )--stopcallnumber

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 17, '   ' )--stopcallabonent

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 12, '   ' )--listchanged

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 20, ' ' )--removedbyoperator

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 2, '' )--busy

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 3, ' ' )--notrespond

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 4, '  ' )--timenotsufficient

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 8, ' ' )--needlater

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 6, ' ' )--operatorskipcall

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 7, ' ' )--operatorabsent



		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 21, ' .   ' )--IncomingOutMaxCount

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 22, '    ' )--IncomingOutPeriod	

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 23, '   ' )--IncomingOutTimeTable

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 24, '    ' )--IncomingOutActivityParams

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 25, '    ' )--IncomingOutQueueTimeout

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 26, ' .  ' )--IncomingOutNoOperators

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 27, ' .  ' )--IncomingOutAllBusy

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 28, ' .     ' )--IncomingOutTaskNotFound

	   end
	
end
GO


exec A_CallCenter_Temp_FillTables
GO

----------------------------------------------------------------------------------------------------
--    call- --------------------------------------------------------
----------------------------------------------------------------------------------------------------

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterCallResult' ) )
drop procedure dbo.A_CallCenter_Temp_UpdateAfterCallResult
GO

Create procedure [dbo].[A_CallCenter_Temp_UpdateAfterCallResult]
	@idchain uniqueidentifier,
	@ideffort uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@callresult int,
	@callresultinfo nvarchar ( 100 ),
	@lenqueue float,
	@timestart datetime,
	@idextline uniqueidentifier
	
as 
begin	
/*	----------------------------------------
	declare @idchain uniqueidentifier
	declare @ideffort uniqueidentifier
	declare @idinlist int
	declare @idtask uniqueidentifier
	declare @number nvarchar ( 20 )
	declare @callresult int
	declare @callresultinfo nvarchar ( 100 )
	declare @lenqueue int
	declare @timestart datetime
	declare @idextline uniqueidentifier
	Select @idchain = 'FD024817-A629-49E6-B550-19EC14787AC8', @ideffort = '1C3468C3-A6FE-4B36-9393-B813CFFB2815', 
		@idinlist = 63, @idtask = 'D48D5F57-6B93-4529-A205-A6B5063320A4', 
		@number = '  ', @callresult = 5, @callresultinfo = '', @lenqueue = 15, @timestart = '26.02.2007 12:04:57',
		@idextline = '00000000-0000-0000-0000-000000000000'
	-----------------------------------------
*/

	declare @idproject uniqueidentifier
	Select @idproject = IdProject From A_TaskManager_Tasks Where Id = @idtask

	-------------------------------------------------------------
	----     -------------------------------
	-------------------------------------------------------------

	--  
	Declare @isoutput bit
	Declare @idlist uniqueidentifier
	Select 	@isoutput = IsOutputTask,
		@idlist = ListId
	From A_TaskManager_Tasks Where Id = @idtask

	--  
	Declare @temp table 
	( 
		IdProject	uniqueidentifier,	--1
		IdTask 		uniqueidentifier,	--1
		IsOutput	bit,			--1
		IdEffort	uniqueidentifier,	--1
		IdOperator 	uniqueidentifier,	--3
		IdInList	int,			--1
		AbonentNumber 	nvarchar ( 20 ),	--1
		CallResult	int,			--1
		CallResultInfo	nvarchar ( 100 ),	--1
		DateTimeStart 	DateTime, 		--
		DateStart 	DateTime, 		--
		TimeStart 	DateTime,		--
		DateTimeStop	DateTime,
		IdConn		uniqueidentifier,	--
		IdChain 	uniqueidentifier,	--
		IdAUser		uniqueidentifier,	--
		IdBUser		uniqueidentifier,	--
		IdExtLine 	uniqueidentifier,	--2
		LenTime 	float, 			--
		LenQueue 	float,			--1
		IsBetweenOp	bit,			--3
		OpponentInfo 	nvarchar ( 100 ),	--6
		IsHandled 	bit,			--4
		IsSuccess	bit,			--5
		IsRecorded	bit,			--
		IdRecDir	int,			--
		ALineNum	nvarchar ( 5 ),		--
		BLineNum	nvarchar ( 5 )		--
		--ARecFile	nvarchar ( 100 ),	--
		--BRecFile 	nvarchar ( 100 )	--
	)

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'


	--     (0, 1)
	Insert Into @temp ( IdProject, IdTask, IsOutput, IdEffort, IdInList, AbonentNumber, CallResult, 
				CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop, 
				IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, 
				IsRecorded, IdRecDir, ALineNum, BLineNum ) --ARecFile, BRecFile )
	Select @idproject, @idtask, @isoutput, @ideffort, @idinlist, @number, @callresult, @callresultinfo, 
		TimeStart, 
		Cast ( Floor ( Cast ( TimeStart as Float ) ) as DateTime ),
		Cast ( Cast ( TimeStart as Float ) - FLOOR ( Cast ( TimeStart as Float ) ) as DateTime ),
		TimeStop,		
		Id, IdChain, AUserId, BUserId, 
		@idextline,
		Cast ( ( TimeStop - TimeAnswer ) as float ) * 86400 as LenTime, @lenqueue,
		IsRecorded, IdRecDir, ALineNum, BLineNum --ARecFile, BRecFile
	FROM A_Stat_Connections_1x1
	Where IdChain = @idchain

	--      ?
	If ( @@rowcount = 0 )
	   begin		
		declare @dtnow datetime
		set @dtnow = GetDate ( )

		Insert Into @temp 
		( 	IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 
			--IsBetweenOp, 
			IsHandled, IsSuccess
			--IsRecorded, IdRecDir, ARecFile, BRecFile 
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @dtnow,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @dtnow - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0
			--0, 0, '', ''
		)
	   end
	else
	   begin
	
		--       (3)---------
		Declare @users table ( Id uniqueidentifier )
		Insert into @users
		Select Id From A_Users
		Insert into @users Values ( 'AB000000-0000-0000-0000-000000000000' )

		Update t
		Set 	IdOperator = case when ( @isoutput > 0 ) then IdAUser else IdBUser end, 
			IsBetweenOp = 0
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id or t.IDBUser = u2.Id

		Update t
		Set 	IdOperator = IdAUser, 
			IsBetweenOp = 1
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id and t.IdBUser = u2.Id
		

		--  ? (4)--------------------------------
		Declare @cnt int
		Select @cnt = Count ( * ) FROM @temp t Where DateTimeStart > @timestart
		
		Update t
		Set IsHandled = case when ( @cnt > 0 ) then 1 else 0 end
		From @temp t

		--  ? (5)---------------------------------------
		Update t
		Set IsSuccess = case When ( @callresult = 5 ) then 1 else 0 end
		From @temp t
	   end

	--    (6)----------------
	Declare @opinfo nvarchar ( 255 )
	Select @opinfo = ''
	Update t
	Set OpponentInfo = @opinfo
	From @temp t

	--   ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]
	Select * FROM @temp

	--     
	
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name From A_TaskManager_Tasks Where Id = @idtask	

	--     
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject

	-------------------------------------------------------------
	----    -------------------------------
	-------------------------------------------------------------
	--     DBProvider


end
GO



If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_AddMissedIncomingCallInfo' ) )
drop procedure dbo.A_CallCenter_Temp_AddMissedIncomingCallInfo
GO

Create procedure [dbo].[A_CallCenter_Temp_AddMissedIncomingCallInfo]
	@idtask uniqueidentifier,	
	@ideffort uniqueidentifier,
	@idinlist int,
	@abonentnumber nvarchar ( 20 ),
	@callresult int,
	@timestart datetime, 
	@timestop datetime,
	@idchain uniqueidentifier,
	@idextline uniqueidentifier
	
as 
begin
	Declare @idproject uniqueidentifier
	Set @idproject = '00000000-0000-0000-0000-000000000000'
	Select @idproject = IdProject 
	From A_TaskManager_Tasks
	Where Id = @idtask

	Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]
	(
		IdProject,
		IdTask,
		IsOutput,
		IdEffort,
		IdInList,
		AbonentNumber,
		CallResult,
		CallResultInfo,
		DateTimeStart,
		DateStart,
		TimeStart,
		DateTimeStop,
		IdChain,
		IdExtLine,
		LenTime,
		LenQueue,
		IsHandled,
		IsSuccess
	)
	Values 
	( 
		@idproject,
		@idtask,
		0,
		@ideffort,
		@idinlist,
		@abonentnumber,
		@callresult,
		'',		
		@timestart, 
		Cast ( Floor ( Cast ( @timestart as Float ) ) as DateTime ),
		Cast ( Cast ( @timestart as Float ) - FLOOR ( Cast ( @timestart as Float ) ) as DateTime ),
		@timestop,
		@idchain,
		@idextline,
		Cast ( @timestop - @timestart as float ) * 86400,
		Cast ( @timestop - @timestart as float ) * 86400,
		0,
		0
	)
end
GO



If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_AddInfoToCubeQueue' ) )
drop procedure dbo.A_CallCenter_Temp_AddInfoToCubeQueue
GO

Create procedure [dbo].[A_CallCenter_Temp_AddInfoToCubeQueue]
	@idtask uniqueidentifier,	
	@idproject uniqueidentifier,
	@dtnow datetime,
	@cntqueue int,
	@cnttalk int,
	@cntopers int,
	@waitstart datetime,
	@waitsec float
as
begin
	Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
	( 
		IdTask,
		IdProject,
		DateTimeStart, 
		DateStart, 
		TimeStart,
		CountQueue,
		CountOperator,
		CountTalking,
		elt1WaitStart,
		elt1WaitSec
	)
	Values
	(
		@idtask,
		@idproject,
		@dtnow,
		Cast ( Floor ( Cast ( @dtnow as float ) ) as DateTime ),
		Cast ( Cast ( @dtnow as float ) - Floor ( Cast ( @dtnow as float ) ) as DateTime ),
		@cntqueue,
		@cntopers,
		@cnttalk,
		@waitstart,
		@waitsec
	)
end
GO




If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateOperatorStates' ) )
drop procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
GO


Create Procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
as
begin

set dateformat dmy

declare @fulllogdt DateTime
declare @logdt DateTime
declare @operlogdt DateTime

Declare @idempty uniqueidentifier
Set @idempty = '00000000-0000-0000-0000-000000000000'
Declare @dtnow DateTime
Set @dtnow = GetDate ()


--print '--------------------------------------start-- ms:  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )
Set @fulllogdt = GetDate ( )

--      
Declare @dtsall DateTime
Select @dtsall = Min ( LastDT ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
if ( @dtsall is null )
	Set @dtsall = DateAdd ( d, -10, GetDate ( ) )

Declare @sc table ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )
Insert Into @sc
	Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId
	From A_Stat_Connections_1x1 sc
	Where TimeStart > @dtsall Or TimeStop > @dtsall Or TimeStop is null

Declare @ush table ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) )
Insert into @ush
	Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '' end
	From A_CallCenter_UserStateHistory
	Where ( TimeEnter > @dtsall Or TimeLeave > @dtsall Or TimeLeave is null )

Declare @uit table ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )
Insert into @uit
	Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask
	Where TimeStart >= @dtsall or TimeStopPost >= @dtsall or TimeStopPost is null
	
	

--print '-----shared-sc- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )

--   
declare @settable table ( Id uniqueidentifier, Name nvarchar ( 100 ) )
Insert into @settable
	Select Id, Name From A_Users u 
		Inner join A_UserParams up on u.Id = up.IdUser
	Where IsOperator = 1

Declare ucursor Cursor LOCAL FAST_FORWARD For 
	Select Id, Name From @settable

declare @idoperator uniqueidentifier, @nameoperator nvarchar ( 100 )	

Set @operlogdt = GetDate ( )
Open ucursor
Fetch Next From ucursor Into @idoperator, @nameoperator

While ( @@fetch_status = 0 )
   begin

	Declare @id uniqueidentifier
	Select @id = Id from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Where Id = @idoperator
	if ( @@rowcount = 0 )
		Insert 
		Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
		( Id, Name ) Values ( @idoperator, @nameoperator )
				
				
	--     
	Declare @dts DateTime, @dts1 DateTime

	Select @dts = Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	Where IdOperator = @idoperator	
	
	Select @dts1 = LastDT
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	Where Id = @idoperator
	
	if ( @dts1 > @dts ) or ( @dts is null )
		Set @dts = @dts1
	
	if ( @dts is null )
		set @dts = '01.01.2000'

	--print '-----def------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @operlogdt = GetDate ( )


	--          
	if ( Cast ( @dtnow - @dts as float ) * 1440 > 1 )
	   begin		

		/*
		PriorHandle		= 1,
		WaitingCall		= 2,
		BackRing		= 3,
		TalkAbonent		= 4,
		TalkInside		= 5,
		InsideTalk		= 6,
		PostHandle		= 7,
		TalkOther		= 8,
		CCLunch			= 9,
		CCReady			= 10,
		System			= 11
		*/

		-----------------------------------------------------
		--   (   ) ----------
		-----------------------------------------------------
		Declare @tempo2 table
		(
			State int,
			Priority int,
			DateTimeStart DateTime,
			DateTimeStop DateTime,
			Id int Identity ( 1, 1 ) not null primary key,
			Info nvarchar ( 100 )
		)

		Delete From @tempo2

		Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
			Select State, Case when State in ( 3, 4 ) then 2 else 4 end, 
				TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
			From @ush
			Where OperatorId = @idoperator
				And State in ( 2, 3, 4 )
				And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )
		
		Update @tempo2
		Set State = Case When Priority = 2 then 9 else 10 end

		
		--      - 
		if ( @@rowcount > 0 )
		begin	
			--      
			Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
				Select 11, 5, TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
				From @ush
				Where OperatorId = @idoperator
					And State = 0
					And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )

			Update @tempo2			
			Set 	DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				DateTimeStop = Case When DateTimeStop > @dtnow then @dtnow else DateTimeStop end
			

			--print '-----t2--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

	
			-----------------------------------------------------
			--   (   ) -----
			-----------------------------------------------------
			Declare @tempo1 table
			(
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				StateCat	int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				IdEffort	uniqueidentifier,
				Priority	int,
				Id		int identity ( 1, 1 ) not null primary key
			)

			Delete From @tempo1
			
			Declare @uito table 
			(
				Id uniqueidentifier,
				UserId uniqueidentifier,
				TaskId uniqueidentifier,	
				EffortId uniqueidentifier,
				TimeStart DateTime,
				TimeStopPrior DateTime,
				TimeStopWaitCall DateTime,
				TimeStopBackCall DateTime,
				TimeStopDialog DateTime,
				TimeStopPost DateTime
			)

			Delete From @uito

			Insert Into @uito
			Select *
			From @uit
			Where UserId = @idoperator
				--And ( TimeStart > @dts or TimeStopPost > @dts or TimeStopPost is null )

			--print '-----t1-crtemp-- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 1, 0, 
					TimeStart, 
					TimeStopPrior
				From @uito--#t
				Where Cast ( TimeStopPrior - TimeStart as float ) * 86400 > 0
			
			--print '-----t1-cra----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
			
			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 2, 0, 
					TimeStopPrior, 
					TimeStopWaitCall
				From @uito--#t
				Where Cast ( TimeStopWaitCall - TimeStopPrior as float ) * 86400 > 0

			--print '-----t1-crb----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 3, 0, 
					TimeStopWaitCall, 
					TimeStopBackCall
				From @uito--#t
				Where Cast ( TimeStopBackCall - TimeStopWaitCall as float ) * 86400 > 0

			--print '-----t1-crc----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 6, 0, 
					TimeStopBackCall, 
					TimeStopDialog
				From @uito--#t
				Where Cast ( TimeStopDialog - TimeStopBackCall as float ) * 86400 > 0

			--print '-----t1-crd----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 7, 0, 
					TimeStopDialog,
					TimeStopPost
				From @uito--#t
				Where Cast ( IsNull ( TimeStopPost, @dtnow ) - IsNull ( TimeStopDialog, @dtnow ) as float ) * 86400 > 0

			--print '-----t1-cre----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			--       
			Update @tempo1 
			Set 	DateTimeStart = case When ( DateTimeStart < @dts ) then @dts else DateTimeStart end,
		 		DateTimeStop = case When ( DateTimeStop > @dtnow ) then @dtnow else DateTimeStop end

			--   / 
			Update tmpo
			Set IsOutput = t.IsOutputTask
			From @tempo1 tmpo, A_TaskManager_Tasks t
			Where tmpo.IdTask = t.Id

			--    
			Update tmpo
			Set CallResult = tic.CallResult
			From @tempo1 tmpo, A_TaskManager_Task_IncomingCalls tic
			Where tmpo.IdEffort = tic.Id

			Update tmpo
			Set CallResult = ste.EResult
			From @tempo1 tmpo, A_TaskManager_SubTaskEfforts ste
			Where tmpo.IdEffort = ste.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo1

			--Select * FROM A_Taskmanager_UserInTask


			--print '-----t1-up------ ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
	
			-----------------------------------------------------
			--   () -----------------------
			-----------------------------------------------------
			
			Declare @tempo3 table
			(
				State int,
				Priority int,
				DateTimeStart DateTime,
				DateTimeStop DateTime,
				Id int identity ( 1, 1 ) not null primary key
			)
			
			Delete From @tempo3
						
			Insert into @tempo3
				Select 8, 0, TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
					And FromCC = 0
				/*
				Select Case When FromCC = 0 then 8 When IsBetweenUsers = 1 then 5 else 4 end, 0,
					TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
				*/

			Update @tempo3
			Set DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				Priority = Case When State = 8 then 3 else 0 end
			
			
			--print '-----t3--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-----------------------------------------------------
			--     ---------------------
			-----------------------------------------------------

	--		Select * FROM @tempo1
	--		Select * FROM @tempo2
	--		Select * From @tempo3

	--		Select * FROM @tempo1 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * FROM @tempo2 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * From @tempo3 Where DateTimeStart > '13.02.2007' Order by DateTimeStart

		
			Declare @tempo table
			(
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete from @tempo

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStart, 0
				From @tempo1

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStop, 1
				From @tempo1

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStart, 0
				From @tempo2

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStop, 1
				From @tempo2

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStart, 0
				From @tempo3

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStop, 1
				From @tempo3
			
			--Select * From @tempo Order By DT

			--print '-----tpt-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		
			-----------------------------------------------------
			--   -------------------------------
			-----------------------------------------------------

			declare @res table ( TableN int, Id int, State int, Priority int, DStart DateTime, DStop DateTime )
			Delete From @res

			--        
			-- : 	0 -    (  )
			--		1 -     (  )
			--		2 - 
			--		3 -  
			--		4 -   
			--		5 -   
			declare @p0 int, @p1 int, @p2 int, @p3 int, @p4 int, @p5 int
			declare @s0 int, @s1 int, @s2 int, @s3 int, @s4 int, @s5 int
			declare @t0 int, @t1 int, @t2 int, @t3 int, @t4 int, @t5 int
			declare @i0 int, @i1 int, @i2 int, @i3 int, @i4 int, @i5 int

			Select @p0 = 0, @p1 = 0, @p2 = 0, @p3 = 0, @p4 = 0	
			Select 	@p0 = IsNull ( P0, 0 ), @p1 = IsNull ( P1, 0 ), @p2 = IsNull ( P2, 0 ), @p3 = IsNull ( P3, 0 ), @p4 = IsNull ( P4, 0 ), @p5 = IsNull ( P5, 0 ),
				@s0 = IsNull ( S0, 0 ), @s1 = IsNull ( S1, 0 ), @s2 = IsNull ( S2, 0 ), @s3 = IsNull ( S3, 0 ), @s4 = IsNull ( S4, 0 ), @s5 = IsNull ( S5, 0 )
			From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
			Where Id = @idoperator
		
			--   	
			Declare @tempo_ordered table
			(
				Id int identity ( 1, 1 ) not null,
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete From @tempo_ordered

			Insert into @tempo_ordered ( TableN, TableID, State, Priority, DT, NK )
				Select TableN, TableID, State, Priority, DT, NK From @tempo
				Order By DT

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * From @tempo_ordered


			Declare @tempo_joined table
			(
				s1 int, p1 int, s2 int, p2 int, dstart datetime, dstop datetime, nk1 bit, nk2 bit, t1 int, t2 int, i1 int, i2 int
			)
			Delete From @tempo_joined
		
			Insert into @tempo_joined 
				Select t1.State as s1, t1.Priority as p1, t2.State as s2, t2.Priority as p2,
					t1.DT as dstart, t2.DT as dstop, t1.NK as nk1, t2.NK as nk2,
					t1.TableN, t2.TableN, t1.TableID, t2.TableID
				From @tempo_ordered t1
					Inner join @tempo_ordered t2 on t1.Id + 1 = t2.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo_joined

			--print '-----tjnd------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			--       
			Declare tcursor Cursor LOCAL FAST_FORWARD For 
				Select s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
				From @tempo_joined
				--Where dstart > '21.02.2007'

			declare @st1 int, @pr1 int, @st2 int, @pr2 int, @dstart DateTime, @dstop DateTime, @nk1 bit, @nk2 bit, @tb1 int, @tb2 int, @id1 int, @id2 int
			declare @actualst int, @actualpr int, @actualt int, @actualid int
			declare @lastst int, @lastpr int, @lastt int, @lastid int, @lastdstart datetime, @lastdstop datetime
			declare @dontinsert bit, @updatelast bit
			declare @insertindex int

			set @insertindex = 0
			set @lastt = 0
			set @dontinsert = 1 --     (   )   
		
			Open tcursor
			Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2

			While @@FETCH_STATUS = 0
   			Begin
				----print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
				--	Cast ( @lastst as nvarchar ( 10 ) ) + '  ' + Cast ( @lastpr as nvarchar ( 10 ) )    + '  //  ' + 
				--	Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) )
			
				---    -----		
				if ( @nk1 = 0 )
				begin			
					if ( @pr1 = 0 )
					begin
			    			set @p0 = @p0 + 1
				    		set @s0 = @st1				
						set @t0 = @tb1	
						set @i0 = @id1
					end
					else if ( @pr1 = 1 )
					begin
				    		set @p1 = @p1 + 1
				    		set @s1 = @st1
						set @t1 = @tb1
						set @i1 = @id1
					end
					else if ( @pr1 = 2 )
					begin
			    			set @p2 = @p2 + 1
				    		set @s2 = @st1
						set @t2 = @tb1
						set @i2 = @id1
					end
					else if ( @pr1 = 3 )
					begin
				    		set @p3 = @p3 + 1
				    		set @s3 = @st1
						set @t3 = @tb1
						set @i3 = @id1
					end
					else if ( @pr1 = 4 )
					begin
			    			set @p4 = @p4 + 1
				    		set @s4 = @st1
						set @t4 = @tb1
						set @i4 = @id1
					end
					else if ( @pr1 = 5 )
					begin
						set @p5 = @p5 + 1
						set @s5 = @st1
						set @t5 = @tb1
						set @i5 = @id1
					end
				end

				---    
				set @dontinsert = 0
				if ( @p0 > 0 )
				begin
					set @actualst = @s0
					set @actualpr = 0
					set @actualt = @t0
					set @actualid = @i0
				end
				else if ( @p1 > 0 )
				begin
					set @actualst = @s1
					set @actualpr = 1
					set @actualt = @t1
					set @actualid = @i1
				end
				else if ( @p2 > 0 )
				begin
					set @actualst = @s2
					set @actualpr = 2
					set @actualt = @t2
					set @actualid = @i2
				end
				else if ( @p3 > 0 )
				begin
					set @actualst = @s3
					set @actualpr = 3
					set @actualt = @t3
					set @actualid = @i3
				end
				else if ( @p4 > 0 )
				begin
					set @actualst = @s4
					set @actualpr = 4
					set @actualt = @t4
					set @actualid = @i4
				end
		
				--     4  2  (  )
				--        
				if (( @p4 = 0 ) and ( @p2 = 0 )) or ( @p5 = 0 )
 				set @dontinsert = 1
			
				--print Convert ( nvarchar ( 10 ), @dstart, 108 ) + ' ' + convert ( nvarchar ( 10 ), @dstop, 108 ) + ' state1=' + cast ( @st1 as nvarchar ( 10 ) ) + ' state2=' + cast ( @st2 as nvarchar ( 10 ) ) + ' nk1=' + cast ( @nk1 as nvarchar ( 10 ) ) + ' nk2=' + cast ( @nk2 as nvarchar ( 10 ) )

				--     			
				set @updatelast = 0
				--     ,    -  
				if ( @lastt = 0 )
				begin
					--print 'lastt = 0'
					set @updatelast = 1			
				end
				--          -   
				else if ( @dontinsert = 0 ) and ( @actualst = @lastst )
				begin
					--print 'lastst = actualst' + Cast ( @actualst as nvarchar ( 10 ))
					set @lastdstop = @dstop
				end		
				--       
				else
				begin
					--print 'insert time=' + Convert ( nvarchar ( 10 ), @lastdstart, 108 ) + '-' + convert ( nvarchar ( 10 ), @lastdstop, 108 ) + ' state=' + cast ( @lastst as nvarchar ( 10 ) )
					if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
						Insert Into @res
						Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )
				
					set @updatelast = 1	
				end
			
				if ( @updatelast = 1 )
				begin
					if ( @dontinsert = 1 )
			  			set @lastt = 0
					else
 					begin
						set @lastt = @actualt
						set @lastid = @actualid
						set @lastst = @actualst
						set @lastpr = @actualpr
						set @lastdstart = @dstart
						set @lastdstop = @dstop
					end
				end
			
		
				---    () -----
				if ( @nk2 = 1 )
				begin
					if ( @pr2 = 0 )
						set @p0 = @p0 - 1
					else if ( @pr2 = 1 )
						set @p1 = @p1 - 1
					else if ( @pr2 = 2 )
						set @p2 = @p2 - 1
					else if ( @pr2 = 3 )
						set @p3 = @p3 - 1
					else if ( @pr2 = 4 )
						set @p4 = @p4 - 1
					else if ( @pr2 = 5 )
						set @p5 = @p5 - 1
				end
			
				Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2
			End


			--      ,    
			if ( @dontinsert = 0 )
				if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
					Insert Into @res
					Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )

			Close tcursor
			Deallocate tcursor

			--print '-----curs------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-------------------------------------------------------------------------------------------------
			--          -------------------------------
			-------------------------------------------------------------------------------------------------

			--       (         )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
				Set 	p0 = @p0, p1 = @p1, p2 = @p2, p3 = @p3, p4 = @p4, p5 = @p5,
					s0 = @s0, s1 = @s1, s2 = @s2, s3 = @s3, s4 = @s4, s5 = @s5,
					LastDT = @dtnow
			Where Id = @idoperator

			Declare @operatorstates table
			(
				Id		int identity ( 1, 1 ) not null primary key,
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float
			)

			Delete From @operatorstates

			Insert into @operatorstates ( IdOperator, State, DateTimeStart, DateTimeStop, DateStart, TimeStart, LenTime, 
				IdTask, IsOutput, CallResult )
			Select @idoperator, r.State, r.DStart, r.DStop,
				Cast ( Floor ( Cast ( DStart as Float ) ) as DateTime ),
				Cast ( Cast ( DStart as float ) - Floor ( Cast ( DStart as Float ) ) as DateTime ),				
				Cast ( DStop - DStart as float ) * 86400,
				IdTask, IsOutput, CallResult
			From @res r
				Left join @tempo1 t1 on t1.Id = r.Id and r.TableN = 1


			--     (     -        )
			declare @crupdate int
			Select top 1 @crupdate = CallResult 
			From @operatorstates
			Where not IdTask is null	
			
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
			Set CallResult = @crupdate
			Where IdOperator = @idoperator and not IdTask is null and CallResult is null


			--    
			declare @idt1 int, @state1 int, @dtstart1 DateTime, @dtstop1 DateTime
			
			Select @idt1 = Max ( Id ) 
			From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
			Where IdOperator = @idoperator

			if ( not @idt1 is null )
			   begin
				Select @state1 = State, @dtstart1 = DateTimeStart, @dtstop1 = DateTimeStop 
				From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
				Where Id = @idt1
				
				declare @idt2 int, @state2 int, @dtstart2 DateTime, @dtstop2 DateTime
				Select Top 1 @idt2 = Id, @state2 = State, @dtstart2 = DateTimeStart, @dtstop2 = DateTimeStop
				From @operatorstates
				Order By DateTimeStart

				if ( @state1 = @state2 ) and ( @dtstart2 = @dtstop1 )
				   begin
					Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
					Set 	DateTimeStop = @dtstop2,
						LenTime = Cast ( @dtstop2 - @dtstart1 as float ) * 86400
					Where Id = @idt1

					Delete From @operatorstates
					Where Id = @idt2
			   	   end
			   end

		
			--  
			Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
				( IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime )			
				Select IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime
				From @operatorstates
			
			--print '-----ins-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

		end
		else
		begin
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set LastDT = @dtnow
			Where Id = @idoperator
		end



	   end
	
	--print '--------------------------------------oper--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @logdt = GetDate ( )
	--Set @operlogdt = GetDate ( )

	Fetch Next From ucursor Into @idoperator, @nameoperator
   end

Close ucursor
Deallocate ucursor

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
--Select * FROM [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Order by Datetimestart

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
end
GO







If exists ( Select * From sysobjects where id = object_id ( 'A_Timer_MinuteProc' ) )
drop procedure dbo.A_Timer_MinuteProc
GO


Create Procedure dbo.[A_Timer_MinuteProc]
as
begin
	exec A_CallCenter_Temp_UpdateOperatorStates
end
GO





If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_OnLoad' ) )
drop procedure dbo.A_CallCenter_Temp_OnLoad
GO

CREATE PROCEDURE dbo.[A_CallCenter_Temp_OnLoad]
as
begin
	exec A_CallCenter_Temp_CreateDB
	exec A_CallCenter_Temp_CreateTables
	exec A_CallCenter_Temp_FillTables
	
	--      (  )     
	--   ?
	Declare @dtnow DateTime 
	Set @dtnow = GetDate ( )
	Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Set 	p0 = 0, p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 0,		
		LastDT = @dtnow
end
GO




