
if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Clients__GetJournal' ) )
DROP PROCEDURE dbo.A_Clients__GetJournal
GO



CREATE procedure [dbo].[A_Clients__GetJournal]
	@idclient	uniqueidentifier,
	@dstart		datetime,
	@dstop		datetime,
	@tstart		datetime,
	@tstop		datetime,
	@idoperator	uniqueidentifier,
	@iduser		uniqueidentifier
as
begin
	
	Declare @tstartfloat float
	Declare @tstopfloat float
	Set @tstartfloat =  Convert ( float, @tstart ) - FLOOR ( Convert ( float, @tstart ) )
	Set @tstopfloat =  Convert ( float, @tstop ) - FLOOR ( Convert ( float, @tstop ) )

	--    

	Declare @userspermitted table ( Id uniqueidentifier )
	Insert into @userspermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @userspermitted ( Id ) Values ( @iduser )

/*
	Declare @usersdenied table ( Id uniqueidentifier )
	Insert into @usersdenied
		Select Id 
		From A_Users
		Where 	Id != @iduser and 
			Id not in ( 	Select UserB 
					From A_UserControls 
					Where UserA = @iduser )
*/

	Declare @linespermitted table ( Id uniqueidentifier )
	Insert into @linespermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @linespermitted
		Select Id 
		From A_ServerExtLines

	---  

	Select * FROM 
	(
/*
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length, 
			AStr as OperatorStr, 
			case when ( u.Id is null ) then sc.IsRecorded else 0 end as IsRecorded, 
			sc.ARecFile, 
			sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @usersdenied u on sc.AUserId = u.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null ) then sc.IsRecorded else 0 end as IsRecorded, 
			sc.ARecFile, 
			sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @usersdenied u on sc.BUserId = u.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )
*/

		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length, 
			AStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile,
			--sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @userspermitted u on sc.AUserId = u.Id
			Left join @linespermitted l on sc.ALineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile, 
			--sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc 
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @userspermitted u on sc.BUserId = u.Id
			Left join @linespermitted l on sc.BLineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )		

			
	) a

	Order By TimeStart Desc

		
end
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Stat_MyCalls_Get' ) )
DROP PROCEDURE dbo.A_Stat_MyCalls_Get
GO


CREATE procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'

*/
	Declare @ids table ( id uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, Length DateTime, Number nvarchar ( 50 ), AbonentName nvarchar ( 100 ), 
				IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ), BLineNum nvarchar ( 5 ), --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ), BOutNumber nvarchar ( 50 ), 
				AStr nvarchar ( 100 ), BStr nvarchar ( 100 ) )
	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, '', '',
			IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber, AStr, BStr
		From A_Stat_Connections_1x1 sc
			inner join @ids ids on sc.Id = ids.id

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = '' and o.Number = ''

	Select Id, Media, Type, TimeStart, Length, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir--, ARecFile, BRecFile
	From @output
	Where Media = @media or @media = 0
	Order By TimeStart Desc

end
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_MobileControl_Journal_Get' ) )
DROP PROCEDURE dbo.A_MobileControl_Journal_Get
GO



CREATE   procedure [dbo].[A_MobileControl_Journal_Get]
	@dstart 	datetime,
 	@dstop 		datetime,
 	@tstart 	datetime,
 	@tstop 		datetime,
	@number		nvarchar ( 50 ),
	@userid		uniqueidentifier
as
begin



---   ---------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare @number nvarchar ( 50 )
declare @userid uniqueidentifier


set @dstart = '2006/06/01'
set @dstop = '2006/07/19'
set @tstart = '10:11:00'
set @tstop = '12:20:00'
set @number = ''
set @userid = '00000000-0000-0000-0000-000000000000'
*/

---------------------------------



declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


--   
declare @chains table ( IdChain uniqueidentifier, TimeStop DateTime )
if ( @number = '' )
	insert into @chains
		Select IdChain, Max ( TimeStop ) as TimeStop
		From A_Stat_Connections_1x1 sc
		Where TimeStop > @dstart and TimeStart < @dstop
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
--			and BOutNumber like '%' + @number + '%'
		Group By IdChain
else
	insert into @chains
		Select IdChain, Max ( TimeStop ) as TimeStop
		From A_Stat_Connections_1x1 sc
		Where TimeStop > @dstart and TimeStart < @dstop
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
			and BOutNumber like '%' + @number + '%'
		Group By IdChain

declare @united table ( id uniqueidentifier, name nvarchar ( 100 ) )
Insert Into @united
	Select Id, Name From A_Users
	Union
	Select Id, ( Cast ( SystemNum as nvarchar ( 10 ) ) + ' ' + Caption ) as Name From A_ServerIntLines

Select sc.Id as connectionid, sc.TimeStart, u.Name as username, u.Id as userid, mcd.mask, mcd.Description, sc.BOutNumber, case When mcf.mask is null then 1 else 0 end as denied, CAST ( CAST ( ch.TimeStop - sc.TimeStart as DateTime ) as float ) as Length, sc.IsRecorded, sc.IdRecDir, sc.ALineNum, sc.BLineNum--, sc.ARecFile, sc.BRecFile 
From A_Stat_Connections_1x1 sc
	inner join A_MobileControlMaskDenied mcd on sc.BOutNumber like REPLACE ( mcd.mask, '?', '_' )
	inner join @united u on sc.AUserId = u.Id or sc.ALineId = u.Id
	inner join @chains ch on sc.IdChain = ch.IdChain
	Left Join A_MobileControlMaskFree mcf on sc.BOutNumber like REPLACE ( mcf.mask, '?', '_' )
Where ( u.Id = @userid or @userid = '00000000-0000-0000-0000-000000000000' )
Order By sc.TimeStart

End
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TalkResults_Filter_Journal' ) )
DROP PROCEDURE dbo.A_TalkResults_Filter_Journal
GO



CREATE   procedure [dbo].[A_TalkResults_Filter_Journal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@ResultValue int = NULL,
	@ResultMask int = NULL,
	@ResultText nvarchar(500) = NULL,
	@CardId uniqueidentifier,
	@showefforts	int
as
begin

declare @tstart2 DateTime
declare @tstop2 DateTime
set @tstart2 = Cast ( Cast ( @tstart as float ) - Floor ( Cast ( @tstart as float ) ) as DateTime )
set @tstop2 = Cast ( Cast ( @tstop as float ) - Floor ( Cast ( @tstop as float ) ) as DateTime )


declare @tmp_card_result table(TaskId  uniqueidentifier, IdChain uniqueidentifier)
delete 	@tmp_card_result

if @ResultValue is not null
	Insert into @tmp_card_result(TaskId,IdChain)	
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Radio stcr on sta.IdAlgVisit=stcr.IdAlgVisit
		Where IdCard = @CardId and ChosenResult = @ResultValue


if @ResultMask is not null 
begin
	Insert into @tmp_card_result ( TaskId, IdChain )
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Check stcc on sta.IdAlgVisit = stcc.IdAlgVisit
			inner join A_BigInt big on big.K & ChosenResult = big.K
		Where IdCard = @CardId 
			and big.K = @ResultMask
end


if @ResultText is not null 
begin
	Insert into @tmp_card_result(TaskId,IdChain)		
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Text stct on sta.IdAlgVisit=stct.IdAlgVisit
		Where IdCard=@CardId and ChosenResult=@ResultText
end


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, IdOperator uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ), LenTime float, IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ), BLineNum nvarchar ( 5 )) --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ) )

Insert into @te

	Select IdEffort, IdChain, IdTask, IdOperator, AbonentNumber, DateTimeStart, CallResult, CallResultInfo, LenTime, IsRecorded, IdRecDir, ALineNum, BLineNum --ARecFile, BRecFile
	From [oktell_cc_temp].dbo.A_Cube_CC_EffortConnections ec
	Where 	(DateStart between @dstart and @dstop)
		and (TimeStart between @tstart2 and @tstop2)
		and ec.IdTask = @taskid
		and AbonentNumber like '%' + @number + '%'
		and Exists ( Select IdChain From @tmp_card_result Where IdChain = ec.IdChain )


Select te.IdChain, te.Number, IsNull ( u.Name, '?' ) as FullName, te.CallTime, case when ( len ( te.Info ) > 0 ) then ( trt.Name + ' (' + te.Info + ')') else trt.Name end as Info, Cast ( te.LenTime / 86400 as DateTime ) as Length, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( IdRecDir, 0 ) as IdRecDir, IsNull ( ALineNum, '') as ALineNum, IsNull ( BLineNum, '') as BLineNum --IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile 
From @te te
	Left join A_Users u on u.Id = te.IdOperator
	Left join [oktell_cc_temp].[dbo].A_Cube_CC_Cat_TaskResultTypes trt on trt.Id = te.Result
Where te.IdOperator is null or te.IdOperator != 'AB000000-0000-0000-0000-000000000000'

end

GO



if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Stat_Connections_1x1' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'ARecFile' )

Alter Table [dbo].[A_Stat_Connections_1x1] 
Drop Column ARecFile, BRecFile
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Stat_Connection_Start' ) )
DROP PROCEDURE dbo.A_Stat_Connection_Start
GO

CREATE Procedure dbo.A_Stat_Connection_Start
	
	@id			uniqueidentifier,
	@idchain		uniqueidentifier,
	@connectiontype		int,
	@reasonstart		int,
	@timestart		datetime,
	@timeanswer		datetime,
	@alineid		uniqueidentifier,
	@alinenum		nvarchar ( 8 ),
	@anumberdialed		nvarchar ( 50 ),
	@aoutnumber		nvarchar ( 50 ),
	@astr			nvarchar ( 50 ),
	@auserid		uniqueidentifier,
	@blineid		uniqueidentifier,
	@blinenum		nvarchar ( 8 ),
	@bnumberdialed		nvarchar ( 50 ),
	@boutnumber		nvarchar ( 50 ),
	@bstr			nvarchar ( 50 ),
	@buserid		uniqueidentifier,
	@isrecorded		int,
	@recorddir		nvarchar ( 1000 )
	--@arecfile		nvarchar ( 50 ),
	--@brecfile		nvarchar ( 50 )
as

begin
	Declare @idprev uniqueidentifier

	Select top 1 @idprev = Id
		from A_Stat_Connections_1x1 
		where IdChain = @idchain 
		order by TimeStart desc

	
	if ( @@rowcount > 0 )	
		Update A_Stat_Connections_1x1
			Set IdNext = @Id
			Where Id = @idprev

	--  ?
	declare @betweenop bit
	Set @betweenop = 0
	if ( exists ( Select Id From A_Users Where Id = @auserid )
	 	and exists ( Select Id From A_Users Where Id = @buserid ) )
		Set @betweenop = 1
	else if ( exists ( Select Id From A_View_ServerIntLinesAll Where Id = @alineid ) 
		and exists ( Select Id From A_View_ServerIntLinesAll Where Id = @blineid ) )
		Set @betweenop = 1

	--  ? -    ,      -        (      )
	declare @fromcc bit
	Set @fromcc = 0
	if exists ( Select TimeStart From A_TaskManager_UserInTask
			Where ( UserId = @auserid or UserId = @buserid )
				And TimeStopDialog is null --     -     -   
			)	
		Set @fromcc = 1
	
	--   
	declare @idrecdir int
	set @idrecdir = 0

	if (( @isrecorded > 0 ) and ( @recorddir != '' ))
	begin
		Select @idrecdir = Max ( id ) 
		From A_Stat_RecordDirectories

		declare @nowrecdir nvarchar ( 1000 )
		Select @nowrecdir = path 
		From A_Stat_RecordDirectories
		Where Id = @idrecdir

		if (( @nowrecdir != @recorddir ) or ( @nowrecdir is null ))
		begin
			Insert into A_Stat_RecordDirectories
			Values ( @recorddir, @timestart )
			
			set @idrecdir = @@identity
		end
	end

	-- 
	Insert into A_Stat_Connections_1x1
	(
		Id,
		IdChain,
		IdPrev,
		ConnectionType,
		ReasonStart,	
		TimeStart,		
		TimeAnswer,		
		ALineId,	
		ALineNum,
		ANumberDialed,
		AOutNumber,	
		AStr,	
		AUserId,
		BLineId,	
		BLineNum,		
		BNumberDialed,
		BOutNumber,	
		BStr,	
		BUserId,
		IsRecorded,
		IdRecDir,
		--ARecFile,
		--BRecFile,
		IsBetweenUsers,
		FromCC
	)

	Values

	(
		@id,
		@idchain,
		@idprev,
		@connectiontype,
		@reasonstart,
		@timestart,
		@timeanswer,
		@alineid,
		@alinenum,
		@anumberdialed,
		@aoutnumber,
		@astr,
		@auserid,
		@blineid,
		@blinenum,
		@bnumberdialed,
		@boutnumber,
		@bstr,
		@buserid,
		@isrecorded,
		@idrecdir,
		--@arecfile,
		--@brecfile,
		@betweenop,
		@fromcc --0
	)

end
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Stat_Connection_Start_GetById' ) )
DROP PROCEDURE dbo.A_Stat_Connection_Start_GetById
GO

CREATE Procedure dbo.A_Stat_Connection_Start_GetById
	
	@id			uniqueidentifier,
	@idchain		uniqueidentifier	OUTPUT,
	@connectiontype		int			OUTPUT,
	@reasonstart		int			OUTPUT,
	@timestart		datetime		OUTPUT,
	@timeanswer		datetime		OUTPUT,
	@alineid		uniqueidentifier	OUTPUT,
	@alinenum		nvarchar ( 8 )		OUTPUT,
	@anumberdialed		nvarchar ( 50 )		OUTPUT,
	@aoutnumber		nvarchar ( 50 )		OUTPUT,
	@astr			nvarchar ( 50 )		OUTPUT,
	@auserid		uniqueidentifier	OUTPUT,
	@blineid		uniqueidentifier	OUTPUT,
	@blinenum		nvarchar ( 8 )		OUTPUT,
	@bnumberdialed		nvarchar ( 50 )		OUTPUT,
	@boutnumber		nvarchar ( 50 )		OUTPUT,
	@bstr			nvarchar ( 50 )		OUTPUT,
	@buserid		uniqueidentifier	OUTPUT,
	@isrecorded		int			OUTPUT
	--@arecfile		nvarchar ( 50 )		OUTPUT,
	--@brecfile		nvarchar ( 50 )		OUTPUT
as

begin
	
	Select 
		@idchain	= IdChain,		
		@connectiontype	= ConnectionType,
		@reasonstart	= ReasonStart,
		@timestart	= TimeStart,
		@timeanswer	= TimeAnswer,
		@alineid	= ALineId,
		@alinenum	= ALineNum,
		@anumberdialed	= ANumberDialed,
		@aoutnumber	= AOutNumber,
		@astr		= AStr,
		@auserid	= AUserId,
		@blineid	= BLineId,
		@blinenum	= BLineNum,
		@bnumberdialed	= BNumberDialed,
		@boutnumber	= BOutNumber,
		@bstr		= BStr,
		@buserid	= BUserId,
		@isrecorded	= IsRecorded
		--@arecfile	= ARecFile,
		--@brecfile	= BRecFile 
	From A_Stat_Connections_1x1 sc
	Where Id = @id
	
end
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Stat_Office_Records_Remove' ) )
DROP PROCEDURE dbo.A_Stat_Office_Records_Remove
GO

CREATE  PROCEDURE dbo.[A_Stat_Office_Records_Remove]
	@id uniqueidentifier
as
begin
	declare @t DateTime
	declare @r bit
	declare @a nvarchar ( 100 )
	declare @b nvarchar ( 100 )
	declare @dir int
	declare @path nvarchar ( 200 )
	
	Select @t = TimeStart, @r = IsRecorded, @a = ALineNum, @b = BLineNum, @dir = IdRecDir
	From A_Stat_Connections_1x1 
	Where Id = @id

	Update A_Stat_Connections_1x1
	Set IsRecorded = 0
	Where Id = @id

	Select @path = Path From A_Stat_RecordDirectories Where Id = @dir
	Select @t, @r, @a, @b, @dir, @path
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Stat_Service_FillTempByFilter' ) )
DROP PROCEDURE dbo.A_Stat_Service_FillTempByFilter
GO

CREATE PROCEDURE [dbo].[A_Stat_Service_FillTempByFilter]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL  --Out Number defined
AS
begin

--Prepare @A_Stat_Connections_1x1_tmp
Declare @A_Stat_Connections_1x1_tmp1 table( Id uniqueidentifier PRIMARY KEY) 
Declare @A_Stat_Connections_1x1_tmp table( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, BUSerId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier) 
declare @tstartfloat float  declare @tstopfloat float 
set @tstartfloat = Convert ( float, @tstart )  
set @tstopfloat  = Convert ( float, @tstop )  
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  

declare @lt float
set @lt = Convert ( float, @lentime ) - Floor ( Convert ( float, @lentime ) )


--Date & Time Intervals
Insert into @A_Stat_Connections_1x1_tmp 
select Id, AUSerId , BUSerId , ALineId , BLineId 
from A_Stat_Connections_1x1 sc
where 
	 ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
	and ( CONVERT ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
	and (( FromCC is null ) or ( FromCC <= @fromcc ))
	
	--and not exists(select id from  @A_Stat_Connections_1x1_tmp where id=sc.ID)


--Permissions
--Users
declare @upermitted table ( Id uniqueidentifier Primary Key )
Insert into @upermitted
	Select UserB
	From A_UserControls auc
	Where UserA = @iduser

if not exists (select UserB from  A_UserControls where UserA = @iduser and UserB = @iduser)
	Insert into @upermitted (Id) Values (@iduser)

Declare @commpermitted table ( Id uniqueidentifier PRIMARY KEY)  	 -- Id Connection
Insert into @commpermitted
	Select  sc.ID --auc.UserB   	
	From @upermitted up
		inner join @A_Stat_Connections_1x1_tmp sc on up.Id = sc.AUserId

Insert into @commpermitted
	Select  sc.ID --auc.UserB   	
	From @upermitted up
		inner join @A_Stat_Connections_1x1_tmp sc on up.Id=sc.BUserId
	Where not exists(select id from @commpermitted where Id=sc.ID)


--Lines
print '------Lines'
declare @lpermitted table ( Id uniqueidentifier Primary Key )
Insert into @lpermitted
     Select IdLine
     From A_UserControlLines
     Where UserA = @iduser
          and IdLine != '11111111-1111-1111-1111-111111111111'       

declare @canlistenext int       
Select @canlistenext = Count ( * ) 
From A_UserControlLines 
Where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

if ( @canlistenext > 0 )
     Insert into @lpermitted
          Select Id 
          FROM A_ServerExtLines sel
          Where not exists(select id from @lpermitted where Id = sel.ID)
     
Insert into @commpermitted
     Select sc.ID            
     From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on sc.ALineId=l.Id
     Where not exists(select id from @commpermitted where Id = sc.ID)

Insert into @commpermitted            
     Select sc.ID            
     From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on  sc.BLineId=l.Id
     Where not exists(select id from @commpermitted where Id = sc.ID)

print '------Lines'

delete @A_Stat_Connections_1x1_tmp 
	where id not in (select Id from @commpermitted )

--Numbers 
--Inner
if @innerprefix is not null begin
	declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, reactid uniqueidentifier )
	declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ), addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
	Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id

		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1

			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid

			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid 
				From @temp

			/* */
			Delete From @temp	
		end --\MakePrefixTableAnyWay condition

		

		--Users
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		--Lines
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)
		
		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
		
end --\NUmbers

--Outer NUMBVERS
if @OutNumber is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc
		where  AOutNumber like '%'+@OutNumber+'%'

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc
		where  BOutNumber like '%'+@OutNumber+'%'
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1

end
--\Outer NUMBVERS

--operatorid
if @operatorid is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
		where  AUserId=@operatorid

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id 
		from @A_Stat_Connections_1x1_tmp sc
		where  BUserId=@operatorid
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
end


Select sc.*
FROM A_Stat_Connections_1x1 sc--,@ulpermitted ul,@tasks t
		Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		--Inner Join @commpermitted cp on sc.ID=cp.ID

end
GO




