
if Exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( 'oktell_cc_temp.dbo.A_Sms' ) )
DROP Table oktell_cc_temp.dbo.A_Sms
GO

Create table oktell_cc_temp.dbo.A_Sms
(	
	Id int identity ( 1, 1 ) not null primary key,
--	IdGuid uniqueidentifier not null,
	Received bit not null,
	DT DateTime not null,
	Sender nvarchar ( 100 ) not null,
	Receiver nvarchar ( 100 ) not null,
	SmsText nvarchar ( 2000 ) not null,
	PushId int null,
	Delivered bit null,
	DeliveredDT DateTime null
)
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Sms_AddReceived' ) )
DROP Procedure dbo.A_Sms_AddReceived
GO

Create procedure dbo.A_Sms_AddReceived
--	@idguid uniqueidentifier,
	@dt datetime,
	@sender nvarchar ( 100 ),
	@receiver nvarchar ( 100 ),
	@smstext nvarchar ( 4000 )
as
begin
	Insert into oktell_cc_temp.dbo.A_Sms
	( 
		--IdGuid, 
		Received, DT, Sender, Receiver, SmsText )
	Values
	( 	--@idguid, 
		1, @dt, @sender, @receiver, @smstext )

	select cast ( @@identity as int )
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Sms_AddSent' ) )
DROP Procedure dbo.A_Sms_AddSent
GO

Create procedure dbo.A_Sms_AddSent
	--@idguid uniqueidentifier,
	@dt datetime,
	@sender nvarchar ( 100 ),
	@receiver nvarchar ( 100 ),
	@smstext nvarchar ( 4000 ),
	@pushid int,
	@delivered bit = null,
	@delivereddt datetime = null
as
begin
	Insert into oktell_cc_temp.dbo.A_Sms
	( 
		--IdGuid, 
		Received, DT, Sender, Receiver, SmsText, PushId, Delivered, DeliveredDT )
	Values
	( 	
		--@idguid, 
		0, @dt, @sender, @receiver, @smstext, @pushid, @delivered, @delivereddt )

	select cast ( @@identity as int )
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Sms_UpdateDelivered' ) )
DROP Procedure dbo.A_Sms_UpdateDelivered
GO

Create procedure dbo.A_Sms_UpdateDelivered
	@id int = 0,
	@pushid int = 0,	
	--@idguid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@delivereddt datetime
as
begin
	Update oktell_cc_temp.dbo.A_Sms
	Set 	Delivered = 1,
		DeliveredDT = @delivereddt
	Where Id = @id  
		or PushId = @pushid
		--or IdGuid = @idguid
end
GO




if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Stat_Talk_Algorythms' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'AlgName' )

Alter Table [dbo].[A_Stat_Talk_Algorythms] 
Drop Column AlgName
GO




if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Stat_Talk_AddScriptVisit' ) )
DROP Procedure dbo.A_Stat_Talk_AddScriptVisit
GO

CREATE    Procedure [dbo].[A_Stat_Talk_AddScriptVisit]
	@idalgvisit 	uniqueidentifier,
	--@algname	nvarchar ( 50 ),
	@idconnection	uniqueidentifier,
	@idclient	uniqueidentifier,
	@idtask		uniqueidentifier	
as
begin
	Insert into A_Stat_Talk_Algorythms
 			( IdAlgVisit, IdConnection, IdClient, IdTask )
		Values
			( @idalgvisit, @idconnection, @idclient, @idtask )
end
GO