If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_UserGroup_User_Save' ) )
drop procedure dbo.A_Admin_UserGroup_User_Save
GO


CREATE  procedure [dbo].[A_Admin_UserGroup_User_Save]
	@id		uniqueidentifier,
	@name		nvarchar ( 200 ),
	@info		nvarchar ( 1000 ),
	@parentgroupid	uniqueidentifier,
	@login		nvarchar ( 50 ),
	@password	nvarchar ( 50 ),	
	@type		int,
	@isoperator	bit,
	@roleid		uniqueidentifier,
	@callerid	nvarchar ( 20 )

as
begin

	Update A_Users
	Set 	
		Name 		= @name,
		Info 		= @info,
		ParentGroupId 	= @parentgroupid,
		Login		= @login,
		Password 	= @password,
		Type		= @type
	Where 
		Id 		= @id
	
	if ( @@rowcount = 0 )
	begin
		Insert 
		Into A_Users 
			( Id, Name, Info, ParentGroupId, Login, Password, Type, Enabled )
		Values
			( @id, @name, @info, @parentgroupid, @login, @password, @type, 1 )
	end

	Update A_UserParams
	Set	IdRole = @roleid,
		CallerId = @callerid,
		IsOperator = @isoperator
	Where IdUser = @id

	if ( @@rowcount = 0 )
		Insert 
		Into A_UserParams ( IdUser, IdRole, IsOperator, CallerId, IsRedirect, IsCC, IsLunch  )
		Values	( @id, @roleid, @isoperator, @callerid, 0, 0, 0 )



	if ( @isoperator = 0 )
	  begin
		Delete 
		From C_GroupOperators
		Where IDoperator = @id
	  end


	exec A_Admin_UserGroup_Group_SiftEmpty


	--      
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo
		Set Name = @name
		Where Id = @id

end
GO




If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_Save' ) )
drop procedure dbo.A_TaskManager_Task_Save
GO



CREATE Procedure dbo.A_TaskManager_Task_Save

	@id 				uniqueidentifier,
	@idproject			uniqueidentifier,
	@name				nvarchar(500),
	@active				int,
	@done				int,
	@type				int,
	@ivrname			nvarchar(500),
	@stopreason			int,
	@talkscript			nvarchar(500),
	@pausewhenbusy			float,
	@pausewhennotrespond		float,
	@maxeffortcountbusy		int,
	@maxeffortcountnotrespond	int,
	@mintimetocheckdone		int,
	@tryconnecttime			int,
	@choiceoperator			int,
	@deleteaftersuccess		int,
	@isextnumber			int,
	@isoutputtask			int,
	@resulted			int,
	@resulttype			int,
	@resultinfo			nvarchar(500),
	@resultdatetime			datetime,
	@creationuserid			uniqueidentifier,
	@creationtype			int,
	@creationdatetime		datetime,
	@startrundatetime		datetime,
	@stoprundatetime		datetime,
	@canadddynamically		int,
	@tagdouble			float,
	@listid				uniqueidentifier,
	@operatorshowquery		bit,
	@operatorshownotify		bit,
	@progresscall			bit,
	@progresscallmaxcount		int,
	@progresscallkeepqueue		bit,
	@predictcall			bit,
	@predictcalloffsetsec		int,
	@queueuse			bit,
	@queuemaxcount			int,
	@queuemusic			nvarchar ( 500 ),
	@queueloyality			int,
	@choiceabonents			int,
	@choicenumber			int,
	@choicetable			int,
	@choiceprogress			int,
	@dontsetdone			bit,
	@pausesynclistwaitingnewabonent int,
	@incomingcallsmaxcount		int,
	@servicescript			nvarchar ( 200 ),
	@dialcallerid			nvarchar ( 20 ),
	@incomingupdateifexists		bit,
	@activeonholidays		bit,
	@code				nvarchar ( 30 ),
	@pausesynclistforcedsec		int,
	@queuemaxtimeminutes		int,
	@predictcallerrprobability	int,
	@queuerandomfrompath		nvarchar ( 200 ),
	@savedb				bit

as

begin
	select name from A_TaskManager_Tasks where id = @id

	if ( @@rowcount > 0 )
	begin
		update A_TaskManager_Tasks
		   Set 
			IdProject			= @idproject,
			Name 				= @name, 			
			Active 				= @active, 
			Done 				= @done, 
			Type 				= @type, 
			IvrName 			= @ivrname, 
			StopReason 			= @stopreason, 
			TalkScript 			= @talkscript, 
			PauseWhenBusy 			= @pausewhenbusy, 
			PauseWhenNotRespond 		= @pausewhennotrespond, 
			MaxEffortCountBusy 		= @maxeffortcountbusy, 
			MaxEffortCountNotRespond 	= @maxeffortcountnotrespond, 
			MinTimeToCheckDone 		= @mintimetocheckdone, 
			TryConnectTime 			= @tryconnecttime, 
			ChoiceOperator			= @choiceoperator,
			DeleteAfterSuccess 		= @deleteaftersuccess, 
			IsExtNumber 			= @isextnumber, 
			IsOutputTask			= @isoutputtask,
			Resulted 			= @resulted, 
			ResultType 			= @resulttype, 
			ResultInfo 			= @resultinfo, 
			ResultDateTime 			= @resultdatetime, 
			CreationUserId 			= @creationuserid, 
			CreationType 			= @creationtype, 
			CreationDateTime 		= @creationdatetime,
			StartRunDateTime		= @startrundatetime,
			StopRunDateTime			= @stoprundatetime,
			CanAddDynamically		= @canadddynamically,	
			TagDouble			= @tagdouble,	
			ListId				= @listid,
			OperatorShowQuery		= @operatorshowquery,
			OperatorShowNotify		= @operatorshownotify,
			ProgressCall			= @progresscall,
			ProgressCallMaxCount		= @progresscallmaxcount,
			ProgressCallKeepQueue		= @progresscallkeepqueue,
			PredictCall			= @predictcall,
			PredictCallOffsetSec		= @predictcalloffsetsec,
			QueueUse 			= @queueuse,
			QueueMaxCount			= @queuemaxcount,
			QueueMusic			= @queuemusic,
			QueueLoyality			= @queueloyality,
			ChoiceAbonent			= @choiceabonents,
			ChoiceNumber			= @choicenumber,
			ChoiceTable			= @choicetable,
			ChoiceProgress			= @choiceprogress,
			DontSetDone			= @dontsetdone,
			PauseSyncListWaitingNewAbonent	= @pausesynclistwaitingnewabonent,
			IncomingCallsMaxCount		= @incomingcallsmaxcount,
			ServiceScript			= @servicescript,
			DialCallerId			= @dialcallerid,
			IncomingUpdateIfExists		= @incomingupdateifexists,
			ActiveOnHolidays		= @activeonholidays,
			Code				= @code,
			PauseSyncListForcedSec		= @pausesynclistforcedsec,
			QueueMaxTimeMinutes		= @queuemaxtimeminutes,
			PredictCallErrProbability	= @predictcallerrprobability,
			QueueRandomFromPath		= @queuerandomfrompath,
			SaveDB				= @savedb
 		   Where
			Id 				= @id
	end
	else
	begin
		insert into A_TaskManager_Tasks
		(
			Id, 
			IdProject,
			Name, 
			Active, 
			Done, 
			Type, 
			IvrName, 
			StopReason, 
			TalkScript, 
			PauseWhenBusy, 
			PauseWhenNotRespond, 
			MaxEffortCountBusy, 
			MaxEffortCountNotRespond, 
			MinTimeToCheckDone, 
			TryConnectTime, 
			ChoiceOperator, 
			DeleteAfterSuccess, 
			IsExtNumber, 
			IsOutputTask, 
			Resulted, 
			ResultType, 
			ResultInfo, 
			ResultDateTime, 
			CreationUserId, 
			CreationType, 
			CreationDateTime, 
			StartRunDateTime, 
			StopRunDateTime, 
			CanAddDynamically, 
			TagDouble, 
			ListId,
			OperatorShowQuery,
			OperatorShowNotify,
			ProgressCall,
			ProgressCallMaxCount,
			ProgressCallKeepQueue,
			PredictCall,
			PredictCallOffsetSec,
			QueueUse,
			QueueMaxCount,
			QueueMusic,
			QueueLoyality,
			ChoiceAbonent,
			ChoiceNumber,
			ChoiceTable,
			ChoiceProgress,
			DontSetDone,			
			PauseSyncListWaitingNewAbonent,
			IncomingCallsMaxCount,
			ServiceScript,
			DialCallerId,
			IncomingUpdateIfExists,
			ActiveOnHolidays,
			Code,
			PauseSyncListForcedSec,
			QueueMaxTimeMinutes,
			PredictCallErrProbability,
			QueueRandomFromPath,
			SaveDB
		) 
		Values  
		(
			@id,
			@idproject,
			@name,
			@active,
			@done,
			@type,
			@ivrname,
			@stopreason,
			@talkscript,
			@pausewhenbusy,
			@pausewhennotrespond,
			@maxeffortcountbusy,
			@maxeffortcountnotrespond,
			@mintimetocheckdone,
			@tryconnecttime,
			@choiceoperator,
			@deleteaftersuccess,
			@isextnumber,
			@isoutputtask,
			@resulted,
			@resulttype,
			@resultinfo,
			@resultdatetime,
			@creationuserid,
			@creationtype,
			@creationdatetime,
			@startrundatetime,
			@stoprundatetime,
			@canadddynamically,
			@tagdouble,
			@listid,
			@operatorshowquery,
			@operatorshownotify,
			@progresscall,
			@progresscallmaxcount,
			@progresscallkeepqueue,
			@predictcall,
			@predictcalloffsetsec,
			@queueuse,
			@queuemaxcount,
			@queuemusic,
			@queueloyality,
			@choiceabonents,
			@choicenumber,
			@choicetable,
			@choiceprogress,
			@dontsetdone,
			@pausesynclistwaitingnewabonent,
			@incomingcallsmaxcount,
			@servicescript,
			@dialcallerid,
			@incomingupdateifexists,
			@activeonholidays,
			@code,
			@pausesynclistforcedsec,
			@queuemaxtimeminutes,
			@predictcallerrprobability,
			@queuerandomfrompath,
			@savedb
		)		
	end


	--      
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_Task' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_Task
		Set Name = @name
		Where Id = @id
end
GO





If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_Project_Save' ) )
drop procedure dbo.A_TaskManager_Project_Save
GO



CREATE procedure [dbo].A_TaskManager_Project_Save
	@id 	uniqueidentifier,
	@name 	nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@datecreation DateTime,
	@idcreator uniqueidentifier
as
begin

	Update A_TaskManager_Projects
	Set	Name = @name,
		Description = @description
	Where Id = @id
	

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Projects
		Values ( @id, @name, @description, @datecreation, @idcreator )

	--      
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_Project' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_Project
		Set Name = @name
		Where Id = @id

end
GO