
If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_CreateTables' ) )
drop procedure dbo.A_CallCenter_Temp_CreateTables
GO

Create Procedure [dbo].[A_CallCenter_Temp_CreateTables]
as
begin
	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
	( 
		IdProject	uniqueidentifier NOT NULL,
		IdTask 		uniqueidentifier NOT NULL,
		IsOutput	bit NOT NULL,
		IdEffort	uniqueidentifier NOT NULL,
		IdOperator 	uniqueidentifier,
		IdInList	int NOT NULL,
		AbonentNumber 	nvarchar ( 20 ) NOT NULL,
		CallResult	int NOT NULL,
		CallResultInfo	nvarchar ( 100 ) Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop	DateTime Not Null,
		IdConn		uniqueidentifier,
		IdChain 	uniqueidentifier,	
		IdAUser		uniqueidentifier,
		IdBUser		uniqueidentifier,
		IdExtLine 	uniqueidentifier NOT NULL,
		LenTime 	float NOT NULL, 
		LenQueue 	float NOT NULL,
		IsBetweenOp	bit,
		OpponentInfo 	nvarchar ( 100 ),
		IsHandled 	bit NOT NULL,
		IsSuccess	bit Not NULL,
		IsRecorded	bit,
		IdRecDir	int,
		ALineNum	nvarchar ( 5 ),
		BLineNum	nvarchar ( 5 )
		--ARecFile	nvarchar ( 100 ),
		--BRecFile 	nvarchar ( 100 )
	)	
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
	( 		
		Id		int identity ( 1, 1 ) not null primary key,
		IdTask 		uniqueidentifier,
		IsOutput	bit,	
		IdOperator 	uniqueidentifier NOT NULL,
		CallResult	int,
		State		int Not Null,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop 	DateTime NOT NULL, 
		LenTime 	float NOT NULL	
	)
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
	( 
		IdTask 		uniqueidentifier NOT NULL,
		IdProject	uniqueidentifier Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		CountQueue	int Not Null,
		CountOperator	int Not Null,
		CountTalking	int Not Null,
		elt1WaitStart	DateTime NOT NULL,
		elt1WaitSec	int Not null,
	)
	end



	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ),
		p0 int,	p1 int, p2 int, p3 int, p4 int, p5 int,
		s0 int,	s1 int, s2 int, s3 int, s4 int, s5 int,
		LastDT DateTime
	)

end
GO


if exists ( select name from sysobjects where id=object_id('dbo.A_CallCenter_Temp_CreateTableIndexes' ) )
Drop procedure dbo.A_CallCenter_Temp_CreateTableIndexes
GO
 
Create procedure dbo.A_CallCenter_Temp_CreateTableIndexes
as
begin

	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DateTimeStart' )
	CREATE CLUSTERED INDEX idxCubeConnections_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		DateTimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DTStart' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		DateStart,
		TimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DateTimeStop' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		DateTimeStop
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdConn' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_IdConn ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		IdConn
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdChain' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_IdChain ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		IdChain
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdTask' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		IdTask
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdOperator' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_IdOperator ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		IdOperator
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_IdProject' )
	CREATE NONCLUSTERED INDEX idxCubeConnections_IdProject ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
	(
		IdProject
	) WITH FILLFACTOR = 80



	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DateTimeStart' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		DateTimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DTStart' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		DateStart,
		TimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DateTimeStop' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		DateTimeStop
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_IdOperator' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_IdOperator ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		IdOperator
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_IdTask' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		IdTask
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_CallResult' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_CallResult ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		CallResult
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_State' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_State ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		State
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_DateTimeStart' )
	CREATE CLUSTERED INDEX idxCubeQueue_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
	(
		DateTimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_DTStart' )
	CREATE NONCLUSTERED INDEX idxCubeQueue_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
	(
		DateStart,
		TimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_DateTimeStop' )
	CREATE NONCLUSTERED INDEX idxCubeQueue_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
	(
		DateTimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_IdTask' )
	CREATE NONCLUSTERED INDEX idxCubeQueue_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
	(
		IdTask
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_CallQueue') and name = 'idxCubeQueue_IdProject' )
	CREATE NONCLUSTERED INDEX idxCubeQueue_IdProject ON oktell_cc_temp.dbo.A_Cube_CC_CallQueue
	(
		IdProject
	) WITH FILLFACTOR = 80


end
GO


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_OnLoad' ) )
drop procedure dbo.A_CallCenter_Temp_OnLoad
GO

CREATE PROCEDURE dbo.[A_CallCenter_Temp_OnLoad]
as
begin
	exec A_CallCenter_Temp_CreateDB
	exec A_CallCenter_Temp_CreateTables
	exec A_CallCenter_Temp_CreateTableIndexes
	exec A_CallCenter_Temp_FillTables
	
	--      (  )     
	--   ?
	Declare @dtnow DateTime 
	Set @dtnow = GetDate ( )
	Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Set 	p0 = 0, p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 0,		
		LastDT = @dtnow
end
GO



