
If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Office_TimeScale' ) )
drop procedure dbo.A_Stat_Office_TimeScale
GO

CREATE  procedure [dbo].[A_Stat_Office_TimeScale]
	@iduser		uniqueidentifier,
	@dstart 	DateTime, 
	@dstop	 	DateTime, 
	@tstart 	DateTime, 
	@tstop	 	DateTime,
	@lentime 	DateTime,
	@conntype 	int 			= -1, 
	@taskid		uniqueidentifier 	= null,
	@fromcc		bit			= null,
	@operatorid 	uniqueidentifier 	= null,
	@innerprefix 	nvarchar ( 20 )		= null, 
	@outnumber 	nvarchar ( 20 )		= null,

	@minvalue 	int 			output, 
	@maxvalue 	int 			output
as
begin
/*
----------------------------------------------------------
------- debug --------------------------------------------
----------------------------------------------------------
	declare @dstart 	DateTime 
	declare @dstop	 	DateTime 
	declare @tstart 	DateTime 
	declare @tstop	 	DateTime
	declare @lentime 	DateTime
	declare @conntype 	int 
	declare @taskid		uniqueidentifier
	declare @fromcc		bit
	declare @operatorid 	uniqueidentifier
	declare @innerprefix	nvarchar ( 20 )
	declare @outnumber	nvarchar ( 20 )
	declare @iduser		uniqueidentifier
	declare @minvalue 	int
	declare @maxvalue 	int
	
	set dateformat dmy
	set @dstart = '25.12.2006' 
	set @dstop = '28.12.2006' 
	set @tstart = '8:00'
	set @tstop = '18:00' 
	set @lentime = '0:00:01' 
	set @conntype = -1
	set @taskid = N'00000000-0000-0000-0000-000000000000'
	set @operatorid = N'00000000-0000-0000-0000-000000000000'
	set @innerprefix = N'' 
	set @outnumber = N''
	set @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
	set @fromcc = 1
----------------------------------------------------------
------- end debug ----------------------------------------
----------------------------------------------------------
*/

	declare @tstartfloat float  declare @tstopfloat float 
	set @tstartfloat = Convert ( float, @tstart )  
	set @tstopfloat  = Convert ( float, @tstop )  
	set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
	set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  


	if ( @taskid = '00000000-0000-0000-0000-000000000000' )
		set @taskid = null

	if ( @operatorid = '00000000-0000-0000-0000-000000000000' )
		set @operatorid = null

	if ( @innerprefix = '' )
		set @innerprefix = null

	if ( @outnumber = '' )
		set @outnumber = null;

	Select top 0 * into #t from A_Stat_Connections_1x1
	Insert into #t Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		'0:00',
		'23:59:59',
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber
	



	Declare @min_ int, @max_ int;
	Declare @emptyguid uniqueidentifier
	Set @emptyguid = '00000000-0000-0000-0000-0000000000000000'



	Select @minvalue = isnull ( min ( c ), 0 ), @maxvalue = isnull ( max ( c ), 0 ) from
	(
		Select count ( * ) c 
		From #t
		Where (( @conntype = -1 ) or ( @conntype = 1 and connectiontype in (4,5) ) or (@conntype = 2 and connectiontype in (1,6,7)) or (@conntype = 3 and connectiontype in (2,3,8)))
		Group By convert ( varchar(10), timestart, 104 ), datepart ( hour, timestart )
	) a;


	declare @empty table ( cdate varchar ( 10 ) collate database_default, c0 int, c1 int, c2 int, c3 int, c4 int, c5 int, c6 int, c7 int, c8 int, c9 int, c10 int, 
		c11 int, c12 int, c13 int, c14 int, c15 int, c16 int, c17 int, c18 int, c19 int, c20 int, c21 int, c22 int, c23 int, cbottom int, ctop int )
	declare @tempdate datetime 
	set @tempdate = @dstart
	while @tempdate < @dstop
	begin
		Insert into @empty ( cdate, c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20, c21, c22, c23, cbottom, ctop )
		Values ( convert ( varchar(10), @tempdate, 126 ), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 )
			
		set @tempdate = DateAdd ( d, 1, @tempdate )
	end
	

	declare @ttt table ( cdate varchar ( 10 ) collate database_default, c0 int, c1 int, c2 int, c3 int, c4 int, c5 int, c6 int, c7 int, c8 int, c9 int, c10 int, 
		c11 int, c12 int, c13 int, c14 int, c15 int, c16 int, c17 int, c18 int, c19 int, c20 int, c21 int, c22 int, c23 int, cbottom int, ctop int )

	insert into @ttt

	Select 	cdate,
     		sum ( c0 ) as c0, 
    	 	sum ( c1 ) as c1,
     		sum ( c2 ) as c2,
	     	sum ( c3 ) as c3,
     		sum ( c4 ) as c4,
     		sum ( c5 ) as c5, 
     		sum ( c6 ) as c6,
     		sum ( c7 ) as c7,
     		sum ( c8 ) as c8,
     		sum ( c9 ) as c9,
     		sum ( c10 ) as c10, 
     		sum ( c11 ) as c11, 
     		sum ( c12 ) as c12,
     		sum ( c13 ) as c13,
     		sum ( c14 ) as c14,
     		sum ( c15 ) as c15,
     		sum ( c16 ) as c16,
     		sum ( c17 ) as c17,
     		sum ( c18 ) as c18,
	     	sum ( c19 ) as c19,
	     	sum ( c20 ) as c20,
	     	sum ( c21 ) as c21,
	     	sum ( c22 ) as c22,  
	     	sum ( c23 ) as c23,
	     	sum ( cbefore ) as cbottom,
	     	sum ( cafter ) as ctop  

	From 

	(

     		Select  
			convert ( varchar(10), timestart, 126 ) cdate,
          		case ( DatePart ( hour, timestart ) ) when 0 then 1 else 0 end as c0,
         		case ( DatePart ( hour, timestart ) ) when 1 then 1 else 0 end as c1,
          		case ( DatePart ( hour, timestart ) ) when 2 then 1 else 0 end as c2,
          		case ( DatePart ( hour, timestart ) ) when 3 then 1 else 0 end as c3,
          		case ( DatePart ( hour, timestart ) ) when 4 then 1 else 0 end as c4,
          		case ( DatePart ( hour, timestart ) ) when 5 then 1 else 0 end as c5,
          		case ( DatePart ( hour, timestart ) ) when 6 then 1 else 0 end as c6,
          		case ( DatePart ( hour, timestart ) ) when 7 then 1 else 0 end as c7,
          		case ( DatePart ( hour, timestart ) ) when 8 then 1 else 0 end as c8,
          		case ( DatePart ( hour, timestart ) ) when 9 then 1 else 0 end as c9,
          		case ( DatePart ( hour, timestart ) ) when 10 then 1 else 0 end as c10,
          		case ( DatePart ( hour, timestart ) ) when 11 then 1 else 0 end as c11,
          		case ( DatePart ( hour, timestart ) ) when 12 then 1 else 0 end as c12,
          		case ( DatePart ( hour, timestart ) ) when 13 then 1 else 0 end as c13,
	          	case ( DatePart ( hour, timestart ) ) when 14 then 1 else 0 end as c14,
	          	case ( DatePart ( hour, timestart ) ) when 15 then 1 else 0 end as c15,
	          	case ( DatePart ( hour, timestart ) ) when 16 then 1 else 0 end as c16,
	          	case ( DatePart ( hour, timestart ) ) when 17 then 1 else 0 end as c17,
	          	case ( DatePart ( hour, timestart ) ) when 18 then 1 else 0 end as c18,
	          	case ( DatePart ( hour, timestart ) ) when 19 then 1 else 0 end as c19,
	          	case ( DatePart ( hour, timestart ) ) when 20 then 1 else 0 end as c20,
	          	case ( DatePart ( hour, timestart ) ) when 21 then 1 else 0 end as c21,
	          	case ( DatePart ( hour, timestart ) ) when 22 then 1 else 0 end as c22,
	          	case ( DatePart ( hour, timestart ) ) when 23 then 1 else 0 end as c23,			
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstartfloat then 1 else 0 end as cbefore,
			case when Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) > @tstopfloat then 1 else 0 end as cafter


     		From 
		(
			Select Id, TimeStart		
			From #t
			Where ((@conntype = -1) or (@conntype = 1 and connectiontype in (4,5)) or (@conntype = 2 and connectiontype in (1,6,7)) or ( @conntype = 3 and connectiontype in (2,3,8)))
	          	Group By Id, TimeStart
		)b

		Union all

		Select *
		FROM @empty
	)a

	Group by cdate
	Order by cdate

	
	declare @mxv1 int
	declare @mxv2 int
	Select @mxv1 = Max ( ctop ) From @ttt
	Select @mxv2 = Max ( cbottom ) From @ttt
	if ( @maxvalue < @mxv1 )
		Set @maxvalue = @mxv1
	if ( @maxvalue < @mxv2 )
		Set @maxvalue = @mxv2

	Select * 
	From @ttt
end
GO

/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Lines_Int_Get' ) )
drop procedure dbo.A_Admin_Lines_Int_Get
GO

CREATE        Procedure [dbo].A_Admin_Lines_Int_Get
	@id	uniqueidentifier
as
begin

   declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )

      begin

	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName
	
	FROM 
	(	
		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId
		From A_ServerIntLines

		Union All

		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId
		From A_ServerUsbLines		
	) e
	
	Inner join A_WorkPlaces w on e.ServerID = w.ID
	Inner join @groups g on e.ParentGroupId = g.GroupId
	Order By SystemNum
    
    end
   else
    begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName
	
	FROM 
	(	
		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId
		From A_ServerIntLines
		
	) e
	
	Inner join A_WorkPlaces w on e.ServerID = w.ID
	Inner join @groups g on e.ParentGroupId = g.GroupId
	Where e.ServerId = @id
	Order By SystemNum
    end
		

end
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_UserGroup_Group_SiftEmpty' ) )
drop procedure dbo.A_Admin_UserGroup_Group_SiftEmpty
GO

CREATE 	procedure [dbo].[A_Admin_UserGroup_Group_SiftEmpty]
as
begin
	--   
	declare @gc table ( nm nvarchar ( 255 ) collate database_default, cnt int )
	Insert into @gc 
		Select [Name], Count ( * ) as cnt 
		From A_Groups
		Group By [Name]

	declare @cnt int	
	Select @cnt = Count ( * )
	From @gc 
	Where cnt > 1

		
	if ( @@rowcount > 0 )
	begin
	   declare @change table ( id uniqueidentifier, idto uniqueidentifier )
	   declare @id uniqueidentifier
           declare @name nvarchar ( 255 )

	   declare @lastid uniqueidentifier	
	   declare @lastname nvarchar ( 255 )
	   set @lastname = ''

	   declare cs Cursor For
		Select id, name 
		From A_Groups
			inner join @gc gc on [name] like gc.nm
		Where gc.cnt > 1
		Order By name
	  

	   Open cs
	   Fetch Next From cs Into @id, @name
	   While ( @@FETCH_STATUS = 0 )
	   Begin
		if ( @name = @lastname )
                    begin
			Insert Into @change ( id, idto )
				Values ( @id, @lastid )
		    end
		else
		    begin
			set @lastid = @id
			set @lastname = @name
		    end
			
	   	Fetch Next From cs Into @id, @name
	   End
	   Close cs
	   Deallocate cs

	   --Select * FROM @change

	Update A_ServerUsbLines
    	Set ParentGroupId = ch.idto
	From A_ServerUsbLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_ServerIntLines
    	Set ParentGroupId = ch.idto
	From A_ServerIntLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_Users
    	Set ParentGroupId = ch.idto
	From A_Users u, @change ch
	Where u.ParentGroupId = ch.Id


	end

	
	Delete 
	From A_Groups 
	Where not ID in ( Select ParentGroupID From A_Users 
				union
			  Select ParentGroupId From A_ServerUsbLines 
				union 
			  Select ParentGroupId From A_ServerIntLines )

end
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_GetResourceTLCrossInfo' ) )
drop procedure dbo.A_CallCenter_GetResourceTLCrossInfo
GO


CREATE procedure [dbo].[A_CallCenter_GetResourceTLCrossInfo]
	@minutes int
as
begin

--  :
--  -   ( )
--  -   ()
--  -   ()
--  -    ()
--  -  ( )
--  -    ( )

--declare @minutes int
--set @minutes = 5

----------------------------------------------------------------------
--   ---------------------------------------------
----------------------------------------------------------------------
Declare @intervalsec int 
set @intervalsec = @minutes * 60

Declare @dtnow DateTime
Declare @dtstart DateTime
Set @dtnow = GetDate()
Set @dtstart = DateAdd ( mi, - @minutes, @dtnow )


Declare @tasks table ( id uniqueidentifier, name nvarchar ( 200 ) collate database_default, IsOutput bit, projectname nvarchar ( 200 ) collate database_default)
Insert into @tasks
	Select t.Id, t.Name, t.IsOutputTask, p.Name 
	From A_TaskManager_Tasks t
		Inner join A_TaskManager_Projects p on t.IdProject = p.Id
	Where Active = 1 
		and Done = 0 
		and StartRunDateTime < GetDate() 
		and StopRunDateTime > GetDate()
		and CreationType = 2
	order by idproject, type


declare @tasklines table ( idtask uniqueidentifier, idline uniqueidentifier )
Insert into @tasklines
	Select TaskId, ExtLineId 
	From A_TaskManager_TaskExtLines el
		Inner join @tasks t on el.TaskId = t.Id
	Where t.IsOutput = 1


declare @tempconn table ( IdConn uniqueidentifier, IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
Insert into @tempconn
	Select IdConn, IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections sc
	Where DateTimeStop > @dtstart

Update @tempconn
Set DateTimeStart = @dtstart
Where DateTimeStart < @dtstart

Update @tempconn
Set DateTimeStop = @dtnow
Where DateTimeStop > @dtnow

Update @tempconn
Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


declare @output table ( IdTask uniqueidentifier, IdLine uniqueidentifier, Val float )

----------------------------------------------------------------------
--   ----------------------------------------------------
----------------------------------------------------------------------

declare @temp5 table ( IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
insert into @temp5
	Select IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime
	From @tempconn 
	Where not IdConn is null


Insert into @output
	Select IdTask, IdExtLine, Sum ( LenTime ) / @intervalsec * 100 as Val
	From
	(
		Select IdTask, IdExtLine, LenTime
		From @temp5

		Union all

		Select IdTask, IdLine, 0
		From @tasklines tl
	) a
	Group By IdTask, IdExtLine
	Order by IdTask

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------


Select * 
From @output

end
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_MobileControl_Journal_Get' ) )
drop procedure dbo.A_MobileControl_Journal_Get
GO

CREATE  procedure [dbo].[A_MobileControl_Journal_Get]
	@dstart 	datetime,
 	@dstop 		datetime,
 	@tstart 	datetime,
 	@tstop 		datetime,
	@number		nvarchar ( 50 ),
	@userid		uniqueidentifier
as
begin



---   ---------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare @number nvarchar ( 50 )
declare @userid uniqueidentifier


set @dstart = '2006/06/01'
set @dstop = '2006/07/19'
set @tstart = '10:11:00'
set @tstop = '12:20:00'
set @number = ''
set @userid = '00000000-0000-0000-0000-000000000000'
*/

---------------------------------



declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


--   
declare @chains table ( IdChain uniqueidentifier, TimeStop DateTime )
if ( @number = '' )
	insert into @chains
		Select IdChain, Max ( TimeStop ) as TimeStop
		From A_Stat_Connections_1x1 sc
		Where TimeStop > @dstart and TimeStart < @dstop
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
--			and BOutNumber like '%' + @number + '%'
		Group By IdChain
else
	insert into @chains
		Select IdChain, Max ( TimeStop ) as TimeStop
		From A_Stat_Connections_1x1 sc
		Where TimeStop > @dstart and TimeStart < @dstop
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
			and BOutNumber like '%' + @number + '%'
		Group By IdChain

declare @united table ( id uniqueidentifier, name nvarchar ( 100 ) collate database_default)
Insert Into @united
	Select Id, Name From A_Users
	Union
	Select Id, ( Cast ( SystemNum as nvarchar ( 10 ) ) + ' ' + Caption ) as Name From A_ServerIntLines

Select sc.Id as connectionid, sc.TimeStart, u.Name as username, u.Id as userid, mcd.mask, mcd.Description, sc.BOutNumber, case When mcf.mask is null then 1 else 0 end as denied, CAST ( CAST ( ch.TimeStop - sc.TimeStart as DateTime ) as float ) as Length, sc.IsRecorded, sc.IdRecDir, sc.ALineNum, sc.BLineNum--, sc.ARecFile, sc.BRecFile 
From A_Stat_Connections_1x1 sc
	inner join A_MobileControlMaskDenied mcd on sc.BOutNumber like REPLACE ( mcd.mask, '?', '_' )
	inner join @united u on sc.AUserId = u.Id or sc.ALineId = u.Id
	inner join @chains ch on sc.IdChain = ch.IdChain
	Left Join A_MobileControlMaskFree mcf on sc.BOutNumber like REPLACE ( mcf.mask, '?', '_' )
Where ( u.Id = @userid or @userid = '00000000-0000-0000-0000-000000000000' )
Order By sc.TimeStart

End
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Personal_GetNumbersDepartmentInfo' ) )
drop procedure dbo.A_Personal_GetNumbersDepartmentInfo
GO

CREATE  Procedure [dbo].[A_Personal_GetNumbersDepartmentInfo]
As
Begin

declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

Insert Into @t
	Select np.Id, np.Prefix, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id


declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
Insert into @groups
	Select Id, Name 
	From A_Groups
Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', ' ' )


declare @cnt int
set @cnt = 0


while ( @@rowcount > 0 ) and ( @cnt < 10 )
begin
	Set @cnt = @cnt + 1
	
	--    @cnt - 
	Insert Into @temp
		Select t.nid, t.prefix, t.reactid, t1.reactid
		From @t t
			Inner join @t t1 on t.Reactid = t1.nId
		Where t.ReactId != t.Nid
	
	--    
	Delete From @t
		From @temp
	Where nid = id and reactid = oldrid

	-- 
	Insert Into @t ( nid, prefix, reactid )
		Select id, prefix, newrid From @temp

	-- 
	Delete From @temp	
end

--Select @cnt

--    
Delete From @t
	From A_NumberPlan np
Where reactid = np.Id

--Select @@rowcount

declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
Insert Into @output
	Select nid, Prefix, groupid, groupname FROM 
	(
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
		From @t t
			Inner join A_Users u on t.ReactId = u.Id
			Inner join @groups g on u.ParentGroupId = g.GroupId
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
		From @t t
			Inner join A_ServerIntLines l on t.ReactId = l.Id
			Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
		From @t t
			Inner join A_ServerUsbLines l on t.ReactId = l.Id
			Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
	) a
	Group By Prefix, GroupId, nid, groupname


declare @og table ( id uniqueidentifier, cnt int )
Insert into @og
	Select * From
	(
		Select nid, count ( * ) as cnt
		From @output
		Group By nid
	)a

Update @output 
Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = ' '
From @output o, @og og
Where o.nid = og.id and og.cnt > 1

Select nid, prefix, groupid, groupname 
From @output
Group By nid, prefix, groupid, groupname

End
GO


/****************************************************************************************************************/
If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Personal_NumbersInfo_Get' ) )
drop procedure dbo.A_Personal_NumbersInfo_Get
GO

CREATE   Procedure [dbo].[A_Personal_NumbersInfo_Get]
As
Begin

declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

Insert Into @t
	Select np.Id, np.Prefix, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id


declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
Insert into @groups
	Select Id, Name 
	From A_Groups
Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', ' ' )


declare @cnt int
set @cnt = 0


while ( @@rowcount > 0 ) and ( @cnt < 10 )
begin
	Set @cnt = @cnt + 1
	
	--    @cnt - 
	Insert Into @temp
		Select t.nid, t.prefix, t.reactid, t1.reactid
		From @t t
			Inner join @t t1 on t.Reactid = t1.nId
		Where t.ReactId != t.Nid
	
	--    
	Delete From @t
		From @temp
	Where nid = id and reactid = oldrid

	-- 
	Insert Into @t ( nid, prefix, reactid )
		Select id, prefix, newrid From @temp

	-- 
	Delete From @temp	
end

--Select @cnt

--    
Delete From @t
	From A_NumberPlan np
Where reactid = np.Id

--Select @@rowcount

declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default, isline bit )
Insert Into @output
	Select nid, Prefix, GroupId, GroupName, min ( IsLine ) as IsLine FROM 
	(
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as IsLine
		From @t t
			Inner join A_Users u on t.ReactId = u.Id
			Inner join @groups g on u.ParentGroupId = g.GroupId
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
		From @t t
			Inner join A_ServerIntLines l on t.ReactId = l.Id
			Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
		From @t t
			Inner join A_ServerUsbLines l on t.ReactId = l.Id
			Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
	) a
	Group By Prefix, GroupId, nid, groupname


declare @og table ( id uniqueidentifier, cnt int )
Insert into @og
	Select * From
	(
		Select nid, count ( * ) as cnt
		From @output
		Group By nid
	)a

Update @output 
Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = ' '
From @output o, @og og
Where o.nid = og.id and og.cnt > 1

Select nid, prefix, groupid, groupname, isline
From @output
Group By nid, prefix, groupid, groupname, isline

End
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Personal_NumbersInfo_GetSeparate' ) )
drop procedure dbo.A_Personal_NumbersInfo_GetSeparate
GO

CREATE      Procedure [dbo].[A_Personal_NumbersInfo_GetSeparate]
As
Begin

declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

Insert Into @t
	Select np.Id, np.Prefix, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id


declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
Insert into @groups
	Select Id, Name 
	From A_Groups
Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', ' ' )


declare @cnt int
set @cnt = 0


while ( @@rowcount > 0 ) and ( @cnt < 10 )
begin
	Set @cnt = @cnt + 1
	
	--    @cnt - 
	Insert Into @temp
		Select t.nid, t.prefix, t.reactid, t1.reactid
		From @t t
			Inner join @t t1 on t.Reactid = t1.nId
		Where t.ReactId != t.Nid
	
	--    
	Delete From @t
		From @temp
	Where nid = id and reactid = oldrid

	-- 
	Insert Into @t ( nid, prefix, reactid )
		Select id, prefix, newrid From @temp

	-- 
	Delete From @temp	
end

--Select @cnt

--    
Delete From @t
	From A_NumberPlan np
Where reactid = np.Id

--Select @@rowcount


--declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ), reactid uniqueidentifier, groupid uniqueidentifier, groupname nvarchar ( 255 ), reacttype int )
--Insert Into @output
		
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as ReactType
		From @t t
			Inner join A_Users u on t.ReactId = u.Id
			Inner join @groups g on u.ParentGroupId = g.GroupId
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as ReactType
		From @t t
			Inner join A_ServerIntLines l on t.ReactId = l.Id
			Inner join @groups g on l.ParentGroupId = g.GroupId
		union all
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 2 as ReactType
		From @t t
			Inner join A_ServerUsbLines l on t.ReactId = l.Id
			Inner join @groups g on l.ParentGroupId = g.GroupId


--Select *
--From @output


End
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Rules_GetForLineAndUser' ) )
drop procedure dbo.A_Rules_GetForLineAndUser
GO

CREATE   PROCEDURE dbo.A_Rules_GetForLineAndUser
@userid uniqueidentifier, @lineid uniqueidentifier
AS
BEGIN

declare @rc int
declare @rcl int
Set @rcl = 0

declare @rules table ( Id uniqueidentifier, Priority int )
declare @numbers table ( Id uniqueidentifier, Prefix nvarchar ( 20 ) collate database_default)

Insert into @rules
	Select R.[ID], R.Priority 
	From A_Rules R 
		Inner join A_RuleRecords RR on RR.RuleID = R.[ID]
	Where RR.ReactID = @userid
		or RR.ReactID=@lineid
		or RR.ReactId in (Select Id From @numbers)


Select @rc = Count ( * ) 
From @rules

declare @cnt int
set @cnt = 0

While ( @rc != @rcl ) And ( @cnt < 10 )
begin
	set @cnt = @cnt + 1

	Insert Into @numbers
		Select np.Id, np.Prefix
		From A_NumberPlan np
			Inner join A_NumberPlanAction npa on npa.NumId = np.id
			Inner join @rules R on npa.ExtraId = r.Id

	Delete From @rules	
	
	Insert into @rules
		Select R.[ID], R.Priority 
		From A_Rules R 
			Inner join A_RuleRecords RR on RR.RuleID = R.[ID]
		Where RR.ReactID = @userid
			or RR.ReactID=@lineid
			or RR.ReactId in (Select Id From @numbers)

	Set @rcl = @rc
	
	Select @rc = Count ( * )
	From @rules
End

Select Id, Priority
From @rules
Group By Id, Priority
Order by Priority Desc


END
GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_MyCalls_Get' ) )
drop procedure dbo.A_Stat_MyCalls_Get
GO

CREATE  procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'

*/
	Declare @ids table ( id uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, Length DateTime, Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 100 ) collate database_default, 
				IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ) collate database_default, BLineNum nvarchar ( 5 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 100 ) collate database_default, BStr nvarchar ( 100 ) collate database_default )
	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, '', '',
			IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber, AStr, BStr
		From A_Stat_Connections_1x1 sc
			inner join @ids ids on sc.Id = ids.id

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = '' and o.Number = ''

	Select Id, Media, Type, TimeStart, Length, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir--, ARecFile, BRecFile
	From @output
	Where Media = @media or @media = 0
	Order By TimeStart Desc

end

GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_AllCalls' ) )
drop procedure dbo.A_Stat_Office_Diagramm_AllCalls
GO

CREATE  procedure [dbo].[A_Stat_Office_Diagramm_AllCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 4
--------------------------------------------------------------------
*/
		

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber

	
	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain

			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )							
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			declare @lines2 table ( lineid uniqueidentifier )
			insert into @lines2
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
	

			Select uid, sum ( count_ ) count_ from
			(
				select AUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join A_Users u on u.Id = ts.AUserId
				Group by AUserId
			
				union all
			
				select BUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join A_Users u on u.Id = ts.BUserId
				Group By BUserId

				union

				select AUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines2 l on l.lineid = ts.BLineId
				Where ( ALineNum like 'IVR' )
				Group by AUserId

				union all
					
				select BUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines2 l on l.lineid = ts.ALineId
				Where ( BLineNum like 'IVR' )
				Group By BUserId
	
			)a
			group by uid
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier )
			insert into @lines3
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines


			Select linenum, sum ( count_ ) count_ from
			(
				select ALineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId	
				Group by ALineNum
			
				union all

				select BLineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.BLineId
				Group By BLineNum

				union all

				select ALineNum as linenum, count ( * ) as count_
				from #tempstatistics ts 
					inner join @lines3 l on l.lineid = ts.BLineId
				where ALineNum like 'IVR' 
				Group by ALineNum

				union all

				select BLineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId
				where BLineNum like 'IVR'
				Group by BLineNum
			)a
			group by linenum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

		declare @lines4 table ( lineid uniqueidentifier )
		insert into @lines4
			Select ID from A_ServerIntLines
			union 
			Select ID from A_ServerUSBLines

		Select prefix, sum ( count_ ) count_ from
		(
			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				inner join A_Users u on u.id = AUserId
			Group by prefix

			union all

			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				inner join A_Users u on u.id = BUserId
			Group by prefix

			union all

			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
				inner join @lines4 l on l.lineid = ALineId
			Group by prefix

			union all
		
			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
				inner join @lines4 l on l.lineid = BLineId
			Group by prefix
		)a
		Group by prefix
	end	

	delete from #tempstatistics

end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_AverageCallTime' ) )
drop procedure dbo.A_Stat_Office_Diagramm_AverageCallTime
GO


CREATE  procedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdateInt') )
				select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDdateInt
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDdateInt

			insert into #tempstatisticsYMDdateInt
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, Count ( * ) as count_
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, m, d, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From #tempstatisticsYMDdateInt

			delete from #tempstatisticsYMDdateInt										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdateInt') )
				select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDHdateInt
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDHdateInt

			insert into #tempstatisticsYMDHdateInt
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From #tempstatisticsYMDHdateInt

			delete from #tempstatisticsYMDHdateInt
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin	
			Select uid, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier )
			insert into @lines3
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines


			Select linenum, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select ALineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId
	
					union all
	
					Select BLineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.BLineId
				)a
				Group by linenum
			)b

		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines


			Select prefix, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = AUserId

					union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = BUserId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)a
				Group by prefix
			)b

		end	

	delete from #tempstatistics

end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_CallTime' ) )
drop procedure dbo.A_Stat_Office_Diagramm_CallTime
GO


CREATE  procedure [dbo].[A_Stat_Office_Diagramm_CallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdate') ) 
				select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDdate 
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDdate

			insert into #tempstatisticsYMDdate
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, m, d, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From #tempstatisticsYMDdate

			delete from #tempstatisticsYMDdate										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdate') )
				select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDHdate 
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDHdate

			insert into #tempstatisticsYMDHdate
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From #tempstatisticsYMDHdate

			delete from #tempstatisticsYMDHdate
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin			
			Select uid, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b			
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines


			Select linenum, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select ALineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines l on l.lineid = ts.ALineId
	
					union all
	
					Select BLineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines l on l.lineid = ts.BLineId
				)a
				Group by linenum
			)b
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
	

			Select prefix, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = AUserId

					union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = BUserId
	
					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)b
				Group by prefix
			)c

		end	

	delete from #tempstatistics

end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_FlashedCalls' ) )
drop procedure dbo.A_Stat_Office_Diagramm_FlashedCalls
GO

CREATE  procedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 0
--------------------------------------------------------------------
*/	

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber


	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsflash') )
		select top 0 sc1.*, sc2.ALineId A2LineId, sc2.BLineId B2LineId into #tempstatisticsflash From A_Stat_Connections_1x1 sc1 inner join A_Stat_Connections_1x1 sc2 on sc1.IDNext = sc2.Id
	else
		delete from #tempstatisticsflash

	insert into #tempstatisticsflash
		Select ts1.*, ts2.ALineId A2LineId, ts2.BLineId B2LineId
		FROM #tempstatistics ts1 inner join 
			#tempstatistics ts2 on ts1.idnext = ts2.id
		where not ( ts1.ALineId = ts2.ALineId and ts1.BLineID = ts2.BLineId ) 
			and not ( ts1.ALineId = ts2.BLineId and ts1.BLineID = ts2.ALineId )
			and not ( ts1.AUserId = 'AB000000-0000-0000-0000-000000000000' )
			and not ( ts1.BUserId = 'AB000000-0000-0000-0000-000000000000' )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From #tempstatisticsflash
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )											
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From #tempstatisticsflash
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			select uid, count ( * ) as count_
			From
			( 
				Select AUserId as uid, TimeStop
				from #tempstatisticsflash
				where StopSide = 0 and 
					(AUserId != '00000000-0000-0000-0000-000000000000')
		
				union all

				Select BUserId as uid, TimeStop
				from #tempstatisticsflash
				where StopSide = 1 and
					(BUserId != '00000000-0000-0000-0000-000000000000')
			)a
			Group by uid								
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines

			select linenum, count ( * ) as count_
			from
			(
				select BLineNum linenum, TimeStop
				from #tempstatisticsflash ts 
				inner join @lines l on ts.BLineId = l.lineid

				union

				select ALineNum linenum, TimeStop
				from #tempstatisticsflash ts 
				inner join @lines l on ts.ALineId = l.lineid
			)a

			group by linenum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end

			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = AUserId
				Group by prefix
					
				union all

					Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = BUserId
				Group by prefix
					
				union all

					Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = ALineId
				Group by prefix
					
				union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix

		end	

	delete from #tempstatisticsflash
	delete from #tempstatistics

end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_HandledCalls' ) )
drop procedure dbo.A_Stat_Office_Diagramm_HandledCalls
GO


CREATE  procedure [dbo].[A_Stat_Office_Diagramm_HandledCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@mode int
as

begin

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/		

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber

	Delete from #tempstatistics
	Where not ConnectionType in ( 4, 5 )

	Delete From #tempstatistics
	Where ConnectionType = 4 and ( not IdNext is null )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain


			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )						
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
				select BUserId, count ( * ) as count_
				from #tempstatistics
				group by BUserId													
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			select BLineNum, count ( * ) as count_
			from #tempstatistics
			group by BLineNum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatistics t inner join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = BUserId
				Group by prefix

				union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatistics t inner join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix
	end	

	delete from #tempstatistics

end
GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Stat_Service_FillTempByFilter' ) )
drop procedure dbo.A_Stat_Service_FillTempByFilter
GO


CREATE  PROCEDURE [dbo].[A_Stat_Service_FillTempByFilter]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL  --Out Number defined
AS
begin

--Prepare @A_Stat_Connections_1x1_tmp
Declare @A_Stat_Connections_1x1_tmp1 table( Id uniqueidentifier PRIMARY KEY) 
Declare @A_Stat_Connections_1x1_tmp table( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, BUSerId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier) 
declare @tstartfloat float  declare @tstopfloat float 
set @tstartfloat = Convert ( float, @tstart )  
set @tstopfloat  = Convert ( float, @tstop )  
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  

declare @lt float
set @lt = Convert ( float, @lentime ) - Floor ( Convert ( float, @lentime ) )


--Date & Time Intervals
Insert into @A_Stat_Connections_1x1_tmp 
select Id, AUSerId , BUSerId , ALineId , BLineId 
from A_Stat_Connections_1x1 sc
where 
	 ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
	and ( CONVERT ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
	and (( FromCC is null ) or ( FromCC <= @fromcc ))
	
	--and not exists(select id from  @A_Stat_Connections_1x1_tmp where id=sc.ID)


--Permissions
--Users
declare @upermitted table ( Id uniqueidentifier Primary Key )
Insert into @upermitted
	Select UserB
	From A_UserControls auc
	Where UserA = @iduser

if not exists (select UserB from  A_UserControls where UserA = @iduser and UserB = @iduser)
	Insert into @upermitted (Id) Values (@iduser)

Declare @commpermitted table ( Id uniqueidentifier PRIMARY KEY)  	 -- Id Connection
Insert into @commpermitted
	Select  sc.ID --auc.UserB   	
	From @upermitted up
		inner join @A_Stat_Connections_1x1_tmp sc on up.Id = sc.AUserId

Insert into @commpermitted
	Select  sc.ID --auc.UserB   	
	From @upermitted up
		inner join @A_Stat_Connections_1x1_tmp sc on up.Id=sc.BUserId
	Where not exists(select id from @commpermitted where Id=sc.ID)


--Lines
print '------Lines'
declare @lpermitted table ( Id uniqueidentifier Primary Key )
Insert into @lpermitted
     Select IdLine
     From A_UserControlLines
     Where UserA = @iduser
          and IdLine != '11111111-1111-1111-1111-111111111111'       

declare @canlistenext int       
Select @canlistenext = Count ( * ) 
From A_UserControlLines 
Where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

if ( @canlistenext > 0 )
     Insert into @lpermitted
          Select Id 
          FROM A_ServerExtLines sel
          Where not exists(select id from @lpermitted where Id = sel.ID)
     
Insert into @commpermitted
     Select sc.ID            
     From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on sc.ALineId=l.Id
     Where not exists(select id from @commpermitted where Id = sc.ID)

Insert into @commpermitted            
     Select sc.ID            
     From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on  sc.BLineId=l.Id
     Where not exists(select id from @commpermitted where Id = sc.ID)

print '------Lines'

delete @A_Stat_Connections_1x1_tmp 
	where id not in (select Id from @commpermitted )

--Numbers 
--Inner
if @innerprefix is not null begin
	declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
	declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
	Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction na on na.NumId = np.Id
		Inner join A_Rules r on na.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id

		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1

			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid

			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid 
				From @temp

			/* */
			Delete From @temp	
		end --\MakePrefixTableAnyWay condition

		

		--Users
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		--Lines
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)
		
		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
		
end --\NUmbers

--Outer NUMBVERS
if @OutNumber is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc
		where  AOutNumber like '%'+@OutNumber+'%'

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc
		where  BOutNumber like '%'+@OutNumber+'%'
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1

end
--\Outer NUMBVERS

--operatorid
if @operatorid is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
		where  AUserId=@operatorid

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id 
		from @A_Stat_Connections_1x1_tmp sc
		where  BUserId=@operatorid
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
end


Select sc.*
FROM A_Stat_Connections_1x1 sc--,@ulpermitted ul,@tasks t
		Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		--Inner Join @commpermitted cp on sc.ID=cp.ID

end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TalkResults_Filter_Journal' ) )
drop procedure dbo.A_TalkResults_Filter_Journal
GO

CREATE    procedure [dbo].[A_TalkResults_Filter_Journal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@ResultValue int = NULL,
	@ResultMask int = NULL,
	@ResultText nvarchar(500) = NULL,
	@CardId uniqueidentifier,
	@showefforts	int
as
begin

declare @tstart2 DateTime
declare @tstop2 DateTime
set @tstart2 = Cast ( Cast ( @tstart as float ) - Floor ( Cast ( @tstart as float ) ) as DateTime )
set @tstop2 = Cast ( Cast ( @tstop as float ) - Floor ( Cast ( @tstop as float ) ) as DateTime )


declare @tmp_card_result table(TaskId  uniqueidentifier, IdChain uniqueidentifier)
delete 	@tmp_card_result

if @ResultValue is not null
	Insert into @tmp_card_result(TaskId,IdChain)	
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Radio stcr on sta.IdAlgVisit=stcr.IdAlgVisit
		Where IdCard = @CardId and ChosenResult = @ResultValue


if @ResultMask is not null 
begin
	Insert into @tmp_card_result ( TaskId, IdChain )
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Check stcc on sta.IdAlgVisit = stcc.IdAlgVisit
			inner join A_BigInt big on big.K & ChosenResult = big.K
		Where IdCard = @CardId 
			and big.K = @ResultMask
end


if @ResultText is not null 
begin
	Insert into @tmp_card_result(TaskId,IdChain)		
		Select IdTask, IdConnection
		From A_Stat_Talk_Algorythms sta
			inner join A_Stat_Talk_Card_Text stct on sta.IdAlgVisit=stct.IdAlgVisit
		Where IdCard=@CardId and ChosenResult=@ResultText
end


declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, IdOperator uniqueidentifier, Number nvarchar ( 50 ) collate database_default, CallTime DateTime, Result int, Info nvarchar ( 500 ) collate database_default, LenTime float, IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ) collate database_default, BLineNum nvarchar ( 5 ) collate database_default) --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ) )

Insert into @te

	Select IdEffort, IdChain, IdTask, IdOperator, AbonentNumber, DateTimeStart, CallResult, CallResultInfo, LenTime, IsRecorded, IdRecDir, ALineNum, BLineNum --ARecFile, BRecFile
	From [oktell_cc_temp].dbo.A_Cube_CC_EffortConnections ec
	Where 	(DateStart between @dstart and @dstop)
		and (TimeStart between @tstart2 and @tstop2)
		and ec.IdTask = @taskid
		and AbonentNumber like '%' + @number + '%'
		and Exists ( Select IdChain From @tmp_card_result Where IdChain = ec.IdChain )


Select te.IdChain, te.Number, IsNull ( u.Name, '?' ) as FullName, te.CallTime, case when ( len ( te.Info ) > 0 ) then ( trt.Name + ' (' + te.Info + ')') else trt.Name end as Info, Cast ( te.LenTime / 86400 as DateTime ) as Length, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( IdRecDir, 0 ) as IdRecDir, IsNull ( ALineNum, '') as ALineNum, IsNull ( BLineNum, '') as BLineNum --IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile 
From @te te
	Left join A_Users u on u.Id = te.IdOperator
	Left join [oktell_cc_temp].[dbo].A_Cube_CC_Cat_TaskResultTypes trt on trt.Id = te.Result
Where te.IdOperator is null or te.IdOperator != 'AB000000-0000-0000-0000-000000000000'

end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallBackOrders_Journal_Get' ) )
drop procedure dbo.A_CallBackOrders_Journal_Get
GO

CREATE        Procedure [dbo].[A_CallBackOrders_Journal_Get]
	@userid		uniqueidentifier,
	@onlynotviewed	bit,
	@onlynotdone	bit
as
begin

/*
-- --
declare @userid uniqueidentifier
declare @onlynotviewed bit
declare @onlynotdone bit

set @userid = '2A594B51-BB89-4DA6-A69F-F48761BAF0D9'
set @onlynotviewed = 0
set @onlynotdone = 0
------------------
*/

declare @numbers table ( Prefix nvarchar ( 20 ) collate database_default)
Insert into @numbers
	Select np.Prefix
	From A_NumberPlan np
		Inner join A_NumberPlanAction npa on np.Id = npa.NumId
		Inner join A_Rules r on npa.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id
	Where rr.ReactId = @userid
	Group by np.Prefix
	


declare @list table 
( IDconn 	uniqueidentifier,
  ClientId 	uniqueidentifier,
  CalledDateTime DateTime,
  IsOrderedTime bit,
  OrderedTime 	DateTime,
  OrderedNumber	nVarChar ( 20 ),
  IsSpecifiedReciever bit,
  Comment 	nVarChar ( 1000 ),
  Done 		bit,
  DoneUserId	uniqueidentifier,
  Viewed 	bit,
  ClientName 	nVarChar ( 200 ),
  DoneUserName  nvarchar ( 50 )
)

Insert Into @list
	Select a.*, cl.Name, u.Name
	From
	(	
		Select cbo.*
		From A_CallBackOrders cbo		
		Where IsSpecifiedReciever = 0
			And ( ( Done = 0 ) or ( @onlynotdone = 0 ) )
			And ( ( Viewed = 0 ) or ( @onlynotviewed = 0 ) )

		Union All

		Select cbo.* 
		From A_CallBackOrders cbo
			Inner join A_CallBackRecievers cbr on cbo.Idconn = cbr.Idconn
			Inner join @numbers n on cbr.IntNumber = n.Prefix
		Where IsSpecifiedReciever = 1
			And ( ( Done = 0 ) or ( @onlynotdone = 0 ) )
			And ( ( Viewed = 0 ) or ( @onlynotviewed = 0 ) )
	)a
		Left join A_Clients cl on a.ClientId = cl.Id
		Left join A_Users u on a.DoneUserId = u.Id



Update A_CallBackOrders 
Set A_CallBackOrders.Viewed = 1 
From A_CallBackOrders, @list lst
Where A_CallBackOrders.IdConn = lst.IdConn



Select * 
From @list
Order by Viewed, Done, CalledDateTime Desc
	
end

GO


/****************************************************************************************************************/


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_GetResourceInfo' ) )
drop procedure dbo.A_CallCenter_GetResourceInfo
GO

CREATE  procedure [dbo].[A_CallCenter_GetResourceInfo]
	@minutes int
as
begin

--  :
--  -   ( )
--  -   ()
--  -   ()
--  -    ()
--  -  ( )
--  -    ( )

--declare @minutes int
--set @minutes = 5

----------------------------------------------------------------------
--   ---------------------------------------------
----------------------------------------------------------------------
Declare @intervalsec int 
set @intervalsec = @minutes * 60

Declare @dtnow DateTime
Declare @dtstart DateTime
Set @dtnow = GetDate()
Set @dtstart = DateAdd ( mi, - @minutes, @dtnow )

Declare @operators table ( id uniqueidentifier )
Insert into @operators
	Select IdUser FROM A_UserParams
	Where IsOperator = 1

Declare @tasks table ( id uniqueidentifier, name nvarchar ( 200 ) collate database_default, IsOutput bit, projectname nvarchar ( 200 ) collate database_default)
Insert into @tasks
	Select t.Id, t.Name, t.IsOutputTask, p.Name 
	From A_TaskManager_Tasks t
		Inner join A_TaskManager_Projects p on t.IdProject = p.Id
	Where Active = 1 
		and Done = 0 
		and StartRunDateTime < GetDate() 
		and StopRunDateTime > GetDate()
		and CreationType = 2
	order by idproject, type

	
Declare @taskoperators table (idtask uniqueidentifier, idoperator uniqueidentifier)
Insert into @taskoperators
	Select TaskId, OperatorId 
	From A_TaskManager_Operators taskopers
		Inner join @operators opers on taskopers.OperatorId = opers.Id

Declare @tasklinecount table (idtask uniqueidentifier, linecount int )
Insert into @tasklinecount
	Select TaskId, Count ( * ) 
	From A_TaskManager_TaskExtLines el
		Inner join @tasks t on t.Id = el.TaskId
	Group By TaskId
	
	Union all
	
	Select Id, IncomingCallsMaxCount
	From A_TaskManager_Tasks
	Where IsOutputTask = 0	

Declare @extlines table ( id uniqueidentifier, name nvarchar ( 100 ) collate database_default)
Insert into @extlines
	Select Id, SystemNum From A_ServerExtLines


declare @tempopers table ( idoperator uniqueidentifier, idtask uniqueidentifier, datetimestart datetime, datetimestop datetime, LenTime float )
Insert into @tempopers
	Select idoperator, idtask, datetimestart, datetimestop, lentime
	From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os
	Where DateTimeStop > @dtstart
		and not os.idtask is null

declare @tempconn table ( IdConn uniqueidentifier, IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
Insert into @tempconn
	Select IdConn, IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections sc
	Where DateTimeStop > @dtstart

Update @tempopers
Set DateTimeStart = @dtstart
Where DateTimeStart < @dtstart

Update @tempopers
Set DateTimeStop = @dtnow
Where DateTimeStop > @dtnow

Update @tempopers
Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400

Update @tempconn
Set DateTimeStart = @dtstart
Where DateTimeStart < @dtstart

Update @tempconn
Set DateTimeStop = @dtnow
Where DateTimeStop > @dtnow

Update @tempconn
Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


declare @output table ( Type int, Id uniqueidentifier, Val float, Name nvarchar ( 100 ) collate database_default, ExtName nvarchar ( 100 ) collate database_default)
		
----------------------------------------------------------------------
--   -----------------------------------------------
----------------------------------------------------------------------

Insert into @output ( Type, Id, Val )
	Select 1, IdOperator, Sum ( LenTime ) / @intervalsec * 100 as Val
	From
	(
		--   
		Select IdOperator, LenTime
		From @tempopers
	
		Union all

		--   
		Select id, 0
		From @operators o
	)a
		Inner join @operators o on a.IdOperator = o.Id
	Group By IdOperator


----------------------------------------------------------------------
--   ----------------------------------------------------
----------------------------------------------------------------------
	
declare @temp51 table ( ALineId uniqueidentifier, BLineId uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
Insert into @temp51
	Select ALineId, BLineId, TimeStart, TimeStop, 0
	From A_Stat_Connections_1x1 sc
	Where TimeStop > @dtstart or TimeStop is null

Update @temp51
Set DateTimeStart = @dtstart
Where DateTimeStart < @dtstart

Update @temp51
Set DateTimeStop = @dtnow
Where DateTimeStop > @dtnow

Update @temp51
Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


declare @temp52 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
Insert into @temp52
	Select el.Id, DateTimeStart, DateTimeStop, LenTime
	From @temp51 sc
		Inner join @extlines el on sc.ALineId = el.Id or sc.BLineId = el.Id



declare @temp5 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
insert into @temp5
	Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
	From @tempconn 
	Where IdConn is null	

	Union all
	
	Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
	From @temp52


Insert into @output ( Type, Id, Val )
	Select 2, IdExtLine, Sum ( LenTime ) / @intervalsec * 100 as Val
	From
	(
		Select IdExtLine, LenTime
		From @temp5

		Union all

		Select Id, 0
		From @extlines
	) a
		Inner join @extlines el on a.IdExtLine = el.Id
	Group By IdExtLine 

----------------------------------------------------------------------
--    -----------------------------------
----------------------------------------------------------------------

declare @taskrescount table ( idtask uniqueidentifier, cnt int )
Insert into @taskrescount 
	Select idtask, sum ( rescnt )
	From
	(
		Select idtask, linecount as rescnt
		From @tasklinecount
	
		Union all

		Select idtask, count ( * ) as rescnt
		From @taskoperators
		Group By Idtask
	)a
	Group By idtask


Declare @tempres table ( IdTask uniqueidentifier, SumLen float )
Insert into @tempres
	Select IdTask, Sum ( LenTime )
	From
	(
		Select IdTask, LenTime 
		From @tempopers
		
		Union all
		
		Select IdTask, LenTime
		From @tempconn
		
		Union all 
		
		Select Id, 0
		From @tasks
	)b
	Group By IdTask


Insert into @output ( Type, Id, Val )
	Select 3, tr.IdTask, case when (cnt = 0) then 0 else SumLen / ( cnt * @intervalsec ) * 100 end as Val
	From @tempres tr
		Inner join @taskrescount trc on tr.IdTask = trc.IdTask
		Inner join @tasks t on tr.IdTask = t.Id

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

Update o
Set o.Name = u.Name
From @output o, A_Users u
Where o.Id = u.Id and o.Type = 1

Update o
Set o.Name = el.Name
From @output o, @extlines el
Where o.Id = el.Id and o.Type = 2

Update o
Set o.Name = t.Name,
    o.ExtName = t.ProjectName
From @output o, @tasks t
Where o.Id = t.Id and o.Type = 3


Select * 
From @output
Order By Type, ExtName, Name

end

GO


/****************************************************************************************************************/

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateOperatorStates' ) )
drop procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
GO

CREATE  Procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
as
begin

set dateformat dmy

if not exists ( Select * FROM master..sysdatabases where name like 'oktell_cc_temp' )
	return

declare @fulllogdt DateTime
declare @logdt DateTime
declare @operlogdt DateTime

Declare @idempty uniqueidentifier
Set @idempty = '00000000-0000-0000-0000-000000000000'
Declare @dtnow DateTime
Set @dtnow = GetDate ()


--print '--------------------------------------start-- ms:  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )
Set @fulllogdt = GetDate ( )

--      
Declare @dtsall DateTime
Select @dtsall = Min ( LastDT ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
if ( @dtsall is null )
	Set @dtsall = DateAdd ( d, -10, GetDate ( ) )

Declare @sc table ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )
Insert Into @sc
	Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId
	From A_Stat_Connections_1x1 sc
	Where TimeStart > @dtsall Or TimeStop > @dtsall Or TimeStop is null

Declare @ush table ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default)
Insert into @ush
	Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '' end
	From A_CallCenter_UserStateHistory
	Where ( TimeEnter > @dtsall Or TimeLeave > @dtsall Or TimeLeave is null )

Declare @uit table ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )
Insert into @uit
	Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask
	Where TimeStart >= @dtsall or TimeStopPost >= @dtsall or TimeStopPost is null
	
	

--print '-----shared-sc- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )

--   
declare @settable table ( Id uniqueidentifier, Name nvarchar ( 100 ) collate database_default)
Insert into @settable
	Select Id, Name From A_Users u 
		Inner join A_UserParams up on u.Id = up.IdUser
	Where IsOperator = 1

Declare ucursor Cursor LOCAL FAST_FORWARD For 
	Select Id, Name From @settable

declare @idoperator uniqueidentifier, @nameoperator nvarchar ( 100 )	

Set @operlogdt = GetDate ( )
Open ucursor
Fetch Next From ucursor Into @idoperator, @nameoperator

While ( @@fetch_status = 0 )
   begin

	Declare @id uniqueidentifier
	Select @id = Id from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Where Id = @idoperator
	if ( @@rowcount = 0 )
		Insert 
		Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
		( Id, Name ) Values ( @idoperator, @nameoperator )
				
				
	--     
	Declare @dts DateTime, @dts1 DateTime

	Select @dts = Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	Where IdOperator = @idoperator	
	
	Select @dts1 = LastDT
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	Where Id = @idoperator
	
	if ( @dts1 > @dts ) or ( @dts is null )
		Set @dts = @dts1
	
	if ( @dts is null )
		set @dts = '01.01.2000'

	--print '-----def------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @operlogdt = GetDate ( )


	--          
	if ( Cast ( @dtnow - @dts as float ) * 1440 > 1 )
	   begin		

		/*
		PriorHandle		= 1,
		WaitingCall		= 2,
		BackRing		= 3,
		TalkAbonent		= 4,
		TalkInside		= 5,
		InsideTalk		= 6,
		PostHandle		= 7,
		TalkOther		= 8,
		CCLunch			= 9,
		CCReady			= 10,
		System			= 11
		*/

		-----------------------------------------------------
		--   (   ) ----------
		-----------------------------------------------------
		Declare @tempo2 table
		(
			State int,
			Priority int,
			DateTimeStart DateTime,
			DateTimeStop DateTime,
			Id int Identity ( 1, 1 ) not null primary key,
			Info nvarchar ( 100 )
		)

		Delete From @tempo2

		Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
			Select State, Case when State in ( 3, 4 ) then 2 else 4 end, 
				TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
			From @ush
			Where OperatorId = @idoperator
				And State in ( 2, 3, 4 )
				And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )
		
		Update @tempo2
		Set State = Case When Priority = 2 then 9 else 10 end

		
		--      - 
		if ( @@rowcount > 0 )
		begin	
			--      
			Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
				Select 11, 5, TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
				From @ush
				Where OperatorId = @idoperator
					And State = 0
					And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )

			Update @tempo2			
			Set 	DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				DateTimeStop = Case When DateTimeStop > @dtnow then @dtnow else DateTimeStop end
			

			--print '-----t2--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

	
			-----------------------------------------------------
			--   (   ) -----
			-----------------------------------------------------
			Declare @tempo1 table
			(
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				StateCat	int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				IdEffort	uniqueidentifier,
				Priority	int,
				Id		int identity ( 1, 1 ) not null primary key
			)

			Delete From @tempo1
			
			Declare @uito table 
			(
				Id uniqueidentifier,
				UserId uniqueidentifier,
				TaskId uniqueidentifier,	
				EffortId uniqueidentifier,
				TimeStart DateTime,
				TimeStopPrior DateTime,
				TimeStopWaitCall DateTime,
				TimeStopBackCall DateTime,
				TimeStopDialog DateTime,
				TimeStopPost DateTime
			)

			Delete From @uito

			Insert Into @uito
			Select *
			From @uit
			Where UserId = @idoperator
				--And ( TimeStart > @dts or TimeStopPost > @dts or TimeStopPost is null )

			--print '-----t1-crtemp-- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 1, 0, 
					TimeStart, 
					TimeStopPrior
				From @uito--#t
				Where Cast ( TimeStopPrior - TimeStart as float ) * 86400 > 0
			
			--print '-----t1-cra----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
			
			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 2, 0, 
					TimeStopPrior, 
					TimeStopWaitCall
				From @uito--#t
				Where Cast ( TimeStopWaitCall - TimeStopPrior as float ) * 86400 > 0

			--print '-----t1-crb----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 3, 0, 
					TimeStopWaitCall, 
					TimeStopBackCall
				From @uito--#t
				Where Cast ( TimeStopBackCall - TimeStopWaitCall as float ) * 86400 > 0

			--print '-----t1-crc----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 6, 0, 
					TimeStopBackCall, 
					TimeStopDialog
				From @uito--#t
				Where Cast ( TimeStopDialog - TimeStopBackCall as float ) * 86400 > 0

			--print '-----t1-crd----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 7, 0, 
					TimeStopDialog,
					TimeStopPost
				From @uito--#t
				Where Cast ( IsNull ( TimeStopPost, @dtnow ) - IsNull ( TimeStopDialog, @dtnow ) as float ) * 86400 > 0

			--print '-----t1-cre----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			--       
			Update @tempo1 
			Set 	DateTimeStart = case 	When ( DateTimeStart < @dts ) then @dts 
							else DateTimeStart end,
		 		DateTimeStop = case 	When ( DateTimeStop > @dtnow ) then @dtnow 
							When ( DateTimeStop < @dts ) then @dts 
							else DateTimeStop end

			Delete From @tempo1
			Where DateTimeStart = DateTimeStop


			--   / 
			Update tmpo
			Set IsOutput = t.IsOutputTask
			From @tempo1 tmpo, A_TaskManager_Tasks t
			Where tmpo.IdTask = t.Id

			--    
			Update tmpo
			Set CallResult = tic.CallResult
			From @tempo1 tmpo, A_TaskManager_Task_IncomingCalls tic
			Where tmpo.IdEffort = tic.Id

			Update tmpo
			Set CallResult = ste.EResult
			From @tempo1 tmpo, A_TaskManager_SubTaskEfforts ste
			Where tmpo.IdEffort = ste.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo1

			--Select * FROM A_Taskmanager_UserInTask


			--print '-----t1-up------ ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
	
			-----------------------------------------------------
			--   () -----------------------
			-----------------------------------------------------
			
			Declare @tempo3 table
			(
				State int,
				Priority int,
				DateTimeStart DateTime,
				DateTimeStop DateTime,
				Id int identity ( 1, 1 ) not null primary key
			)
			
			Delete From @tempo3
						
			Insert into @tempo3
				Select 8, 0, TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
					And FromCC = 0
				/*
				Select Case When FromCC = 0 then 8 When IsBetweenUsers = 1 then 5 else 4 end, 0,
					TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
				*/

			Update @tempo3
			Set DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				Priority = Case When State = 8 then 3 else 0 end
			
			
			--print '-----t3--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-----------------------------------------------------
			--     ---------------------
			-----------------------------------------------------

	--		Select * FROM @tempo1
	--		Select * FROM @tempo2
	--		Select * From @tempo3

	--		Select * FROM @tempo1 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * FROM @tempo2 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * From @tempo3 Where DateTimeStart > '13.02.2007' Order by DateTimeStart

		
			Declare @tempo table
			(
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete from @tempo

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStart, 0
				From @tempo1

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStop, 1
				From @tempo1

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStart, 0
				From @tempo2

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStop, 1
				From @tempo2

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStart, 0
				From @tempo3

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStop, 1
				From @tempo3
			
			--Select * From @tempo Order By DT

			--print '-----tpt-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		
			-----------------------------------------------------
			--   -------------------------------
			-----------------------------------------------------

			declare @res table ( TableN int, Id int, State int, Priority int, DStart DateTime, DStop DateTime )
			Delete From @res

			--        
			-- : 	0 -    (  )
			--		1 -     (  )
			--		2 - 
			--		3 -  
			--		4 -   
			--		5 -   
			declare @p0 int, @p1 int, @p2 int, @p3 int, @p4 int, @p5 int
			declare @s0 int, @s1 int, @s2 int, @s3 int, @s4 int, @s5 int
			declare @t0 int, @t1 int, @t2 int, @t3 int, @t4 int, @t5 int
			declare @i0 int, @i1 int, @i2 int, @i3 int, @i4 int, @i5 int

			Select @p0 = 0, @p1 = 0, @p2 = 0, @p3 = 0, @p4 = 0	
			Select 	@p0 = IsNull ( P0, 0 ), @p1 = IsNull ( P1, 0 ), @p2 = IsNull ( P2, 0 ), @p3 = IsNull ( P3, 0 ), @p4 = IsNull ( P4, 0 ), @p5 = IsNull ( P5, 0 ),
				@s0 = IsNull ( S0, 0 ), @s1 = IsNull ( S1, 0 ), @s2 = IsNull ( S2, 0 ), @s3 = IsNull ( S3, 0 ), @s4 = IsNull ( S4, 0 ), @s5 = IsNull ( S5, 0 )
			From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
			Where Id = @idoperator
		
			--   	
			Declare @tempo_ordered table
			(
				Id int identity ( 1, 1 ) not null,
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete From @tempo_ordered

			Insert into @tempo_ordered ( TableN, TableID, State, Priority, DT, NK )
				Select TableN, TableID, State, Priority, DT, NK From @tempo
				Order By DT

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * From @tempo_ordered


			Declare @tempo_joined table
			(
				s1 int, p1 int, s2 int, p2 int, dstart datetime, dstop datetime, nk1 bit, nk2 bit, t1 int, t2 int, i1 int, i2 int
			)
			Delete From @tempo_joined
		
			Insert into @tempo_joined 
				Select t1.State as s1, t1.Priority as p1, t2.State as s2, t2.Priority as p2,
					t1.DT as dstart, t2.DT as dstop, t1.NK as nk1, t2.NK as nk2,
					t1.TableN, t2.TableN, t1.TableID, t2.TableID
				From @tempo_ordered t1
					Inner join @tempo_ordered t2 on t1.Id + 1 = t2.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo_joined

			--print '-----tjnd------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			--       
			Declare tcursor Cursor LOCAL FAST_FORWARD For 
				Select s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
				From @tempo_joined
				--Where dstart > '21.02.2007'

			declare @st1 int, @pr1 int, @st2 int, @pr2 int, @dstart DateTime, @dstop DateTime, @nk1 bit, @nk2 bit, @tb1 int, @tb2 int, @id1 int, @id2 int
			declare @actualst int, @actualpr int, @actualt int, @actualid int
			declare @lastst int, @lastpr int, @lastt int, @lastid int, @lastdstart datetime, @lastdstop datetime
			declare @dontinsert bit, @updatelast bit
			declare @insertindex int

			set @insertindex = 0
			set @lastt = 0
			set @dontinsert = 1 --     (   )   
		
			Open tcursor
			Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2

			While @@FETCH_STATUS = 0
   			Begin
				----print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
				--	Cast ( @lastst as nvarchar ( 10 ) ) + '  ' + Cast ( @lastpr as nvarchar ( 10 ) )    + '  //  ' + 
				--	Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) )
			
				---    -----		
				if ( @nk1 = 0 )
				begin			
					if ( @pr1 = 0 )
					begin
			    			set @p0 = @p0 + 1
				    		set @s0 = @st1				
						set @t0 = @tb1	
						set @i0 = @id1
					end
					else if ( @pr1 = 1 )
					begin
				    		set @p1 = @p1 + 1
				    		set @s1 = @st1
						set @t1 = @tb1
						set @i1 = @id1
					end
					else if ( @pr1 = 2 )
					begin
			    			set @p2 = @p2 + 1
				    		set @s2 = @st1
						set @t2 = @tb1
						set @i2 = @id1
					end
					else if ( @pr1 = 3 )
					begin
				    		set @p3 = @p3 + 1
				    		set @s3 = @st1
						set @t3 = @tb1
						set @i3 = @id1
					end
					else if ( @pr1 = 4 )
					begin
			    			set @p4 = @p4 + 1
				    		set @s4 = @st1
						set @t4 = @tb1
						set @i4 = @id1
					end
					else if ( @pr1 = 5 )
					begin
						set @p5 = @p5 + 1
						set @s5 = @st1
						set @t5 = @tb1
						set @i5 = @id1
					end
				end

				---    
				set @dontinsert = 0
				if ( @p0 > 0 )
				begin
					set @actualst = @s0
					set @actualpr = 0
					set @actualt = @t0
					set @actualid = @i0
				end
				else if ( @p1 > 0 )
				begin
					set @actualst = @s1
					set @actualpr = 1
					set @actualt = @t1
					set @actualid = @i1
				end
				else if ( @p2 > 0 )
				begin
					set @actualst = @s2
					set @actualpr = 2
					set @actualt = @t2
					set @actualid = @i2
				end
				else if ( @p3 > 0 )
				begin
					set @actualst = @s3
					set @actualpr = 3
					set @actualt = @t3
					set @actualid = @i3
				end
				else if ( @p4 > 0 )
				begin
					set @actualst = @s4
					set @actualpr = 4
					set @actualt = @t4
					set @actualid = @i4
				end
		
				--     4  2  (  )
				--        
				if (( @p4 = 0 ) and ( @p2 = 0 )) or ( @p5 = 0 )
 				set @dontinsert = 1
			
				--print Convert ( nvarchar ( 10 ), @dstart, 108 ) + ' ' + convert ( nvarchar ( 10 ), @dstop, 108 ) + ' state1=' + cast ( @st1 as nvarchar ( 10 ) ) + ' state2=' + cast ( @st2 as nvarchar ( 10 ) ) + ' nk1=' + cast ( @nk1 as nvarchar ( 10 ) ) + ' nk2=' + cast ( @nk2 as nvarchar ( 10 ) )

				--     			
				set @updatelast = 0
				--     ,    -  
				if ( @lastt = 0 )
				begin
					--print 'lastt = 0'
					set @updatelast = 1			
				end
				--          -   
				else if ( @dontinsert = 0 ) and ( @actualst = @lastst )
				begin
					--print 'lastst = actualst' + Cast ( @actualst as nvarchar ( 10 ))
					set @lastdstop = @dstop
				end		
				--       
				else
				begin
					--print 'insert time=' + Convert ( nvarchar ( 10 ), @lastdstart, 108 ) + '-' + convert ( nvarchar ( 10 ), @lastdstop, 108 ) + ' state=' + cast ( @lastst as nvarchar ( 10 ) )
					if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
						Insert Into @res
						Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )
				
					set @updatelast = 1	
				end
			
				if ( @updatelast = 1 )
				begin
					if ( @dontinsert = 1 )
			  			set @lastt = 0
					else
 					begin
						set @lastt = @actualt
						set @lastid = @actualid
						set @lastst = @actualst
						set @lastpr = @actualpr
						set @lastdstart = @dstart
						set @lastdstop = @dstop
					end
				end
			
		
				---    () -----
				if ( @nk2 = 1 )
				begin
					if ( @pr2 = 0 )
						set @p0 = @p0 - 1
					else if ( @pr2 = 1 )
						set @p1 = @p1 - 1
					else if ( @pr2 = 2 )
						set @p2 = @p2 - 1
					else if ( @pr2 = 3 )
						set @p3 = @p3 - 1
					else if ( @pr2 = 4 )
						set @p4 = @p4 - 1
					else if ( @pr2 = 5 )
						set @p5 = @p5 - 1
				end
			
				Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2
			End


			--      ,    
			if ( @dontinsert = 0 )
				if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
					Insert Into @res
					Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )

			Close tcursor
			Deallocate tcursor

			--print '-----curs------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-------------------------------------------------------------------------------------------------
			--          -------------------------------
			-------------------------------------------------------------------------------------------------

			--       (         )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
				Set 	p0 = @p0, p1 = @p1, p2 = @p2, p3 = @p3, p4 = @p4, p5 = @p5,
					s0 = @s0, s1 = @s1, s2 = @s2, s3 = @s3, s4 = @s4, s5 = @s5,
					LastDT = @dtnow
			Where Id = @idoperator

			Declare @operatorstates table
			(
				Id		int identity ( 1, 1 ) not null primary key,
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float
			)

			Delete From @operatorstates

			Insert into @operatorstates ( IdOperator, State, DateTimeStart, DateTimeStop, DateStart, TimeStart, LenTime, 
				IdTask, IsOutput, CallResult )
			Select @idoperator, r.State, r.DStart, r.DStop,
				Cast ( Floor ( Cast ( DStart as Float ) ) as DateTime ),
				Cast ( Cast ( DStart as float ) - Floor ( Cast ( DStart as Float ) ) as DateTime ),				
				Cast ( DStop - DStart as float ) * 86400,
				IdTask, IsOutput, CallResult
			From @res r
				Left join @tempo1 t1 on t1.Id = r.Id and r.TableN = 1


			--     (     -        )
			declare @crupdate int
			Select top 1 @crupdate = CallResult 
			From @operatorstates
			Where not IdTask is null	
			
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
			Set CallResult = @crupdate
			Where IdOperator = @idoperator and not IdTask is null and CallResult is null


			--    
			declare @idt1 int, @state1 int, @dtstart1 DateTime, @dtstop1 DateTime
			
			Select @idt1 = Max ( Id ) 
			From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
			Where IdOperator = @idoperator

			if ( not @idt1 is null )
			   begin
				Select @state1 = State, @dtstart1 = DateTimeStart, @dtstop1 = DateTimeStop 
				From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
				Where Id = @idt1
				
				declare @idt2 int, @state2 int, @dtstart2 DateTime, @dtstop2 DateTime
				Select Top 1 @idt2 = Id, @state2 = State, @dtstart2 = DateTimeStart, @dtstop2 = DateTimeStop
				From @operatorstates
				Order By DateTimeStart

				if ( @state1 = @state2 ) and ( @dtstart2 = @dtstop1 )
				   begin
					Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
					Set 	DateTimeStop = @dtstop2,
						LenTime = Cast ( @dtstop2 - @dtstart1 as float ) * 86400
					Where Id = @idt1

					Delete From @operatorstates
					Where Id = @idt2
			   	   end
			   end

		
			--  
			Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
				( IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime )			
				Select IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime
				From @operatorstates
			
			--print '-----ins-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

		end
		else
		begin
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set LastDT = @dtnow
			Where Id = @idoperator
		end



	   end
	
	--print '--------------------------------------oper--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @logdt = GetDate ( )
	--Set @operlogdt = GetDate ( )

	Fetch Next From ucursor Into @idoperator, @nameoperator
   end

Close ucursor
Deallocate ucursor

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
--Select * FROM [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Order by Datetimestart

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
end

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
