
if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Projects' and TABLE_SCHEMA like 'dbo' )
if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Projects' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'MainScript' )
Alter Table A_TaskManager_Projects
Add MainScript nvarchar ( 500 ) null
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Project_MainScriptGet]'))
drop procedure [dbo].[A_TaskManager_Project_MainScriptGet]
GO

CREATE       Procedure [dbo].A_TaskManager_Project_MainScriptGet
	@id	uniqueidentifier,
	@name	nvarchar ( 500 ) Output
as
begin
	Select @name = MainScript
	From A_TaskManager_Projects
	Where Id = @id

	if ( @@rowcount = 0 )
		set @name = ''
end
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Project_MainScriptSet]'))
drop procedure [dbo].[A_TaskManager_Project_MainScriptSet]
GO

CREATE       Procedure [dbo].A_TaskManager_Project_MainScriptSet
	@id	uniqueidentifier,
	@name 	nvarchar ( 500 )
as
begin
	Update A_TaskManager_Projects
	Set MainScript = @name
	Where Id = @id
end
GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Project_Save]'))
drop procedure [dbo].[A_TaskManager_Project_Save]
GO

CREATE procedure [dbo].A_TaskManager_Project_Save
	@id 	uniqueidentifier,
	@name 	nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@datecreation DateTime,
	@idcreator uniqueidentifier,
	@mainscript nvarchar ( 500 ) = null
as
begin

	Update A_TaskManager_Projects
	Set	Name = @name,
		Description = @description
	Where Id = @id
	

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Projects ( Id, Name, Description, DateCreation, IdCreator, MainScript )
		Values ( @id, @name, @description, @datecreation, @idcreator, @mainscript )

	--      
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_Project' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_Project
		Set Name = @name
		Where Id = @id

end
GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Project_GetAll]'))
drop procedure [dbo].[A_TaskManager_Project_GetAll]
GO

CREATE procedure [dbo].A_TaskManager_Project_GetAll
as
begin

Select Id, Name, Description, DateCreation, IdCreator, MainScript
From A_TaskManager_Projects

end
GO