
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ICQMessages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ICQMessages]
GO

CREATE TABLE [dbo].[A_ICQMessages] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[date_receive] [datetime] NOT NULL ,
	[message] [varchar] (2000) COLLATE database_default NOT NULL ,
	[uin_from] [varchar] (12) COLLATE database_default NOT NULL ,
	[uin_to] [varchar] (12) COLLATE database_default NOT NULL ,
	[is_used] [bit] NOT NULL 
) ON [PRIMARY]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ICQ_AddReceived]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_ICQ_AddReceived]
GO

CREATE  procedure dbo.A_ICQ_AddReceived
	@@uin_from nvarchar ( 12 ),
	@@uin_to nvarchar ( 12 ),
	@@message nvarchar ( 4000 )
as
begin
	Insert into A_ICQMessages
	( uin_from, uin_to, message )
	Values
	( @@uin_from, @@uin_to, @@message )
end

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ICQ_GetFirstUnusedMessage]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_ICQ_GetFirstUnusedMessage]
GO

CREATE  procedure dbo.A_ICQ_GetFirstUnusedMessage
	@@uin_to nvarchar ( 12 )
as
begin
	declare @id int
	declare @uin_from nvarchar( 12 )
	declare @message nvarchar( 4000 )

	Begin tran GetFirstUnusedMessage

	Select top 1 @id = id
	From  A_ICQMessages
	Where uin_to = @@uin_to and is_used = 0
	Order by id asc

	--update A_ICQMessages
	--set is_used = 1 
	--where id = @id

	Select top 1 @uin_from = uin_from, @message = message
	From  A_ICQMessages
	Where id = @id

	--Timely delete used position
	Delete A_ICQMessages
	Where id = @id

	Select @uin_from, @message
	
	Commit tran GetFirstUnusedMessage
end

GO
