if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Admin_Line_Ext_Set' ) )
Drop procedure [dbo].A_Admin_Lines_Ext_Get
GO

CREATE        Procedure [dbo].A_Admin_Lines_Ext_Get
	@id	uniqueidentifier
as
begin

	Select 	
		e.Id,		
		w.Name, 
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled, 
		Cast ( e.CanSimpleOut as bit ) as CanSimpleOut,
		Cast ( e.CanIp as bit ) as CanIp, 
		Cast ( e.CanAutoDial as bit ) as CanAutoDial,
		Cast ( e.CanMobile as bit ) as CanMobile, 
		e.Prefix,
		e.ExtNumber,
		e.Caption,
		e.DialType,
		e.ConnectedPBX,
		e.Type
	
	From A_ServerExtLines e 
		Inner Join A_WorkPlaces w on e.ServerID = w.ID

	Where ( e.ServerID = @id ) or ( @id = '00000000-0000-0000-0000-000000000000' )

	Order By SystemNum


end

GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Admin_Line_Ext_Set' ) )
Drop procedure [dbo].A_Admin_Line_Ext_Set
GO

CREATE     Procedure [dbo].A_Admin_Line_Ext_Set
	@id			uniqueidentifier,
	@extnumber		nvarchar ( 20 ),
	@canautodial		bit,
	@canipout		bit,
	@canmobile		bit,
	@cansimpleout		bit,
	@caption		nvarchar ( 50 ),
	@dt			int,
	@enabled		bit,
	@prefix			nvarchar ( 50 ),
	@connectedpbx		bit,
	@type			int = 1
as
begin

	Update A_ServerExtLines 
	Set 
		ExtNumber 	= @extnumber,
		CanAutoDial 	= @canautodial,
		CanIp 		= @canipout,
		CanMobile 	= @canmobile,
		CanSimpleOut 	= @cansimpleout,
		Caption 	= @caption,
		DialType 	= @dt,
		Enabled 	= @enabled,
		Prefix 		= @prefix,
		ConnectedPBX	= @connectedpbx,
		Type		= @type
	Where
		Id = @id
		
end

GO