if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_OperatorTimeTable' ))
	Drop table dbo.A_CallCenter_OperatorTimeTable
GO

Create table dbo.A_CallCenter_OperatorTimeTable
(
	Id uniqueidentifier,
	IdOperator uniqueidentifier,
	TableType int,
	DayOfWeek int,
	StartTime DateTime,
	FinishTime DateTime
)
GO


if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_OperatorTimeTable_GetAll' ))
	Drop procedure dbo.A_CallCenter_OperatorTimeTable_GetAll
GO

Create procedure dbo.A_CallCenter_OperatorTimeTable_GetAll
as
begin
	Select * 
	FROM A_CallCenter_OperatorTimeTable
	Order By IdOperator, TableType
end
GO


if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_OperatorTimeTable_Save' ))
	Drop procedure dbo.A_CallCenter_OperatorTimeTable_Save
GO

Create procedure dbo.A_CallCenter_OperatorTimeTable_Save
	@idoperator	uniqueidentifier,
	@day		int,
	@starttime	datetime,
	@finishtime 	datetime,
	@tabletype	int
as
begin
	Insert Into A_CallCenter_OperatorTimeTable 
		( ID, IDoperator, TableType, DayOfWeek, StartTime, FinishTime )
	Values
		( NewID(), @idoperator, @tabletype, @day, @starttime, @finishtime )
end
GO


if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.A_CallCenter_OperatorTimeTable_DeleteByOperator' ))
	Drop procedure dbo.A_CallCenter_OperatorTimeTable_DeleteByOperator
GO

CREATE PROCEDURE [dbo].[A_CallCenter_OperatorTimeTable_DeleteByOperator] 	
	@id uniqueidentifier
As
begin
	Delete from A_CallCenter_OperatorTimeTable where IdOperator = @id
end
GO


if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.C_GroupOperatorTimeTable_Save' ))
	Drop procedure dbo.C_GroupOperatorTimeTable_Save
GO

if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.C_GroupOperatorTimeTable_DeleteByOperator' ))
	Drop procedure dbo.C_GroupOperatorTimeTable_DeleteByOperator
GO

if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.C_GroupOperatorTimeTable_GetAll' ))
	Drop procedure dbo.C_GroupOperatorTimeTable_GetAll
GO

if exists ( Select * From sysobjects Where Id = object_id ( 'dbo.C_OperatorTimeTable' ))
	Drop table dbo.C_OperatorTimeTable
GO