if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Redirect_Save' ) )
	Drop procedure dbo.A_Redirect_Save
GO

CREATE procedure [dbo].[A_Redirect_Save]
	@id uniqueidentifier,
	@iduser uniqueidentifier,
	@priorityindex int,
	@creationdate datetime,
	@caption nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@redirectstateonly bit,
	@cascaderedirect bit,
	@destinationnumber nvarchar ( 50 ),
	@enabled bit = 0
as
begin
	Declare @cnt int
	
	Select @cnt = Count ( * ) 
	From A_Redirect 
	Where Id = @id


	if ( @cnt > 0 )
	begin
		declare @prlast int

		Select @prlast = PriorityIndex
		From A_Redirect
		Where Id = @id

		Update A_Redirect
		Set PriorityIndex = PriorityIndex + 1 
		Where PriorityIndex >= @priorityindex 
			and PriorityIndex < @prlast
			and IdUser = @iduser

		Update A_Redirect
		Set PriorityIndex = PriorityIndex - 1
		Where PriorityIndex > @prlast
			and PriorityIndex <= @priorityindex
			and IdUser = @iduser

		Update A_Redirect			
		Set 	IdUser = @iduser,
			PriorityIndex = @priorityindex,
			CreationDate = @creationdate,
			Caption = @caption,
			Description = @description,
			RedirectStateOnly = @redirectstateonly,
			CascadeRedirect = @cascaderedirect,
			DestinationNumber = @destinationnumber
		Where
			Id = @id

	end
	else
	begin
		Update A_Redirect 
		Set PriorityIndex = PriorityIndex + 1
		Where PriorityIndex >= @priorityindex
			And IdUser = @iduser


		Insert Into A_Redirect 
			( Id, IdUser, PriorityIndex, CreationDate, Caption, Description, RedirectStateOnly, CascadeRedirect, Enabled, DestinationNumber )
		Values
			( @id, @iduser, @priorityindex, @creationdate, @caption, @description, @redirectstateOnly, @cascaderedirect, @enabled, @destinationnumber )
	end
	
end
GO

