if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncTable' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncTable
GO

Create procedure A_TaskManager_List_DirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC'
	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC ) With FillFactor = 80	

			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
				( State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		declare @k int
		Set @k = 1
		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 Id, 0, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.Id )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncQuery' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
GO

Create procedure A_TaskManager_List_DirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC'
	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC ) With FillFactor = 80	

			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
				( State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		declare @k int
		Set @k = 1
		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], 0, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetTable' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_GetTable
GO


CREATE  procedure A_TaskManager_List_DirectDB_GetTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], 0, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0		

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetQuery' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_GetQuery
GO

Create procedure A_TaskManager_List_DirectDB_GetQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
		
		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], 0, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0		

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetParams' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_GetParams
GO

Create procedure A_TaskManager_List_DirectDB_GetParams
	@taskid uniqueidentifier,
	@id int
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )
	Set @sql = 'Select * From ' + @tableidx + ' Where Id = ' + cast ( @id as nvarchar( 10 ) )

	exec sp_sqlexec @sql
	
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SetParams_lastnum' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_SetParams_lastnum
GO

Create procedure A_TaskManager_List_DirectDB_SetParams_lastnum
	@taskid uniqueidentifier,
	@id int,
	@lastnum int
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )
	Set @sql = 'Update ' + @tableidx + ' Set NIdx = ' + Cast ( @lastnum as nvarchar ( 10 ) ) + ' Where Id = ' + cast ( @id as nvarchar( 10 ) )

	exec sp_sqlexec @sql
	
end
GO



if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetCountRemain' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_GetCountRemain
GO

Create procedure A_TaskManager_List_DirectDB_GetCountRemain
	@taskid uniqueidentifier	
as
begin
	--      DirectDbMethod
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		declare @sql nvarchar ( 4000 )
		Set @sql = ' 
			Select Count ( Id ) 
			From ' + @tableidx + '
			Where State = 0'
		
		exec sp_sqlexec @sql
	end
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_CacheDelete' ) )
	Drop procedure dbo.A_TaskManager_List_DirectDB_CacheDelete
GO

Create procedure A_TaskManager_List_DirectDB_CacheDelete
	@taskid uniqueidentifier	
as
begin
	--      DirectDbMethod
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		declare @sql nvarchar ( 4000 )
		Set @sql = ' Drop table ' + @tableidx
		
		exec sp_sqlexec @sql
	end
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint' ) )
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
GO

CREATE  Procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
	@idtask uniqueidentifier,
	@id 	int,
	@state 	int
as

begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'

	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		declare @sql nvarchar ( 4000 )
		Set @sql = ' Update ' + @tableidx + ' Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
		
		exec sp_sqlexec @sql
	end
end
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Task_ClearStatistics' ) )
	Drop procedure dbo.A_TaskManager_Task_ClearStatistics
GO

CREATE Procedure dbo.A_TaskManager_Task_ClearStatistics
	@id uniqueidentifier
as
begin
	Delete 
	From dbo.A_TaskManager_SubTasks
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskEfforts
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskNumber
	Where TaskId = @id

	Update dbo.A_TaskManager_Tasks
	Set Done = 0
	Where Id = @id	
	
	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id	

end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Task_Delete' ) )
	Drop procedure dbo.A_TaskManager_Task_Delete
GO

CREATE Procedure [dbo].[A_TaskManager_Task_Delete]
	@id 	uniqueidentifier
as
begin
	Delete 
	From A_TaskManager_Tasks 
	Where Id = @id

	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Task_DeleteById' ) )
	Drop procedure dbo.A_TaskManager_Task_DeleteById
GO

CREATE  Procedure dbo.A_TaskManager_Task_DeleteById
	@id uniqueidentifier
as
begin
	Delete 
	From A_TaskManager_Tasks	
	Where id = @id

	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Task_DeleteByName' ) )
	Drop procedure dbo.A_TaskManager_Task_DeleteByName
GO

CREATE  Procedure dbo.A_TaskManager_Task_DeleteByName
	@name 	nvarchar(500)
as

begin
	declare @id uniqueidentifier

	Select @id = Id 
	From A_TaskManager_Tasks	
	Where name = @name

	Delete 
	From A_TaskManager_Tasks
	Where Id = @id

	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
end
GO




if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_Tasks' ) )
if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Tasks' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DirectDbMethod' )
Alter Table A_TaskManager_Tasks
Add DirectDbMethod int not null default 0, DirectDbMethodProc nvarchar ( 200 ) not null default ''
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TaskManager_AllTask_Get' ) )
DROP PROCEDURE dbo.A_TaskManager_AllTask_Get
GO


CREATE Procedure dbo.A_TaskManager_AllTask_Get
as

begin
	select 	
		Id,
		IdProject,
		Name,
		Active,
		Done,
		Type,
		IvrName,
		StopReason,
		TalkScript,
		PauseWhenBusy,
		PauseWhenNotRespond,
		MaxEffortCountBusy,
		MaxEffortCountNotRespond,
		MinTimeToCheckDone,
		TryConnectTime,
		ChoiceOperator,
		DeleteAfterSuccess,
		IsExtNumber,
		IsOutputTask,
		Resulted,
		ResultType,
		ResultInfo,
		ResultDateTime,
		CreationUserId,
		CreationType,
		CreationDateTime,
		StartRunDateTime,
		StopRunDateTime,
		CanAddDynamically,
		TagDouble,
		ListId,
		OperatorShowQuery,
		OperatorShowNotify,
		ProgressCall,
		ProgressCallMaxCount,
		ProgressCallKeepQueue,
		PredictCall,
		PredictCallOffsetSec,
		QueueUse,
		QueueMaxCount,
		QueueMusic,
		QueueLoyality,
		ChoiceAbonent,
		ChoiceNumber,
		ChoiceTable,
		ChoiceProgress,
		DontSetDone,
		PauseSyncListWaitingNewAbonent,
		IncomingCallsMaxCount,
		ServiceScript,
		DialCallerId,
		IncomingUpdateIfExists,
		ActiveOnHolidays,
		Code,
		PauseSyncListForcedSec,
		QueueMaxTimeMinutes,
		PredictCallErrProbability,
		QueueRandomFromPath,
		SaveDB,
		DirectDbMethod,
		DirectDbMethodProc
	
	from A_TaskManager_Tasks
end
GO

if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_TaskManager_Task_Save' ) )
DROP PROCEDURE dbo.A_TaskManager_Task_Save
GO

CREATE Procedure dbo.A_TaskManager_Task_Save

	@id 				uniqueidentifier,
	@idproject			uniqueidentifier,
	@name				nvarchar(500),
	@active				int,
	@done				int,
	@type				int,
	@ivrname			nvarchar(500),
	@stopreason			int,
	@talkscript			nvarchar(500),
	@pausewhenbusy			float,
	@pausewhennotrespond		float,
	@maxeffortcountbusy		int,
	@maxeffortcountnotrespond	int,
	@mintimetocheckdone		int,
	@tryconnecttime			int,
	@choiceoperator			int,
	@deleteaftersuccess		int,
	@isextnumber			int,
	@isoutputtask			int,
	@resulted			int,
	@resulttype			int,
	@resultinfo			nvarchar(500),
	@resultdatetime			datetime,
	@creationuserid			uniqueidentifier,
	@creationtype			int,
	@creationdatetime		datetime,
	@startrundatetime		datetime,
	@stoprundatetime		datetime,
	@canadddynamically		int,
	@tagdouble			float,
	@listid				uniqueidentifier,
	@operatorshowquery		bit,
	@operatorshownotify		bit,
	@progresscall			bit,
	@progresscallmaxcount		int,
	@progresscallkeepqueue		bit,
	@predictcall			bit,
	@predictcalloffsetsec		int,
	@queueuse			bit,
	@queuemaxcount			int,
	@queuemusic			nvarchar ( 500 ),
	@queueloyality			int,
	@choiceabonents			int,
	@choicenumber			int,
	@choicetable			int,
	@choiceprogress			int,
	@dontsetdone			bit,
	@pausesynclistwaitingnewabonent int,
	@incomingcallsmaxcount		int,
	@servicescript			nvarchar ( 200 ),
	@dialcallerid			nvarchar ( 20 ),
	@incomingupdateifexists		bit,
	@activeonholidays		bit,
	@code				nvarchar ( 30 ),
	@pausesynclistforcedsec		int,
	@queuemaxtimeminutes		int,
	@predictcallerrprobability	int,
	@queuerandomfrompath		nvarchar ( 200 ),
	@savedb				bit,
	@directdbmethod			int = 0,
	@directdbmethodproc		nvarchar ( 200 ) = ''

as

begin
	select name from A_TaskManager_Tasks where id = @id

	if ( @@rowcount > 0 )
	begin
		update A_TaskManager_Tasks
		   Set 
			IdProject			= @idproject,
			Name 				= @name, 			
			Active 				= @active, 
			Done 				= @done, 
			Type 				= @type, 
			IvrName 			= @ivrname, 
			StopReason 			= @stopreason, 
			TalkScript 			= @talkscript, 
			PauseWhenBusy 			= @pausewhenbusy, 
			PauseWhenNotRespond 		= @pausewhennotrespond, 
			MaxEffortCountBusy 		= @maxeffortcountbusy, 
			MaxEffortCountNotRespond 	= @maxeffortcountnotrespond, 
			MinTimeToCheckDone 		= @mintimetocheckdone, 
			TryConnectTime 			= @tryconnecttime, 
			ChoiceOperator			= @choiceoperator,
			DeleteAfterSuccess 		= @deleteaftersuccess, 
			IsExtNumber 			= @isextnumber, 
			IsOutputTask			= @isoutputtask,
			Resulted 			= @resulted, 
			ResultType 			= @resulttype, 
			ResultInfo 			= @resultinfo, 
			ResultDateTime 			= @resultdatetime, 
			CreationUserId 			= @creationuserid, 
			CreationType 			= @creationtype, 
			CreationDateTime 		= @creationdatetime,
			StartRunDateTime		= @startrundatetime,
			StopRunDateTime			= @stoprundatetime,
			CanAddDynamically		= @canadddynamically,	
			TagDouble			= @tagdouble,	
			ListId				= @listid,
			OperatorShowQuery		= @operatorshowquery,
			OperatorShowNotify		= @operatorshownotify,
			ProgressCall			= @progresscall,
			ProgressCallMaxCount		= @progresscallmaxcount,
			ProgressCallKeepQueue		= @progresscallkeepqueue,
			PredictCall			= @predictcall,
			PredictCallOffsetSec		= @predictcalloffsetsec,
			QueueUse 			= @queueuse,
			QueueMaxCount			= @queuemaxcount,
			QueueMusic			= @queuemusic,
			QueueLoyality			= @queueloyality,
			ChoiceAbonent			= @choiceabonents,
			ChoiceNumber			= @choicenumber,
			ChoiceTable			= @choicetable,
			ChoiceProgress			= @choiceprogress,
			DontSetDone			= @dontsetdone,
			PauseSyncListWaitingNewAbonent	= @pausesynclistwaitingnewabonent,
			IncomingCallsMaxCount		= @incomingcallsmaxcount,
			ServiceScript			= @servicescript,
			DialCallerId			= @dialcallerid,
			IncomingUpdateIfExists		= @incomingupdateifexists,
			ActiveOnHolidays		= @activeonholidays,
			Code				= @code,
			PauseSyncListForcedSec		= @pausesynclistforcedsec,
			QueueMaxTimeMinutes		= @queuemaxtimeminutes,
			PredictCallErrProbability	= @predictcallerrprobability,
			QueueRandomFromPath		= @queuerandomfrompath,
			SaveDB				= @savedb,
			DirectDbMethod			= @directdbmethod,
			DirectDbMethodProc		= @directdbmethodproc
 		   Where
			Id 				= @id
	end
	else
	begin
		insert into A_TaskManager_Tasks
		(
			Id, 
			IdProject,
			Name, 
			Active, 
			Done, 
			Type, 
			IvrName, 
			StopReason, 
			TalkScript, 
			PauseWhenBusy, 
			PauseWhenNotRespond, 
			MaxEffortCountBusy, 
			MaxEffortCountNotRespond, 
			MinTimeToCheckDone, 
			TryConnectTime, 
			ChoiceOperator, 
			DeleteAfterSuccess, 
			IsExtNumber, 
			IsOutputTask, 
			Resulted, 
			ResultType, 
			ResultInfo, 
			ResultDateTime, 
			CreationUserId, 
			CreationType, 
			CreationDateTime, 
			StartRunDateTime, 
			StopRunDateTime, 
			CanAddDynamically, 
			TagDouble, 
			ListId,
			OperatorShowQuery,
			OperatorShowNotify,
			ProgressCall,
			ProgressCallMaxCount,
			ProgressCallKeepQueue,
			PredictCall,
			PredictCallOffsetSec,
			QueueUse,
			QueueMaxCount,
			QueueMusic,
			QueueLoyality,
			ChoiceAbonent,
			ChoiceNumber,
			ChoiceTable,
			ChoiceProgress,
			DontSetDone,			
			PauseSyncListWaitingNewAbonent,
			IncomingCallsMaxCount,
			ServiceScript,
			DialCallerId,
			IncomingUpdateIfExists,
			ActiveOnHolidays,
			Code,
			PauseSyncListForcedSec,
			QueueMaxTimeMinutes,
			PredictCallErrProbability,
			QueueRandomFromPath,
			SaveDB,
			DirectDbMethod,
			DirectDbMethodProc
		) 
		Values  
		(
			@id,
			@idproject,
			@name,
			@active,
			@done,
			@type,
			@ivrname,
			@stopreason,
			@talkscript,
			@pausewhenbusy,
			@pausewhennotrespond,
			@maxeffortcountbusy,
			@maxeffortcountnotrespond,
			@mintimetocheckdone,
			@tryconnecttime,
			@choiceoperator,
			@deleteaftersuccess,
			@isextnumber,
			@isoutputtask,
			@resulted,
			@resulttype,
			@resultinfo,
			@resultdatetime,
			@creationuserid,
			@creationtype,
			@creationdatetime,
			@startrundatetime,
			@stoprundatetime,
			@canadddynamically,
			@tagdouble,
			@listid,
			@operatorshowquery,
			@operatorshownotify,
			@progresscall,
			@progresscallmaxcount,
			@progresscallkeepqueue,
			@predictcall,
			@predictcalloffsetsec,
			@queueuse,
			@queuemaxcount,
			@queuemusic,
			@queueloyality,
			@choiceabonents,
			@choicenumber,
			@choicetable,
			@choiceprogress,
			@dontsetdone,
			@pausesynclistwaitingnewabonent,
			@incomingcallsmaxcount,
			@servicescript,
			@dialcallerid,
			@incomingupdateifexists,
			@activeonholidays,
			@code,
			@pausesynclistforcedsec,
			@queuemaxtimeminutes,
			@predictcallerrprobability,
			@queuerandomfrompath,
			@savedb,
			@directdbmethod,
			@directdbmethodproc
		)		
	end


	--      
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_Task' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_Task
		Set Name = @name
		Where Id = @id
end

GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetTaskPointInfo_Direct' ) )
	Drop procedure dbo.A_TaskManager_List_GetTaskPointInfo_Direct
GO

CREATE procedure [dbo].[A_TaskManager_List_GetTaskPointInfo_Direct]
	@idtask uniqueidentifier,
	@idpoint int
as
begin
	Select IdInList, NResult, isnull ( NextEffortTime, GetDate() ) as NextEffortTime
	From A_TaskManager_SubTasks st
	Where TaskId = @idtask 
		And IdInList = @idpoint
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetTaskNumberInfo_Direct' ) )
	Drop procedure dbo.A_TaskManager_List_GetTaskNumberInfo_Direct
GO

CREATE  procedure [dbo].[A_TaskManager_List_GetTaskNumberInfo_Direct]
	@idtask uniqueidentifier,
	@idpoint int
as
begin

	Select IdInList, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, isnull ( NextEffortTime, GetDate() ) as NextEffortTime
	From A_TaskManager_SubTaskNumber stn		
	Where TaskId = @idtask 
		And IdInList = @idpoint
end
GO