if not exists ( select name from sysindexes where id=object_id ( 'A_TaskManager_SubTasks' ) and name = 'idx_SubTasks_TId_IdP' )
	Create Nonclustered Index idx_SubTasks_TId_IdP ON dbo.A_TaskManager_SubTasks
	( TaskId, IdInList ) With FillFactor = 80
GO


if not exists ( select name from sysindexes where id=object_id ( 'A_TaskManager_SubTaskNumber' ) and name = 'idx_SubTasksNumber_TId_IdP_N' )
	Create Nonclustered Index idx_SubTasksNumber_TId_IdP_N ON dbo.A_TaskManager_SubTaskNumber
	( TaskId, IdInList, Number ) With FillFactor = 80
GO


if not exists ( select name from sysindexes where id=object_id ( 'A_Stat_Connections_1x1' ) and name = 'idx_StatConnections_IdChain' )
	Create Nonclustered Index idx_StatConnections_IdChain ON dbo.A_Stat_Connections_1x1
	( IdChain ) With FillFactor = 80
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint' ) )
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
GO


CREATE Procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
	@idtask uniqueidentifier,
	@id 	int,
	@state 	int
as

begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'

	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		declare @sql nvarchar ( 4000 )
		Set @sql = ' Update ' + @tableidx + ' With ( ROWLOCK ) Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
		
		exec sp_sqlexec @sql
	end
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Office_GetJournal' ) )
	Drop procedure dbo.A_Stat_Office_GetJournal
GO

CREATE procedure [dbo].[A_Stat_Office_GetJournal]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	@conntype int = -1
as
begin	
	Select top 0 * into #t from A_Stat_Connections_1x1
	Insert into #t Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype

	Select top 1000 t.*, TimeStop - TimeAnswer as Length, TimeAnswer - TimeStart as AnswerLength
	From #t t
	Order By TimeStart Desc
end

GO