
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ICQMessages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ICQMessages]
GO

CREATE TABLE [dbo].[A_ICQMessages] (
     [id] [int] IDENTITY (1, 1) NOT NULL ,
     [date_receive] [datetime] NOT NULL ,
     [message] [varchar] (2000) COLLATE database_default NOT NULL ,
     [uin_from] [varchar] (12) COLLATE database_default NOT NULL ,
     [uin_to] [varchar] (12) COLLATE database_default NOT NULL ,
     [is_used] [bit] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ICQMessages] WITH NOCHECK ADD 
     CONSTRAINT [DF_A_ICQMessages_date_receive] DEFAULT (getdate()) FOR [date_receive],
     CONSTRAINT [DF_A_ICQMessages_is_used] DEFAULT (0) FOR [is_used]
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_ICQ_GetFirstUnusedMessage' ) )
	Drop procedure dbo.A_ICQ_GetFirstUnusedMessage
GO

Create procedure dbo.A_ICQ_GetFirstUnusedMessage
	@@uin_to nvarchar ( 12 )
as
begin

	declare @id int
	declare @uin_from nvarchar( 12 )
	declare @message nvarchar( 4000 )
	declare @date datetime

	Begin tran GetFirstUnusedMessage

	Select top 1 @id = id
	From  A_ICQMessages
	Where uin_to = @@uin_to and is_used = 0
	Order by id asc

	--update A_ICQMessages
	--set is_used = 1 
	--where id = @id

	Select top 1 @uin_from = uin_from, @message = message, @date = date_receive
	From  A_ICQMessages
	Where id = @id

	--Timely delete used position
	Delete A_ICQMessages
	Where id = @id

	if ( not @uin_from is null )
		Select @uin_from, @message, @date
	
	Commit tran GetFirstUnusedMessage
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_ICQ_AddReceived' ) )
	Drop procedure dbo.A_ICQ_AddReceived
GO


CREATE  procedure dbo.A_ICQ_AddReceived
	@@uin_from nvarchar ( 12 ),
	@@uin_to nvarchar ( 12 ),
	@@message nvarchar ( 4000 )
as
begin
	Insert into A_ICQMessages
	( uin_from, uin_to, message )
	Values
	( @@uin_from, @@uin_to, @@message )
end
GO

