if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_GetAllUnShown_ForUser' ) )
	drop procedure dbo.A_UserNotifyLog_GetAllUnShown_ForUser
GO

Create  Procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
	@id 	uniqueidentifier
as
begin
	BEGIN TRAN

	Select Top 15 * 
	FROM A_User_NotifyLog WITH ( TABLOCK )
	where IDuser = @id and WasShown = 0
	Order by NotifyDateTime Desc

	Update A_User_NotifyLog with ( TABLOCK )
		Set WasShown = 1 
		Where IdUser = @id and WasShown = 0

	COMMIT
end
GO


if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_Delete' ) )
	drop procedure dbo.A_UserNotifyLog_Delete
GO

CREATE   Procedure [dbo].[A_UserNotifyLog_Delete]
	@id		uniqueidentifier
as
begin
	Delete 
	From A_User_NotifyLog WITH ( TABLOCK )
	Where Id = @id
end
GO


if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_Save' ) )
	drop procedure dbo.A_UserNotifyLog_Save
GO


CREATE  Procedure [dbo].[A_UserNotifyLog_Save]
	@userid		uniqueidentifier,
	@datetime	datetime,
	@logtype	int,
	@sendertext	nvarchar(500),
	@text		nvarchar(4000),
	@wasshown	int
as
begin
	declare @id uniqueidentifier
	set @id = NewId ()

	select * FROM A_Users where ID = @userid

	if ( @@rowcount > 0 )
		Insert into A_User_NotifyLog WITH ( TABLOCK )
			( Id, IdUser, NotifyDateTime, LogType, TextSender, TextInfo, WasShown )
		Values
			( @id, @userid, @datetime, @logtype, @sendertext, @text, @wasshown )

end
GO



if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_SetShownById' ) )
	drop procedure dbo.A_UserNotifyLog_SetShownById
GO


CREATE Procedure [dbo].[A_UserNotifyLog_SetShownById]
	@id 	uniqueidentifier
as
begin
	Update A_User_NotifyLog with ( TABLOCK )
		Set WasShown = 1 where Id = @id
end
GO
