
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserNotifyLog_GetAllUnShown_ForUser' ) )
	drop procedure dbo.A_UserNotifyLog_GetAllUnShown_ForUser
GO



CREATE   Procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
	@id 	uniqueidentifier
as
begin

	Select Top 15 * 
	FROM A_User_NotifyLog --WITH ( TabLock, HoldLock )
	where IDuser = @id and WasShown = 0
	Order by NotifyDateTime Desc

	Update A_User_NotifyLog --with ( TABLOCK )
		Set WasShown = 1 
		Where IdUser = @id and WasShown = 0

end
GO

-------------------------------------------------------------------------------------------

if not exists ( Select * FROM sysindexes where name = 'idx_Notify_user_wasshown' )	
	Create nonclustered index idx_Notify_user_wasshown on dbo.A_User_NotifyLog ( IDuser, WasShown ) with FillFactor = 50
GO


------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserNotifyLog_Save' ) )
	drop procedure dbo.A_UserNotifyLog_Save
GO


CREATE Procedure [dbo].[A_UserNotifyLog_Save]
	@userid		uniqueidentifier,
	@datetime	datetime,
	@logtype	int,
	@sendertext	nvarchar(500),
	@text		nvarchar(4000),
	@wasshown	int
as
begin
	declare @id uniqueidentifier
	set @id = NewId ()

	if exists ( Select id From A_Users Where Id = @userid )
		
		Insert into A_User_NotifyLog
			( Id, IdUser, NotifyDateTime, LogType, TextSender, TextInfo, WasShown )
		Values
			( @id, @userid, @datetime, @logtype, @sendertext, @text, @wasshown )
end

GO


------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterCallResult' ) )
	Drop procedure dbo.A_CallCenter_Temp_UpdateAfterCallResult
GO


Create procedure [dbo].[A_CallCenter_Temp_UpdateAfterCallResult]
	@idchain uniqueidentifier,
	@ideffort uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@callresult int,
	@callresultinfo nvarchar ( 100 ),
	@lenqueue float,
	@timestart datetime,
	@idextline uniqueidentifier,
	@dtnow datetime = null
	
as 
begin	
/*	----------------------------------------
	declare @idchain uniqueidentifier
	declare @ideffort uniqueidentifier
	declare @idinlist int
	declare @idtask uniqueidentifier
	declare @number nvarchar ( 20 )
	declare @callresult int
	declare @callresultinfo nvarchar ( 100 )
	declare @lenqueue int
	declare @timestart datetime
	declare @idextline uniqueidentifier
	Select @idchain = 'FD024817-A629-49E6-B550-19EC14787AC8', @ideffort = '1C3468C3-A6FE-4B36-9393-B813CFFB2815', 
		@idinlist = 63, @idtask = 'D48D5F57-6B93-4529-A205-A6B5063320A4', 
		@number = '  ', @callresult = 5, @callresultinfo = '', @lenqueue = 15, @timestart = '26.02.2007 12:04:57',
		@idextline = '00000000-0000-0000-0000-000000000000'
	-----------------------------------------
*/
	if ( @dtnow is null )
		set @dtnow = GetDate()

	--    
	Declare @idproject uniqueidentifier
	Declare @isoutput bit
	Declare @idlist uniqueidentifier

	Select 	@idproject = IdProject,
		@isoutput = IsOutputTask,
		@idlist = ListId
	From A_TaskManager_Tasks 
	Where Id = @idtask

	-------------------------------------------------------------
	----     -------------------------------
	-------------------------------------------------------------

	--  
	Declare @temp table 
	( 
		IdProject	uniqueidentifier,	--1
		IdTask 		uniqueidentifier,	--1
		IsOutput	bit,			--1
		IdEffort	uniqueidentifier,	--1
		IdOperator 	uniqueidentifier,	--3
		IdInList	int,			--1
		AbonentNumber 	nvarchar ( 20 ),	--1
		CallResult	int,			--1
		CallResultInfo	nvarchar ( 100 ),	--1
		DateTimeStart 	DateTime, 		--
		DateStart 	DateTime, 		--
		TimeStart 	DateTime,		--
		DateTimeStop	DateTime,
		IdConn		uniqueidentifier,	--
		IdChain 	uniqueidentifier,	--
		IdAUser		uniqueidentifier,	--
		IdBUser		uniqueidentifier,	--
		IdExtLine 	uniqueidentifier,	--2
		LenTime 	float, 			--
		LenQueue 	float,			--1
		IsBetweenOp	bit,			--3
		OpponentInfo 	nvarchar ( 100 ),	--6
		IsHandled 	bit,			--4
		IsSuccess	bit,			--5
		IsRecorded	bit,			--
		IdRecDir	int,			--
		ALineNum	nvarchar ( 5 ),		--
		BLineNum	nvarchar ( 5 )		--
		--ARecFile	nvarchar ( 100 ),	--
		--BRecFile 	nvarchar ( 100 )	--
	)

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'


	--     (0, 1)
	Insert Into @temp ( IdProject, IdTask, IsOutput, IdEffort, IdInList, AbonentNumber, CallResult, 
				CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop, 
				IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, 
				IsRecorded, IdRecDir, ALineNum, BLineNum ) --ARecFile, BRecFile )
	Select @idproject, @idtask, @isoutput, @ideffort, @idinlist, @number, @callresult, @callresultinfo, 
		TimeStart, 
		Cast ( Floor ( Cast ( TimeStart as Float ) ) as DateTime ),
		Cast ( Cast ( TimeStart as Float ) - FLOOR ( Cast ( TimeStart as Float ) ) as DateTime ),
		TimeStop,		
		Id, IdChain, AUserId, BUserId, 
		@idextline,
		Cast ( ( TimeStop - TimeAnswer ) as float ) * 86400 as LenTime, @lenqueue,
		IsRecorded, IdRecDir, ALineNum, BLineNum --ARecFile, BRecFile
	FROM A_Stat_Connections_1x1 --With ( TabLock )
	Where IdChain = @idchain

	--      ?
	If ( @@rowcount = 0 )
	   begin

		Insert Into @temp 
		( 	IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 
			--IsBetweenOp, 
			IsHandled, IsSuccess
			--IsRecorded, IdRecDir, ARecFile, BRecFile 
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @dtnow,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @dtnow - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0
			--0, 0, '', ''
		)
	   end
	else
	   begin
	
		--       (3)---------
		Declare @users table ( Id uniqueidentifier primary key )
		Insert into @users
			Select Id From A_Users

		Insert into @users Values ( 'AB000000-0000-0000-0000-000000000000' )

		Update t
		Set 	IdOperator = case when ( @isoutput > 0 ) then IdAUser else IdBUser end, 
			IsBetweenOp = 0
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id or t.IDBUser = u2.Id

		Update t
		Set 	IdOperator = IdAUser, 
			IsBetweenOp = 1
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id and t.IdBUser = u2.Id
		

		--  ? (4)--------------------------------
		Declare @cnt int
		Select @cnt = Count ( * ) FROM @temp t Where DateTimeStart > @timestart
		
		Update t
		Set IsHandled = case when ( @cnt > 0 ) then 1 else 0 end
		From @temp t

		--  ? (5)---------------------------------------
		Update t
		Set IsSuccess = case When ( @callresult = 5 ) then 1 else 0 end
		From @temp t
	   end

	--    (6)----------------
	Declare @opinfo nvarchar ( 255 )
	Select @opinfo = ''
	Update t
	Set OpponentInfo = @opinfo
	From @temp t

	--   ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] --With ( TabLock )
	Select * FROM @temp

	--     
	
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name From A_TaskManager_Tasks Where Id = @idtask	

	--     
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject

	-------------------------------------------------------------
	----    -------------------------------
	-------------------------------------------------------------
	--     DBProvider

end
GO

------------------------------------------------------------------------------------------



if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateOperatorStates' ) )
	drop procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
GO

CREATE Procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
	@dtnow datetime = null
as
begin

set dateformat dmy

if ( @dtnow is null )
	set @dtnow = GetDate()

if not exists ( Select * FROM master..sysdatabases where name like 'oktell_cc_temp' )
	return

--declare @fulllogdt DateTime
--declare @logdt DateTime
--declare @operlogdt DateTime
declare @sqltext nvarchar ( 4000 )

Declare @idempty uniqueidentifier
Set @idempty = '00000000-0000-0000-0000-000000000000'

--print '   ## start creating temp tables ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print 's 00  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '--------------------------------------start-- ms:  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )
--Set @fulllogdt = GetDate ( )

--      
Declare @dtsall DateTime
Select @dtsall = Min ( LastDT ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
if ( @dtsall is null )
	Set @dtsall = DateAdd ( d, -10, @dtnow )

--set @dtsall = '6.10.2007 14:20'
--print @dtsall
--print 's 01  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

Declare @sc table ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

/*
Insert Into @sc
	Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId
	From A_Stat_Connections_1x1 sc With ( TabLock )
	Where TimeStart > @dtsall Or TimeStop > @dtsall Or TimeStop is null

print 's 02_1  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
*/

	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos01' ) )
		Drop Table #tmpos01
	Create table #tmpos01 ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

	set @sqltext = 'Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId 
		From A_Stat_Connections_1x1 sc 
		Where TimeStart > @dtt1 Or TimeStop > @dtt1 Or TimeStop is null'
	Insert Into #tmpos01
		exec sp_executesql @sqltext, N'@dtt1 datetime', @dtsall
	Insert into @sc
		Select * FROM #tmpos01

	drop table #tmpos01


--print 's 02_2  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

Declare @ush table ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default)

/*
Insert into @ush
	Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '' end
	From A_CallCenter_UserStateHistory with ( TabLock )
	Where ( TimeEnter > @dtsall Or TimeLeave > @dtsall Or TimeLeave is null )

*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos02' ) )
		Drop Table #tmpos02
	Create table #tmpos02 ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default )

	set @sqltext = 'Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '''' end
		From A_CallCenter_UserStateHistory 
		Where ( TimeEnter > @dtt1 Or TimeLeave > @dtt1 Or TimeLeave is null )'

	Insert Into #tmpos02
		exec sp_executesql @sqltext, N'@dtt1 datetime', @dtsall
	Insert into @ush
		Select * FROM #tmpos02	

	drop table #tmpos02


Declare @uit table ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )
/*
Insert into @uit
	Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask
	Where TimeStart >= @dtsall or TimeStopPost >= @dtsall or TimeStopPost is null
*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos03' ) )
		Drop Table #tmpos03
	Create table #tmpos03 ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )

	set @sqltext = 'Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask 
	Where TimeStart >= @dtt1 or TimeStopPost >= @dtt1 or TimeStopPost is null'

	Insert Into #tmpos03
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	Insert into @uit
		Select * FROM #tmpos03	

	drop table #tmpos03


Declare @umaxdts table ( UserId uniqueidentifier, MaxDTS DateTime  )

Insert into @umaxdts
	Select IdOperator, Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]-- With ( TabLock )
	Group By IdOperator

--print '   ## created all tables. Starting cursor cycle ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '-----shared-sc- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )


--   
declare @settable table ( Id uniqueidentifier, Name nvarchar ( 100 ) collate database_default)
Insert into @settable
	Select Id, Name From A_Users u 
		Inner join A_UserParams up on u.Id = up.IdUser
	Where IsOperator = 1


Declare ucursor Cursor LOCAL FAST_FORWARD For 
	Select Id, Name From @settable

declare @idoperator uniqueidentifier, @nameoperator nvarchar ( 100 )	

--Set @operlogdt = @dtnow

Open ucursor
Fetch Next From ucursor Into @idoperator, @nameoperator

While ( @@fetch_status = 0 )
   begin

	Declare @id uniqueidentifier
	Select @id = Id from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Where Id = @idoperator
	if ( @@rowcount = 0 )
		Insert 
		Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
		( Id, Name ) Values ( @idoperator, @nameoperator )
				
				
	--     
	Declare @dts DateTime, @dts1 DateTime

	/*
	Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	Where IdOperator = @idoperator	
	*/
	Select @dts = MaxDTS
	From @umaxdts
	Where UserId = @idoperator
	
	Select @dts1 = LastDT
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	Where Id = @idoperator
	
	if ( @dts1 > @dts ) or ( @dts is null )
		Set @dts = @dts1
	
	if ( @dts is null )
		set @dts = '01.01.2000'

	--print '-----def------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @operlogdt = GetDate ( )


	--          
	if ( Cast ( @dtnow - @dts as float ) * 1440 > 1 )
	   begin		

		/*
		PriorHandle		= 1,
		WaitingCall		= 2,
		BackRing		= 3,
		TalkAbonent		= 4,
		TalkInside		= 5,
		InsideTalk		= 6,
		PostHandle		= 7,
		TalkOther		= 8,
		CCLunch			= 9,
		CCReady			= 10,
		System			= 11
		*/

		-----------------------------------------------------
		--   (   ) ----------
		-----------------------------------------------------
		Declare @tempo2 table
		(
			State int,
			Priority int,
			DateTimeStart DateTime,
			DateTimeStop DateTime,
			Id int Identity ( 1, 1 ) not null primary key,
			Info nvarchar ( 100 )
		)

		Delete From @tempo2

		Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
			Select State, Case when State in ( 3, 4 ) then 2 else 4 end, 
				TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
			From @ush
			Where OperatorId = @idoperator
				And State in ( 2, 3, 4 )
				And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )
		
		Update @tempo2
		Set State = Case When Priority = 2 then 9 else 10 end

		
		--      - 
		if ( @@rowcount > 0 )
		begin	
			--      
			Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
				Select 11, 5, TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
				From @ush
				Where OperatorId = @idoperator
					And State = 0
					And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )

			Update @tempo2			
			Set 	DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				DateTimeStop = Case When DateTimeStop > @dtnow then @dtnow else DateTimeStop end
			

			--print '-----t2--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

	
			-----------------------------------------------------
			--   (   ) -----
			-----------------------------------------------------
			Declare @tempo1 table
			(
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				StateCat	int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				IdEffort	uniqueidentifier,
				Priority	int,
				Id		int identity ( 1, 1 ) not null primary key
			)

			Delete From @tempo1
			
			Declare @uito table 
			(
				Id uniqueidentifier,
				UserId uniqueidentifier,
				TaskId uniqueidentifier,	
				EffortId uniqueidentifier,
				TimeStart DateTime,
				TimeStopPrior DateTime,
				TimeStopWaitCall DateTime,
				TimeStopBackCall DateTime,
				TimeStopDialog DateTime,
				TimeStopPost DateTime
			)

			Delete From @uito

			Insert Into @uito
			Select *
			From @uit
			Where UserId = @idoperator
				--And ( TimeStart > @dts or TimeStopPost > @dts or TimeStopPost is null )

			--print '-----t1-crtemp-- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 1, 0, 
					TimeStart, 
					TimeStopPrior
				From @uito--#t
				Where Cast ( TimeStopPrior - TimeStart as float ) * 86400 > 0
			
			--print '-----t1-cra----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
			
			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,

						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 2, 0, 
					TimeStopPrior, 
					TimeStopWaitCall
				From @uito--#t
				Where Cast ( TimeStopWaitCall - TimeStopPrior as float ) * 86400 > 0

			--print '-----t1-crb----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 3, 0, 
					TimeStopWaitCall, 
					TimeStopBackCall
				From @uito--#t
				Where Cast ( TimeStopBackCall - TimeStopWaitCall as float ) * 86400 > 0

			--print '-----t1-crc----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 6, 0, 
					TimeStopBackCall, 
					TimeStopDialog
				From @uito--#t
				Where Cast ( TimeStopDialog - TimeStopBackCall as float ) * 86400 > 0

			--print '-----t1-crd----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 7, 0, 
					TimeStopDialog,
					TimeStopPost
				From @uito--#t
				Where Cast ( IsNull ( TimeStopPost, @dtnow ) - IsNull ( TimeStopDialog, @dtnow ) as float ) * 86400 > 0

			--print '-----t1-cre----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			--       
			Update @tempo1 
			Set 	DateTimeStart = case 	When ( DateTimeStart < @dts ) then @dts 
							else DateTimeStart end,
		 		DateTimeStop = case 	When ( DateTimeStop > @dtnow ) then @dtnow 
							When ( DateTimeStop < @dts ) then @dts 
							else DateTimeStop end

			Delete From @tempo1
			Where DateTimeStart = DateTimeStop


			--   / 
			Update tmpo
			Set IsOutput = t.IsOutputTask
			From @tempo1 tmpo, A_TaskManager_Tasks t
			Where tmpo.IdTask = t.Id

			--    
			Update tmpo
			Set CallResult = tic.CallResult
			From @tempo1 tmpo, A_TaskManager_Task_IncomingCalls tic
			Where tmpo.IdEffort = tic.Id

			Update tmpo
			Set CallResult = ste.EResult
			From @tempo1 tmpo, A_TaskManager_SubTaskEfforts ste
			Where tmpo.IdEffort = ste.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo1

			--Select * FROM A_Taskmanager_UserInTask


			--print '-----t1-up------ ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
	
			-----------------------------------------------------
			--   () -----------------------
			-----------------------------------------------------
			
			Declare @tempo3 table
			(
				State int,
				Priority int,
				DateTimeStart DateTime,
				DateTimeStop DateTime,
				Id int identity ( 1, 1 ) not null primary key
			)
			
			Delete From @tempo3
						
			Insert into @tempo3
				Select 8, 0, TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
					And FromCC = 0
				/*
				Select Case When FromCC = 0 then 8 When IsBetweenUsers = 1 then 5 else 4 end, 0,
					TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
				*/

			Update @tempo3
			Set DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				Priority = Case When State = 8 then 3 else 0 end
			
			
			--print '-----t3--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-----------------------------------------------------
			--     ---------------------
			-----------------------------------------------------

	--		Select * FROM @tempo1
	--		Select * FROM @tempo2
	--		Select * From @tempo3

	--		Select * FROM @tempo1 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * FROM @tempo2 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * From @tempo3 Where DateTimeStart > '13.02.2007' Order by DateTimeStart

		
			Declare @tempo table
			(
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete from @tempo

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStart, 0
				From @tempo1

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStop, 1
				From @tempo1

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStart, 0
				From @tempo2

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStop, 1
				From @tempo2

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStart, 0
				From @tempo3

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStop, 1
				From @tempo3
			
			--Select * From @tempo Order By DT

			--print '-----tpt-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		
			-----------------------------------------------------
			--   -------------------------------
			-----------------------------------------------------

			declare @res table ( TableN int, Id int, State int, Priority int, DStart DateTime, DStop DateTime )
			Delete From @res

			--        
			-- : 	0 -    (  )
			--		1 -     (  )
			--		2 - 
			--		3 -  
			--		4 -   
			--		5 -   
			declare @p0 int, @p1 int, @p2 int, @p3 int, @p4 int, @p5 int
			declare @s0 int, @s1 int, @s2 int, @s3 int, @s4 int, @s5 int
			declare @t0 int, @t1 int, @t2 int, @t3 int, @t4 int, @t5 int
			declare @i0 int, @i1 int, @i2 int, @i3 int, @i4 int, @i5 int

			Select @p0 = 0, @p1 = 0, @p2 = 0, @p3 = 0, @p4 = 0	
			Select 	@p0 = IsNull ( P0, 0 ), @p1 = IsNull ( P1, 0 ), @p2 = IsNull ( P2, 0 ), @p3 = IsNull ( P3, 0 ), @p4 = IsNull ( P4, 0 ), @p5 = IsNull ( P5, 0 ),
				@s0 = IsNull ( S0, 0 ), @s1 = IsNull ( S1, 0 ), @s2 = IsNull ( S2, 0 ), @s3 = IsNull ( S3, 0 ), @s4 = IsNull ( S4, 0 ), @s5 = IsNull ( S5, 0 )
			From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
			Where Id = @idoperator
		
			--   	
			Declare @tempo_ordered table
			(
				Id int identity ( 1, 1 ) not null,
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete From @tempo_ordered

			Insert into @tempo_ordered ( TableN, TableID, State, Priority, DT, NK )
				Select TableN, TableID, State, Priority, DT, NK From @tempo
				Order By DT

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * From @tempo_ordered


			Declare @tempo_joined table
			(
				s1 int, p1 int, s2 int, p2 int, dstart datetime, dstop datetime, nk1 bit, nk2 bit, t1 int, t2 int, i1 int, i2 int
			)
			Delete From @tempo_joined
		
			Insert into @tempo_joined 
				Select t1.State as s1, t1.Priority as p1, t2.State as s2, t2.Priority as p2,
					t1.DT as dstart, t2.DT as dstop, t1.NK as nk1, t2.NK as nk2,
					t1.TableN, t2.TableN, t1.TableID, t2.TableID
				From @tempo_ordered t1
					Inner join @tempo_ordered t2 on t1.Id + 1 = t2.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo_joined

			--print '-----tjnd------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			--       
			Declare tcursor Cursor LOCAL FAST_FORWARD For 
				Select s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
				From @tempo_joined
				--Where dstart > '21.02.2007'

			declare @st1 int, @pr1 int, @st2 int, @pr2 int, @dstart DateTime, @dstop DateTime, @nk1 bit, @nk2 bit, @tb1 int, @tb2 int, @id1 int, @id2 int
			declare @actualst int, @actualpr int, @actualt int, @actualid int
			declare @lastst int, @lastpr int, @lastt int, @lastid int, @lastdstart datetime, @lastdstop datetime
			declare @dontinsert bit, @updatelast bit
			declare @insertindex int

			set @insertindex = 0
			set @lastt = 0
			set @dontinsert = 1 --     (   )   
		
			Open tcursor
			Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2

			While @@FETCH_STATUS = 0
   			Begin
				----print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
				--	Cast ( @lastst as nvarchar ( 10 ) ) + '  ' + Cast ( @lastpr as nvarchar ( 10 ) )    + '  //  ' + 
				--	Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) )
			
				---    -----		
				if ( @nk1 = 0 )
				begin			
					if ( @pr1 = 0 )
					begin
			    			set @p0 = @p0 + 1
				    		set @s0 = @st1				
						set @t0 = @tb1	
						set @i0 = @id1
					end
					else if ( @pr1 = 1 )
					begin
				    		set @p1 = @p1 + 1
				    		set @s1 = @st1
						set @t1 = @tb1
						set @i1 = @id1
					end
					else if ( @pr1 = 2 )
					begin
			    			set @p2 = @p2 + 1
				    		set @s2 = @st1
						set @t2 = @tb1
						set @i2 = @id1
					end
					else if ( @pr1 = 3 )
					begin
				    		set @p3 = @p3 + 1
				    		set @s3 = @st1
						set @t3 = @tb1
						set @i3 = @id1
					end
					else if ( @pr1 = 4 )
					begin
			    			set @p4 = @p4 + 1
				    		set @s4 = @st1
						set @t4 = @tb1
						set @i4 = @id1
					end
					else if ( @pr1 = 5 )
					begin
						set @p5 = @p5 + 1
						set @s5 = @st1
						set @t5 = @tb1
						set @i5 = @id1
					end
				end

				---    
				set @dontinsert = 0
				if ( @p0 > 0 )
				begin
					set @actualst = @s0
					set @actualpr = 0
					set @actualt = @t0
					set @actualid = @i0
				end
				else if ( @p1 > 0 )
				begin
					set @actualst = @s1
					set @actualpr = 1
					set @actualt = @t1
					set @actualid = @i1

				end
				else if ( @p2 > 0 )
				begin
					set @actualst = @s2
					set @actualpr = 2
					set @actualt = @t2
					set @actualid = @i2
				end
				else if ( @p3 > 0 )
				begin
					set @actualst = @s3
					set @actualpr = 3
					set @actualt = @t3
					set @actualid = @i3
				end
				else if ( @p4 > 0 )
				begin
					set @actualst = @s4
					set @actualpr = 4
					set @actualt = @t4
					set @actualid = @i4
				end
		
				--     4  2  (  )
				--        
				if (( @p4 = 0 ) and ( @p2 = 0 )) or ( @p5 = 0 )
 				set @dontinsert = 1
			
				--print Convert ( nvarchar ( 10 ), @dstart, 108 ) + ' ' + convert ( nvarchar ( 10 ), @dstop, 108 ) + ' state1=' + cast ( @st1 as nvarchar ( 10 ) ) + ' state2=' + cast ( @st2 as nvarchar ( 10 ) ) + ' nk1=' + cast ( @nk1 as nvarchar ( 10 ) ) + ' nk2=' + cast ( @nk2 as nvarchar ( 10 ) )

				--     			
				set @updatelast = 0
				--     ,    -  
				if ( @lastt = 0 )
				begin
					--print 'lastt = 0'
					set @updatelast = 1			
				end
				--          -   
				else if ( @dontinsert = 0 ) and ( @actualst = @lastst )
				begin
					--print 'lastst = actualst' + Cast ( @actualst as nvarchar ( 10 ))
					set @lastdstop = @dstop
				end		
				--       
				else
				begin
					--print 'insert time=' + Convert ( nvarchar ( 10 ), @lastdstart, 108 ) + '-' + convert ( nvarchar ( 10 ), @lastdstop, 108 ) + ' state=' + cast ( @lastst as nvarchar ( 10 ) )
					if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
						Insert Into @res
						Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )
				
					set @updatelast = 1	
				end
			
				if ( @updatelast = 1 )
				begin
					if ( @dontinsert = 1 )
			  			set @lastt = 0
					else
 					begin
						set @lastt = @actualt
						set @lastid = @actualid
						set @lastst = @actualst
						set @lastpr = @actualpr
						set @lastdstart = @dstart
						set @lastdstop = @dstop
					end
				end
			
		
				---    () -----
				if ( @nk2 = 1 )
				begin
					if ( @pr2 = 0 )
						set @p0 = @p0 - 1
					else if ( @pr2 = 1 )
						set @p1 = @p1 - 1
					else if ( @pr2 = 2 )
						set @p2 = @p2 - 1
					else if ( @pr2 = 3 )
						set @p3 = @p3 - 1
					else if ( @pr2 = 4 )
						set @p4 = @p4 - 1
					else if ( @pr2 = 5 )
						set @p5 = @p5 - 1
				end
			
				Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2
			End


			--      ,    
			if ( @dontinsert = 0 )
				if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
					Insert Into @res
					Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )

			Close tcursor
			Deallocate tcursor

			--print '-----curs------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-------------------------------------------------------------------------------------------------
			--          -------------------------------
			-------------------------------------------------------------------------------------------------

			--       (         )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
				Set 	p0 = @p0, p1 = @p1, p2 = @p2, p3 = @p3, p4 = @p4, p5 = @p5,
					s0 = @s0, s1 = @s1, s2 = @s2, s3 = @s3, s4 = @s4, s5 = @s5,
					LastDT = @dtnow
			Where Id = @idoperator

			Declare @operatorstates table
			(
				Id		int identity ( 1, 1 ) not null primary key,
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float
			)

			Delete From @operatorstates

			Insert into @operatorstates ( IdOperator, State, DateTimeStart, DateTimeStop, DateStart, TimeStart, LenTime, 
				IdTask, IsOutput, CallResult )
			Select @idoperator, r.State, r.DStart, r.DStop,
				Cast ( Floor ( Cast ( DStart as Float ) ) as DateTime ),
				Cast ( Cast ( DStart as float ) - Floor ( Cast ( DStart as Float ) ) as DateTime ),				
				Cast ( DStop - DStart as float ) * 86400,
				IdTask, IsOutput, CallResult
			From @res r
				Left join @tempo1 t1 on t1.Id = r.Id and r.TableN = 1


			--     (     -        )
			declare @crupdate int
			Select top 1 @crupdate = CallResult 
			From @operatorstates
			Where not IdTask is null	
			
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
			Set CallResult = @crupdate
			Where IdOperator = @idoperator and not IdTask is null and CallResult is null


			--    
			declare @idt1 int, @state1 int, @dtstart1 DateTime, @dtstop1 DateTime
			
			Select @idt1 = Max ( Id ) 
			From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
			Where IdOperator = @idoperator

			if ( not @idt1 is null )
			   begin
				Select @state1 = State, @dtstart1 = DateTimeStart, @dtstop1 = DateTimeStop 
				From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
				Where Id = @idt1
				
				declare @idt2 int, @state2 int, @dtstart2 DateTime, @dtstop2 DateTime
				Select Top 1 @idt2 = Id, @state2 = State, @dtstart2 = DateTimeStart, @dtstop2 = DateTimeStop
				From @operatorstates
				Order By DateTimeStart

				if ( @state1 = @state2 ) and ( @dtstart2 = @dtstop1 )
				   begin
					Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
					Set 	DateTimeStop = @dtstop2,
						LenTime = Cast ( @dtstop2 - @dtstart1 as float ) * 86400
					Where Id = @idt1

					Delete From @operatorstates
					Where Id = @idt2
			   	   end
			   end

		
			--  
			Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
				( IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime )			
				Select IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime
				From @operatorstates
			
			--print '-----ins-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

		end
		else
		begin
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set LastDT = @dtnow
			Where Id = @idoperator
		end



	   end
	
	--print '--------------------------------------oper--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @logdt = GetDate ( )
	--Set @operlogdt = GetDate ( )

	Fetch Next From ucursor Into @idoperator, @nameoperator
   end

Close ucursor
Deallocate ucursor

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
--Select * FROM [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Order by Datetimestart

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
end
GO

------------------------------------------------------------------------------------------


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_User_StopHandlingEffort' ) )
	drop procedure dbo.A_TaskManager_User_StopHandlingEffort
GO


CREATE   procedure [dbo].[A_TaskManager_User_StopHandlingEffort]
	@effortid		uniqueidentifier,
	@stop			datetime

as
begin

	begin tran AAA

	Update A_TaskManager_UserInTask with ( TabLock, HoldLock ) 
	Set TimeStopPost = @stop
	Where EffortId = @effortid
		and TimeStopPost is null

	Update A_TaskManager_UserInTask --with ( TabLock ) 
	Set TimeStopDialog = @stop
	Where EffortId = @effortid
		and TimeStopDialog is null

	Update A_TaskManager_UserInTask --with ( TabLock ) 
	Set TimeStopBackCall = @stop
	Where EffortId = @effortid
		and TimeStopBackCall is null

	Update A_TaskManager_UserInTask --with ( TabLock ) 
	Set TimeStopWaitCall = @stop
	Where EffortId = @effortid
		and TimeStopWaitCall is null

	Update A_TaskManager_UserInTask --with ( TabLock ) 
	Set TimeStopPrior = @stop
	Where EffortId = @effortid
		and TimeStopPrior is null

	Commit Tran AAA
	
end
GO


------------------------------------------------------------------------------------------

if not exists ( Select * FROM sysindexes where name = 'idx_UIT_complex' )
	Create nonclustered index idx_UIT_complex on dbo.A_TaskManager_UserInTask ( EffortId, TimeStopPost, TimeStopDialog, TimeStopBackCall, TimeStopWaitCall, TimeStopPrior ) With FillFactor = 80
GO

------------------------------------------------------------------------------------------


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_Timer_MinuteProc' ) )
	Drop procedure dbo.A_Timer_MinuteProc
GO


CREATE Procedure dbo.[A_Timer_MinuteProc]
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		set @dtnow = GetDate()

	exec A_CallCenter_Temp_UpdateOperatorStates @dtnow
end
GO

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_CloseAll' ) )
	Drop procedure dbo.A_Stat_Connection_CloseAll
GO

CREATE    Procedure dbo.A_Stat_Connection_CloseAll
	
	@timeoff	datetime,
	@reasonstop	int

as

begin	

	declare @lastpingtime datetime
	select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
	if ( @@rowcount = 0 )
		set @lastpingtime = @timeoff
		

	Update A_Stat_Connections_1x1 --With ( TabLock )
		Set 
			ReasonStop = @reasonstop,			
			TimeStop = @lastpingtime,
			StopSide = -1
		Where
			TimeStop is null
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_Start_GetById' ) )
	Drop procedure dbo.A_Stat_Connection_Start_GetById
GO

CREATE  Procedure dbo.A_Stat_Connection_Start_GetById
	
	@id			uniqueidentifier,
	@idchain		uniqueidentifier	OUTPUT,
	@connectiontype		int			OUTPUT,
	@reasonstart		int			OUTPUT,
	@timestart		datetime		OUTPUT,
	@timeanswer		datetime		OUTPUT,
	@alineid		uniqueidentifier	OUTPUT,
	@alinenum		nvarchar ( 8 )		OUTPUT,
	@anumberdialed		nvarchar ( 50 )		OUTPUT,
	@aoutnumber		nvarchar ( 50 )		OUTPUT,
	@astr			nvarchar ( 50 )		OUTPUT,
	@auserid		uniqueidentifier	OUTPUT,
	@blineid		uniqueidentifier	OUTPUT,
	@blinenum		nvarchar ( 8 )		OUTPUT,
	@bnumberdialed		nvarchar ( 50 )		OUTPUT,
	@boutnumber		nvarchar ( 50 )		OUTPUT,
	@bstr			nvarchar ( 50 )		OUTPUT,
	@buserid		uniqueidentifier	OUTPUT,
	@isrecorded		int			OUTPUT
	--@arecfile		nvarchar ( 50 )		OUTPUT,
	--@brecfile		nvarchar ( 50 )		OUTPUT
as

begin
	
	Select 
		@idchain	= IdChain,		
		@connectiontype	= ConnectionType,
		@reasonstart	= ReasonStart,
		@timestart	= TimeStart,
		@timeanswer	= TimeAnswer,
		@alineid	= ALineId,
		@alinenum	= ALineNum,
		@anumberdialed	= ANumberDialed,
		@aoutnumber	= AOutNumber,
		@astr		= AStr,
		@auserid	= AUserId,
		@blineid	= BLineId,
		@blinenum	= BLineNum,
		@bnumberdialed	= BNumberDialed,
		@boutnumber	= BOutNumber,
		@bstr		= BStr,
		@buserid	= BUserId,
		@isrecorded	= IsRecorded
		--@arecfile	= ARecFile,
		--@brecfile	= BRecFile 
	From A_Stat_Connections_1x1 sc --With ( TabLock )
	Where Id = @id
	
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_Stop' ) )
	Drop procedure dbo.A_Stat_Connection_Stop
GO

CREATE  Procedure dbo.A_Stat_Connection_Stop
	
	@id			uniqueidentifier,
	@reasonstop		int,
	@stopside		int,
	@timestop		datetime

as

begin
	
	Update A_Stat_Connections_1x1 --With ( TabLock )
		Set 
			ReasonStop = @reasonstop,
			StopSide = @stopside,
			TimeStop = @timestop
		Where
			Id = @id
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_Stop_GetById' ) )
	Drop procedure dbo.A_Stat_Connection_Stop_GetById
GO

CREATE   Procedure dbo.A_Stat_Connection_Stop_GetById
	
	@id			uniqueidentifier,
	@reasonstop		int			OUTPUT,
	@stopside		int			OUTPUT,
	@timestop		datetime		OUTPUT
as

begin
	
	Select 
		@reasonstop 	= ReasonStop,
		@stopside	= StopSide,
		@timestop	= TimeStop
		
	From A_Stat_Connections_1x1 sc --With ( TabLock )
	Where Id = @id
	
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_GetRecordsById' ) )
	Drop procedure dbo.A_Stat_GetRecordsById
GO

CREATE  procedure [dbo].[A_Stat_GetRecordsById]
	@id uniqueidentifier
as
begin
	Select *
	From A_Stat_Connections_1x1 --With ( TabLock )
	Where Id = @id
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_GetStatRecordById' ) )
	Drop procedure dbo.A_Stat_GetStatRecordById
GO

CREATE procedure [dbo].[A_Stat_GetStatRecordById]
	@id uniqueidentifier
as
begin
	Select *
	From A_Stat_Connections_1x1 --With ( TabLock )
	Where Id = @id
end
GO

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Clients__GetJournal' ) )
	Drop procedure dbo.A_Clients__GetJournal
GO




CREATE procedure [dbo].[A_Clients__GetJournal]
	@idclient	uniqueidentifier,
	@dstart		datetime,
	@dstop		datetime,
	@tstart		datetime,
	@tstop		datetime,
	@idoperator	uniqueidentifier,
	@iduser		uniqueidentifier
as
begin
	
	Declare @tstartfloat float
	Declare @tstopfloat float
	Set @tstartfloat =  Convert ( float, @tstart ) - FLOOR ( Convert ( float, @tstart ) )
	Set @tstopfloat =  Convert ( float, @tstop ) - FLOOR ( Convert ( float, @tstop ) )

	--    

	Declare @userspermitted table ( Id uniqueidentifier )
	Insert into @userspermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @userspermitted ( Id ) Values ( @iduser )


	Declare @linespermitted table ( Id uniqueidentifier )
	Insert into @linespermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @linespermitted
		Select Id 
		From A_ServerExtLines

	---  

	Select * FROM 
	(
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length, 
			AStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile,
			--sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc -- with ( TabLock )
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @userspermitted u on sc.AUserId = u.Id
			Left join @linespermitted l on sc.ALineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.TimeStart, 
			sc.TimeStop - sc.TimeStart as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile, 
			--sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc -- with ( TabLock )
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @userspermitted u on sc.BUserId = u.Id
			Left join @linespermitted l on sc.BLineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )		

			
	) a

	Order By TimeStart Desc

		
end

GO


------------------------------------------------------------------------------------------



if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_Effort' ) )
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Effort
GO

Create Procedure dbo.A_TaskManager_TaskOut_UpdateResult_Effort
	@id 			uniqueidentifier,
	@idinlist		int,
	@idtask			uniqueidentifier,
	@number			nvarchar ( 20 ),
	@edatetime		datetime,
	@eresult		int,
	@einfo			nvarchar(500),
	@idchain		uniqueidentifier
as

begin
	-- 
	Insert Into A_TaskManager_SubTaskEfforts --With ( TabLock )
		( Id, IdInList, TaskId, Number, EDateTime, EResult, EInfo, ConnectionChainId )
	Values	
		( @id, @idinlist, @idtask, @number, @edatetime, @eresult, @einfo, @idchain )

	--      	
	Update A_Stat_Connections_1x1 --With ( tablock )
	Set FromCC = 1 
	Where IdChain = @idchain
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_AddIncomingCall' ) )
	Drop procedure dbo.A_TaskManager_Task_AddIncomingCall
GO


Create Procedure dbo.A_TaskManager_Task_AddIncomingCall

	@id				uniqueidentifier,
	@taskid				uniqueidentifier,
	@number				nvarchar ( 50 ),
	@timestart			datetime,
	@timestop			datetime,
	@callresult			int,
	@callresultinfo			nvarchar ( 500 ),
	@connectionchainid		uniqueidentifier
as

begin
	
	if Exists ( select Id from A_TaskManager_Tasks where id = @taskid )
	begin
		--   
		Insert Into A_TaskManager_Task_IncomingCalls --With ( TabLock )
			( Id, TaskId, Number, CallTimeStart, CallTimeStop, CallResult, CallInfo, ConnectionChainId )
		Values 
			( @id, @taskid, @number, @timestart, @timestop, @callresult, @callresultinfo, @connectionchainid )

		--      
		Update A_Stat_Connections_1x1 --with ( tablock )
		Set FromCC = 1 
		Where IdChain = @connectionchainid
	end
end
GO
------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_ClearStatistics' ) )
	Drop procedure dbo.A_TaskManager_Task_ClearStatistics
GO


CREATE Procedure dbo.A_TaskManager_Task_ClearStatistics
	@id uniqueidentifier
as
begin
	Delete 
	From dbo.A_TaskManager_SubTasks --With ( TabLock )
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskEfforts --With ( TabLock )
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskNumber --With ( TabLock )
	Where TaskId = @id

	Update dbo.A_TaskManager_Tasks
	Set Done = 0
	Where Id = @id	
	
	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id	

end

GO
------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_PointSimple' ) )
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_PointSimple
GO

CREATE Procedure dbo.A_TaskManager_TaskOut_UpdateResult_PointSimple
	@idtask			uniqueidentifier,	
	@idinlist		int,
	@nresult		int
as

begin
	update A_TaskManager_SubTasks --With ( TabLock )
	set
		NResult	= @nresult
   	where		
		TaskId = @idtask
		and IdInList = @idinlist
end

GO
------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_ClearSubTasks' ) )
	Drop procedure dbo.A_TaskManager_Task_ClearSubTasks
GO

CREATE  Procedure dbo.A_TaskManager_Task_ClearSubTasks
	@taskid		uniqueidentifier
as

begin
	Delete 
	From A_TaskManager_SubTasks --With ( TabLock )
	Where TaskId = @taskid
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_NumberSimple' ) )
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_NumberSimple
GO


CREATE procedure [dbo].A_TaskManager_TaskOut_UpdateResult_NumberSimple
	@idtask 		uniqueidentifier,
	@idinlist		int,
	@number			nvarchar ( 20 ),
	@nresult		int
as
begin

	update A_TaskManager_SubTaskNumber -- With ( TabLock )
	set
		NResult	= @nresult
	where		
		TaskId = @idtask
		and IdInList = @idinlist
		and Number = @number
end
GO
------------------------------------------------------------------------------------------


if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_AddMissedIncomingCallInfo' ) )
	Drop procedure dbo.A_CallCenter_Temp_AddMissedIncomingCallInfo
GO

Create procedure [dbo].[A_CallCenter_Temp_AddMissedIncomingCallInfo]
	@idtask uniqueidentifier,	
	@ideffort uniqueidentifier,
	@idinlist int,
	@abonentnumber nvarchar ( 20 ),
	@callresult int,
	@timestart datetime, 
	@timestop datetime,
	@idchain uniqueidentifier,
	@idextline uniqueidentifier
	
as 
begin
	Declare @idproject uniqueidentifier
	Set @idproject = '00000000-0000-0000-0000-000000000000'
	Select @idproject = IdProject 
	From A_TaskManager_Tasks
	Where Id = @idtask

	Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] --With ( TabLock )
	(
		IdProject,
		IdTask,
		IsOutput,
		IdEffort,
		IdInList,
		AbonentNumber,
		CallResult,
		CallResultInfo,
		DateTimeStart,
		DateStart,
		TimeStart,
		DateTimeStop,
		IdChain,
		IdExtLine,
		LenTime,
		LenQueue,
		IsHandled,
		IsSuccess
	)
	Values 
	( 
		@idproject,
		@idtask,
		0,
		@ideffort,
		@idinlist,
		@abonentnumber,
		@callresult,
		'',		
		@timestart, 
		Cast ( Floor ( Cast ( @timestart as Float ) ) as DateTime ),
		Cast ( Cast ( @timestart as Float ) - FLOOR ( Cast ( @timestart as Float ) ) as DateTime ),
		@timestop,
		@idchain,
		@idextline,
		Cast ( @timestop - @timestart as float ) * 86400,
		Cast ( @timestop - @timestart as float ) * 86400,
		0,
		0
	)
end
GO

------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TalkForm_Stat_Get' ) )
	Drop procedure dbo.A_TalkForm_Stat_Get
GO


CREATE     procedure [dbo].[A_TalkForm_Stat_Get]
	@taskid uniqueidentifier,
	@formid uniqueidentifier,
	@objid uniqueidentifier,
	@objtype 	int,
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@userid	uniqueidentifier=NULL
as

begin

	declare @tstart2 DateTime
	declare @tstop2 DateTime
	set @tstart2 = Cast ( Cast ( @tstart as float ) - Floor ( Cast ( @tstart as float ) ) as DateTime )
	set @tstop2 = Cast ( Cast ( @tstop as float ) - Floor ( Cast ( @tstop as float ) ) as DateTime )


	declare @te table ( IdChain uniqueidentifier, TaskId uniqueidentifier  )

	Insert into @te
	
		Select IdChain, IdTask
		From [oktell_cc_temp].dbo.A_Cube_CC_EffortConnections ec --With ( TabLock )
		Where ec.IdTask = @taskid
			and (DateStart between @dstart and @dstop)
			and (TimeStart between @tstart2 and @tstop2)
			and ((@userid is NULL) or (@userid in (IdAUser, IdBUser)))
		Group By IdChain, IdTask

	if (@objtype = 109) -- CheckBoxGroup
	begin
		Select cast(I as bigint), Count ( * ) as cnt 	
		From A_TalkForm_Stat_Values sv 
			inner join A_BigInt big on big.K & ChosenResult = big.K
			inner join @te te on sv.IdConnection = te.IdChain
		Where sv.IdTask = @taskid
			and sv.IdForm = @formid
			and sv.IdElement = @objid
			and sv.ElementType = @objtype
		Group By I
	end
	else
	begin
		Select ChosenResult, Count ( * ) as cnt 
		From A_TalkForm_Stat_Values sv 
			inner join @te te on sv.IdConnection = te.IdChain
		Where sv.IdTask = @taskid
			and sv.IdForm = @formid
			and sv.IdElement = @objid
			and sv.ElementType = @objtype
		Group By ChosenResult
	end
end
GO
------------------------------------------------------------------------------------------

if Exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TalkResults_Filter_Journal' ) )
	Drop procedure dbo.A_TalkResults_Filter_Journal
GO


CREATE     procedure [dbo].[A_TalkResults_Filter_Journal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@ResultValue int = NULL,
	@ResultMask int = NULL,
	@ResultText nvarchar(500) = NULL,
	@CardId uniqueidentifier,
	@showefforts	int
as
begin

	declare @tstart2 DateTime
	declare @tstop2 DateTime
	set @tstart2 = Cast ( Cast ( @tstart as float ) - Floor ( Cast ( @tstart as float ) ) as DateTime )
	set @tstop2 = Cast ( Cast ( @tstop as float ) - Floor ( Cast ( @tstop as float ) ) as DateTime )


	declare @tmp_card_result table(TaskId  uniqueidentifier, IdChain uniqueidentifier)
	delete 	@tmp_card_result

	if @ResultValue is not null
		Insert into @tmp_card_result(TaskId,IdChain)	
			Select IdTask, IdConnection
			From A_Stat_Talk_Algorythms sta
				inner join A_Stat_Talk_Card_Radio stcr on sta.IdAlgVisit=stcr.IdAlgVisit
			Where IdCard = @CardId and ChosenResult = @ResultValue


	if @ResultMask is not null 
	begin
		Insert into @tmp_card_result ( TaskId, IdChain )
			Select IdTask, IdConnection
			From A_Stat_Talk_Algorythms sta
				inner join A_Stat_Talk_Card_Check stcc on sta.IdAlgVisit = stcc.IdAlgVisit
				inner join A_BigInt big on big.K & ChosenResult = big.K
			Where IdCard = @CardId 
				and big.K = @ResultMask
	end


	if @ResultText is not null 
	begin
		Insert into @tmp_card_result(TaskId,IdChain)		
			Select IdTask, IdConnection
			From A_Stat_Talk_Algorythms sta
				inner join A_Stat_Talk_Card_Text stct on sta.IdAlgVisit=stct.IdAlgVisit
			Where IdCard=@CardId and ChosenResult=@ResultText
	end


	declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, TaskId uniqueidentifier, IdOperator uniqueidentifier, Number nvarchar ( 50 ) collate database_default, CallTime DateTime, Result int, Info nvarchar ( 500 ) collate database_default, LenTime float, IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ) collate database_default, BLineNum nvarchar ( 5 ) collate database_default) --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ) )

	Insert into @te
		Select IdEffort, IdChain, IdTask, IdOperator, AbonentNumber, DateTimeStart, CallResult, CallResultInfo, LenTime, IsRecorded, IdRecDir, ALineNum, BLineNum --ARecFile, BRecFile
		From [oktell_cc_temp].dbo.A_Cube_CC_EffortConnections ec --With ( TabLock )
		Where 	(DateStart between @dstart and @dstop)
			and (TimeStart between @tstart2 and @tstop2)
			and ec.IdTask = @taskid
			and AbonentNumber like '%' + @number + '%'
			and Exists ( Select IdChain From @tmp_card_result Where IdChain = ec.IdChain )


	Select te.IdChain, te.Number, IsNull ( u.Name, '?' ) as FullName, te.CallTime, case when ( len ( te.Info ) > 0 ) then ( trt.Name + ' (' + te.Info + ')') else trt.Name end as Info, Cast ( te.LenTime / 86400 as DateTime ) as Length, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( IdRecDir, 0 ) as IdRecDir, IsNull ( ALineNum, '') as ALineNum, IsNull ( BLineNum, '') as BLineNum --IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile 
	From @te te
		Left join A_Users u on u.Id = te.IdOperator
		Left join [oktell_cc_temp].[dbo].A_Cube_CC_Cat_TaskResultTypes trt on trt.Id = te.Result
	Where te.IdOperator is null or te.IdOperator != 'AB000000-0000-0000-0000-000000000000'

end
GO
------------------------------------------------------------------------------------------
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_CallCenter_GetResourceInfo' ) )
	Drop procedure dbo.A_CallCenter_GetResourceInfo
GO


CREATE  procedure [dbo].[A_CallCenter_GetResourceInfo]
	@minutes int,
	@dtnow datetime = null
as
begin

--  :
--  -   ( )
--  -   ()
--  -   ()
--  -    ()
--  -  ( )
--  -    ( )

--declare @minutes int
--set @minutes = 5

----------------------------------------------------------------------
--   ---------------------------------------------
----------------------------------------------------------------------
	Declare @intervalsec int 
	set @intervalsec = @minutes * 60

	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Declare @dtstart DateTime
	Set @dtstart = DateAdd ( mi, - @minutes, @dtnow )

	Declare @operators table ( id uniqueidentifier )
	Insert into @operators
		Select IdUser FROM A_UserParams
		Where IsOperator = 1

	Declare @tasks table ( id uniqueidentifier, name nvarchar ( 200 ) collate database_default, IsOutput bit, projectname nvarchar ( 200 ) collate database_default)
	Insert into @tasks
		Select t.Id, t.Name, t.IsOutputTask, p.Name 
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_Projects p on t.IdProject = p.Id
		Where Active = 1 
			and Done = 0 
			and StartRunDateTime < @dtnow
			and StopRunDateTime > @dtnow
			and CreationType = 2
		order by idproject, type

	
	Declare @taskoperators table (idtask uniqueidentifier, idoperator uniqueidentifier)
	Insert into @taskoperators
		Select TaskId, OperatorId 
		From A_TaskManager_Operators taskopers
			Inner join @operators opers on taskopers.OperatorId = opers.Id

	Declare @tasklinecount table (idtask uniqueidentifier, linecount int )
	Insert into @tasklinecount
		Select TaskId, Count ( * ) 
		From A_TaskManager_TaskExtLines el
			Inner join @tasks t on t.Id = el.TaskId
		Group By TaskId
		
		Union all
	
		Select Id, IncomingCallsMaxCount
		From A_TaskManager_Tasks
		Where IsOutputTask = 0	

	Declare @extlines table ( id uniqueidentifier, name nvarchar ( 100 ) collate database_default)
	Insert into @extlines
		Select Id, SystemNum From A_ServerExtLines


	declare @tempopers table ( idoperator uniqueidentifier, idtask uniqueidentifier, datetimestart datetime, datetimestop datetime, LenTime float )
	Insert into @tempopers
		Select idoperator, idtask, datetimestart, datetimestop, lentime
		From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os --With ( TabLock )
		Where DateTimeStop > @dtstart
			and not os.idtask is null

	declare @tempconn table ( IdConn uniqueidentifier, IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	Insert into @tempconn
		Select IdConn, IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections sc --With ( TabLock )
		Where DateTimeStop > @dtstart

	Update @tempopers
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @tempopers
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow

	Update @tempopers
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400

	Update @tempconn
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @tempconn
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow

	Update @tempconn
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


	declare @output table ( Type int, Id uniqueidentifier, Val float, Name nvarchar ( 100 ) collate database_default, ExtName nvarchar ( 100 ) collate database_default)
		
----------------------------------------------------------------------
--   -----------------------------------------------
----------------------------------------------------------------------

	Insert into @output ( Type, Id, Val )
		Select 1, IdOperator, Sum ( LenTime ) / @intervalsec * 100 as Val
		From
		(
			--   
			Select IdOperator, LenTime
			From @tempopers
	
			Union all
	
			--   
			Select id, 0
			From @operators o
		)a
			Inner join @operators o on a.IdOperator = o.Id
		Group By IdOperator


----------------------------------------------------------------------
--   ----------------------------------------------------
----------------------------------------------------------------------
	
	declare @temp51 table ( ALineId uniqueidentifier, BLineId uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	Insert into @temp51
		Select ALineId, BLineId, TimeStart, TimeStop, 0
		From A_Stat_Connections_1x1 sc --With ( TabLock )
		Where TimeStop > @dtstart or TimeStop is null

	Update @temp51
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @temp51
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow

	Update @temp51
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


	declare @temp52 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	Insert into @temp52
		Select el.Id, DateTimeStart, DateTimeStop, LenTime
		From @temp51 sc
			Inner join @extlines el on sc.ALineId = el.Id or sc.BLineId = el.Id



	declare @temp5 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	insert into @temp5
		Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From @tempconn 
		Where IdConn is null	

		Union all
	
		Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From @temp52


	Insert into @output ( Type, Id, Val )
		Select 2, IdExtLine, Sum ( LenTime ) / @intervalsec * 100 as Val
		From
		(
			Select IdExtLine, LenTime
			From @temp5

			Union all

			Select Id, 0
			From @extlines
		) a
			Inner join @extlines el on a.IdExtLine = el.Id
		Group By IdExtLine 

----------------------------------------------------------------------
--    -----------------------------------
----------------------------------------------------------------------

	declare @taskrescount table ( idtask uniqueidentifier, cnt int )
	Insert into @taskrescount 
		Select idtask, sum ( rescnt )
		From
		(
			Select idtask, linecount as rescnt
			From @tasklinecount
	
			Union all

			Select idtask, count ( * ) as rescnt
			From @taskoperators
			Group By Idtask
		)a
		Group By idtask


	Declare @tempres table ( IdTask uniqueidentifier, SumLen float )
	Insert into @tempres
		Select IdTask, Sum ( LenTime )
		From
		(
			Select IdTask, LenTime 
			From @tempopers
			
			Union all
		
			Select IdTask, LenTime
			From @tempconn
			
			Union all 
		
			Select Id, 0
			From @tasks
		)b
		Group By IdTask


	Insert into @output ( Type, Id, Val )
		Select 3, tr.IdTask, case when (cnt = 0) then 0 else SumLen / ( cnt * @intervalsec ) * 100 end as Val
		From @tempres tr
			Inner join @taskrescount trc on tr.IdTask = trc.IdTask
			Inner join @tasks t on tr.IdTask = t.Id

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

	Update o
	Set o.Name = u.Name
	From @output o, A_Users u
	Where o.Id = u.Id and o.Type = 1

	Update o
	Set o.Name = el.Name
	From @output o, @extlines el
	Where o.Id = el.Id and o.Type = 2

	Update o
	Set o.Name = t.Name,
	    o.ExtName = t.ProjectName
	From @output o, @tasks t
	Where o.Id = t.Id and o.Type = 3


	Select * 
	From @output
	Order By Type, ExtName, Name

end
GO

------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_CallCenter_GetResourceTLCrossInfo' ) )
	Drop procedure dbo.A_CallCenter_GetResourceTLCrossInfo
GO


CREATE procedure [dbo].[A_CallCenter_GetResourceTLCrossInfo]
	@minutes int,
	@dtnow datetime = null
as
begin

--  :
--  -   ( )
--  -   ()
--  -   ()
--  -    ()
--  -  ( )
--  -    ( )

--declare @minutes int
--set @minutes = 5

----------------------------------------------------------------------
--   ---------------------------------------------
----------------------------------------------------------------------
	Declare @intervalsec int 
	set @intervalsec = @minutes * 60

	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Declare @dtstart DateTime
	Set @dtstart = DateAdd ( mi, - @minutes, @dtnow )


	Declare @tasks table ( id uniqueidentifier, name nvarchar ( 200 ) collate database_default, IsOutput bit, projectname nvarchar ( 200 ) collate database_default)
	Insert into @tasks
		Select t.Id, t.Name, t.IsOutputTask, p.Name 
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_Projects p on t.IdProject = p.Id
		Where Active = 1 
			and Done = 0 
			and StartRunDateTime < @dtnow
			and StopRunDateTime > @dtnow
			and CreationType = 2
		order by idproject, type


	declare @tasklines table ( idtask uniqueidentifier, idline uniqueidentifier )
	Insert into @tasklines
		Select TaskId, ExtLineId 
		From A_TaskManager_TaskExtLines el
			Inner join @tasks t on el.TaskId = t.Id
		Where t.IsOutput = 1


	declare @tempconn table ( IdConn uniqueidentifier, IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	Insert into @tempconn
		Select IdConn, IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections sc --With ( TabLock )
		Where DateTimeStop > @dtstart

	Update @tempconn
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @tempconn
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow

	Update @tempconn
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


	declare @output table ( IdTask uniqueidentifier, IdLine uniqueidentifier, Val float )

----------------------------------------------------------------------
--   ----------------------------------------------------
----------------------------------------------------------------------

	declare @temp5 table ( IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	insert into @temp5
		Select IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From @tempconn 
		Where not IdConn is null


	Insert into @output
		Select IdTask, IdExtLine, Sum ( LenTime ) / @intervalsec * 100 as Val
		From
		(
			Select IdTask, IdExtLine, LenTime
			From @temp5

			Union all

			Select IdTask, IdLine, 0
			From @tasklines tl
		) a
		Group By IdTask, IdExtLine
		Order by IdTask

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------


	Select * 
	From @output

end
GO

------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_CallCenter_GetResourceTOCrossInfo' ) )
	Drop procedure dbo.A_CallCenter_GetResourceTOCrossInfo
GO



Create procedure [dbo].[A_CallCenter_GetResourceTOCrossInfo]
	@minutes int,
	@dtnow datetime = null
as
begin

--  :
--  -   ( )
--  -   ()
--  -   ()
--  -    ()
--  -  ( )
--  -    ( )

--declare @minutes int
--set @minutes = 5

----------------------------------------------------------------------
--   ---------------------------------------------
----------------------------------------------------------------------
	Declare @intervalsec int 
	set @intervalsec = @minutes * 60

	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Declare @dtstart DateTime
	Set @dtstart = DateAdd ( mi, - @minutes, @dtnow )

	Declare @operators table ( id uniqueidentifier )
	Insert into @operators
		Select IdUser FROM A_UserParams
		Where IsOperator = 1

	Declare @tasks table ( id uniqueidentifier )
	Insert into @tasks
		Select Id
		From A_TaskManager_Tasks 
		Where Active = 1 
			and Done = 0 
			and StartRunDateTime < @dtnow 
			and StopRunDateTime > @dtnow
			and CreationType = 2
		order by idproject, type

	
	Declare @taskoperators table ( idtask uniqueidentifier, idoperator uniqueidentifier )
	Insert into @taskoperators
		Select TaskId, OperatorId 
		From A_TaskManager_Operators taskopers
			Inner join @operators opers on taskopers.OperatorId = opers.Id

	declare @tempopers table ( idoperator uniqueidentifier, idtask uniqueidentifier, datetimestart datetime, datetimestop datetime, LenTime float )
	Insert into @tempopers
		Select idoperator, idtask, datetimestart, datetimestop, lentime
		From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os
		Where DateTimeStop > @dtstart
			and not os.idtask is null

	Update @tempopers
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @tempopers
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow

	Update @tempopers
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


	declare @output table ( IdTask uniqueidentifier, IdOperator uniqueidentifier, Val float )
		
----------------------------------------------------------------------
--   -----------------------------------------------
----------------------------------------------------------------------

	Insert into @output ( IdTask, IdOperator, Val )
		Select IdTask, IdOperator, Sum ( LenTime ) / @intervalsec * 100 as Val
		From
		(
			--   
			Select IdTask, IdOperator, LenTime
			From @tempopers
	
			Union all

			--   
			Select t.id, topers.IdOperator, 0
			From @tasks t
				Inner join @taskoperators topers on t.Id = topers.IdTask
		)a
		Group By IdTask, IdOperator
		Order By IdTask

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

	Select * 
	From @output

end
GO

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TalkForm_Stat_Values_Save' ) )
	Drop procedure dbo.A_TalkForm_Stat_Values_Save
GO



Create Procedure [dbo].[A_TalkForm_Stat_Values_Save]
	@idTask uniqueidentifier, 
	@idOperator uniqueidentifier, 
	@idForm uniqueidentifier, 
	@idElement uniqueidentifier, 
	@ElementType int, 
	@Value bigint,
	@IdConnection uniqueidentifier=NULL,
	@dtnow datetime = null
AS
begin
	if ( @dtnow is null )
		set @dtnow = GetDate()

	Insert Into A_TalkForm_Stat_Values
		([Id], idTask, idOperator, idForm, idElement, ElementType, ChosenResult, TimeSave, IdConnection)
	Values
		(NewId(), @idTask, @idOperator, @idForm, @idElement, @ElementType, @Value, @dtnow, @IdConnection)
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_ListAuto_InsertRow' ) )
	Drop procedure dbo.A_TaskManager_ListAuto_InsertRow
GO


Create procedure [dbo].[A_TaskManager_ListAuto_InsertRow]
	@number nvarchar ( 20 ),
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Insert into A_TaskManager_TaskAuto_List ( Phone, CreationDate ) 
	Values ( @number, @dtnow )
	
	Select @@identity
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_GetTaskNumberInfo' ) )
	Drop procedure dbo.A_TaskManager_List_GetTaskNumberInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetTaskNumberInfo]
	@idtask uniqueidentifier,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select IdInList, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime
	From A_TaskManager_SubTaskNumber stn --With ( TabLock )
	Where TaskId = @idtask
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_GetTaskNumberInfo_Direct' ) )
	Drop procedure dbo.A_TaskManager_List_GetTaskNumberInfo_Direct
GO


CREATE  procedure [dbo].[A_TaskManager_List_GetTaskNumberInfo_Direct]
	@idtask uniqueidentifier,
	@idpoint int,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select IdInList, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime
	From A_TaskManager_SubTaskNumber stn --With ( TabLock )
	Where TaskId = @idtask 
		And IdInList = @idpoint
end
GO



if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_GetTaskPointInfo' ) )
	Drop procedure dbo.A_TaskManager_List_GetTaskPointInfo
GO


Create procedure [dbo].[A_TaskManager_List_GetTaskPointInfo]
	@idtask uniqueidentifier,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select IdInList, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime
	From A_TaskManager_SubTasks st --With ( TabLock )
	Where TaskId = @idtask
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_GetTaskPointInfo_Direct' ) )
	Drop procedure dbo.A_TaskManager_List_GetTaskPointInfo_Direct
GO



CREATE procedure [dbo].[A_TaskManager_List_GetTaskPointInfo_Direct]
	@idtask uniqueidentifier,
	@idpoint int,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select IdInList, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime
	From A_TaskManager_SubTasks st --With ( TabLock )
	Where TaskId = @idtask 
		And IdInList = @idpoint
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Operator_Get_DayTalkTime' ) )
	Drop procedure dbo.A_TaskManager_Operator_Get_DayTalkTime
GO


Create  procedure [dbo].[A_TaskManager_Operator_Get_DayTalkTime]
	@idoperator		uniqueidentifier,
	@time			float OUTPUT,
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Set @time = 0

	Select @time = Sum ( Convert ( float, TimeStop - TimeStart ) )
	From A_Stat_Connections_1x1 sc --With ( TabLock )
	Where ( AUserId = @idoperator 
		or BUserId = @idoperator )
		and Convert ( float, @dtnow - TimeStop ) < 1 
		and DatePart ( dd, @dtnow ) = DatePart ( dd, TimeStop )
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Operator_Get_FreeTime' ) )
	Drop procedure dbo.A_TaskManager_Operator_Get_FreeTime
GO



CREATE  procedure [dbo].[A_TaskManager_Operator_Get_FreeTime]
	@idoperator		uniqueidentifier,
	@time			float OUTPUT,
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Set @time = 0

	Select @time = Convert ( float, @dtnow - Max ( TimeStop ) )
	From A_Stat_Connections_1x1 sc --With ( TabLock )
	Where AUserId = @idoperator or 
		BUserId = @idoperator	
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_Operator_Get_TaskWork' ) )
	Drop procedure dbo.A_TaskManager_Operator_Get_TaskWork
GO


Create Procedure [dbo].[A_TaskManager_Operator_Get_TaskWork]
	@idoperator		uniqueidentifier,
	@extraid		uniqueidentifier,
	@time			float OUTPUT,
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Set @time = 0

	Select Sum ( Convert ( float, TimeStopPost - TimeStart ) )
	From A_TaskManager_UserInTask -- with ( TabLock )
	Where UserId = @idoperator
		and TaskId = @extraid
		and Convert ( float, @dtnow - TimeStopPost ) < 1 
		and DatePart ( dd, @dtnow ) = DatePart ( dd, TimeStopPost )
end
GO

--------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_CallCenter_UserStateChange' ) )
	drop procedure dbo.A_CallCenter_UserStateChange
GO

CREATE procedure dbo.[A_CallCenter_UserStateChange]
	@start bit,
	@idoperator uniqueidentifier,
	@state int,
	@info nvarchar ( 100 ) = null,
	@selfinfo bit = null,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		set @dtnow = GetDate()

	Begin tran AAA

	update A_CallCenter_UserStateHistory with ( TabLock, HoldLock )
	Set TimeLeave = @dtnow,
		LengthSec = Cast ( (@dtnow - TimeEnter) as float ) * 86400
	Where OperatorId = @idoperator 
		and State = @state
		and TimeLeave is null


	if ( @start > 0 )
	  begin
		if ( @state in ( 2, 3, 4 ) )
			update A_CallCenter_UserStateHistory -- with ( TabLock )
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow - TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and State in ( 2, 3, 4 )
				and TimeLeave is null

		Insert into A_CallCenter_UserStateHistory --with ( RowLock )
		Values ( NewId ( ), @idoperator, @state, @dtnow, null, null, @info, @selfinfo )

		if ( @state = 1 )
			Insert into A_CallCenter_UserStateHistory --with ( RowLock )
			Values ( NewId ( ), @idoperator, 2, @dtnow, null, null, '', 0 )
	  end
	else
	  begin
		if ( @state = 0 )
			update A_CallCenter_UserStateHistory --with ( TabLock )
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow- TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and TimeLeave is null
		else if ( @state = 1 )
			update A_CallCenter_UserStateHistory --with ( TabLock )
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow- TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and TimeLeave is null
				and State != 0
	  end

	Commit Tran AAA
end
GO

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_User_StartHandling' ) )
	drop procedure dbo.A_TaskManager_User_StartHandling
GO

CREATE  procedure [dbo].[A_TaskManager_User_StartHandling ]
	@id			uniqueidentifier,
	@userid			uniqueidentifier,
	@taskid			uniqueidentifier,
	@effortid		uniqueidentifier,
	@start			datetime

as
begin

	Insert Into A_TaskManager_UserInTask with ( TabLock )
			( Id, UserId, TaskId, EffortId, TimeStart )
		values
			( @id, @userid, @taskid, @effortid, @start )
	
end
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_User_UpdateHandling' ) )
	drop procedure dbo.A_TaskManager_User_UpdateHandling
GO

CREATE   procedure [dbo].[A_TaskManager_User_UpdateHandling ]
	@id			uniqueidentifier,
	@stopprior		datetime = NULL,
	@stopwaitcall		datetime = NULL,
	@stopbackcall		datetime = NULL,
	@stopdialog		datetime = NULL,
	@stoppost		datetime = NULL

as
begin

	Update A_TaskManager_UserInTask With ( TabLock )
	Set 	
		TimeStopPrior = IsNull ( TimeStopPrior, @stopprior ),
		TimeStopWaitCall = IsNull ( TimeStopWaitCall, @stopwaitcall ),
		TimeStopBackCall = IsNull ( TimeStopBackCall, @stopbackcall ),
		TimeStopDialog = IsNull ( TimeStopDialog, @stopdialog ),
		TimeStopPost = IsNull ( TimeStopPost, @stoppost )
	Where Id = @id
end

GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint' ) )
	drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
GO

CREATE Procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
	@idtask uniqueidentifier,
	@id 	int,
	@state 	int
as

begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'

	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		declare @sql nvarchar ( 4000 )
		Set @sql = ' Update ' + @tableidx + ' Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
		
		exec sp_sqlexec @sql
	end
end
GO
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_DB_InitOnStart' ) )
	drop procedure dbo.A_DB_InitOnStart
GO

CREATE PROCEDURE [dbo].[A_DB_InitOnStart]
As
begin

		-----------------------------------------------------
		--    -----------
		-----------------------------------------------------
		
		declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------

		Begin tran AAA

		Update A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Set TimeStopPost = @lastpingtime 
		Where TimeStopPost is null

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopDialog = @lastpingtime 
		Where TimeStopDialog is null

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopPrior = @lastpingtime
		Where TimeStopPrior is null

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopWaitCall = @lastpingtime 
		Where TimeStopWaitCall is null

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopBackCall = @lastpingtime 
		Where TimeStopBackCall is null

		Commit Tran AAA

		-----------------------------------------------------
		--        ,   
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set 	TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		--  
		-----------------------------------------------------

		Delete From A_Monopoly
		Delete From C_MonopolyForTaskChanging

		-----------------------------------------------------
		--   ,  -    
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		--    
		-----------------------------------------------------

		DECLARE tcursor CURSOR FOR 
			Select name, Id  FROM sysobjects 
			Where type = 'U' and name like 'A_TaskManager_LocalList%'
		declare @llid int
		declare @llname nvarchar ( 1000 )
		declare @ltid uniqueidentifier
		declare @ltids nvarchar ( 50 )
		declare @sql nvarchar ( 500 )

		OPEN tcursor
		FETCH NEXT FROM tcursor INTO @llname, @llid

		WHILE @@FETCH_STATUS = 0
		BEGIN
			set @llname = 'dbo.[' + @llname + ']'

			--   (id    Id  ) (      -       . N-1  )	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			--      JoinedTable  
			if not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname )
			begin
				set @sql = ' DROP TABLE ' + @llname
				--print @sql
				exec sp_executesql @stmt =@sql
			end

		FETCH NEXT FROM tcursor INTO @llname, @llid
		END

		CLOSE tcursor
		DEALLOCATE tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		--   ??
		--         ?
		--     ?
		--   ..   ,     ..
		Exec A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
end

GO

------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_DB_RemoveTails' ) )
	drop procedure dbo.A_DB_RemoveTails
GO


CREATE PROCEDURE [dbo].[A_DB_RemoveTails] AS
begin

		-----------------------------------------------------
		--    ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (LineId in (Select [ID] From A_ServerIntLines union all Select ID From A_ServerUSBLines))
		Delete FROM A_ServerExtLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerIntLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerGSMLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerUSBLines where not [ServerID] in (Select [id] from A_WORKPLACES)
	
		Delete FROM A_ServerUSBLines where not [id] in (Select LineID from A_WORKPLACES)
		Delete FROM A_LinesReactors where not [WPID] in (Select [id] from A_WORKPLACES)
		Delete From A_LinesReactors where not LineID in (Select [ID] from A_ServerExtLines 
								union Select [ID] from A_ServerIntLines
								union Select [ID] from A_ServerGSMLines
								union Select [ID] from A_ServerUSBLines)
		delete from A_ServerNumbers where not [id] in (Select [ID] FROM A_WorkPlaces Where type=5)
		delete from A_ServerNumbers where [id] in (Select [ID] from A_WorkPlaces where hasdatabase>0)



		declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] from A_WORKPLACES union 
			Select [id] from A_Users union
			Select [id] from A_ServerExtLines union
			Select [id] from A_ExtNumbers union
			Select [id] from A_ServerIntLines union
			Select [id] from A_ServerUSBLines 

		
		Delete From A_RuleRecords where not RuleID in (Select ID from A_Rules)

		Delete from A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ from @t ))

		Delete from A_NumberPlanAction where numtype=0 and extraid not in (Select ID from A_Rules)
		delete from A_NumberPlan where id not in (Select numid from A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID from A_NumberPlan)
		Delete From A_Rules	Where not id in ( select ruleid from A_RuleRecords )		

		delete from A_TaskManager_TaskExtLines where not ExtLineId in ( Select id from A_ServerExtLines )
		delete from A_TaskManager_Operators where not OperatorId in ( Select id from A_Users union Select Id from C_Groups )

		-----------------------------------------------------
		--     =   -   
		-----------------------------------------------------
		declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null  0  ID    ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		--  0     -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id from A_Users)

		-----------------------------------------------------
		--         --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		Declare defusercur Cursor For
			Select Id, DefaultUserId
			From A_ServerIntLines
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'
		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 from @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		--    ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id from C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id from @uidt)
			or not UserB in (Select id from @uidt)

		-----------------------------------------------------
		--     --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		--   ------------------------------------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------
		Delete From A_UserRoles 
		Where creationtype != 0 
			and not exists ( Select IdRole FROM A_UserParams up Where up.IdRole = A_UserRoles.Id )
		Delete From A_UserRolesExt 
		Where not exists ( Select Id From A_UserRoles a where a.Id = IdRole )

end
GO
------------------------------------------------------------------------------------------


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_DB_UserLogoff' ) )
	drop procedure dbo.A_DB_UserLogoff
GO


CREATE PROCEDURE [dbo].[A_DB_UserLogoff] 
	@iduser uniqueidentifier
AS
begin

		declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'


		-----------------------------------------------------
		-- Monopoly     
		-----------------------------------------------------		
		delete from C_MonopolyForTaskChanging where IdUser = @iduser

		-----------------------------------------------------
		--     -
		-----------------------------------------------------
		exec A_CallCenter_UserStateChange @start = 0, @idoperator = @iduser, @state = 0, @info = '', @selfinfo = 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------
		Begin Tran UIT

		Update A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Set TimeStopPost = @lastpingtime 
		Where TimeStopPost is null 
			and UserId = @iduser

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopDialog = @lastpingtime 
		Where TimeStopDialog is null
			and UserId = @iduser

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopPrior = @lastpingtime
		Where TimeStopPrior is null
			and UserId = @iduser

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopWaitCall = @lastpingtime 
		Where TimeStopWaitCall is null
			and UserId = @iduser

		Update A_TaskManager_UserInTask --with ( TabLock )
		Set TimeStopBackCall = @lastpingtime 
		Where TimeStopBackCall is null
			and UserId = @iduser

		Commit Tran UIT

		/*
		-----------------------------------------------------
		--     -     
		-----------------------------------------------------		
		Declare @dtnow DateTime 
		Set @dtnow = GetDate ( )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set 	p0 = 0, p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 0,
				LastDT = @dtnow
			Where Id = @iduser
		*/
end

GO

------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_Service_StatRemove' ) )
	drop procedure dbo.A_Service_StatRemove
GO


Create procedure dbo.A_Service_StatRemove	
	@pbxdrop bit,
	@pbxdropfiles bit,
	@pbxfromdate DateTime,
	@ccdrop bit,
	@ccdropfiles bit,
	@ccfromdate DateTime,
	@dropped int OUTPUT
as
begin

--
/*
declare @pbxdrop bit
declare @pbxdropfiles bit
declare @pbxfromdate DateTime
declare @ccdrop bit
declare @ccdropfiles bit
declare @ccfromdate DateTime
declare @dropped int

set @pbxdrop = 0
set @pbxdropfiles = 1
set @pbxfromdate = '05.05.2007'
set @ccdrop = 0
set @ccdropfiles = 0
set @ccfromdate = '01.04.2007'
*/
--
	set @dropped = 0

	--       
	declare @a table ( IdRecDir int, ALineNum nvarchar ( 5 ), BLineNum nvarchar ( 5 ), TimeStart DateTime, FromCC bit )


	if ( @pbxdropfiles = 1 and @ccdropfiles = 1 )	
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1 --with ( TabLock, HoldLock )
			Where (( TimeStart < @pbxfromdate and FromCC = 0 )
				Or ( TimeStart < @ccfromdate and FromCC = 1 )) 
				And IsRecorded = 1
			Order By TimeStart

	else if ( @pbxdropfiles = 1 )
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1 --with ( TabLock, HoldLock )
			Where ( TimeStart < @pbxfromdate and FromCC = 0 )
				And IsRecorded = 1
			Order By TimeStart

	else if ( @ccdropfiles = 1 )
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1 --with ( TabLock, HoldLock )
			Where ( TimeStart < @ccfromdate and FromCC = 1 )
				And IsRecorded = 1
			Order By TimeStart


	--   
	if ( @pbxdrop = 1 and @ccdrop = 1 )
	begin
		Delete
		From A_Stat_Connections_1x1 --with ( TabLock )
		Where ( TimeStart < @pbxfromdate and FromCC = 0 )
			Or ( TimeStart < @ccfromdate and FromCC = 1 )

		Set @dropped = @@rowcount
	end

	else if ( @pbxdrop = 1 )
	begin
		Delete
		From A_Stat_Connections_1x1 --with ( TabLock )
		Where ( TimeStart < @pbxfromdate and FromCC = 0 )

		Set @dropped = @@rowcount
	end

	else if ( @ccdrop = 1 )
	begin
		Delete
		From A_Stat_Connections_1x1 --with ( TabLock )
		Where ( TimeStart < @ccfromdate and FromCC = 1 )

		Set @dropped = @@rowcount
	end


	--  
	Select * FROM @a	
end
GO

------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_Stat_MyCalls_Get' ) )
	drop procedure dbo.A_Stat_MyCalls_Get
GO


CREATE  procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'

*/
	Declare @ids table ( id uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, Length DateTime, Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 100 ) collate database_default, 
				IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ) collate database_default, BLineNum nvarchar ( 5 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 100 ) collate database_default, BStr nvarchar ( 100 ) collate database_default )
	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, '', '',
			IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber, AStr, BStr
		From A_Stat_Connections_1x1 sc --with ( TabLock )
			inner join @ids ids on sc.Id = ids.id

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = '' and o.Number = ''

	Select Id, Media, Type, TimeStart, Length, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir--, ARecFile, BRecFile
	From @output
	Where Media = @media or @media = 0
	Order By TimeStart Desc

end
GO
------------------------------------------------------------------------------------------


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_Stat_Connection_Start' ) )
	drop procedure dbo.A_Stat_Connection_Start
GO


CREATE  Procedure dbo.A_Stat_Connection_Start
	
	@id			uniqueidentifier,
	@idchain		uniqueidentifier,
	@connectiontype		int,
	@reasonstart		int,
	@timestart		datetime,
	@timeanswer		datetime,
	@alineid		uniqueidentifier,
	@alinenum		nvarchar ( 8 ),
	@anumberdialed		nvarchar ( 50 ),
	@aoutnumber		nvarchar ( 50 ),
	@astr			nvarchar ( 50 ),
	@auserid		uniqueidentifier,
	@blineid		uniqueidentifier,
	@blinenum		nvarchar ( 8 ),
	@bnumberdialed		nvarchar ( 50 ),
	@boutnumber		nvarchar ( 50 ),
	@bstr			nvarchar ( 50 ),
	@buserid		uniqueidentifier,
	@isrecorded		int,
	@recorddir		nvarchar ( 1000 )
	--@arecfile		nvarchar ( 50 ),
	--@brecfile		nvarchar ( 50 )
as

begin

	Declare @idprev uniqueidentifier

	--  ?
	declare @betweenop bit
	Set @betweenop = 0
	if ( exists ( Select Id From A_Users Where Id = @auserid )
	 	and exists ( Select Id From A_Users Where Id = @buserid ) )
		Set @betweenop = 1
	else if ( exists ( Select Id From A_View_ServerIntLinesAll Where Id = @alineid ) 
		and exists ( Select Id From A_View_ServerIntLinesAll Where Id = @blineid ) )
		Set @betweenop = 1

	--  ? -    ,      -        (      )
	declare @fromcc bit
	Set @fromcc = 0
	if exists ( Select TimeStart From A_TaskManager_UserInTask --with ( TabLock )
			Where ( UserId = @auserid or UserId = @buserid )
				And TimeStopDialog is null --     -     -   
			)	
		Set @fromcc = 1

	--   
	declare @idrecdir int
	set @idrecdir = 0

	if (( @isrecorded > 0 ) and ( @recorddir != '' ))
	begin
		Select @idrecdir = Max ( id ) 
		From A_Stat_RecordDirectories

		declare @nowrecdir nvarchar ( 1000 )
		Select @nowrecdir = path 
		From A_Stat_RecordDirectories
		Where Id = @idrecdir

		if (( @nowrecdir != @recorddir ) or ( @nowrecdir is null ))
		begin
			Insert into A_Stat_RecordDirectories
			Values ( @recorddir, @timestart )
			
			set @idrecdir = @@identity
		end
	end


	--Begin tran AAA

	--   
	Select top 1 @idprev = Id
		from A_Stat_Connections_1x1 --With ( TabLock )
		where IdChain = @idchain 
		order by TimeStart desc

	
	-- 
	Insert into A_Stat_Connections_1x1 --With ( UpdLock, HoldLock )
	(
		Id,
		IdChain,
		IdPrev,
		ConnectionType,
		ReasonStart,	
		TimeStart,		
		TimeAnswer,		
		ALineId,	
		ALineNum,
		ANumberDialed,
		AOutNumber,	
		AStr,	
		AUserId,
		BLineId,	
		BLineNum,		
		BNumberDialed,
		BOutNumber,	
		BStr,	
		BUserId,
		IsRecorded,
		IdRecDir,
		--ARecFile,
		--BRecFile,
		IsBetweenUsers,
		FromCC
	)

	Values

	(
		@id,
		@idchain,
		@idprev,
		@connectiontype,
		@reasonstart,
		@timestart,
		@timeanswer,
		@alineid,
		@alinenum,
		@anumberdialed,
		@aoutnumber,
		@astr,
		@auserid,
		@blineid,
		@blinenum,
		@bnumberdialed,
		@boutnumber,
		@bstr,
		@buserid,
		@isrecorded,
		@idrecdir,
		--@arecfile,
		--@brecfile,
		@betweenop,
		@fromcc --0
	)


	--    
	if ( @@rowcount > 0 )	
		Update A_Stat_Connections_1x1 --With ( TabLock )
			Set IdNext = @Id
			Where Id = @idprev

	--Commit Tran AAA

end
GO

------------------------------------------------------------------------------------------


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_Stat_Office_Records_Remove' ) )
	drop procedure dbo.A_Stat_Office_Records_Remove
GO


CREATE  PROCEDURE dbo.[A_Stat_Office_Records_Remove]
	@id uniqueidentifier
as
begin
	declare @t DateTime
	declare @r bit
	declare @a nvarchar ( 100 )
	declare @b nvarchar ( 100 )
	declare @dir int
	declare @path nvarchar ( 200 )
	
	Select @t = TimeStart, @r = IsRecorded, @a = ALineNum, @b = BLineNum, @dir = IdRecDir
	From A_Stat_Connections_1x1 --with ( TabLock )
	Where Id = @id

	Update A_Stat_Connections_1x1 --with ( TabLock )
	Set IsRecorded = 0
	Where Id = @id

	Select @path = Path From A_Stat_RecordDirectories Where Id = @dir
	Select @t, @r, @a, @b, @dir, @path
end
GO

------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_Stat_Service_FillTempByFilter' ) )
	drop procedure dbo.A_Stat_Service_FillTempByFilter
GO


CREATE   PROCEDURE [dbo].[A_Stat_Service_FillTempByFilter]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	@conntype int = -1
AS
begin

	--Prepare @A_Stat_Connections_1x1_tmp
	Declare @A_Stat_Connections_1x1_tmp1 table( Id uniqueidentifier PRIMARY KEY) 
	Declare @A_Stat_Connections_1x1_tmp table( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, BUSerId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier) 
	declare @tstartfloat float  declare @tstopfloat float 
	set @tstartfloat = Convert ( float, @tstart )  
	set @tstopfloat  = Convert ( float, @tstop )  
	set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
	set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  

	declare @lt float
	set @lt = Convert ( float, @lentime ) - Floor ( Convert ( float, @lentime ) )


	--Date & Time Intervals
	Insert into @A_Stat_Connections_1x1_tmp 
	select Id, AUSerId , BUSerId , ALineId , BLineId 
	from A_Stat_Connections_1x1 sc --With ( TabLock )
	where 
		 ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
		and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
		and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
		and ( CONVERT ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
		and (( FromCC is null ) or ( FromCC <= @fromcc ))
		and (@conntype = -1 or (@conntype = 1 and ConnectionType in (4,5)) or (@conntype = 2 and ConnectionType in (1,6,7)) or (@conntype = 3 and ConnectionType in (2,3,8)))
	
		--and not exists(select id from  @A_Stat_Connections_1x1_tmp where id=sc.ID)


	--Permissions
	--Users
	declare @upermitted table ( Id uniqueidentifier Primary Key )
	Insert into @upermitted
		Select UserB
		From A_UserControls auc
		Where UserA = @iduser

	if not exists (select UserB from  A_UserControls where UserA = @iduser and UserB = @iduser)
		Insert into @upermitted (Id) Values (@iduser)

	Declare @commpermitted table ( Id uniqueidentifier PRIMARY KEY)  	 -- Id Connection
	Insert into @commpermitted
		Select  sc.ID --auc.UserB   	
		From @upermitted up
			inner join @A_Stat_Connections_1x1_tmp sc on up.Id = sc.AUserId
	
	Insert into @commpermitted
		Select  sc.ID --auc.UserB   	
		From @upermitted up
			inner join @A_Stat_Connections_1x1_tmp sc on up.Id=sc.BUserId
		Where not exists(select id from @commpermitted where Id=sc.ID)


	--Lines
	print '------Lines'
	declare @lpermitted table ( Id uniqueidentifier Primary Key )
	Insert into @lpermitted
    	 Select IdLine
    	 From A_UserControlLines
    	 Where UserA = @iduser
          and IdLine != '11111111-1111-1111-1111-111111111111'       

	declare @canlistenext int       
	Select @canlistenext = Count ( * ) 
	From A_UserControlLines 
	Where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
    		Insert into @lpermitted
	          Select Id 
        	  From A_ServerExtLines sel
	          Where not exists(select id from @lpermitted where Id = sel.ID)
     
	Insert into @commpermitted
    	 Select sc.ID            
    	 From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on sc.ALineId=l.Id
    	 Where not exists(select id from @commpermitted where Id = sc.ID)

	Insert into @commpermitted            
    	 Select sc.ID            
    	 From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on  sc.BLineId=l.Id
    	 Where not exists(select id from @commpermitted where Id = sc.ID)

	print '------Lines'

	delete @A_Stat_Connections_1x1_tmp 
	where id not in (select Id from @commpermitted )

--Numbers 
	--Inner
	if @innerprefix is not null 
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )

		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id

		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1

			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid

			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid 
				From @temp

			/* */
			Delete From @temp	
		end --\MakePrefixTableAnyWay condition

		

		--Users
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		--Lines
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)
		
		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
		
	end --\NUmbers

	--Outer NUMBVERS
	if @OutNumber is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc --With ( TabLock )
		where  AOutNumber like '%'+@OutNumber+'%'

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc --With ( TabLock )
		where  BOutNumber like '%'+@OutNumber+'%'
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1

	end
	--\Outer NUMBVERS

	--operatorid
	if @operatorid is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
		where  AUserId=@operatorid

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id 
		from @A_Stat_Connections_1x1_tmp sc
		where  BUserId=@operatorid
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
	end


	Select sc.*
	FROM A_Stat_Connections_1x1 sc --With ( TabLock )--,@ulpermitted ul,@tasks t
		Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		--Inner Join @commpermitted cp on sc.ID=cp.ID

end
GO
------------------------------------------------------------------------------------------


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_Number' ) )
	drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Number
GO


CREATE procedure [dbo].A_TaskManager_TaskOut_UpdateResult_Number
	@idtask 		uniqueidentifier,
	@idinlist		int,
	@number			nvarchar ( 20 ),
	@countbusy		int,
	@countnotrespond 	int,
	@countqhangoff		int,
	@qtime			int,
	@nextefforttime 	DateTime,
	@nresult		int
as
begin
	--Begin tran AAA

	update A_TaskManager_SubTaskNumber --With ( TabLock, HoldLock )
	   set
		CountBusy		= @countbusy,
		CountNotRespond		= @countnotrespond,
		CountQHangOff		= @countqhangoff,
		QTime			= @qtime,
		NextEffortTime 		= @nextefforttime,
		NResult			= @nresult
	   where		
		TaskId = @idtask
		and IdInList = @idinlist
		and Number = @number

	if ( @@rowcount = 0 )
		Insert Into A_TaskManager_SubTaskNumber --With ( TabLock )
			( IdInList, TaskId, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, NextEffortTime )
		Values
			( @idinlist, @idtask, @number, @countbusy, @countnotrespond, @countqhangoff, @qtime, @nresult, @nextefforttime )	

	--Commit Tran AAA
end

GO
------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_Point' ) )
	drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Point
GO

CREATE      Procedure dbo.A_TaskManager_TaskOut_UpdateResult_Point
	@idtask			uniqueidentifier,	
	@idinlist		int,
	@nextefforttime		datetime,
	@nresult		int
as

begin	
	--Begin tran AAA

	update A_TaskManager_SubTasks --With ( TabLock, HoldLock )
	   set
		NextEffortTime 		= @nextefforttime,
		NResult			= @nresult
	   where		
		TaskId = @idtask
		and IdInList = @idinlist

	if ( @@rowcount = 0 )
		Insert Into A_TaskManager_SubTasks --With ( TabLock )
			( IdInList, TaskId, NResult, IsDeleted, NextEffortTime )
		Values
			( @idinlist, @idtask, @nresult, 0, @nextefforttime )

	--Commit Tran AAA
end
GO

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetQuery' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_GetQuery
GO

Create procedure A_TaskManager_List_DirectDB_GetQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
		
		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], 0, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0		

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetTable' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_GetTable
GO

CREATE  procedure A_TaskManager_List_DirectDB_GetTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], 0, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0		

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncQuery' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
GO

Create procedure A_TaskManager_List_DirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		declare @k int
		Set @k = 1
		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], 0, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncTable' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_SyncTable
GO

Create procedure A_TaskManager_List_DirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		declare @k int
		Set @k = 1
		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 Id, 0, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.Id )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO


if not exists ( Select * FROM sysindexes where name = 'idx_CCUSH_oper_state_tl' )
	Create nonclustered index idx_CCUSH_oper_state_tl on A_CallCenter_UserStateHistory ( OperatorId, State, TimeLeave ) with FillFactor = 80
GO