if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Connections_Errors]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Stat_Connections_Errors]
GO

CREATE TABLE [dbo].[A_Stat_Connections_Errors] (
	[Id] [uniqueidentifier] NOT NULL ,
	[IdChain] [uniqueidentifier] NULL ,
	[TimeStart] [datetime] NULL ,
	[TimeAnswer] [datetime] NULL ,
	[TimeStop] [datetime] NULL ,
	[ReasonStart] [int] NULL ,
	[ALineId] [uniqueidentifier] NULL ,
	[BLineId] [uniqueidentifier] NULL ,
	[AOutNumber] [nvarchar] (50) COLLATE database_default NULL ,
	[BOutNumber] [nvarchar] (50) COLLATE database_default NULL ,
	[ALineNum] [nvarchar] (8) COLLATE database_default NULL ,
	[BLineNum] [nvarchar] (8) COLLATE database_default NULL ,
	[AUserId] [uniqueidentifier] NULL ,
	[BUserId] [uniqueidentifier] NULL ,
	[ANumberDialed] [nvarchar] (50) COLLATE database_default NULL ,
	[BNumberDialed] [nvarchar] (50) COLLATE database_default NULL ,
	[ConnectionType] [int] NULL ,
	[Astr] [nvarchar] (50) COLLATE database_default NULL ,
	[Bstr] [nvarchar] (50) COLLATE database_default NULL ,
	[AttemptNum] [int] NULL 
) ON [PRIMARY]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Stat_Connection_ErrorInfo_Save]'))
drop procedure [dbo].[A_Stat_Connection_ErrorInfo_Save]
GO


Create procedure A_Stat_Connection_ErrorInfo_Save
	@id			uniqueidentifier,
	@idchain		uniqueidentifier,
	@connectiontype		int,
	@reasonstart		int,
	@timestart		datetime,
	@timeanswer		datetime,
	@alineid		uniqueidentifier,
	@alinenum		nvarchar ( 8 ),
	@anumberdialed		nvarchar ( 50 ),
	@aoutnumber		nvarchar ( 50 ),
	@astr			nvarchar ( 50 ),
	@auserid		uniqueidentifier,
	@blineid		uniqueidentifier,
	@blinenum		nvarchar ( 8 ),
	@bnumberdialed		nvarchar ( 50 ),
	@boutnumber		nvarchar ( 50 ),
	@bstr			nvarchar ( 50 ),
	@buserid		uniqueidentifier,
	@attemptnum		int
as

begin

	-- 
	Insert into A_Stat_Connections_Errors --With ( UpdLock, HoldLock )
	(
		Id,
		IdChain,		
		ConnectionType,
		ReasonStart,	
		TimeStart,		
		TimeAnswer,		
		ALineId,	
		ALineNum,
		ANumberDialed,
		AOutNumber,	
		AStr,	
		AUserId,
		BLineId,	
		BLineNum,		
		BNumberDialed,
		BOutNumber,	
		BStr,	
		BUserId,
		AttemptNum
	)

	Values

	(
		@id,
		@idchain,		
		@connectiontype,
		@reasonstart,
		@timestart,
		@timeanswer,
		@alineid,
		@alinenum,
		@anumberdialed,
		@aoutnumber,
		@astr,
		@auserid,
		@blineid,
		@blinenum,
		@bnumberdialed,
		@boutnumber,
		@bstr,
		@buserid,
		@attemptnum
	)

end
GO