
if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_CacheDelete' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_CacheDelete
GO

CREATE procedure A_TaskManager_List_DistrDirectDB_CacheDelete
	@taskid uniqueidentifier	
as
begin
	--      DirectDbMethod
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		declare @sql nvarchar ( 4000 )
		Set @sql = ' Drop table ' + @tableidx
		
		exec sp_sqlexec @sql
	end
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_Task_Delete' ) )
	Drop procedure dbo.A_TaskManager_Task_Delete
GO

CREATE  Procedure [dbo].[A_TaskManager_Task_Delete]
	@id 	uniqueidentifier
as
begin
	Delete 
	From A_TaskManager_Tasks 
	Where Id = @id

	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
	Exec dbo.A_TaskManager_List_DistrDirectDB_CacheDelete @id
end
GO

if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncTable' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTable
GO


CREATE  procedure A_TaskManager_List_DistrDirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		declare @k int
		Set @k = 1
		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 Id, 0, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.Id )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncQuery' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQuery
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @tableacindex nvarchar ( 200 )
	declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		declare @k int
		Set @k = 1
		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], 0, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_ClearOperatorLinks' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_ClearOperatorLinks
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_ClearOperatorLinks
	@taskid uniqueidentifier
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Update ' + @tableidx + '
			Set IdOperator = null
			'

		exec sp_sqlexec @sql
	end
end
GO

if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTotalCount' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTotalCount
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_GetTotalCount
	@taskid uniqueidentifier
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Select count ( Id ) From ' + @tableidx

		exec sp_sqlexec @sql
	end
end
GO




if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_RefreshOperator
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@listtable nvarchar ( 1000 ) = '',
	@listquery nvarchar ( 1000 ) = '',
	@listidfield nvarchar ( 100 ) = '',
	@listnamefield nvarchar ( 100 ) = '',
	@count int = 0,
	@letter1 char ( 1 ) = '',
	@letter2 char ( 1 ) = ''
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		if ( @count > 0 )
  		    Set @sql = '
			SET ROWCOUNT ' + cast ( @count as nvarchar ( 10 ) ) + '

			Update ' + @tableidx + ' 
			Set IdOperator = ' + @operator + '
			Where IdOperator is null

			SET ROWCOUNT 0
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listtable != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct Id 
				From ' + @listtable + '
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listquery != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct Id 
				From (' + @listquery + ') a
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else 
		    Set @sql = '
			Update ' + @tableidx + ' 
			Set IdOperator = NULL
			Where IdOperator = ''00000000-0000-0000-0000-000000000000'''

			
		exec sp_sqlexec @sql
	end
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetCurrentDistribution' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetCurrentDistribution
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_GetCurrentDistribution
	@taskid uniqueidentifier
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Select IdOperator, Count ( Id )
			From ' + @tableidx + '
			Group by IdOperator
			'

		exec sp_sqlexec @sql
	end
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_Task_ClearStatistics' ) )
	Drop procedure dbo.A_TaskManager_Task_ClearStatistics
GO

CREATE Procedure dbo.A_TaskManager_Task_ClearStatistics
	@id uniqueidentifier
as
begin
	Delete 
	From dbo.A_TaskManager_SubTasks --With ( TabLock )
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskEfforts --With ( TabLock )
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskNumber --With ( TabLock )
	Where TaskId = @id

	Update dbo.A_TaskManager_Tasks
	Set Done = 0
	Where Id = @id
	
	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
	Exec dbo.A_TaskManager_List_DistrDirectDB_CacheDelete @id
end
GO




if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetCountRemain' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetCountRemain
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_GetCountRemain
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		if ( @operatorid = '00000000-0000-0000-0000-000000000000' )
		    Set @sql = '
			Select Count ( Id ) 
			From ' + @tableidx + '
			Where State = 0
			'
		else
  		    Set @sql = '
			Select Count ( Id ) 
			From ' + @tableidx + '
			Where State = 0
				And IdOperator = ' + @operator


		exec sp_sqlexec @sql
	end
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTable' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTable
GO


CREATE procedure A_TaskManager_List_DistrDirectDB_GetTable
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	declare @sql nvarchar ( 4000 )


	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 Id, 0, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.Id )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0 
		And IdOperator = ' + @operator + '
		'

	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQuery' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQuery
GO

CREATE procedure A_TaskManager_List_DistrDirectDB_GetQuery
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 		Select top 100000 [' + @idfield + '], 0, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
			end
			'

	exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		And IdOperator = ' + @operator + '
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0	
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetParams' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetParams
GO

CREATE procedure A_TaskManager_List_DistrDirectDB_GetParams
	@taskid uniqueidentifier,
	@id int
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )
	Set @sql = 'Select * From ' + @tableidx + ' Where Id = ' + cast ( @id as nvarchar( 10 ) )

	exec sp_sqlexec @sql	
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_SetParams_lastnum' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SetParams_lastnum
GO

CREATE procedure A_TaskManager_List_DistrDirectDB_SetParams_lastnum
	@taskid uniqueidentifier,
	@id int,
	@lastnum int
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )
	Set @sql = 'Update ' + @tableidx + ' Set NIdx = ' + Cast ( @lastnum as nvarchar ( 10 ) ) + ' Where Id = ' + cast ( @id as nvarchar( 10 ) )

	exec sp_sqlexec @sql	
end

GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_CallCenter_OperatorLastCall_Get' ) )
	Drop procedure dbo.A_CallCenter_OperatorLastCall_Get
GO

CREATE procedure A_CallCenter_OperatorLastCall_Get
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier
as
begin
	declare @idinlist int
	declare @number nvarchar ( 50 )
	declare @callresult int
	declare @userresult int
	declare @callresultname nvarchar ( 500 )
	declare @userresultname nvarchar ( 500 )

	Select Top 1 @idinlist = IdInList, @number = AbonentNumber, @callresult = CallResult, @userresult = UserResult
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
	Where IdTask = @taskid and IdOperator = @operatorid
	Order by DateTimeStart Desc

	Select @callresultname = name 
	From oktell_cc_temp.dbo.A_Cube_CC_Cat_TaskResultTypes
	Where id = @callresult

	Select @userresultname = name
	From dbo.A_TaskManager_CardUserResults
	Where Id = @userresult

	if ( not @idinlist is null )
		Select @idinlist, @number, @callresult, @callresultname, @userresult, IsNull ( @userresultname, '< >' )
end
GO




if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_DecrementAC' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_DecrementAC
GO

CREATE  procedure A_TaskManager_List_DistrDirectDB_DecrementAC
	@taskid uniqueidentifier,
	@idinlist int
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Update ' + @tableidx + ' 
			Set AC = AC - 1
			Where Id = ' + Cast ( @idinlist as nvarchar ( 10 ) ) + '
			'

		exec sp_sqlexec @sql
	end
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTableExact' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTableExact
GO


CREATE procedure A_TaskManager_List_DistrDirectDB_GetTableExact
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 50 )
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	declare @sql nvarchar ( 4000 )


	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 Id, 0, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.Id )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	
	--  ,    (   )
	--        
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where State = 0
			and IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact
GO

CREATE procedure A_TaskManager_List_DistrDirectDB_GetQueryExact
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 50 )
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 		Select top 100000 [' + @idfield + '], 0, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
			end
			'

	exec sp_sqlexec @sql
	end	
	
	

	--  ,    (   )
	--        
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where State = 0
			and IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint' ) )
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
GO


CREATE Procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
	@idtask uniqueidentifier,
	@id 	int,
	@state 	int
as

begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'
	
	declare @tableidxd nvarchar ( 200 )
	set @tableidxd = 'dbo.[A_TaskManager_dIdx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
 	begin
		Set @sql = ' Update ' + @tableidx + ' Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
		
		exec sp_sqlexec @sql
	end
	
	else if exists ( select * from sysobjects where id = object_id ( @tableidxd ) )
   	begin
		Set @sql = ' Update ' + @tableidxd + ' Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
		
		exec sp_sqlexec @sql
	end
end
GO