
if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardLunchStates' ) )
	Drop table dbo.A_TaskManager_CardLunchStates
GO

Create table dbo.A_TaskManager_CardLunchStates
( 
  Id int primary key not null,  
  Name nvarchar ( 500 ) not null,
  IsDefault bit not null
)
GO

if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardLunchStates_Get' ) )
	Drop procedure dbo.A_TaskManager_CardLunchStates_Get
GO

Create procedure dbo.A_TaskManager_CardLunchStates_Get
as
begin
	Select Id, Name, IsDefault
	From A_TaskManager_CardLunchStates
	Order by Id
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardLunchStates_Clear' ) )
	Drop procedure dbo.A_TaskManager_CardLunchStates_Clear
GO

Create procedure dbo.A_TaskManager_CardLunchStates_Clear
as
begin
	Delete
	From A_TaskManager_CardLunchStates
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardLunchStates_Add' ) )
	Drop procedure dbo.A_TaskManager_CardLunchStates_Add
GO

Create procedure dbo.A_TaskManager_CardLunchStates_Add
	@id int,
	@name nvarchar ( 500 ),
	@isdefault bit = 0
as
begin
	Insert into A_TaskManager_CardLunchStates
	Values ( @id, @name, @isdefault )
end
GO

Insert into A_TaskManager_CardLunchStates Values ( 1, '', 0 )
Insert into A_TaskManager_CardLunchStates Values ( 2, '5 ', 0 )
Insert into A_TaskManager_CardLunchStates Values ( 3, '  ', 0 )
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_UserState_GetInfo' ) )
	Drop procedure dbo.A_UserState_GetInfo
GO

CREATE     Procedure dbo.A_UserState_GetInfo

	@userid				uniqueidentifier,
	@datestart			datetime,
	@datestop			datetime,
	@state				int
as

begin
	
	if ( @state < 0 )
		Select State, TimeChange, Info, UserSelfInfo From A_UserStateHistory
		Where UserId = @userid and TimeChange > @datestart and TimeChange < @dateStop 
		Order By TimeChange Desc
	else
		Select State, TimeChange, Info, UserSelfInfo From A_UserStateHistory
		Where UserId = @userid and TimeChange > @datestart and TimeChange < @dateStop 		
		And State = @state
		Order By TimeChange Desc
end
GO