

if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardUserResults_Clear' ) )
	Drop procedure dbo.A_TaskManager_CardUserResults_Clear
GO

Create procedure dbo.A_TaskManager_CardUserResults_Clear
as
begin
	Delete
	From A_TaskManager_CardUserResults
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardUserResults_Add' ) )
	Drop procedure dbo.A_TaskManager_CardUserResults_Add
GO

Create procedure dbo.A_TaskManager_CardUserResults_Add
	@id int,
	@name nvarchar ( 500 ),
	@isoutput bit,
	@success bit,
	@isdefault bit = 0
as
begin
	Insert into A_TaskManager_CardUserResults
	Values ( @id, @name, @isoutput, @success, @isdefault )
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes' ) )
	Drop procedure dbo.A_CallCenter_Info_GetOperatorIndexes
GO

Create procedure dbo.A_CallCenter_Info_GetOperatorIndexes
	@iduser uniqueidentifier,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		set @dtnow = GetDate ( )

	declare @dtday datetime
	set @dtday = Cast ( Floor ( Cast ( @dtnow as float ) ) as datetime )

	declare @cntsuccess int, @lunchlen float
	
	Select @cntsuccess = Count ( * ) From
	(
		Select distinct IdChain
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
		Where DateTimeStart > @dtday
			and CallResult = 5
			and IdOperator = @iduser
	) a


	Select @lunchlen = Sum ( Cast ( TimeLeave - TimeEnter as float ) * 86400 ) From
	(
		Select case when TimeEnter < @dtday then @dtnow else timeenter end as TimeEnter,
			IsNull ( TimeLeave, @dtnow ) as TimeLeave
		FROM A_Callcenter_UserStateHistory
		Where State = 3 and ( TimeLeave > @dtday or TimeLeave is Null )
	) a

	Select IsNull ( @cntsuccess, 0 ), IsNull ( @lunchlen, 0 )

end
GO