if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTableExact' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTableExact
GO

CREATE procedure A_TaskManager_List_DistrDirectDB_GetTableExact
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 50 )
as
begin
--------------------------------------
/*
declare @taskid uniqueidentifier
declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	declare @sql nvarchar ( 4000 )


	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			declare @k int
			Set @k = 1
			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 Id, 0, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.Id )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	
	--  ,    (   )
	--        
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '
			--and State = 0

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_OperatorLastCall_Get' ) )
	Drop procedure dbo.A_CallCenter_OperatorLastCall_Get
GO

CREATE  procedure A_CallCenter_OperatorLastCall_Get
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier
as
begin
----------------------------------------
/*
	declare @taskid uniqueidentifier, @operatorid uniqueidentifier
	select @taskid = 'C5D4BCB0-3831-432E-A611-ACBBAD6FFACC', @operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
*/
-----------------------------------------

	declare @idinlist int
	declare @number nvarchar ( 50 )
	declare @callresult int
	declare @userresult int
	declare @callresultname nvarchar ( 500 )
	declare @userresultname nvarchar ( 500 )

	declare @tableidx nvarchar ( 200 ), @tableidxname nvarchar ( 200 ), @cached bit
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	set @tableidxname = 'A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) )
	set @cached = 0
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
  	  if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like @tableidxname 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IdOperator' )
    	  begin
		declare @sql nvarchar ( 4000 )
		Set @sql = '
			Select Top 1 IdInList, AbonentNumber, CallResult, UserResult
			From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
				Inner join ' + @tableidx + ' t on ec.IdInList = t.Id
			Where ec.IdTask = ''' + Cast ( @taskid as nvarchar ( 100 ) ) + '''
				 and ( t.IdOperator = ''' + Cast ( @operatorid as nvarchar ( 100 ) ) + ''' or 
					ec.IdOperator = ''' + Cast ( @operatorid as nvarchar ( 100 ) ) + ''' )
			Order by DateTimeStart desc
			'				
		
		if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
			drop table #t
		create table #t ( idinlist int, abonentnumber nvarchar ( 100 ) collate database_default, callresult int, userresult int )

		Insert into #t
			exec sp_sqlexec @sql

		Select Top 1 @idinlist = IdInList, @number = AbonentNumber, @callresult = CallResult, @userresult = UserResult
		From #t

		set @cached = 1
	  end
	
	if ( @cached = 0 )
	begin
	  	Select Top 1 @idinlist = IdInList, @number = AbonentNumber, @callresult = CallResult, @userresult = UserResult
	  	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
	  	Where IdTask = @taskid and IdOperator = @operatorid
	  	Order by DateTimeStart Desc
	end

	Select @callresultname = name 
	From oktell_cc_temp.dbo.A_Cube_CC_Cat_TaskResultTypes
	Where id = @callresult

	Select @userresultname = name
	From dbo.A_TaskManager_CardUserResults
	Where Id = @userresult

	if ( not @idinlist is null )
		Select @idinlist, @number, @callresult, @callresultname, @userresult, IsNull ( @userresultname, '< >' )
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes' ) )
	Drop procedure dbo.A_CallCenter_Info_GetOperatorIndexes
GO

CREATE procedure dbo.A_CallCenter_Info_GetOperatorIndexes
	@iduser uniqueidentifier,
	@dtnow datetime = null
as
begin
------------------------------
/*
	declare @iduser uniqueidentifier, @dtnow datetime
	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', @dtnow = null
*/
------------------------------
	if ( @dtnow is null )
		set @dtnow = GetDate ( )

	declare @dtday datetime
	set @dtday = Cast ( Floor ( Cast ( @dtnow as float ) ) as datetime )

	declare @cntsuccess int, @lunchlen float
	
	Select @cntsuccess = Count ( * ) From
	(
		Select distinct IdChain
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
		Where DateTimeStart > @dtday
			and CallResult = 5
			and IdOperator = @iduser
	) a

	Select @lunchlen = Sum ( Cast ( TimeLeave - TimeEnter as float ) * 86400 ) From
	(
		Select case when TimeEnter < @dtday then @dtday else timeenter end as TimeEnter,
			IsNull ( TimeLeave, @dtnow ) as TimeLeave
		FROM A_Callcenter_UserStateHistory
		Where State = 3 and ( TimeLeave > @dtday or TimeLeave is Null )
	) a

	Select IsNull ( @cntsuccess, 0 ), IsNull ( @lunchlen, 0 )

end
GO