
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes' ) )
	Drop procedure dbo.A_CallCenter_Info_GetOperatorIndexes
GO

CREATE procedure dbo.A_CallCenter_Info_GetOperatorIndexes
	@iduser uniqueidentifier,
	@dtnow datetime = null
as
begin
------------------------------
/*
	declare @iduser uniqueidentifier, @dtnow datetime
	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', @dtnow = null
*/
------------------------------
	if ( @dtnow is null )
		set @dtnow = GetDate ( )

	declare @dtday datetime
	set @dtday = Cast ( Floor ( Cast ( @dtnow as float ) ) as datetime )

	declare @cntsuccess int, @worklen float, @cclen float, @cconlinelen float, @cclunchlen float
	
	Select @cntsuccess = Count ( * ) From
	(
		Select distinct IdChain
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
		Where DateTimeStart > @dtday
			and CallResult = 5
			and IdOperator = @iduser
	) a

	if exists ( select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tstates' ) )
		drop table #tstates

	Select State, Sum ( Cast ( TimeLeave - TimeEnter as float ) * 86400 ) as LenSec Into #tstates 
	From
	(
		Select State, case when TimeEnter < @dtday then @dtday else timeenter end as TimeEnter,
			IsNull ( TimeLeave, @dtnow ) as TimeLeave
		FROM A_Callcenter_UserStateHistory
		Where OperatorId = @iduser
			and ( TimeLeave > @dtday or TimeLeave is Null )
	) a
	Group By State

	Select @worklen = LenSec From #tstates Where State = 0
	Select @cclen = LenSec From #tstates Where State = 1
	Select @cconlinelen = LenSec From #tstates Where State = 2
	Select @cclunchlen = LenSec From #tstates Where State = 3


	Select IsNull ( @cntsuccess, 0 ) as CountSuccess, 
		IsNull ( @worklen, 0 ) as AuthorizedSec, 
		IsNull ( @cclen, 0 ) as CCSec, 
		IsNull ( @cconlinelen, 0 ) as CCOnlineSec, 
		IsNull ( @cclunchlen, 0 ) as CCLunchSec

end
GO




if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes_Custom' ) )
	Drop procedure dbo.A_CallCenter_Info_GetOperatorIndexes_Custom
GO

CREATE procedure dbo.A_CallCenter_Info_GetOperatorIndexes_Custom
	@iduser uniqueidentifier,
	@dtnow datetime = null
as
begin
------------------------------
/*
	declare @iduser uniqueidentifier, @dtnow datetime
	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', @dtnow = null
*/
------------------------------
	if ( @dtnow is null )
		set @dtnow = GetDate ( )

	declare @dtday datetime
	set @dtday = Cast ( Floor ( Cast ( @dtnow as float ) ) as datetime )


	--Select ' 1:', ' 1'
	-- Select * From #t

end
GO