if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetTable' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_GetTable
GO

Create procedure dbo.A_TaskManager_List_DirectDB_GetTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], @k, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		--     ,   -     
		begin tran search_update 

		Declare @id int, @efc int, @st int, @ln int
		Select top 1  @Id = Id, @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		From ' + @tableidx + ' with ( Index ( [' + @tableacindex + '] ) )
		Where AC = @min
			and State = 0		

		Update ' + @tableidx + ' 
		Set AC = AC + 1, NIdx = NIdx + 1
		Where Id = @id

		--Select @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		--From ' + @tableidx + ' 
		--Where Id = @id

		commit tran search_update
		
		Select @efc, @st, @ln, ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetQuery' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_GetQuery
GO

Create procedure dbo.A_TaskManager_List_DirectDB_GetQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
		
		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], @k, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		--     ,   -     
		begin tran search_update_q

		Declare @id int, @efc int, @st int, @ln int
		Select top 1 @Id = Id, @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		From ' + @tableidx + ' with ( Index ( [' + @tableacindex + '] ) )
		Where AC = @min
			and State = 0

		Update ' + @tableidx + ' 
		Set AC = AC + 1, NIdx = NIdx + 1
		Where Id = @id

		--Select @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		--From ' + @tableidx + ' 
		--Where Id = @id

		commit tran search_update_q
		
		Select @efc, @st, @ln, ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_Start' ) )
	drop procedure dbo.A_Stat_Connection_Start
GO

Create Procedure dbo.A_Stat_Connection_Start
	
	@id			uniqueidentifier,
	@idchain		uniqueidentifier,
	@connectiontype		int,
	@reasonstart		int,
	@timestart		datetime,
	@timeanswer		datetime,
	@alineid		uniqueidentifier,
	@alinenum		nvarchar ( 8 ),
	@anumberdialed		nvarchar ( 50 ),
	@aoutnumber		nvarchar ( 50 ),
	@astr			nvarchar ( 50 ),
	@auserid		uniqueidentifier,
	@blineid		uniqueidentifier,
	@blinenum		nvarchar ( 8 ),
	@bnumberdialed		nvarchar ( 50 ),
	@boutnumber		nvarchar ( 50 ),
	@bstr			nvarchar ( 50 ),
	@buserid		uniqueidentifier,
	@isrecorded		int,
	@recorddir		nvarchar ( 1000 ),

	@optimizedblevel	int = 0,
	@fromccinput		int = -1
as

begin

	Declare @idprev uniqueidentifier

	--  ?
	Declare @betweenop bit
	Set @betweenop = 0
	if ( exists ( Select Id From A_Users Where Id = @auserid )
	 	and exists ( Select Id From A_Users Where Id = @buserid ) )
		Set @betweenop = 1
	else if ( exists ( Select Id From A_View_ServerIntLinesAll Where Id = @alineid ) 
		and exists ( Select Id From A_View_ServerIntLinesAll Where Id = @blineid ) )
		Set @betweenop = 1

	--  ? -    ,      -        (      )
	Declare @fromcc bit
	if ( @fromccinput >= 0 and @fromccinput <= 1 )
		Set @fromcc = @fromccinput
	else
	  begin
		Set @fromcc = 0
		if exists ( Select TimeStart From A_TaskManager_UserInTask With ( NOLOCK )
				Where ( UserId = @auserid or UserId = @buserid )
				And TimeStopDialog is null --     -     -   
				)	
			Set @fromcc = 1
 	  end

	--   
	Declare @idrecdir int
	set @idrecdir = 0

	if (( @isrecorded > 0 ) and ( @recorddir != '' ))
	begin
		Select @idrecdir = Max ( id ) 
		From A_Stat_RecordDirectories

		Declare @nowrecdir nvarchar ( 1000 )
		Select @nowrecdir = path 
		From A_Stat_RecordDirectories
		Where Id = @idrecdir

		if (( @nowrecdir != @recorddir ) or ( @nowrecdir is null ))
		begin
			Insert into A_Stat_RecordDirectories
			Values ( @recorddir, @timestart )
			
			set @idrecdir = @@identity
		end
	end


	if ( @optimizedblevel = 0 )
	begin
		--   
		Select top 1 @idprev = Id
		From A_Stat_Connections_1x1 With ( NOLOCK )
		Where IdChain = @idchain 
		Order by TimeStart desc

		--    
		if ( @@rowcount > 0 )	
			Update A_Stat_Connections_1x1
			Set IdNext = @Id
			Where Id = @idprev
	end

	
	-- 
	Insert into A_Stat_Connections_1x1
	(
		Id,
		IdChain,
		IdPrev,
		ConnectionType,
		ReasonStart,	
		TimeStart,		
		TimeAnswer,		
		ALineId,	
		ALineNum,
		ANumberDialed,
		AOutNumber,	
		AStr,	
		AUserId,
		BLineId,	
		BLineNum,		
		BNumberDialed,
		BOutNumber,	
		BStr,	
		BUserId,
		IsRecorded,
		IdRecDir,		
		IsBetweenUsers,
		FromCC
	)

	Values

	(
		@id,
		@idchain,
		@idprev,
		@connectiontype,
		@reasonstart,
		@timestart,
		@timeanswer,
		@alineid,
		@alinenum,
		@anumberdialed,
		@aoutnumber,
		@astr,
		@auserid,
		@blineid,
		@blinenum,
		@bnumberdialed,
		@boutnumber,
		@bstr,
		@buserid,
		@isrecorded,
		@idrecdir,		
		@betweenop,
		@fromcc --0
	)
	
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterCallResult' ) )
	drop procedure dbo.A_CallCenter_Temp_UpdateAfterCallResult
GO

Create procedure [dbo].[A_CallCenter_Temp_UpdateAfterCallResult]
	@idchain uniqueidentifier,
	@ideffort uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@callresult int,
	@callresultinfo nvarchar ( 100 ),
	@lenqueue float,
	@timestart datetime,
	@idextline uniqueidentifier,
	@userresult int = 0,
	@dtnow datetime = null
	
as 
begin	

/*	----------------------------------------
	Declare @idchain uniqueidentifier
	Declare @ideffort uniqueidentifier
	Declare @idinlist int
	Declare @idtask uniqueidentifier
	Declare @number nvarchar ( 20 )
	Declare @callresult int
	Declare @callresultinfo nvarchar ( 100 )
	Declare @lenqueue int
	Declare @timestart datetime
	Declare @idextline uniqueidentifier
	Select @idchain = 'FD024817-A629-49E6-B550-19EC14787AC8', @ideffort = '1C3468C3-A6FE-4B36-9393-B813CFFB2815', 
		@idinlist = 63, @idtask = 'D48D5F57-6B93-4529-A205-A6B5063320A4', 
		@number = '  ', @callresult = 5, @callresultinfo = '', @lenqueue = 15, @timestart = '26.02.2007 12:04:57',
		@idextline = '00000000-0000-0000-0000-000000000000'
	-----------------------------------------
*/
	if ( @dtnow is null )
		set @dtnow = GetDate()

	--    
	Declare @idproject uniqueidentifier
	Declare @isoutput bit
	Declare @idlist uniqueidentifier

	Select 	@idproject = IdProject,
		@isoutput = IsOutputTask,
		@idlist = ListId
	From A_TaskManager_Tasks 
	Where Id = @idtask

	-------------------------------------------------------------
	----     -------------------------------
	-------------------------------------------------------------

	--  
	Declare @temp table 
	( 
		IdProject	uniqueidentifier,	--1
		IdTask 		uniqueidentifier,	--1
		IsOutput	bit,			--1
		IdEffort	uniqueidentifier,	--1
		IdOperator 	uniqueidentifier,	--3
		IdInList	int,			--1
		AbonentNumber 	nvarchar ( 20 ),	--1
		CallResult	int,			--1
		CallResultInfo	nvarchar ( 100 ),	--1
		DateTimeStart 	DateTime, 		--
		DateStart 	DateTime, 		--
		TimeStart 	DateTime,		--
		DateTimeStop	DateTime,
		IdConn		uniqueidentifier,	--
		IdChain 	uniqueidentifier,	--
		IdAUser		uniqueidentifier,	--
		IdBUser		uniqueidentifier,	--
		IdExtLine 	uniqueidentifier,	--2
		LenTime 	float, 			--
		LenQueue 	float,			--1
		IsBetweenOp	bit,			--3
		OpponentInfo 	nvarchar ( 100 ),	--6
		IsHandled 	bit,			--4
		IsSuccess	bit,			--5
		IsRecorded	bit,			--
		IdRecDir	int,			--
		ALineNum	nvarchar ( 5 ),		--
		BLineNum	nvarchar ( 5 ),		--
		--ARecFile	nvarchar ( 100 ),	--
		--BRecFile 	nvarchar ( 100 )	--
		UserResult	int default 0		--7
	)

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'


	--     (0, 1)
	Insert Into @temp ( IdProject, IdTask, IsOutput, IdEffort, IdInList, AbonentNumber, CallResult, 
				CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop, 
				IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, 
				IsRecorded, IdRecDir, ALineNum, BLineNum, UserResult ) --ARecFile, BRecFile )
	Select @idproject, @idtask, @isoutput, @ideffort, @idinlist, @number, @callresult, @callresultinfo, 
		TimeStart, 
		Cast ( Floor ( Cast ( TimeStart as Float ) ) as DateTime ),
		Cast ( Cast ( TimeStart as Float ) - FLOOR ( Cast ( IsNull ( TimeStop, @dtnow ) as Float ) ) as DateTime ),
		IsNull ( TimeStop, @dtnow ),		
		Id, IdChain, AUserId, BUserId, 
		@idextline,
		Cast ( ( IsNull ( TimeStop, @dtnow ) - TimeAnswer ) as float ) * 86400 as LenTime, @lenqueue,
		IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile
		@userresult
	FROM A_Stat_Connections_1x1 With ( NOLOCK )
	Where IdChain = @idchain

	--      ?
	If ( @@rowcount = 0 )
	   begin

		Insert Into @temp 
		( 	IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 

			--IsBetweenOp, 
			IsHandled, IsSuccess,
			--IsRecorded, IdRecDir, ARecFile, BRecFile,
			UserResult
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @dtnow,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @dtnow - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0,
			--0, 0, '', '',
			@userresult
		)
	   end
	else
	   begin
		--        
		Delete from @temp
		Where DateTimeStart < @timestart

		Declare @timeendeff datetime
		Select @timeendeff = min ( DateTimeStart ) From @temp

		Insert Into @temp 
		( 	IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 
			--IsBetweenOp, 
			IsHandled, IsSuccess,
			--IsRecorded, IdRecDir, ARecFile, BRecFile 
			UserResult
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @timeendeff,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @timeendeff - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0,
			--0, 0, '', '',
			@userresult
		)	

		--       (3)---------
		Declare @users table ( Id uniqueidentifier primary key )
		Insert into @users
			Select Id From A_Users

		Insert into @users Values ( 'AB000000-0000-0000-0000-000000000000' )

		Update t
		Set 	IdOperator = case when ( @isoutput > 0 ) then IdAUser else IdBUser end, 
			IsBetweenOp = 0
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id or t.IDBUser = u2.Id

		Update t
		Set 	IdOperator = IdAUser, 
			IsBetweenOp = 1
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id and t.IdBUser = u2.Id
		

		--  ? (4)--------------------------------
		Declare @cnt int
		Select @cnt = Count ( * ) FROM @temp t 
		Where DateTimeStart > @timestart
		
		Update t
		Set IsHandled = case when ( @cnt > 1 ) then 1 else 0 end --   
		From @temp t

		--  ? (5)---------------------------------------
		Update t
		Set IsSuccess = case When ( @callresult = 5 ) then 1 else 0 end
		From @temp t
	   end

	--    (6)----------------
	Declare @opinfo nvarchar ( 255 )
	Select @opinfo = ''
	Update t
	Set OpponentInfo = @opinfo
	From @temp t

	--  ,     ,    (      )
	if exists ( Select * from tempdb..sysobjects Where id = object_id ( 'tempdb..#textract' ) )
		drop table #textract
	Select * into #textract 
	From @temp 
	Order by datetimestart

	if ( @isoutput = 0 ) --          
	begin
		Declare @dt1 datetime, @dt2 datetime
		-- 
		Select @dt1 = Max ( DateTimeStart ) From #textract Where DateTimeStart <= @timestart and (( IdOperator is null ) or ( IdOperator = 'AB000000-0000-0000-0000-000000000000' ))
		-- 
		Select @dt2 = Min ( DateTimeStart ) From #textract Where DateTimeStart > @timestart and (( IdOperator is null ) or ( IdOperator = 'AB000000-0000-0000-0000-000000000000' ))

		Delete from #textract Where DateTimeStart < @dt1 or DateTimeStart >= @dt2 or LenTime is NULL
	end

	--   ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] --With ( TabLock )
	Select * FROM #textract

	--     
	
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name From A_TaskManager_Tasks Where Id = @idtask	

	--     
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject

	-------------------------------------------------------------
	----    -------------------------------
	-------------------------------------------------------------
	--     DBProvider


end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_User_StopHandlingEffort' ) )
	drop procedure dbo.A_TaskManager_User_StopHandlingEffort
GO

Create  procedure [dbo].[A_TaskManager_User_StopHandlingEffort]
	@effortid		uniqueidentifier,
	@stop			datetime

as
begin
	Update A_TaskManager_UserInTask --with ( TabLock ) 
	Set	TimeStopPost = IsNull ( TimeStopPost, @stop ),
		TimeStopDialog = IsNull ( TimeStopDialog, @stop ),
		TimeStopBackCall = IsNull ( TimeStopBackCall, @stop ),
		TimeStopWaitCall = IsNull ( TimeStopWaitCall, @stop ),
		TimeStopPrior = IsNull ( TimeStopPrior, @stop )
	Where EffortId = @effortid	
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_User_StartHandling' ) )
	drop procedure dbo.A_TaskManager_User_StartHandling
GO

Create procedure [dbo].[A_TaskManager_User_StartHandling ]
	@id			uniqueidentifier,
	@userid			uniqueidentifier,
	@taskid			uniqueidentifier,
	@effortid		uniqueidentifier,
	@start			datetime

as
begin
	Insert Into A_TaskManager_UserInTask --with ( TabLock )
			( Id, UserId, TaskId, EffortId, TimeStart )
		values
			( @id, @userid, @taskid, @effortid, @start )
	
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_User_UpdateHandling' ) )
	drop procedure dbo.A_TaskManager_User_UpdateHandling
GO

Create procedure [dbo].[A_TaskManager_User_UpdateHandling ]
	@id			uniqueidentifier,
	@stopprior		datetime = NULL,
	@stopwaitcall		datetime = NULL,
	@stopbackcall		datetime = NULL,
	@stopdialog		datetime = NULL,
	@stoppost		datetime = NULL

as
begin

	Update A_TaskManager_UserInTask --With ( TabLock )
	Set 	
		TimeStopPrior = IsNull ( TimeStopPrior, @stopprior ),
		TimeStopWaitCall = IsNull ( TimeStopWaitCall, @stopwaitcall ),
		TimeStopBackCall = IsNull ( TimeStopBackCall, @stopbackcall ),
		TimeStopDialog = IsNull ( TimeStopDialog, @stopdialog ),
		TimeStopPost = IsNull ( TimeStopPost, @stoppost )
	Where Id = @id
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_DB_UserLogoff' ) )
	drop procedure dbo.A_DB_UserLogoff
GO

Create PROCEDURE [dbo].[A_DB_UserLogoff] 
	@iduser uniqueidentifier
AS
begin

		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'


		-----------------------------------------------------
		-- Monopoly     
		-----------------------------------------------------		
		delete from C_MonopolyForTaskChanging where IdUser = @iduser

		-----------------------------------------------------
		--     -
		-----------------------------------------------------
		exec A_CallCenter_UserStateChange @start = 0, @idoperator = @iduser, @state = 0, @info = '', @selfinfo = 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------
		Update A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( UserId = @iduser ) and
			(( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null ))
		/*
		-----------------------------------------------------
		--     -     
		-----------------------------------------------------		
		Declare @dtnow DateTime 
		Set @dtnow = GetDate ( )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set 	p0 = 0, p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 0,
				LastDT = @dtnow
			Where Id = @iduser
		*/
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_Operator_Get_TaskWork' ) )
	drop procedure dbo.A_TaskManager_Operator_Get_TaskWork
GO

Create Procedure [dbo].[A_TaskManager_Operator_Get_TaskWork]
	@idoperator		uniqueidentifier,
	@extraid		uniqueidentifier,
	@time			float OUTPUT,
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Set @time = 0

	Select Sum ( Convert ( float, TimeStopPost - TimeStart ) )
	From A_TaskManager_UserInTask with ( NOLOCK )
	Where UserId = @idoperator
		and TaskId = @extraid
		and Convert ( float, @dtnow - TimeStopPost ) < 1 
		and DatePart ( dd, @dtnow ) = DatePart ( dd, TimeStopPost )
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_DB_InitOnStart' ) )
	drop procedure dbo.A_DB_InitOnStart
GO

Create procedure [dbo].[A_DB_InitOnStart]
As
begin

		-----------------------------------------------------
		--    -----------
		-----------------------------------------------------
		
		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		Declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------

		Update A_TaskManager_UserInTask with ( TabLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null )

		-----------------------------------------------------
		--        ,   
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set 	TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		--  
		-----------------------------------------------------

		Delete From A_Monopoly
		Delete From C_MonopolyForTaskChanging

		-----------------------------------------------------
		--   ,  -    
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		--    
		-----------------------------------------------------

		Declare tcursor CURSOR FOR 
			Select name, Id  FROM sysobjects 
			Where type = 'U' and name like 'A_TaskManager_LocalList%'
		Declare @llid int
		Declare @llname nvarchar ( 1000 )
		Declare @ltid uniqueidentifier
		Declare @ltids nvarchar ( 50 )
		Declare @sql nvarchar ( 500 )

		OPEN tcursor
		FETCH NEXT FROM tcursor INTO @llname, @llid

		WHILE @@FETCH_STATUS = 0
		BEGIN
			set @llname = 'dbo.[' + @llname + ']'

			--   (id    Id  ) (      -       . N-1  )	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			--      JoinedTable  
			if not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname )
			begin
				set @sql = ' DROP TABLE ' + @llname
				--print @sql
				exec sp_executesql @stmt =@sql
			end

		FETCH NEXT FROM tcursor INTO @llname, @llid
		END

		CLOSE tcursor
		DEALLOCATE tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		--   ??
		--         ?
		--     ?
		--   ..   ,     ..
		Exec A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ) )
	drop procedure dbo.A_DB_RemoveTails
GO

Create procedure [dbo].[A_DB_RemoveTails] as
begin

		-----------------------------------------------------
		--    ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (LineId in (Select [ID] From A_ServerIntLines union all Select ID From A_ServerUSBLines))
		Delete FROM A_ServerExtLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerIntLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerGSMLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerUSBLines where not [ServerID] in (Select [id] from A_WORKPLACES)
	
		Delete FROM A_ServerUSBLines where not [id] in (Select LineID from A_WORKPLACES)
		Delete FROM A_LinesReactors where not [WPID] in (Select [id] from A_WORKPLACES)
		Delete From A_LinesReactors where not LineID in (Select [ID] from A_ServerExtLines 
								union Select [ID] from A_ServerIntLines
								union Select [ID] from A_ServerGSMLines
								union Select [ID] from A_ServerUSBLines)
		delete from A_ServerNumbers where not [id] in (Select [ID] FROM A_WorkPlaces Where type=5)
		delete from A_ServerNumbers where [id] in (Select [ID] from A_WorkPlaces where hasdatabase>0)



		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] from A_WORKPLACES union 
			Select [id] from A_Users union
			Select [id] from A_ServerExtLines union
			Select [id] from A_ExtNumbers union
			Select [id] from A_ServerIntLines union
			Select [id] from A_ServerUSBLines 

		
		Delete From A_RuleRecords where not RuleID in (Select ID from A_Rules)

		Delete from A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ from @t ))

		Delete from A_NumberPlanAction where numtype=0 and extraid not in (Select ID from A_Rules)
		delete from A_NumberPlan where id not in (Select numid from A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID from A_NumberPlan)
		Delete From A_Rules	Where not id in ( select ruleid from A_RuleRecords )		

		delete from A_TaskManager_TaskExtLines where not ExtLineId in ( Select id from A_ServerExtLines )
		delete from A_TaskManager_Operators where not OperatorId in ( Select id from A_Users union Select Id from C_Groups )

		-----------------------------------------------------
		--     =   -   
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null  0  ID    ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		--  0     -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id from A_Users)

		-----------------------------------------------------
		--         --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		Declare defusercur Cursor For
			Select Id, DefaultUserId
			From A_ServerIntLines
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'
		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 from @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		--    ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id from C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id from @uidt)
			or not UserB in (Select id from @uidt)

		-----------------------------------------------------
		--     --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		--   ------------------------------------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------
		Delete From A_UserRoles 
		Where creationtype != 0 
			and not exists ( Select IdRole FROM A_UserParams up Where up.IdRole = A_UserRoles.Id )
		Delete From A_UserRolesExt 
		Where not exists ( Select Id From A_UserRoles a where a.Id = IdRole )

end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateOperatorStates' ) )
	drop procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
GO

Create Procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
	@dtnow datetime = null
as
begin

set dateformat dmy

if ( @dtnow is null )
	set @dtnow = GetDate()

if not exists ( Select * FROM master..sysdatabases where name like 'oktell_cc_temp' )
	return

--Declare @fulllogdt DateTime
--Declare @logdt DateTime
--Declare @operlogdt DateTime
Declare @sqltext nvarchar ( 4000 )

Declare @idempty uniqueidentifier
Set @idempty = '00000000-0000-0000-0000-000000000000'

--print '   ## start creating temp tables ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print 's 00  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '--------------------------------------start-- ms:  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )
--Set @fulllogdt = GetDate ( )

--      
Declare @dtsall DateTime
Select @dtsall = Min ( LastDT ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
if ( @dtsall is null )
	Set @dtsall = DateAdd ( d, -10, @dtnow )

--set @dtsall = '6.10.2007 14:20'
--print @dtsall
--print 's 01  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

Declare @sc table ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

/*
Insert Into @sc
	Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId
	From A_Stat_Connections_1x1 sc With ( TabLock )
	Where TimeStart > @dtsall Or TimeStop > @dtsall Or TimeStop is null

print 's 02_1  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
*/

	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos01' ) )
		Drop Table #tmpos01
	Create table #tmpos01 ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

	set @sqltext = 'Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId 
		From A_Stat_Connections_1x1 sc With ( NOLOCK )
		Where TimeStart > @dtt1 Or TimeStop > @dtt1 Or TimeStop is null'
	Insert Into #tmpos01
		exec sp_executesql @sqltext, N'@dtt1 datetime', @dtsall
	Insert into @sc
		Select * FROM #tmpos01

	drop table #tmpos01


--print 's 02_2  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

Declare @ush table ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default)

/*
Insert into @ush
	Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '' end
	From A_CallCenter_UserStateHistory with ( TabLock )
	Where ( TimeEnter > @dtsall Or TimeLeave > @dtsall Or TimeLeave is null )

*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos02' ) )
		Drop Table #tmpos02
	Create table #tmpos02 ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default )

	set @sqltext = 'Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '''' end
		From A_CallCenter_UserStateHistory With ( NOLOCK )
		Where ( TimeEnter > @dtt1 Or TimeLeave > @dtt1 Or TimeLeave is null )'

	Insert Into #tmpos02
		exec sp_executesql @sqltext, N'@dtt1 datetime', @dtsall
	Insert into @ush
		Select * FROM #tmpos02	

	drop table #tmpos02


Declare @uit table ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )
/*
Insert into @uit
	Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask
	Where TimeStart >= @dtsall or TimeStopPost >= @dtsall or TimeStopPost is null
*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos03' ) )
		Drop Table #tmpos03
	Create table #tmpos03 ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )

	set @sqltext = 'Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask With ( NOLOCK )
	Where TimeStart >= @dtt1 or TimeStopPost >= @dtt1 or TimeStopPost is null'

	Insert Into #tmpos03
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	Insert into @uit
		Select * FROM #tmpos03	

	drop table #tmpos03


Declare @umaxdts table ( UserId uniqueidentifier, MaxDTS DateTime  )

Insert into @umaxdts
	Select IdOperator, Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] With ( NOLOCK )
	Group By IdOperator

--print '   ## created all tables. Starting cursor cycle ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '-----shared-sc- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )


--   
Declare @settable table ( Id uniqueidentifier, Name nvarchar ( 100 ) collate database_default)
Insert into @settable
	Select Id, Name From A_Users u 
		Inner join A_UserParams up on u.Id = up.IdUser
	Where IsOperator = 1


Declare ucursor Cursor LOCAL FAST_FORWARD For 
	Select Id, Name From @settable

Declare @idoperator uniqueidentifier, @nameoperator nvarchar ( 100 )	

--Set @operlogdt = @dtnow

Open ucursor
Fetch Next From ucursor Into @idoperator, @nameoperator

While ( @@fetch_status = 0 )
   begin

	Declare @id uniqueidentifier
	Select @id = Id from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Where Id = @idoperator
	if ( @@rowcount = 0 )
		Insert 
		Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
		( Id, Name ) Values ( @idoperator, @nameoperator )
				
				
	--     
	Declare @dts DateTime, @dts1 DateTime

	/*
	Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	Where IdOperator = @idoperator	
	*/
	Select @dts = MaxDTS
	From @umaxdts
	Where UserId = @idoperator
	
	Select @dts1 = LastDT
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	Where Id = @idoperator
	
	if ( @dts1 > @dts ) or ( @dts is null )
		Set @dts = @dts1
	
	if ( @dts is null )
		set @dts = '01.01.2000'

	--print '-----def------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @operlogdt = GetDate ( )


	--          
	if ( Cast ( @dtnow - @dts as float ) * 1440 > 1 )
	   begin		

		/*
		PriorHandle		= 1,
		WaitingCall		= 2,
		BackRing		= 3,
		TalkAbonent		= 4,
		TalkInside		= 5,
		InsideTalk		= 6,
		PostHandle		= 7,
		TalkOther		= 8,
		CCLunch			= 9,
		CCReady			= 10,
		System			= 11
		*/

		-----------------------------------------------------
		--   (   ) ----------
		-----------------------------------------------------
		Declare @tempo2 table
		(
			State int,
			Priority int,
			DateTimeStart DateTime,
			DateTimeStop DateTime,
			Id int Identity ( 1, 1 ) not null primary key,
			Info nvarchar ( 100 )
		)

		Delete From @tempo2

		Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
			Select State, Case when State in ( 3, 4 ) then 2 else 4 end, 
				TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
			From @ush
			Where OperatorId = @idoperator
				And State in ( 2, 3, 4 )
				And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )
		
		Update @tempo2
		Set State = Case When Priority = 2 then 9 else 10 end

		
		--      - 
		if ( @@rowcount > 0 )
		begin	
			--      
			Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info )
				Select 11, 5, TimeEnter, IsNull ( TimeLeave, @dtnow ), Info
				From @ush
				Where OperatorId = @idoperator
					And State = 0
					And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )

			Update @tempo2			
			Set 	DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				DateTimeStop = Case When DateTimeStop > @dtnow then @dtnow else DateTimeStop end
			

			--print '-----t2--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

	
			-----------------------------------------------------
			--   (   ) -----
			-----------------------------------------------------
			Declare @tempo1 table
			(
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				StateCat	int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				IdEffort	uniqueidentifier,
				Priority	int,
				Id		int identity ( 1, 1 ) not null primary key
			)

			Delete From @tempo1
			
			Declare @uito table 
			(
				Id uniqueidentifier,
				UserId uniqueidentifier,
				TaskId uniqueidentifier,	
				EffortId uniqueidentifier,
				TimeStart DateTime,
				TimeStopPrior DateTime,
				TimeStopWaitCall DateTime,
				TimeStopBackCall DateTime,
				TimeStopDialog DateTime,
				TimeStopPost DateTime
			)

			Delete From @uito

			Insert Into @uito
			Select *
			From @uit
			Where UserId = @idoperator
				--And ( TimeStart > @dts or TimeStopPost > @dts or TimeStopPost is null )

			--print '-----t1-crtemp-- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 1, 0, 
					TimeStart, 
					TimeStopPrior
				From @uito--#t
				Where Cast ( TimeStopPrior - TimeStart as float ) * 86400 > 0
			
			--print '-----t1-cra----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
			
			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,

						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 2, 0, 
					TimeStopPrior, 
					TimeStopWaitCall
				From @uito--#t
				Where Cast ( TimeStopWaitCall - TimeStopPrior as float ) * 86400 > 0

			--print '-----t1-crb----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 3, 0, 
					TimeStopWaitCall, 
					TimeStopBackCall
				From @uito--#t
				Where Cast ( TimeStopBackCall - TimeStopWaitCall as float ) * 86400 > 0

			--print '-----t1-crc----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 6, 0, 
					TimeStopBackCall, 
					TimeStopDialog
				From @uito--#t
				Where Cast ( TimeStopDialog - TimeStopBackCall as float ) * 86400 > 0

			--print '-----t1-crd----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 7, 0, 
					TimeStopDialog,
					TimeStopPost
				From @uito--#t
				Where Cast ( IsNull ( TimeStopPost, @dtnow ) - IsNull ( TimeStopDialog, @dtnow ) as float ) * 86400 > 0

			--print '-----t1-cre----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			--       
			Update @tempo1 
			Set 	DateTimeStart = case 	When ( DateTimeStart < @dts ) then @dts 
							else DateTimeStart end,
		 		DateTimeStop = case 	When ( DateTimeStop > @dtnow ) then @dtnow 
							When ( DateTimeStop < @dts ) then @dts 
							else DateTimeStop end

			Delete From @tempo1
			Where DateTimeStart = DateTimeStop


			--   / 
			Update tmpo
			Set IsOutput = t.IsOutputTask
			From @tempo1 tmpo, A_TaskManager_Tasks t
			Where tmpo.IdTask = t.Id

			--    
			Update tmpo
			Set CallResult = tic.CallResult
			From @tempo1 tmpo, A_TaskManager_Task_IncomingCalls tic
			Where tmpo.IdEffort = tic.Id

			Update tmpo
			Set CallResult = ste.EResult
			From @tempo1 tmpo, A_TaskManager_SubTaskEfforts ste
			Where tmpo.IdEffort = ste.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo1

			--Select * FROM A_Taskmanager_UserInTask


			--print '-----t1-up------ ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
	
			-----------------------------------------------------
			--   () -----------------------
			-----------------------------------------------------
			
			Declare @tempo3 table
			(
				State int,
				Priority int,
				DateTimeStart DateTime,
				DateTimeStop DateTime,
				Id int identity ( 1, 1 ) not null primary key
			)
			
			Delete From @tempo3
						
			Insert into @tempo3
				Select 8, 0, TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
					And FromCC = 0
				/*
				Select Case When FromCC = 0 then 8 When IsBetweenUsers = 1 then 5 else 4 end, 0,
					TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
				*/

			Update @tempo3
			Set DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				Priority = Case When State = 8 then 3 else 0 end
			
			
			--print '-----t3--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-----------------------------------------------------
			--     ---------------------
			-----------------------------------------------------

	--		Select * FROM @tempo1
	--		Select * FROM @tempo2
	--		Select * From @tempo3

	--		Select * FROM @tempo1 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * FROM @tempo2 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * From @tempo3 Where DateTimeStart > '13.02.2007' Order by DateTimeStart

		
			Declare @tempo table
			(
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete from @tempo

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStart, 0
				From @tempo1

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStop, 1
				From @tempo1

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStart, 0
				From @tempo2

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStop, 1
				From @tempo2

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStart, 0
				From @tempo3

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStop, 1
				From @tempo3
			
			--Select * From @tempo Order By DT

			--print '-----tpt-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		
			-----------------------------------------------------
			--   -------------------------------
			-----------------------------------------------------

			Declare @res table ( TableN int, Id int, State int, Priority int, DStart DateTime, DStop DateTime )
			Delete From @res

			--        
			-- : 	0 -    (  )
			--		1 -     (  )
			--		2 - 
			--		3 -  
			--		4 -   
			--		5 -   
			Declare @p0 int, @p1 int, @p2 int, @p3 int, @p4 int, @p5 int
			Declare @s0 int, @s1 int, @s2 int, @s3 int, @s4 int, @s5 int
			Declare @t0 int, @t1 int, @t2 int, @t3 int, @t4 int, @t5 int
			Declare @i0 int, @i1 int, @i2 int, @i3 int, @i4 int, @i5 int

			Select @p0 = 0, @p1 = 0, @p2 = 0, @p3 = 0, @p4 = 0	
			Select 	@p0 = IsNull ( P0, 0 ), @p1 = IsNull ( P1, 0 ), @p2 = IsNull ( P2, 0 ), @p3 = IsNull ( P3, 0 ), @p4 = IsNull ( P4, 0 ), @p5 = IsNull ( P5, 0 ),
				@s0 = IsNull ( S0, 0 ), @s1 = IsNull ( S1, 0 ), @s2 = IsNull ( S2, 0 ), @s3 = IsNull ( S3, 0 ), @s4 = IsNull ( S4, 0 ), @s5 = IsNull ( S5, 0 )
			From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
			Where Id = @idoperator
		
			--   	
			Declare @tempo_ordered table
			(
				Id int identity ( 1, 1 ) not null,
				TableN int,
				TableID int,
				State int,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete From @tempo_ordered

			Insert into @tempo_ordered ( TableN, TableID, State, Priority, DT, NK )
				Select TableN, TableID, State, Priority, DT, NK From @tempo
				Order By DT

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * From @tempo_ordered


			Declare @tempo_joined table
			(
				s1 int, p1 int, s2 int, p2 int, dstart datetime, dstop datetime, nk1 bit, nk2 bit, t1 int, t2 int, i1 int, i2 int
			)
			Delete From @tempo_joined
		
			Insert into @tempo_joined 
				Select t1.State as s1, t1.Priority as p1, t2.State as s2, t2.Priority as p2,
					t1.DT as dstart, t2.DT as dstop, t1.NK as nk1, t2.NK as nk2,
					t1.TableN, t2.TableN, t1.TableID, t2.TableID
				From @tempo_ordered t1
					Inner join @tempo_ordered t2 on t1.Id + 1 = t2.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo_joined

			--print '-----tjnd------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			--       
			Declare tcursor Cursor LOCAL FAST_FORWARD For 
				Select s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
				From @tempo_joined
				--Where dstart > '21.02.2007'

			Declare @st1 int, @pr1 int, @st2 int, @pr2 int, @dstart DateTime, @dstop DateTime, @nk1 bit, @nk2 bit, @tb1 int, @tb2 int, @id1 int, @id2 int
			Declare @actualst int, @actualpr int, @actualt int, @actualid int
			Declare @lastst int, @lastpr int, @lastt int, @lastid int, @lastdstart datetime, @lastdstop datetime
			Declare @dontinsert bit, @updatelast bit
			Declare @insertindex int

			set @insertindex = 0
			set @lastt = 0
			set @dontinsert = 1 --     (   )   
		
			Open tcursor
			Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2

			While @@FETCH_STATUS = 0
   			Begin
				----print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
				--	Cast ( @lastst as nvarchar ( 10 ) ) + '  ' + Cast ( @lastpr as nvarchar ( 10 ) )    + '  //  ' + 
				--	Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) )
			
				---    -----		
				if ( @nk1 = 0 )
				begin			
					if ( @pr1 = 0 )
					begin
			    			set @p0 = @p0 + 1
				    		set @s0 = @st1				
						set @t0 = @tb1	
						set @i0 = @id1
					end
					else if ( @pr1 = 1 )
					begin
				    		set @p1 = @p1 + 1
				    		set @s1 = @st1
						set @t1 = @tb1
						set @i1 = @id1
					end
					else if ( @pr1 = 2 )
					begin
			    			set @p2 = @p2 + 1
				    		set @s2 = @st1
						set @t2 = @tb1
						set @i2 = @id1
					end
					else if ( @pr1 = 3 )
					begin
				    		set @p3 = @p3 + 1
				    		set @s3 = @st1
						set @t3 = @tb1
						set @i3 = @id1
					end
					else if ( @pr1 = 4 )
					begin
			    			set @p4 = @p4 + 1
				    		set @s4 = @st1
						set @t4 = @tb1
						set @i4 = @id1
					end
					else if ( @pr1 = 5 )
					begin
						set @p5 = @p5 + 1
						set @s5 = @st1
						set @t5 = @tb1
						set @i5 = @id1
					end
				end

				---    
				set @dontinsert = 0
				if ( @p0 > 0 )
				begin
					set @actualst = @s0
					set @actualpr = 0
					set @actualt = @t0
					set @actualid = @i0
				end
				else if ( @p1 > 0 )
				begin
					set @actualst = @s1
					set @actualpr = 1
					set @actualt = @t1
					set @actualid = @i1

				end
				else if ( @p2 > 0 )
				begin
					set @actualst = @s2
					set @actualpr = 2
					set @actualt = @t2
					set @actualid = @i2
				end
				else if ( @p3 > 0 )
				begin
					set @actualst = @s3
					set @actualpr = 3
					set @actualt = @t3
					set @actualid = @i3
				end
				else if ( @p4 > 0 )
				begin
					set @actualst = @s4
					set @actualpr = 4
					set @actualt = @t4
					set @actualid = @i4
				end
		
				--     4  2  (  )
				--        
				if (( @p4 = 0 ) and ( @p2 = 0 )) or ( @p5 = 0 )
 				set @dontinsert = 1
			
				--print Convert ( nvarchar ( 10 ), @dstart, 108 ) + ' ' + convert ( nvarchar ( 10 ), @dstop, 108 ) + ' state1=' + cast ( @st1 as nvarchar ( 10 ) ) + ' state2=' + cast ( @st2 as nvarchar ( 10 ) ) + ' nk1=' + cast ( @nk1 as nvarchar ( 10 ) ) + ' nk2=' + cast ( @nk2 as nvarchar ( 10 ) )

				--     			
				set @updatelast = 0
				--     ,    -  
				if ( @lastt = 0 )
				begin
					--print 'lastt = 0'
					set @updatelast = 1			
				end
				--          -   
				else if ( @dontinsert = 0 ) and ( @actualst = @lastst )
				begin
					--print 'lastst = actualst' + Cast ( @actualst as nvarchar ( 10 ))
					set @lastdstop = @dstop
				end		
				--       
				else
				begin
					--print 'insert time=' + Convert ( nvarchar ( 10 ), @lastdstart, 108 ) + '-' + convert ( nvarchar ( 10 ), @lastdstop, 108 ) + ' state=' + cast ( @lastst as nvarchar ( 10 ) )
					if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
						Insert Into @res
						Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )
				
					set @updatelast = 1	
				end
			
				if ( @updatelast = 1 )
				begin
					if ( @dontinsert = 1 )
			  			set @lastt = 0
					else
 					begin
						set @lastt = @actualt
						set @lastid = @actualid
						set @lastst = @actualst
						set @lastpr = @actualpr
						set @lastdstart = @dstart
						set @lastdstop = @dstop
					end
				end
			
		
				---    () -----
				if ( @nk2 = 1 )
				begin
					if ( @pr2 = 0 )
						set @p0 = @p0 - 1
					else if ( @pr2 = 1 )
						set @p1 = @p1 - 1
					else if ( @pr2 = 2 )
						set @p2 = @p2 - 1
					else if ( @pr2 = 3 )
						set @p3 = @p3 - 1
					else if ( @pr2 = 4 )
						set @p4 = @p4 - 1
					else if ( @pr2 = 5 )
						set @p5 = @p5 - 1
				end
			
				Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2
			End


			--      ,    
			if ( @dontinsert = 0 )
				if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
					Insert Into @res
					Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )

			Close tcursor
			Deallocate tcursor

			--print '-----curs------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-------------------------------------------------------------------------------------------------
			--          -------------------------------
			-------------------------------------------------------------------------------------------------

			--       (         )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
				Set 	p0 = @p0, p1 = @p1, p2 = @p2, p3 = @p3, p4 = @p4, p5 = @p5,
					s0 = @s0, s1 = @s1, s2 = @s2, s3 = @s3, s4 = @s4, s5 = @s5,
					LastDT = @dtnow
			Where Id = @idoperator

			Declare @operatorstates table
			(
				Id		int identity ( 1, 1 ) not null primary key,
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float
			)

			Delete From @operatorstates

			Insert into @operatorstates ( IdOperator, State, DateTimeStart, DateTimeStop, DateStart, TimeStart, LenTime, 
				IdTask, IsOutput, CallResult )
			Select @idoperator, r.State, r.DStart, r.DStop,
				Cast ( Floor ( Cast ( DStart as Float ) ) as DateTime ),
				Cast ( Cast ( DStart as float ) - Floor ( Cast ( DStart as Float ) ) as DateTime ),				
				Cast ( DStop - DStart as float ) * 86400,
				IdTask, IsOutput, CallResult
			From @res r
				Left join @tempo1 t1 on t1.Id = r.Id and r.TableN = 1


			--     (     -        )
			Declare @crupdate int
			Select top 1 @crupdate = CallResult 
			From @operatorstates
			Where not IdTask is null	
			
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
			Set CallResult = @crupdate
			Where IdOperator = @idoperator and not IdTask is null and CallResult is null


			--    
			Declare @idt1 int, @state1 int, @dtstart1 DateTime, @dtstop1 DateTime
			
			Select @idt1 = Max ( Id ) 
			From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
			Where IdOperator = @idoperator

			if ( not @idt1 is null )
			   begin
				Select @state1 = State, @dtstart1 = DateTimeStart, @dtstop1 = DateTimeStop 
				From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
				Where Id = @idt1
				
				Declare @idt2 int, @state2 int, @dtstart2 DateTime, @dtstop2 DateTime
				Select Top 1 @idt2 = Id, @state2 = State, @dtstart2 = DateTimeStart, @dtstop2 = DateTimeStop
				From @operatorstates
				Order By DateTimeStart

				if ( @state1 = @state2 ) and ( @dtstart2 = @dtstop1 )
				   begin
					Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
					Set 	DateTimeStop = @dtstop2,
						LenTime = Cast ( @dtstop2 - @dtstart1 as float ) * 86400
					Where Id = @idt1

					Delete From @operatorstates
					Where Id = @idt2
			   	   end
			   end

		
			--  
			Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
				( IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime )			
				Select IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime
				From @operatorstates
			
			--print '-----ins-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

		end
		else
		begin
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set LastDT = @dtnow
			Where Id = @idoperator
		end



	   end
	
	--print '--------------------------------------oper--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @logdt = GetDate ( )
	--Set @operlogdt = GetDate ( )

	Fetch Next From ucursor Into @idoperator, @nameoperator
   end

Close ucursor
Deallocate ucursor

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
--Select * FROM [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Order by Datetimestart

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_DB_Optimize' ) )
	drop procedure dbo.A_DB_Optimize
GO

Create procedure dbo.A_DB_Optimize
as
begin
	Declare @logname nvarchar(500)
	Declare @sz int, @msz int
	Declare @curdb nvarchar ( 500 )
	Set @curdb = DB_name()

	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	--  maxsize    1500
	if ( @msz != -1 and @msz < 1500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', maxsize=1500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )

	DBCC DBREINDEX ( 'dbo.A_CallCenter_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_1x1' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_Errors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_Algorythms' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_StopInfo' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_Task_IncomingCalls' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskNumber' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskEfforts' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_UserInTask' )
	DBCC DBREINDEX ( 'dbo.A_User_NotifyLog' )
	DBCC DBREINDEX ( 'dbo.A_UserMessages' )
	DBCC DBREINDEX ( 'dbo.A_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_VoiceMail' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_1x1' )
	
	DBCC SHRINKDATABASE (oktell)

	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	if ( @sz < 500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', size=500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )


	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	begin
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @msz != -1 and @msz < 1500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', maxsize=1500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )

		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_EffortConnections' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_OperatorStates' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_CallQueue' )

		DBCC SHRINKDATABASE (oktell_cc_temp)
		
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @sz < 500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', size=500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )
	end
end 
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncQuery' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQuery
GO

CREATE procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != @cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncQuery' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
GO

CREATE procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

					Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != @cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncTable' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTable
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncTable' ) )
	drop procedure dbo.A_TaskManager_List_DirectDB_SyncTable
GO

Create procedure dbo.A_TaskManager_List_DirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTableExact' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTableExact
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_GetTableExact
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 50 )
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )


	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], @k, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	
	--  ,    (   )
	--        
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '
			--and State = 0

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 50 )
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	

		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 		Select top 100000 [' + @idfield + '], @k, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
			end
			'

	exec sp_sqlexec @sql
	end	
	
	

	--  ,    (   )
	--        
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where State = 0
			and IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTable' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTable
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_GetTable
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )


	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], @k, 0, 0
					From ' + @table + ' t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0 
		And IdOperator = ' + @operator + '
		'

	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + ' 
		From ' + @table + '
		Where [' + @idfield + '] = @id
		'
	
	exec sp_sqlexec @sql
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQuery' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQuery
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_GetQuery
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	

		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 		Select top 100000 [' + @idfield + '], @k, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
			end
			'

	exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		And IdOperator = ' + @operator + '
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0	
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO



if exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DateTimeStart' )
begin
	use oktell_cc_temp
	Drop index A_Cube_CC_EffortConnections.idxCubeConnections_DateTimeStart
	use oktell
end
GO


if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_EffortConnections') and name = 'idxCubeConnections_DateTimeStart' )
CREATE NONCLUSTERED INDEX idxCubeConnections_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_EffortConnections
(
	DateTimeStart
) WITH FILLFACTOR = 80
GO
