
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_FreeTime' ) )
	drop procedure dbo.A_TaskManager_OperatorsAll_Get_FreeTime
GO

Create   procedure [dbo].[A_TaskManager_OperatorsAll_Get_FreeTime]
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select u.id, 
		--Max ( TimeStop ) as TimeStop_Last,
		Convert ( float, @dtnow - Max ( IsNull ( TimeStop, @dtnow ) ) ) as MaxFreeTime_Days
	From A_Stat_Connections_1x1 sc --With ( TabLock )
		Inner join A_USers u on sc.AUserId = u.id or sc.BUserId = u.Id	
	Group by u.Id
	order by MaxFreeTime_Days desc
end
GO



if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_TaskWork' ) )
	drop procedure dbo.A_TaskManager_OperatorsAll_Get_TaskWork
GO

Create   Procedure [dbo].[A_TaskManager_OperatorsAll_Get_TaskWork]
	@extraid		uniqueidentifier,
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select u.Id, Sum ( Convert ( float, TimeStopPost - TimeStart ) ) as TaskWork_Days
	From A_TaskManager_UserInTask uit with ( NOLOCK )
		Inner join A_Users u on uit.UserId = u.Id
	Where TaskId = @extraid
		and FLOOR ( cast ( @dtnow as float ) ) = FLOOR ( cast ( TimeStopPost as float ) )
	Group By u.Id
	Order by TaskWork_Days
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_DayTalkTime' ) )
	drop procedure dbo.A_TaskManager_OperatorsAll_Get_DayTalkTime
GO

Create   procedure [dbo].[A_TaskManager_OperatorsAll_Get_DayTalkTime]
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select u.Id, Sum ( Convert ( float, TimeStop - TimeStart ) ) as DayTalks_Days
	From A_Stat_Connections_1x1 sc --With ( TabLock )
		inner join A_Users u on sc.AUserId = u.Id or sc.BUserId = u.Id
	Where FLOOR ( cast ( @dtnow as float ) ) = FLOOR ( cast ( TimeStop as float ) )		
	Group by u.Id
	Order by DayTalks_Days
end
GO

