if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientContacts_A_ClientContactTypes]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientContacts] DROP CONSTRAINT FK_A_ClientContacts_A_ClientContactTypes
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_Groups_A_ClientGroups]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_Groups] DROP CONSTRAINT FK_A_Clients_Groups_A_ClientGroups
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientContacts_A_Clients]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientContacts] DROP CONSTRAINT FK_A_ClientContacts_A_Clients
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientHistory_A_Clients]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientHistory] DROP CONSTRAINT FK_A_ClientHistory_A_Clients
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_Groups_A_Clients]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_Groups] DROP CONSTRAINT FK_A_Clients_Groups_A_Clients
GO

exec A_DB_ClearConstraintsAll 'A_ClientContactTypes'
exec A_DB_ClearConstraintsAll 'A_ClientContacts'
exec A_DB_ClearConstraintsAll 'A_ClientGroups'
exec A_DB_ClearConstraintsAll 'A_Clients_Groups'
exec A_DB_ClearConstraintsAll 'A_ClientHistory'
exec A_DB_ClearConstraintsAll 'A_Clients'
GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientContactTypes]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_ClientContactTypes] (
	[Id] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (100) COLLATE database_default NULL ,
	[IsPhoneNumber] [bit] NULL 
) ON [PRIMARY]
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientContacts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_ClientContacts] (
	[Id] [uniqueidentifier] NOT NULL ,
	[IdClient] [uniqueidentifier] NULL ,
	[IdContact] [uniqueidentifier] NULL ,
	[Content] [nvarchar] (255) COLLATE database_default NULL ,
	[IsDefaultPhone] [bit] NULL 
) ON [PRIMARY]
GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_ClientGroups] (
	[Id] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (255) COLLATE database_default NULL ,
	[OwnerId] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients_Groups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_Clients_Groups] (
	[Id] [uniqueidentifier] NOT NULL ,
	[IdClient] [uniqueidentifier] NULL ,
	[IdGroup] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientHistory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_ClientHistory] (
	[Id] [uniqueidentifier] NOT NULL ,
	[IdClient] [uniqueidentifier] NULL ,
	[CreationDateTime] [datetime] NULL ,
	[Content] [nvarchar] (1000) COLLATE database_default NULL ,
	[IdUser] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[A_Clients] (
	[Id] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (200) COLLATE database_default NULL ,
	[OwnerId] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO


ALTER TABLE [dbo].[A_ClientContactTypes] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientContactTypes] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientContacts] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientContacts] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientGroups] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientGroups] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO


ALTER TABLE [dbo].[A_Clients_Groups] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Clients_Groups] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientHistory] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientHistory] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Clients] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Clients] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientContacts] ADD 
	CONSTRAINT [FK_A_ClientContacts_A_ClientContactTypes] FOREIGN KEY 
	(
		[IdContact]
	) REFERENCES [dbo].[A_ClientContactTypes] (
		[Id]
	) ON DELETE CASCADE  ON UPDATE CASCADE ,
	CONSTRAINT [FK_A_ClientContacts_A_Clients] FOREIGN KEY 
	(
		[IdClient]
	) REFERENCES [dbo].[A_Clients] (
		[Id]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[A_ClientHistory] ADD 
	CONSTRAINT [FK_A_ClientHistory_A_Clients] FOREIGN KEY 
	(
		[IdClient]
	) REFERENCES [dbo].[A_Clients] (
		[Id]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO
