if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO









CREATE        Procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
@@IdCategory uniqueidentifier
as
begin

-- -   
declare @@EnableAdditionalSearchFilterGroups bit
set @@EnableAdditionalSearchFilterGroups = 0
if( exists( select top 1 idGroup from ##TempSearchByCustomFilterGroups ) )
	set @@EnableAdditionalSearchFilterGroups = 1 

--  
select distinct c.idContragent, Code, c.[Name]
into #tmp_clients
From A_Contragent c
	left join A_Contragent_ContragentGroup ccg on c.IdContragent = ccg.IdContragent
	left join A_Contragent_KeyWords ck on c.IdContragent = ck.IdContragent
	left join A_KeyWord k on ck.IdKeyWord = k.IdKeyWord

	left join A_ContragentContact cc on c.IdContragent = cc.IdContragent

	left join A_Clients_ClientForms ccf on c.IdContragent = ccf.IdContragent
	left join A_ContragentCategory_Conditions cat on ccf.IdForm = cat.IdForm 
				and ccf.IdFormList = cat.IdFormList 
				and ccf.IdFormControl = cat.IdFormControl
	left join ##TempSearchByCustomFilterGroups tmp_gr on isnull ( ccg.IdGroup, '00000000-0000-0000-0000-000000000000' ) = tmp_gr.IdGroup or tmp_gr.IdGroup = '00000000-0000-0000-0000-000000000000'
Where 	
	( ( @@EnableAdditionalSearchFilterGroups = 1 and --   	    
		tmp_gr.IdGroup is not null ) and --      " " = '00000000-0000-0000-0000-000000000000'
		( (--   
			case ccf.ValueUsed 
			  when 'ValueStr' then ValueStr
			  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
			  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
			  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
			 --   
			  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
		    	  end like dbo.PrepareStrToLike( cat.Value )
		   )
			 or 
			( exists( Select IdCategory from A_ContragentCategory Where IdCategory = @@IdCategory ) and 
			  not exists( Select IdCategory from A_ContragentCategory_Conditions Where IdCategory = @@IdCategory ) )
		)
	  or
	  ( @@EnableAdditionalSearchFilterGroups = 0 and --   
		( (--   
			case ccf.ValueUsed 
			  when 'ValueStr' then ValueStr
			  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
			  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
			  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
			 --   
			  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
		    	  end like dbo.PrepareStrToLike( cat.Value )
		   )
			 or 
			( exists( Select IdCategory from A_ContragentCategory Where IdCategory = @@IdCategory ) and 
			  not exists( Select IdCategory from A_ContragentCategory_Conditions Where IdCategory = @@IdCategory ) )
		)
	  )
	)

--  
Select distinct idContragent, Code, [Name] 
from #tmp_clients

	--  
	drop table #tmp_clients

	-- ,   A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups
	--    
	drop table ##TempSearchByCustomFilterGroups 

end














GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

