
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_ClearConstraintsAll' ))
	drop procedure dbo.A_DB_ClearConstraintsAll
GO


Create procedure [dbo].[A_DB_ClearConstraintsAll]
	@simpletablename nvarchar ( 500 )
as
begin
	
declare @tablename varchar ( 500 )
declare @sql nvarchar(1000)
set @tablename='dbo.' + @simpletablename
DECLARE tcursor CURSOR FOR 
	select s.name, s.parent_obj, s1.name
	from sysobjects s
		inner join sysobjects s1 on s.parent_obj = s1.Id
	where ( s.type = 'F' or s.type = 'K' ) and s.name like '%' + @simpletablename + '%' 
	Order by s.Id desc

declare @cnstrname varchar(500)
declare @parent int
declare @subtab varchar ( 500 )


OPEN tcursor
FETCH NEXT FROM tcursor INTO @cnstrname, @parent, @subtab

WHILE @@FETCH_STATUS = 0
BEGIN

set @sql = ' ALTER TABLE ' + @subtab + 
	' DROP CONSTRAINT ' + @cnstrname
exec sp_executesql @stmt =@sql
print @sql

FETCH NEXT FROM tcursor INTO @cnstrname, @parent, @subtab
END

CLOSE tcursor
DEALLOCATE tcursor

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetInfo' ))
	drop procedure dbo.A_TaskManager_List_GetInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@id uniqueidentifier
as
begin

	Select Id, Name, Description, ProjectId, Type, 
		Query, JoinedTable, ColumnId, ColumnsPhone, 
		ColumnName, ColumnsViewed, ColumnsViewedDescription,
		ColumnsSqlType, ColumnsSqlTypeSize
	From A_TaskManager_Lists
	Where Id = @id or ProjectId = @id
	Order by Name
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_Save' ))
	drop procedure dbo.A_TaskManager_List_Save
GO


Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 )	
as
begin
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	--    ,    
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		Name 			= @name,
		Description 		= @description,
		ProjectId 		= @idproject,
		Type 			= @type,
		Query 			= @query,
		JoinedTable 		= @joinedtable,
		ColumnId 		= @columnid,
		ColumnsPhone 		= @columnsphone,
		ColumnName 		= @columnname,
		ColumnsViewed 		= @columnsviewed,
		ColumnsViewedDescription = @columnsvieweddescription,
		ColumnsSqlType 		= @columnssqltype,
		ColumnsSqlTypeSize 	= @columnssqltypesize
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, ColumnId, ColumnsPhone, ColumnName, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @columnid, @columnsphone, @columnname, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize )
end
GO


exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ContragentCategories'
exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ContragentConditions'
exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ContragentGroups'

exec A_DB_ClearConstraintsAll 'A_ContragentCategory_Conditions'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory_GrantedForms'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory_GrantedLists'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory_Rigths'
exec A_DB_ClearConstraintsAll 'A_Contragent_Rigths'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory'
exec A_DB_ClearConstraintsAll 'A_ContragentGroup'
exec A_DB_ClearConstraintsAll 'A_ContragentContact'
exec A_DB_ClearConstraintsAll 'A_Contragent_KeyWords'
exec A_DB_ClearConstraintsAll 'A_Contragent_ContragentGroup'
exec A_DB_ClearConstraintsAll 'A_Contragent'

exec A_DB_ClearConstraintsAll 'A_ClientFormColumns'
exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ClientFormColumns'
exec A_DB_ClearConstraintsAll 'A_ClientFormControl'
exec A_DB_ClearConstraintsAll 'A_ClientFormList'
exec A_DB_ClearConstraintsAll 'A_ClientFormRigths'
exec A_DB_ClearConstraintsAll 'A_ClientForm'
exec A_DB_ClearConstraintsAll 'A_Clients_ClientForms'
GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormControl_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormControl] DROP CONSTRAINT FK_A_ClientFormControl_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormList_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormList] DROP CONSTRAINT FK_A_ClientFormList_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormRigths_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormRigths] DROP CONSTRAINT FK_A_ClientFormRigths_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_ClientForms_A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_ClientForms] DROP CONSTRAINT FK_A_Clients_ClientForms_A_ClientFormControl
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetFomListControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Lists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Lists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveFormControl]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientForm]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormRigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients_ClientForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Clients_ClientForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_ContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_KeyWords]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_KeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Conditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Conditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedLists]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Rigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Rigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_Rigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_Rigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentContact]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentGroup]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormControl_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormControl] DROP CONSTRAINT FK_A_ClientFormControl_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormList_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormList] DROP CONSTRAINT FK_A_ClientFormList_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormRigths_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormRigths] DROP CONSTRAINT FK_A_ClientFormRigths_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_ClientForms_A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_ClientForms] DROP CONSTRAINT FK_A_Clients_ClientForms_A_ClientFormControl
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_ClientForms_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_ClientForms] DROP CONSTRAINT FK_A_Clients_ClientForms_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_ContragentGroup_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_ContragentGroup] DROP CONSTRAINT FK_A_Contragent_ContragentGroup_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_KeyWords_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_KeyWords] DROP CONSTRAINT FK_A_Contragent_KeyWords_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ContragentContact_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ContragentContact] DROP CONSTRAINT FK_A_ContragentContact_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_ContragentGroup_A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_ContragentGroup] DROP CONSTRAINT FK_A_Contragent_ContragentGroup_A_ContragentGroup
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ContragentGroup_A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ContragentGroup] DROP CONSTRAINT FK_A_ContragentGroup_A_ContragentGroup
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_KeyWords_A_KeyWord]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_KeyWords] DROP CONSTRAINT FK_A_Contragent_KeyWords_A_KeyWord
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientForm]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormColumns]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormColumns]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormRigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients_ClientForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Clients_ClientForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentContact]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_ContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_KeyWords]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_KeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_KeyWord]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_KeyWord]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientForm]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientForm]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetFomListControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Lists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Lists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveFormControl]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_ClearContacts]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_ClearContacts]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_ClearGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_ClearGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_ClearKeyWords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_ClearKeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_Delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_Delete]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetCommonByGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetCommonByGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetContact]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetFormsGranted]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetFormsGranted]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetFormsUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetFormsUsed]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetKeyWord]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetKeyWord]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetKeyWords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetKeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValue]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveContact]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveKeyWord]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveKeyWord]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValue]
GO

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Office_Contragents_SaveGroup' ) )
	drop procedure dbo.A_CallCenter_Office_Contragents_SaveGroup
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_ClientForm_GetFomListControls' ) )
	drop procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentCategories]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentConditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentGroups]
GO

exec A_DB_ClearConstraintsAll 'A_ContragentCategory_Conditions'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory_GrantedForms'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory_GrantedLists'
exec A_DB_ClearConstraintsAll 'A_ContragentCategory_Rigths'
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Conditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Conditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedLists]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Rigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Rigths]
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_Categories_DeleteCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_Categories_DeleteCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearConditions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedForms]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Conditions_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Conditions_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedForms_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedForms_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedLists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedLists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedFormList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveRigth]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Contragents_GetValueByLink]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[Contragents_GetValueByLink]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PrepareStrToLike]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[PrepareStrToLike]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_Categories_DeleteCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_Categories_DeleteCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearConditions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedForms]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Conditions_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Conditions_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedForms_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedForms_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedLists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedLists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedFormList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_CheckValueUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_CheckValueUsed]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_DeleteGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_DeleteGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveContragentGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Scipt_GetContragentCode]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Scipt_GetContragentCode]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Scipt_GetContragentId_Int]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Scipt_GetContragentId_Int]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveColumns]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveColumns]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveGroup]
GO


exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ClientFormColumns'
exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ContragentCategories'
exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ContragentConditions'
exec A_DB_ClearConstraintsAll 'A_TaskManager_Lists_ContragentGroups'
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ClientFormColumns]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ClientFormColumns]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentCategories]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentConditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_Categories_DeleteCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_Categories_DeleteCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearConditions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedForms]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Conditions_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Conditions_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedForms_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedForms_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedLists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedLists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedFormList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_CheckValueUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_CheckValueUsed]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_DeleteGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_DeleteGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveContragentGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Scipt_GetContragentCode]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Scipt_GetContragentCode]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Scipt_GetContragentId_Int]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Scipt_GetContragentId_Int]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveColumns]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveColumns]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_Categories_DeleteCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_Categories_DeleteCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearConditions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedForms]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Conditions_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Conditions_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedForms_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedForms_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedLists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedLists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedFormList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetFomListControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Lists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Lists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveFormControl]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_CheckValueUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_CheckValueUsed]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_ClearContacts]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_ClearContacts]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_ClearGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_ClearGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_ClearKeyWords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_ClearKeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_Delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_Delete]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_DeleteGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_DeleteGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientCategoryProperties]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientGrantedCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetClientGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetClientGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetCommonByGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetCommonByGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetContact]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetFormsGranted]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetFormsGranted]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetFormsUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetFormsUsed]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetKeyWord]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetKeyWord]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetKeyWords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetKeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValue]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveContact]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveContragentGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveKeyWord]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveKeyWord]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValue]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Scipt_GetContragentCode]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Scipt_GetContragentCode]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Scipt_GetContragentId_Int]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Scipt_GetContragentId_Int]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveColumns]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveColumns]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_SaveGroup]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_SaveGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValue]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValue]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveCommonForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveCommonForScript]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_DeleteForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_DeleteForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValueClientForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValueClientForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValueClientForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValueClientForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_PrepareQueryToClientTable]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_PrepareQueryToClientTable]
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_CheckFormForUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_CheckFormForUsed]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValueForScript]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValueForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValueForScript]
GO

