if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysDefault' ) )
	Drop Table dbo.A_HolidaysDefault
GO

Create Table dbo.A_HolidaysDefault
(
	Date DateTime,
	Type bit,
	AsDayOfWeek int,
	Description nvarchar (1000)
)
GO

insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '01.01.2000', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '07.01.2000', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '23.02.2000', 104 ) , 1, 0, '  ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '08.03.2000', 104 ) , 1, 0, '  ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '01.05.2000', 104 ) , 1, 0, '   ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '09.05.2000', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '12.06.2000', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysDefault (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '04.11.2000', 104 ) , 1, 0, '  ' )
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysUser' ) )
	Drop Table dbo.A_HolidaysUser
GO

Create Table dbo.A_HolidaysUser
(
	Date DateTime,
	Type bit,
	AsDayOfWeek int,
	Description nvarchar (1000)
)

GO

insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '02.01.2008', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '03.01.2008', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '04.01.2008', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '05.01.2008', 104 ) , 1, 0, ' ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '25.02.2008', 104 ) , 1, 0, '.. 23.02   ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '10.03.2008', 104 ) , 1, 0, '.. 08.03   ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '02.05.2008', 104 ) , 1, 0, ' 04.05-' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '13.06.2008', 104 ) , 1, 0, ' 07.06-' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '03.11.2008', 104 ) , 1, 0, ' 01.11-' )

insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '04.05.2008', 104 ) , 0, 5, '.. 02.05 ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '07.06.2008', 104 ) , 0, 5, '.. 13.06 ' )
insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( CONVERT ( DateTime, '01.11.2008', 104 ) , 0, 5, '.. 03.11 ' )
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysDefault_Get' ) )
	Drop Procedure dbo.A_HolidaysDefault_Get
GO

CREATE  Procedure dbo.A_HolidaysDefault_Get
as 
begin
     Select *
     From dbo.A_HolidaysDefault

end
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysUser_Get' ) )
	Drop Procedure dbo.A_HolidaysUser_Get
GO

CREATE  Procedure dbo.A_HolidaysUser_Get
as 
begin
     Select *
     From dbo.A_HolidaysUser
end
GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysUser_ClearAll' ) )
	Drop Procedure dbo.A_HolidaysUser_ClearAll
GO

CREATE  Procedure dbo.A_HolidaysUser_ClearAll
as 
begin
    DELETE FROM dbo.A_HolidaysUser;
end

GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysUser_Add' ) )
	Drop Procedure dbo.A_HolidaysUser_Add
GO

CREATE  Procedure dbo.A_HolidaysUser_Add
    @date DateTime, @type bit, @asdayofweek int, @description nvarchar (1000)
as 
begin
    insert into dbo.A_HolidaysUser (Date, Type, AsDayOfWeek, Description) values ( @date , @type, @asdayofweek, @description );
end

GO

if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_HolidaysUser_Del' ) )
	Drop Procedure dbo.A_HolidaysUser_Del
GO

CREATE  Procedure dbo.A_HolidaysUser_Del
    @year int
as 
begin
    DELETE FROM dbo.A_HolidaysUser where datepart ( year, date ) = @year
end

GO

