if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Personal_GetNumbersDepartmentInfo' ) )
	Drop procedure dbo.A_Personal_GetNumbersDepartmentInfo
GO

Create Procedure [dbo].[A_Personal_GetNumbersDepartmentInfo]
As
Begin
	--      

	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join A_Rules r on na.ExtraId = r.Id
			Inner Join A_RuleRecords rr on rr.RuleId = r.Id
		Where na.NumType != 2 --   (    )


	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', ' ' )

	
	Declare @cnt int
	Set @cnt = 0

	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--    @cnt - 
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				Inner Join @t t1 on t.Reactid = t1.nId
			Where t.ReactId != t.Nid
	
		--    
		Delete 	From @t
			From @temp
		Where nid = id and reactid = oldrid

		-- 
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		-- 
		Delete From @temp	
	end

	--     
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id

	--    
	Declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert Into @output
		Select nid, Prefix, groupid, groupname From 
		(
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner Join A_Users u on t.ReactId = u.Id
				Inner Join @groups g on u.ParentGroupId = g.GroupId
			Union all

			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner join A_View_ServerIntLinesAll l on t.ReactId = l.Id
				Inner Join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		) a
		Group By Prefix, GroupId, nid, groupname


	--    ,       
	Declare @og table ( id uniqueidentifier, cnt int )
	Insert into @og
		Select * From
		(
			Select nid, count ( * ) as cnt
			From @output
			Group By nid
		)a
	
	Update @output 
	Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = ' '
	From @output o, @og og
	Where o.nid = og.id and og.cnt > 1


	--   
	Insert into @output
		Select np.Id, np.Prefix, g.GroupId, g.GroupName
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join @groups g on na.ExtraId = g.GroupId
		Where na.NumType = 2


	--  
	Select nid, prefix, groupid, groupname 
	From @output
	Group By nid, prefix, groupid, groupname

End
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_Personal_NumbersInfo_Get' ))
	drop procedure dbo.A_Personal_NumbersInfo_Get
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_Personal_NumbersInfo_GetSeparate' ))
	drop procedure [dbo].[A_Personal_NumbersInfo_GetSeparate]
GO

Create  Procedure [dbo].[A_Personal_NumbersInfo_GetSeparate]
As
Begin
--       
	
	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join A_Rules r on na.ExtraId = r.Id
			Inner Join A_RuleRecords rr on rr.RuleId = r.Id
		Where na.NumType = 0 --  (      )


	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', ' ' )


	Declare @cnt int
	Set @cnt = 0


	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--    @cnt - 
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				Inner Join @t t1 on t.Reactid = t1.nId
			Where t.ReactId != t.Nid
	
		--    
		Delete From @t
			From @temp
		Where nid = id and reactid = oldrid

		-- 
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		-- 
		Delete From @temp	
	end

	--     
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id
	
	Declare @eid uniqueidentifier
	Set @eid = '00000000-0000-0000-0000-000000000000'
	
	--  
	Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as ReactType
	From @t t
		Inner Join A_Users u on t.ReactId = u.Id
		Inner Join @groups g on u.ParentGroupId = g.GroupId
	
	Union all

	Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as ReactType
	From @t t
		Inner Join A_View_ServerIntLinesAll l on t.ReactId = l.Id
		Inner Join @groups g on l.ParentGroupId = g.GroupId

	Union all

	--    
	Select np.Id, np.Prefix, @eid, g.GroupId, g.GroupName, 2
	From A_NumberPlan np
		Inner Join A_NumberPlanAction na on na.NumId = np.Id
		Inner Join @groups g on na.ExtraId = g.GroupId
	Where na.NumType != 0
End
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_UserGroup_Group_SiftEmpty' ))
	Drop procedure dbo.A_Admin_UserGroup_Group_SiftEmpty
GO

Create	procedure [dbo].[A_Admin_UserGroup_Group_SiftEmpty]
as
begin
	--   

	--   
	declare @gc table ( nm nvarchar ( 255 ) collate database_default, cnt int )
	Insert into @gc 
		Select [Name], Count ( * ) as cnt 
		From A_Groups
		Group By [Name]

	declare @cnt int	
	Select @cnt = Count ( * )
	From @gc 
	Where cnt > 1

		
	if ( @@rowcount > 0 )
	begin
	   declare @change table ( id uniqueidentifier, idto uniqueidentifier )
	   declare @id uniqueidentifier
           declare @name nvarchar ( 255 )

	   declare @lastid uniqueidentifier	
	   declare @lastname nvarchar ( 255 )
	   set @lastname = ''

	   declare cs Cursor For
		Select id, name 
		From A_Groups
			Inner Join @gc gc on [name] like gc.nm
		Where gc.cnt > 1
		Order By name
	  

	   Open cs
	   Fetch Next From cs Into @id, @name
	   While ( @@FETCH_STATUS = 0 )
	   Begin
		if ( @name = @lastname )
                    begin
			Insert Into @change ( id, idto )
				Values ( @id, @lastid )
		    end
		else
		    begin
			set @lastid = @id
			set @lastname = @name
		    end
			
	   	Fetch Next From cs Into @id, @name
	   End
	   Close cs
	   Deallocate cs

	   --Select * From @change

	Update A_ServerUsbLines
    	Set ParentGroupId = ch.idto
	From A_ServerUsbLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_ServerIntLines
    	Set ParentGroupId = ch.idto
	From A_ServerIntLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_ServerSipLines
    	Set ParentGroupId = ch.idto
	From A_ServerSipLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_ServerVirtualLines
    	Set ParentGroupId = ch.idto
	From A_ServerVirtualLines u, @change ch
	Where u.ParentGroupId = ch.Id


	Update A_Users
    	Set ParentGroupId = ch.idto
	From A_Users u, @change ch
	Where u.ParentGroupId = ch.Id


	Update A_NumberPlanAction
    	Set ExtraId = ch.idto
	From A_NumberPlanAction u, @change ch
	Where u.NumType != 0 and u.ExtraId = ch.Id


	end

	
	Delete 
	From A_Groups 
	Where not ID in ( Select ParentGroupID From A_Users 
				union
			  Select ParentGroupId From A_View_ServerIntLinesAll 
				union
			  Select ExtraId From A_NumberPlanAction Where NumType != 0 )

end
GO
