
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_User_NotifyLog' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_User_NotifyLog' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'OneOnScreen' )
	Alter Table dbo.A_User_NotifyLog
	Add OneOnScreen bit NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_User_NotifyLog' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_User_NotifyLog' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'OneOnScreenId' )
	Alter Table dbo.A_User_NotifyLog
	Add OneOnScreenId nvarchar(200) NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_Save' ) )
	Drop procedure dbo.A_UserNotifyLog_Save
GO

Create Procedure [dbo].[A_UserNotifyLog_Save]
	@userid		uniqueidentifier,
	@datetime	datetime,
	@logtype	int,
	@sendertext	nvarchar(500),
	@text		nvarchar(4000),
	@wasshown	int,
	@oneonscreen	bit = NULL,
	@oneonscreenid	nvarchar(200) = NULL
as
begin
	declare @id uniqueidentifier
	set @id = NewId ()

	if exists ( Select id From A_Users Where Id = @userid )
		
		Insert into A_User_NotifyLog
			( Id, IdUser, NotifyDateTime, LogType, TextSender, TextInfo, WasShown, OneOnScreen, OneOnScreenId )
		Values
			( @id, @userid, @datetime, @logtype, @sendertext, @text, @wasshown, @oneonscreen, @oneonscreenid )
end
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_GetAllUnShown_ForUser' ) )
	Drop procedure dbo.A_UserNotifyLog_GetAllUnShown_ForUser
GO

Create Procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
	@id uniqueidentifier
as
begin
	Declare @dtnow datetime
	set @dtnow = GetDate()

	Declare @dttoday datetime
	set @dttoday = Cast ( Floor ( cast ( @dtnow as float ) ) as DateTime )

	Select Top 15 Id, IdUser, NotifyDateTime, LogType, TextSender, TextInfo, WasShown, OneOnScreen, OneOnScreenId
	From A_User_NotifyLog With ( Index ( idxUserNotifies_UserDTWasShown ) )--WITH ( TabLock, HoldLock )
	Where IDuser = @id and WasShown = 0 --and NotifyDateTime > @dttoday
	Order by NotifyDateTime Desc

	Update A_User_NotifyLog --with ( TABLOCK )
	Set WasShown = 1 
	Where IdUser = @id and WasShown = 0
end
GO