if exists ( Select * from sysobjects where id= object_id ( 'dbo.A_Stat_MyCalls_Get' ))
	Drop procedure dbo.A_Stat_MyCalls_Get
GO

Create procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 10 - , 11 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'	

*/

     Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, 
				TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, Length DateTime, 
				Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 200 ) collate database_default, 
				IsRecorded int, IdRecDir int, 
				ALineNum nvarchar ( 10 ) collate database_default, BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 200 ) collate database_default, BStr nvarchar ( 100 ) collate database_default, 
				IsConf int, Director uniqueidentifier, CTS DateTime )
     --  
     declare @filtercomment bit
     set @filtercomment = case when ( @comment IS NULL or @comment like '' ) then 0 else 1 end

     Declare @id0 uniqueidentifier
     Set @id0 = '00000000-0000-0000-0000-000000000000'

     Declare @ids table ( id uniqueidentifier )

    -------------------------------------
    --  -----------------------
    -------------------------------------

    if ( @type in ( 0, 1, 2 )) begin

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart >= @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart >= @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	

	Insert into @output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

	    Select sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeAnswer, sc.TimeStop, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', IsRecorded, IdRecDir, 
			ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr,
			0 as IsConf, @id0 as Director, sc.TimeStart as CTS

	    From A_Stat_Connections_1x1 sc --with ( TabLock )
			inner join @ids ids on sc.Id = ids.id
	    Where sc.TimeStop is not null

	--    ( )
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @output
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end
    end

    -------------------------------------
    --  ----------------------
    -------------------------------------
    if ( @type in ( 0, 10, 11 )) begin

	--   	
	Declare @A_Stat_Conference_Ctmp1 table ( IdConn uniqueidentifier PRIMARY KEY )
	Declare @A_Stat_Conference_tmp1 table ( Id uniqueidentifier PRIMARY KEY, RecordAccess int, Director uniqueidentifier )

	Insert into @A_Stat_Conference_Ctmp1
		Select IdConn
		FROM A_Stat_Conference_Competitors scc
		Where (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
			And IdUser = @userid

	Insert into @A_Stat_Conference_tmp1
		Select Id, RecordAccess, Director 
		FROM A_Stat_Conference sc
		Where (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
			or (( TimeStart < @dstop ) and ( TimeStop >= @dstop ))
			or (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
			or (( TimeStart >= @dstart ) and ( TimeStop <= @dstop ))

	--    ( )
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @A_Stat_Conference_tmp1
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end

	--   
	Declare @A_Stat_Conference_tmp2 table ( Id uniqueidentifier PRIMARY KEY )

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
		Where sc.RecordAccess = 1 --  
			And sc.Director = @userid

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
			Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
		Where sc.RecordAccess = 2 -- 
			And scc.IdUser = @userid
		Group By sc.Id

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc
			Inner join A_Stat_Conference_RecordAccessUsers scr on sc.Id = scr.IdConf
		Where sc.RecordAccess = 3 --  
			And scr.IdUser = @userid
		Group By sc.Id

		

	Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into @output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		Select IdConn, IdChain, 
			case when sc.Type = 1 then 11/**/ else 10/**/ end, 
			case when sc.Type = 1 then 11/**/ else 10/**/ end,
			scc.TimeStart, scc.TimeStart as TimeAnswer, scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, LineNum, sc.Room, 
			scc.IdUser, @idconfuser,
			scc.IdLine, IdConf,
			'', '', StrName, case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, Director, sc.TimeStart as CTS
		FROM A_Stat_Conference_Competitors scc
			Inner join A_Stat_Conference sc on sc.Id = scc.IdConf
			Left join @A_Stat_Conference_tmp2 sct on sc.Id = sct.Id --    
		Where ((( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart < @dstop ) and ( scc.TimeStop >= @dstop ))
			or (( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart >= @dstart ) and ( scc.TimeStop <= @dstop )))
			And (( @number = '' ) or ( sc.Room = @number ))
			And scc.IdUser = @userid
			And ((( sc.Type = 1 ) and ( @type = 11 )) or (( sc.Type = 0 ) and ( @type = 10 )) or ( @type = 0 ))
    end

    -------------------------------------
    --  ----------------------
    -------------------------------------
    if ( @type in ( 0, 3 )) begin

	Insert into @output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

	    Select Idg, IdChain, 3, 3, 
		TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
		AOutNumber, AStr, 0, 0, 
		ALineNum, BLineNum, 
		AUserId, BUserId,
		ALineId, BLineId,
		AOutNumber, Number,
		AStr, '',
		0, @id0, TimeStart
	    From A_Stat_MissedCalls
	    Where ( BUserId = @userid )
		And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
 	
    end

	-----------------------------------
  	--  -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid
		And Type = 0

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @userid )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @id0 )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From @output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	--  ---------------------------
	-----------------------------------
	
	Select Top 1000 sc.Id, IdChain, Media, Type, TimeStart, TimeAnswer, TimeStop, Cast ( Cast ( Length as float ) * 86400 as int ) as Length, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir, 
		IsConf, Director, CTS, 
		case When ( c.Id is null ) then 0 else 1 end as HasComment		
	From @output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where ( Media = @media ) or ( @media = 0 ) or ( Type >= 10 )
	Order By TimeStart Desc
end
GO


if exists ( Select * from sysobjects where id= object_id ( 'dbo.A_CallCenter_ControlEvents_GetJournal' ))
	Drop procedure dbo.A_CallCenter_ControlEvents_GetJournal
GO

Create procedure dbo.A_CallCenter_ControlEvents_GetJournal
	@iduser uniqueidentifier,
	@datestart datetime,
	@datestop datetime,
	@timestart datetime,
	@timestop datetime,
	@idsevent nvarchar ( 4000 ),
	@idstask nvarchar ( 4000 ),
	@idsoperator nvarchar ( 4000 )
as
begin
	Declare @dstart datetime, @tstart datetime, @dstop datetime, @tstop datetime
	Set @dstart = Cast ( Floor ( Cast ( @datestart as float ) ) as DateTime )
	Set @dstop = Cast ( Floor ( Cast ( @datestop as float ) + 1 ) as DateTime )
	Set @tstart = Cast ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) as DateTime )
	Set @tstop = Cast ( Cast ( @timestop as float ) - Floor ( Cast ( @timestop as float ) ) as DateTime )

	declare @temp nvarchar ( 4000 )
	declare @tempid uniqueidentifier

	Declare @events table ( id uniqueidentifier )
	Declare @tasks table ( id uniqueidentifier )
	Declare @operators table ( id uniqueidentifier )

	set @temp = @idsevent
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @events values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end	
	else
		Insert into @events
			Select Id 
			From A_CallCenter_ControlEvents
			Where IsDeleted = 0

	set @temp = @idstask
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @tasks values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end
	else
	   begin
		Insert into @tasks
			Select Id 
			From A_TaskManager_Tasks
		Insert into @tasks ( id ) values ( '00000000-0000-0000-0000-000000000000' )			
	   end


	set @temp = @idsoperator
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @operators values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end
	else
	   begin
		Insert into @operators
			Select Id 
			From A_Users
		Insert into @operators ( id ) values ( '00000000-0000-0000-0000-000000000000' )			
	   end
	

	Select top 1000 j.Id, j.IdEvent, ce.Name as EventName, j.EventDateTime, j.ValStr, j.ValDec, j.IdTask, ti.Name as TaskName, j.IdOperator, oi.Name as OperatorName
	From A_CallCenter_ControlEventsJournal j
		Inner join A_CallCenter_ControlEvents ce on j.IdEvent = ce.Id
		Inner join @events e on j.IdEvent = e.Id
		Inner join @tasks t on j.IdTask = t.Id
		Inner join @operators o on j.IdOperator = o.Id
		Left join A_TaskManager_Tasks ti on ti.Id = t.Id
		Left join A_Users oi on oi.Id = o.Id
	Where ( EventDate between @dstart and @dstop )
		and ( EventTime > @tstart ) and ( EventTime < @tstop )
	Order by EventDateTime Desc
end
GO