/****** Object:  StoredProcedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]    Script Date: 12/15/2011 12:06:58 ******/
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Office_Diagramm_FlashedCalls]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
GO

CREATE procedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int,
	@comment nvarchar ( 4000 ) = NULL
as
begin
 --.  "  "


-- ---------------------------------------------------

--DECLARE @iduser uniqueidentifier,
--		@dstart datetime,
--		@dstop datetime,
--		@tstart datetime,
--		@tstop datetime,
--		@lentime datetime,
--		@taskid uniqueidentifier,
--		@fromcc bit,
--		@operatorid uniqueidentifier ,
--		@innerprefix nvarchar ( 100 ),
--		@outnumber nvarchar ( 100 ) ,
--		@conntype int ,
--		@mode int,
--		@comment nvarchar ( 4000 )	
	
--Select	@iduser='08BADA93-618D-4493-A7DC-112E39C1D5B9',
--@dstart='2012-01-02 00:00:00',@dstop='2012-01-12 23:59:59.963',
--@tstart='2006-07-26 08:00:00',@tstop='2006-07-26 20:00:00',
--@lentime='2006-07-26 00:00:01',@fromcc=0,@conntype=-1,@comment=N'',@mode=5

--------------------------------------------------------------------


	if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		Select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete From #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		0, -- dont show conf
		@comment

	if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsflash') )
		Select top 0 sc1.*, sc2.ALineId A2LineId, sc2.BLineId B2LineId into #tempstatisticsflash 
		From A_Stat_Connections_1x1 sc1 Inner Join A_Stat_Connections_1x1 sc2 on sc1.IDNext = sc2.Id
	else
		delete From #tempstatisticsflash

	insert into #tempstatisticsflash
		Select ts1.*, ts2.ALineId A2LineId, ts2.BLineId B2LineId
		From #tempstatistics ts1 Inner Join 
			#tempstatistics ts2 on ts1.idnext = ts2.id
		where not ( ts1.ALineId = ts2.ALineId and ts1.BLineID = ts2.BLineId ) 
			and not ( ts1.ALineId = ts2.BLineId and ts1.BLineID = ts2.ALineId )
			and not ( ts1.AUserId = 'AB000000-0000-0000-0000-000000000000' )
			and not ( ts1.BUserId = 'AB000000-0000-0000-0000-000000000000' )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin	
 				
 			--   111214
			declare @tempdate datetime
			set @tempdate = @dstart
			
			while (@tempdate<@dstop)
			begin
			insert into #tempstatisticsflash (id,timestart) --
			values (newid(),@tempdate)
			set @tempdate = dateadd(dd,1,@tempdate)
			end
				
		
			Select Year ( timestart) y, Month ( timestart ) m, Day ( timestart ) d, count ( * )-1 as Count_
			From #tempstatisticsflash
			Group by Year ( timestart ), Month ( timestart ), Day ( timestart )											
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			
			--   111214
			declare @temptime datetime
			set @temptime = @tstart
			
			while (@temptime<@tstop)
			begin
			insert into #tempstatisticsflash (id,timestart,TimeStop, TimeAnswer) --
			values (newid(),@temptime,@temptime,@temptime)
			set @temptime = dateadd(hh,1,@temptime)
			end
		
			Select DatePart ( hour, timestart ) h, count ( * )-1 as Count_
			From #tempstatisticsflash
			Group by DatePart ( hour, timestart )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			Select uid, count ( * ) as count_
			From
			( 
				Select AUserId as uid, timestart
				From #tempstatisticsflash
				where StopSide = 0 and 
					(AUserId != '00000000-0000-0000-0000-000000000000')
		
				Union all

				Select BUserId as uid, timestart
				From #tempstatisticsflash
				where StopSide = 1 and
					(BUserId != '00000000-0000-0000-0000-000000000000')
			)a
			Group by uid								
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin			
			declare @lines table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			insert into @lines (lineid, caption)
				Select id, caption From A_View_ServerLinesAll											
			
			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum,
				count_
			From
			(
				Select lineid, linenum, count ( * ) as count_
				from
				(
					Select BLineNum as lineid, BLineNum linenum, timestart
					From #tempstatisticsflash ts 
					Inner Join @lines l on ts.BLineId = l.lineid

					union
	
					Select ALineNum as lineid, ALineNum linenum, timestart
					From #tempstatisticsflash ts 
					Inner Join @lines l on ts.ALineId = l.lineid
				)a
				group by lineid, linenum
			)
			b
				Left join @lines l on b.lineid = l.lineid
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner Join A_NumberPlanAction na on na.NumId = np.Id
					Inner Join A_Rules r on na.ExtraId = r.Id
					Inner Join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner Join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end

			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select Id From A_View_ServerIntLinesAll


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t Inner Join 
					@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 Inner Join 
					A_Users u on u.id = AUserId
				Group by prefix
					
				Union all

					Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t Inner Join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 Inner Join 
					A_Users u on u.id = BUserId
				Group by prefix
					
				Union all

					Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t Inner Join 
					@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = ALineId
				Group by prefix
					
				Union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t Inner Join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix

		end
	--EStatisticsViewMode.svmByWeekDay:
	else if ( @mode = 5 )
		begin
		
			--   
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-12')
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-13')
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-14')
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-15')
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-16')
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-17')
			insert into #tempstatisticsflash (id, Timestart)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-18')
			
			--select * from #tempstatisticsflash
			select (DatePart(dw, TimeStart)+5)%7 as WDay, count(*)-1 as count_
			From #tempstatisticsflash
			Group by (DatePart(dw, TimeStart)+5)%7
			Order by WDay
		end

	delete From #tempstatisticsflash
	delete From #tempstatistics

end
GO


