﻿--W_Clients_ClientDelete
--W_Clients_ClientView
--W_Clients_ClientEdit
--W_Clients_ClientGetAll
--W_Clients_ContactAdd
--W_Clients_ContactDelete
--W_Clients_ContactTypesGet
--W_Clients_GroupsGet
--W_Clients_HistoryGet
--W_Clients_InfoEdit
--W_Clients_InfoGet
--W_Clients_InfoTypeEdit
--W_Clients_InfoTypeGetAll
--W_Clients_RightsGet
--W_Clients_RightsSet

---------------------------------------------------------------------------
------------------Изменение и создание таблиц------------------------------
---------------------------------------------------------------------------

--A_Clients

if not exists(	select *
				from information_schema.columns
				where table_name = 'A_Clients' and column_name='isdeleted')
alter TABLE [dbo].A_Clients
add isdeleted [bit]
GO
---------------------
--W_ClientInfo-------
---------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_ClientInfo]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].W_ClientInfo
GO

CREATE TABLE [dbo].W_ClientInfo(
	[id] [uniqueidentifier] NOT NULL,
	[IdClient] [uniqueidentifier] NOT NULL,
	[IdType] [uniqueidentifier] NOT NULL,
	[Value] [nvarchar] (4000) NULL,
	[isdeleted] [bit] null
) 
GO
--------------------
--W_ClientInfoFields
--------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_ClientInfoTypes]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].W_ClientInfoTypes
GO

CREATE TABLE [dbo].W_ClientInfoTypes(
	[IdType] [uniqueidentifier] NOT NULL,
	[Order] [int] null,
	[Name] [nvarchar] (4000) NULL,
) 
GO
-----------------
--A_ClientHistory
-----------------
if not exists(	select *
				from information_schema.columns
				where table_name = 'A_ClientHistory' and column_name='idconn')
alter TABLE [dbo].A_ClientHistory
add idconn [uniqueidentifier]
GO

if not exists(	select *
				from information_schema.columns
				where table_name = 'A_ClientHistory' and column_name='isdeleted')
alter TABLE [dbo].A_ClientHistory
add isdeleted [bit]
GO

--тут может упасть если pk называется по другому
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_ClientHistory]') AND name = N'PK_A_ClientHistory')
begin
	ALTER TABLE [dbo].[A_ClientHistory] DROP CONSTRAINT [PK_A_ClientHistory]
	ALTER TABLE [dbo].[A_ClientHistory] ADD  CONSTRAINT [PK_A_ClientHistory] PRIMARY KEY nonCLUSTERED 
	(
		[Id] ASC
	) 
	
end
GO

--тут может упасть если уже есть кластерный индекс
IF  not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_ClientHistory]') AND name = N'A_ClientHistory_creationdate')
CREATE CLUSTERED INDEX [A_ClientHistory_creationdate] ON [dbo].[A_ClientHistory] 
(
	[CreationDateTime] ASC
)WITH FILLFACTOR = 95 ON [PRIMARY]
GO
----------------------
--A_ClientContactTypes
----------------------
if not exists(	select *
				from information_schema.columns
				where table_name = 'A_ClientContactTypes' and column_name='web')
begin
	alter TABLE [dbo].A_ClientContactTypes
	add web [bit]
end
GO

if not exists(	select *
				from A_ClientContactTypes
				where id = 'FAF439A4-0491-42EC-A955-0B3D30F1A324')
begin
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('FAF439A4-0491-42EC-A955-0B3D30F1A324', 'Телефон', 1, 1)
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('FCA247FF-D1D7-4088-A852-3044AF23702E','Сотовый', 1, 1)
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('F31900B1-634A-45FA-A3FD-16F0ABA788FC','Факс', 0, 1)
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('4E91DAF0-817F-4276-AA85-4604C56E0E5A','E-mail', 0, 1)
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('300834E3-6E73-406E-8418-ABC49F1AB30E','Skype', 0, 1)
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('41B40290-65A1-4B1B-B13C-19A125C04697','ICQ', 0, 1)
	insert into A_ClientContactTypes ( [Id], [Name], IsPhoneNumber , web) Values ('90A7B580-4536-41CC-88BF-9DC4F05B1525','Сайт', 0, 1)
end
GO

------------------
--A_ClientContacts
------------------
if not exists(	select *
				from information_schema.columns
				where table_name = 'A_ClientContacts' and column_name='comment')

	alter TABLE [dbo].A_ClientContacts
	add comment [nvarchar] (200)
GO

if not exists(	select *
				from information_schema.columns
				where table_name = 'A_ClientContacts' and column_name='number')

	alter TABLE [dbo].A_ClientContacts
	add number nvarchar(200)
GO

if not exists(	select *
				from information_schema.columns
				where table_name = 'A_ClientContacts' and column_name='isdeleted')

	alter TABLE [dbo].A_ClientContacts
	add isdeleted bit
GO

--удаляем старую процедуру и создаем новую, которая не удаляет дефолтные типы контактов
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Clients_Contacts_Type_Delete]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Clients_Contacts_Type_Delete]
GO

create procedure [dbo].[A_Clients_Contacts_Type_Delete]
	@id	uniqueidentifier
As
begin
	Delete 
	From A_ClientContactTypes 
	Where [Id] = @id
    and web != 1 or web is null
end
GO

------------------------------------------------------------
-------------------------- права ---------------------------
------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_ClientRights]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].W_ClientRights
GO

CREATE TABLE [dbo].W_ClientRights(
	[IdClient] [uniqueidentifier] NULL,
	[IdOwner] [uniqueidentifier] null,
	[Canedit] bit NULL,
) 
GO

--select * from W_ClientRights 
--select * from A_Clients

insert into W_ClientRights (idclient, idowner, canedit)
select id, ownerid, 1
from A_Clients


------------------------------------------------------------
-------------------------- группы --------------------------
------------------------------------------------------------
----клиент может быть только в одной группе
--select id 
--into #oldids
--from A_Clients_groups
--where IdClient in (
--		select idclient
--		from A_Clients_groups
--		group by idclient
--		having count (*) > 1)
--		--and IdGroup in
		
--insert into A_Clients_groups (Id, IdClient, idgroup)
--select	newid() id
--		,idclient
--		,idgroup = (select top 1 IdGroup 
--						from  A_Clients_groups cg
--						left join A_ClientGroups g
--						on cg.IdGroup = g.Id
--						where cg.IdClient = cg1.IdClient
--						order by ownerid)

--from A_Clients_groups cg1
--group by idclient
--having count (*) > 1

--delete 
--from A_Clients_groups
--where ID in (select * from #oldids)

--drop table #oldids

----чтобы нельзя было добавить клиента в две и более групп - надо лезть в код
----все группы стали общими
--update A_clientGroups
--set Ownerid = '00000000-0000-0000-0000-000000000000'

------------------------------------------------------------
-------------------------- Процедуры -----------------------
------------------------------------------------------------
------------------------------------------------------------
------------------- W_Clients_ClientGetAll -----------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ClientGetAll]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ClientGetAll
GO

create Procedure [dbo].W_Clients_ClientGetAll
@authorizeduserid	uniqueidentifier,
@idGroup uniqueidentifier = null,	
@first INT = null, 
@count INT = null, 
@text nvarchar (2000) = null
as
begin
		
	--security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	select distinct idclient 
	into #viewedclients	
	from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
	
	if (@text is null)
	begin
		select identity (int,1,1) rownumber
						,idclient
						,idGroup
						,defaultPhone
						,defaultPhonenumbers
						,defaultPhoneid
						,[idtype]
						,Name
		into #temp					
		from (
			select		 c.id idClient
						, isnull((select top 1 idGroup from A_Clients_Groups where idclient = c.id), '00000000-0000-0000-0000-000000000000') idGroup
						, cc.content defaultPhone
						, cc.number defaultPhonenumbers
						, cc.id defaultPhoneid
						, [idtype] = case 
							when (ct.web != 1 or ct.web is null) and ct.isphoneNumber = 1 then 'FAF439A4-0491-42EC-A955-0B3D30F1A324' -- телефон
							when (ct.web != 1 or ct.web is null) and ct.isphoneNumber = 0 then '90A7B580-4536-41CC-88BF-9DC4F05B1525' -- сайт
							else cc.idContact end 
						, c.Name 

			from A_clients c
			inner join #viewedclients vc
			on vc.idclient = c.id
			left join A_ClientContacts cc
			on cc.idclient = c.id and cc.isdefaultphone = 1 and (cc.isdeleted is null or cc.isdeleted = 0) 
			left join A_ClientContactTypes ct
			on cc.idContact = ct.id
			where (c.isdeleted is null or c.isdeleted = 0)
			--where (ownerid = '00000000-0000-0000-0000-000000000000' or ownerid = @authorizeduserid)--личные клиенты фильтруются в правах
		) t1
		where (@idGroup is null or idGroup = @idGroup)
		order by Name
	
		if (@first is null or @count is null)
			select * from #temp
		else 
		begin
			select * from #temp
			WHERE rownumber between @first and @first+@count-1
		end
		drop table #temp
	end 
	else 
	begin
				select identity (int,1,1) rownumber
						,idclient
						,idGroup
						,Name
		into #temp1					
		from (
			select		 id idClient
						, isnull((select top 1 idGroup from A_Clients_Groups where idclient = c.id), '00000000-0000-0000-0000-000000000000') idGroup
						, Name 

			from A_clients c
			inner join #viewedclients vc
			on vc.idclient = c.id
			where (isdeleted is null or isdeleted = 0)
			--where (ownerid = '00000000-0000-0000-0000-000000000000' or ownerid = @authorizeduserid)--личные клиенты фильтруются в правах
		) t1
		where (@idGroup is null or idGroup = @idGroup)
		and (Name like '%[ "#@№(-:;.,«'']' + @text + '%' or Name like @text + '%')		
		order by Name

		if (@first is null or @count is null)
			select * from #temp1
		else 
		begin
			select * from #temp1
			WHERE rownumber between @first and @first+@count-1
		end
		drop table #temp1
	end
	drop table #viewedclients
end

GO

------------------------------------------------------------
------------------ [W_Clients_GroupsGet] ---------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_GroupsGet]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Clients_GroupsGet]
GO

CREATE Procedure [dbo].[W_Clients_GroupsGet]
	@authorizeduserid		uniqueidentifier
as
begin
	--security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	--select distinct cr.idclient 
	--into #viewedclients	
	--from W_ClientRights  cr
	--inner join  W_Clients c
	--	on c.id = cr.idclient and (c.isdeleted is null or c.isdeleted = 0)
	--where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')

	select c.id [idclient]
	into #viewedclients	
	from A_Clients c
	where exists (select * from W_ClientRights cr where c.id = cr.idclient and (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000'))
	and (c.isdeleted is null or c.isdeleted = 0)
	
	SELECT [Id][IdGroup]
		  ,[Name]
		  ,isnull(t1.count,0) [count]
	FROM [dbo].[A_ClientGroups] cg
	left join 
	(
	select idgroup, count (*) count
	from  A_clients_groups cg
	inner join #viewedclients vc
	on vc.[idclient] = cg.idclient
	group by  idgroup	
	) t1
	on cg.[Id] = t1.idgroup
	--Where OwnerId = @authorizeduserid
	--	Or OwnerId = '00000000-0000-0000-0000-000000000000'
	order by name

end
GO

------------------------------------------------------------
-------------- [W_Clients_ContactGetAll] ---------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ContactGetAll]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ContactGetAll
GO

CREATE Procedure [dbo].W_Clients_ContactGetAll
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier
as
begin

	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient))
	begin	
		select	cc.id, 
				cc.idClient, 
				[idType] = case 
						when (ct.web != 1 or ct.web is null) and ct.isphoneNumber = 1 then 'FAF439A4-0491-42EC-A955-0B3D30F1A324' -- телефон
						when (ct.web != 1 or ct.web is null) and ct.isphoneNumber = 0 then '90A7B580-4536-41CC-88BF-9DC4F05B1525' -- сайт
						else cc.idContact end, 
				cc.Content [Value], 
				cc.number,
				cc.isDefaultphone ,
				cc.comment 
				--дебаг ,ct.*
		from A_ClientContacts cc
			left join A_ClientContactTypes ct
			on cc.idContact = ct.id
		where idclient = @idClient
		and (cc.isdeleted is null or cc.isdeleted !=1)
	end
end
GO

------------------------------------------------------------
------------------ [W_Clients_ClientView] ------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ClientView]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ClientView
GO

CREATE Procedure [dbo].W_Clients_ClientView
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier
as
begin

	--клиент мог быть удален
	if exists( select * from A_Clients where id = @idClient and isdeleted = 1)
		return
		
	----security
	declare @authorizedusergroupid uniqueidentifier, @editable int
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient))
	begin
		select @editable = canedit from W_ClientRights 
		where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
			and idclient = @idClient and canedit = 1
		
		select
			(select name from A_Clients where id = @idClient) name,
			(select top 1 idGroup from A_Clients_Groups where idClient = @idClient) idGroup,
			@editable editable
		
		select top 1 
			ch.id
			,content
			,creationdatetime
			,(select count (*) from A_ClientHistory where idclient = @idClient and (isdeleted is null or isdeleted = 0))[historycount]
			, u.name
		from A_ClientHistory ch
			left join A_users u
			on ch.iduser = u.id
		where idclient = @idClient
			and (ch.isdeleted is null or ch.isdeleted = 0)
		order by creationdatetime desc
		
		exec [dbo].W_Clients_ContactGetAll
		@authorizeduserid,
		@idClient
	end
end
GO

------------------------------------------------------------
-------------- [W_Clients_HistoryGet] ----------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_HistoryGet]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_HistoryGet
GO

CREATE Procedure [dbo].W_Clients_HistoryGet
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient))
	begin	
		SELECT ch.[Id]
			  ,ch.[IdClient]
			  ,ch.[CreationDateTime]
			  ,ch.[Content]
			  ,ch.[IdUser]
			  ,ch.[idconn]
			  ,datediff(ss, x1.timestart, x1.timestop) [len]
		  FROM [dbo].[A_ClientHistory] ch
			  left join A_stat_connections_1x1 x1 
			  on x1.id = ch.idconn
		  where ch.[IdClient] = @idClient
			 and (isdeleted is null or isdeleted = 0)
	end
end
GO

------------------------------------------------------------
-------------- [W_Clients_HistoryAdd] ----------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].W_Clients_HistoryAdd') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_HistoryAdd
GO

CREATE Procedure [dbo].W_Clients_HistoryAdd	
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier,
	@value	nvarchar (2000),
    @idConn uniqueidentifier = null
    
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		declare @id uniqueidentifier, @insertdate datetime
		select @id = newID(), @insertdate = getdate()
		insert into dbo.A_ClientHistory (id, idClient, creationdatetime, content, iduser, idConn)
		values (@id, @idClient, @insertdate, @value, @authorizeduserid, @idConn)

		select @id [id], @insertdate [insertdate]
		--select * from dbo.A_ClientHistory
	end
end
GO


------------------------------------------------------------
-------------- [W_Clients_HistoryEdit] ---------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].W_Clients_HistoryEdit') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_HistoryEdit
GO

CREATE Procedure [dbo].W_Clients_HistoryEdit
	@authorizeduserid uniqueidentifier,
	@idNote uniqueidentifier = null,
	@idClient uniqueidentifier,
	@value	nvarchar (2000),
    @idConn uniqueidentifier = null
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		if (@idNote is null) -- создание
		begin
			declare @id uniqueidentifier, @insertdate datetime
			select @id = newID(), @insertdate = getdate()
			insert into dbo.A_ClientHistory (id,idclient,Creationdatetime,content, iduser, idconn)
			values (@id, @idClient, @insertdate, @value, @authorizeduserid, @idConn)

			select @id [id], @insertdate [insertdate]
			--select * from dbo.A_ClientHistory
		end
		else if (@value = '') -- удаление
		begin
			update dbo.A_ClientHistory
			set isdeleted = 1
			where id = @idNote
			select @@rowcount result
		end
		else --изменение
		begin 
			update dbo.A_ClientHistory
			set  content = @value,
			idConn = @idConn
			where id = @idNote
			
			if (@@rowcount > 0)
				select @id [id], @insertdate [insertdate]
		end
	end
end
GO

------------------------------------------------------------
-------------- [W_Clients_HistoryDel] ----------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].W_Clients_HistoryDel') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_HistoryDel
GO

CREATE Procedure [dbo].W_Clients_HistoryDel
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier,
	@idNote uniqueidentifier,
	@del bit
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		if (@del=1) -- удаление
		begin
			update dbo.A_ClientHistory
			set isdeleted = 1
			where id = @idNote
			select @@rowcount result
		end
		else --восстановление
		begin 
			update dbo.A_ClientHistory
			set isdeleted = 0
			where id = @idNote
			select @@rowcount result
		end
	end
end
GO


------------------------------------------------------------
--------------------- [W_Clients_ClientEdit] ----------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ClientEdit]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ClientEdit
GO

CREATE Procedure [dbo].W_Clients_ClientEdit
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier = null, --айди клиента (guid). Может быть пустым, в таком случае создается новый клиент
    @clientName	nvarchar (2000) = null, --название клиента (string)
    @idGroup uniqueidentifier = null, --айди категории клиентов (guid) Может быть пустым. В таком случае создается новая категория, если уже нет категории с таким же названием
    @groupName	nvarchar (2000) = null, --название категории клиентов (string). может быть пустым, в таком случае айди будет непустым
	@editType int = null -- {0-только я, 1-моя группа, 2-вся компания}
as
begin

		----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid

	--если ид и название группы пустое - создаем клиента без группы
	if (@idGroup is null and (@groupName is null or @groupName = ''))
		select @idGroup = '00000000-0000-0000-0000-000000000000'
	
	if (@idGroup is null)
	begin 
		--создание новой группы
		select @idGroup = newid()
		insert into A_Clientgroups
		values (@idGroup, @groupName, '00000000-0000-0000-0000-000000000000')
		if (@@rowcount = 0)
			select @idGroup = null
	end	
	
	if (@idClient is null)
	begin 
		--создание нового клиента
		select @idClient = newid()
		insert into A_clients (id, name, ownerid)
		values (@idClient, @clientName, '00000000-0000-0000-0000-000000000000')
		if (@@rowcount = 0)
			select @idClient = null
		else 
		begin
			--устанавливаем права на нового клиента
			if (@editType = 1)
				insert into W_ClientRights (idclient, idowner, canedit)
				values (@idClient, @authorizedusergroupid, 1)		
			else if (@editType = 2)
				insert into W_ClientRights (idclient, idowner, canedit)
				values (@idClient, '00000000-0000-0000-0000-000000000000', 1)	
			else
				insert into W_ClientRights (idclient, idowner, canedit)
				values (@idClient, @authorizeduserid, 1)	
				
			--добавляем клиента в группу
			insert into A_Clients_Groups
			values (newid(), @idClient, @idGroup)
		end
	end
	else
	begin
		----security
		if (exists(select * from W_ClientRights 
		where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
			and idclient = @idClient and canedit = 1))
		begin
		--изменение данных клиента
			update A_clients
			set Name = @clientName
			where id = @idClient
			
			--удаляем все старые группы
			delete from A_Clients_Groups
			where idclient = @idClient
			
			--добавляем клиента в группу
			insert into A_Clients_Groups
			values (newid(), @idClient, @idGroup)
			
		end
		else return
	end
	select @idClient [idClient], @idGroup [idGroup]
end
GO

------------------------------------------------------------
------------------ [W_Clients_ClientDelete] ----------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ClientDelete]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ClientDelete
GO

create Procedure [dbo].W_Clients_ClientDelete
@authorizeduserid	uniqueidentifier,
@idClient uniqueidentifier,	
@del bit
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		if (@del=1) -- удаление
		begin
			update dbo.A_Clients
			set isdeleted = 1
			where id = @idClient
			select @@rowcount result
		end
		else --восстановление
		begin 
			update dbo.A_Clients
			set isdeleted = 0
			where id = @idClient
			select @@rowcount result
		end
	end
end
GO

------------------------------------------------------------
--------------- [W_Clients_ContactTypesGet] ----------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ContactTypesGet]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Clients_ContactTypesGet]
GO

CREATE Procedure [dbo].[W_Clients_ContactTypesGet]
	@authorizeduserid		uniqueidentifier
as
begin
	SELECT [Id]
		  ,[Name]
		  ,[IsPhoneNumber]
	FROM [dbo].[A_ClientContactTypes]
	where web is not null or web != 0
	--Where OwnerId = @authorizeduserid
	--	Or OwnerId = '00000000-0000-0000-0000-000000000000'
end

GO

------------------------------------------------------------
------------------ [W_Clients_ContactAdd] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ContactAdd]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ContactAdd
GO

CREATE Procedure [dbo].W_Clients_ContactAdd
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier,
	@idContact uniqueidentifier = null,-- айди контакта (guid). Может быть пусто. В этом случае создается новый контакт.
    @comment nvarchar (2000) = null, --название контакта (string). Может быть пусто. В этом случае айди типа будет непустым
    @idType uniqueidentifier, -- id типа контакта
    @contactValue nvarchar (2000), --значение (string)
    @isDefaultPhone bit --телефон по умолчанию? (bool)
as
begin
	--1) Редактировать контакт: можно сменить значение, коммент, тип или нопер по умолчанию по @idContact.
	--2) Создать новый контакт
	
	--debug
	--declare @authorizeduserid uniqueidentifier,
	--		@idClient uniqueidentifier,
	--		@idContact uniqueidentifier ,-- айди контакта (guid). Может быть пусто. В этом случае создается новый контакт.
	--		@comment nvarchar (2000), --название контакта (string). Может быть пусто. В этом случае айди типа будет непустым
	--		@idType uniqueidentifier, -- id типа контакта
	--		@contactValue nvarchar (2000), --значение (string)
	--		@isDefaultPhone bit --телефон по умолчанию? (bool)
			
	--select
	--		@authorizeduserid = '33c2050a-712b-4037-805b-728a18ad1b98',
	--		@idClient = '0ef85181-4f97-4335-a549-2ff554cf52eb',
	--		@comment = '',
	--		@idType ='faf439a4-0491-42ec-a955-0b3d30f1a324',
	--		@contactValue='5247248',
	--		@isDefaultPhone = 0

	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin			
		if (@idContact is not null) -- редактируем существующий контакт
			begin
				--если устанавливаем новый номер по умолчанию
				if (@isDefaultPhone = 1)
					update A_ClientContacts
					set isDefaultPhone = 0
					where idClient = @idClient
					
				--если удаляем контакт
				if(@contactValue = '')
				begin
					--delete from A_ClientContacts
					--where id = @idContact
					--select @@rowcount result
					return
				end
				else
				begin					
					if exists (select * from A_ClientContactTypes where isphonenumber = 1 and id = @idType)
					begin
						update A_ClientContacts
						set content = @contactValue,
							number = [dbo].[GetNumber](@contactValue),
							comment = @comment, 
							idContact = @idType,
							isDefaultPhone = @isDefaultPhone
						where idclient = @idClient
						and id = @idContact
						
						if (@@rowcount = 0)--(not exists (select * from A_ClientContacts where id = @idContact))
						insert into A_ClientContacts (id, idclient, idcontact, content, isdefaultphone, comment, number)
						values (@idContact, @idClient, @idType, @contactValue, @isDefaultPhone, @comment, [dbo].[GetNumber](@contactValue))
					end
					else
					begin
						update A_ClientContacts
						set content = @contactValue,
							comment = @comment, 
							idContact = @idType,
							isDefaultPhone = @isDefaultPhone
						where idclient = @idClient
						and id = @idContact
						
						if (@@rowcount = 0)--(not exists (select * from A_ClientContacts where id = @idContact))
						insert into A_ClientContacts (id, idclient, idcontact, content, isdefaultphone, comment)
						values (@idContact, @idClient, @idType, @contactValue, @isDefaultPhone, @comment)
					end
				end
			end
		else if (@comment is not null and @idContact is null) -- создаем новый контакт
			begin
			select	@idContact = newid()		
			
			if (@isDefaultPhone = 1)
				update A_ClientContacts
				set isDefaultPhone = 0
				where idClient = @idClient
				
			insert into A_ClientContacts (id, idclient, idcontact, content, isdefaultphone, comment, number)
			values (@idContact, @idClient, @idType, @contactValue, @isDefaultPhone, @comment, [dbo].[GetNumber](@contactValue))
			end
		
		select @idContact [idContact]
	end
end
GO

------------------------------------------------------------
---------------- [W_Clients_ContactDelete] -----------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_ContactDelete]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_ContactDelete
GO

create Procedure [dbo].W_Clients_ContactDelete
@authorizeduserid	uniqueidentifier,
@idClient uniqueidentifier,	
@idContact uniqueidentifier,
@del bit
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		if (@del=1) -- удаление
		begin
			update dbo.A_ClientContacts
			set isdeleted = 1
			where id = @idContact
			select @@rowcount result
		end
		else --восстановление
		begin 
			update dbo.A_ClientContacts
			set isdeleted = 0
			where id = @idContact
			select @@rowcount result
		end
	end
end
GO

------------------------------------------------------------
-------------- [W_Clients_InfoGet] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_InfoGet]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_InfoGet
GO

CREATE Procedure [dbo].W_Clients_InfoGet
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier
as
begin

	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient))
	begin	
		select ci.id, idclient, idtype, value 
		from W_ClientInfo ci, A_Clients c
		where idclient = @idClient 
		and c.id = idclient
		and (c.isdeleted is null or c.isdeleted = 0)
	end
end
GO

------------------------------------------------------------
--------------- [W_Clients_InfoTypeGetAll] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_InfoTypeGetAll]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_InfoTypeGetAll
GO

CREATE Procedure [dbo].W_Clients_InfoTypeGetAll
as
begin
	SELECT [IdType]
		  ,[Name]
		  ,[order]
	FROM [dbo].[W_ClientInfoTypes]
	order by [order]
	--return 0
end
GO

------------------------------------------------------------
---------------- [W_Clients_InfoEdit] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_InfoEdit]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Clients_InfoEdit]
GO

create Procedure [dbo].W_Clients_InfoEdit
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier,
    @idField uniqueidentifier = null,--	айди поля анкеты (guid) . 
    @idType uniqueidentifier = null,	 --	айди типа поля анкеты (guid) . 
    @typeName nvarchar (2000) = null,
    @value nvarchar (2000),		--	текст поля (string)
    @order int = null					--	порядок (int)
as
begin

	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		--если ид и название поля пустое - создаем поля "новое поле"
		if (@idType is null and (@typeName is null or @typeName = ''))
			select @typeName = 'Новое поле'
		
		if (@idType is null) --если такого поля еще нет
		begin 
			--создание нового поля
			select @idType = newid()
			
			select @order = max ([order]) +1
			from W_ClientInfoTypes
			
			insert into W_ClientInfoTypes
			values (@idType, isnull(@order,0), @typeName)
			if (@@rowcount = 0)
				select @idType = null
		end	
		else
		begin
			--обновляем или задаем существующее поле
			update W_ClientInfo
			set Value = @value
			where id = @idField
			
			if (@@rowcount = 0)
			begin
				select @idField = newid()
				insert into W_ClientInfo (id, idClient,idType, value)
				values (@idField, @idClient,@idType, @value)
			end
		end
		select @idType [idType], @idField [idfield]
	end
end
GO

------------------------------------------------------------
---------------- [W_Clients_InfoDelete] -----------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_InfoDelete]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_InfoDelete
GO

create Procedure [dbo].W_Clients_InfoDelete
@authorizeduserid	uniqueidentifier,
@idClient uniqueidentifier,	
@idField uniqueidentifier,
@del bit
as
begin
	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		if (@del=1) -- удаление
		begin
			update dbo.W_ClientInfo
			set isdeleted = 1
			where id = @idField
			select @@rowcount result
		end
		else --восстановление
		begin 
			update dbo.W_ClientInfo
			set isdeleted = 0
			where id = @idField
			select @@rowcount result
		end
	end
end
GO


------------------------------------------------------------
---------------- [W_Clients_InfoTypeEdit] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_InfoTypeEdit]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Clients_InfoTypeEdit]
GO

create Procedure [dbo].W_Clients_InfoTypeEdit
	@authorizeduserid uniqueidentifier,
    @idType uniqueidentifier,	--	айди поля анкеты (guid) . Может быть пустым, в таком случае создается новое поле, если нет поля с таким же названием
    @typeName nvarchar (2000)	 ,	--	название поля (string). Может быть пустым. в таком случае айди поля будет непустым
   -- @value nvarchar (2000),		--	текст поля (string)
    @order int					--	порядок (int)
as
begin
	------security
	--declare @authorizedusergroupid uniqueidentifier
	--select @authorizedusergroupid = parentgroupid 
	--from A_users
	--where id = @authorizeduserid
	
	--if (exists(select * from W_ClientRights 
	--where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
	--	and idclient = @idClient and canedit = 1))
	--begin	
		--если ид и название поля пустое - создаем поля "новое поле"
		if (@idType is null and (@typeName is null or @typeName = ''))
			select @typeName = 'Новое поле'
		
		if (@idType is null)
		begin 
			--создание нового поля
			select @idType = newid()
			
			update W_ClientInfoTypes
			set [order] = [order]+1
			where [order] >= @order
			
			insert into W_ClientInfoTypes
			values (@idType, @order, @typeName)
			if (@@rowcount = 0)
				select @idType = null
		end	
		else
		begin
			update W_ClientInfoTypes
			set [order] = [order]+1
			where [order] >= @order
			
			update W_ClientInfoTypes
			set [order] = @order, NAME = @typeName
			where idType = @idType
		end
		select @idType [idType]
	--end
end
GO

------------------------------------------------------------
---------------- [W_Clients_RightsSet] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_RightsSet]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_RightsSet
GO

create Procedure [dbo].W_Clients_RightsSet
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier,
    @idOwner uniqueidentifier,
    @canView bit,
    @canEdit bit 
as
begin

	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient and canedit = 1))
	begin	
		if (@canView = 0)
		begin
			delete from [dbo].W_ClientRights 
			where idclient = @idClient
			and idOwner = @idOwner
			select @@rowcount result
		end
		else
		begin
			update [dbo].W_ClientRights 
			set canedit = @canedit
			where idclient = @idClient
			and idOwner = @idOwner
			
			if (@@rowcount = 0)
			insert into [dbo].W_ClientRights (idclient, idowner, canedit)
			values (@idClient, @idOwner, @canedit)
			
			select @@rowcount result
		end
	end
end
GO

------------------------------------------------------------
---------------- [W_Clients_RightsGet] -------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_RightsGet]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_RightsGet
GO

create Procedure [dbo].W_Clients_RightsGet
	@authorizeduserid uniqueidentifier,
	@idClient uniqueidentifier
as
begin

	----security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @authorizeduserid
	
	if (exists(select * from W_ClientRights 
	where (idOwner = @authorizeduserid or idOwner = @authorizedusergroupid  or idOwner = '00000000-0000-0000-0000-000000000000')
		and idclient = @idClient))
	begin	
		select idclient, idowner, canedit 
		from [dbo].W_ClientRights 
		where idclient = @idClient		
	end
end
GO

------------------------------------------------------------
------------------------ [GetNumber] -----------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[GetNumber]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION [dbo].[GetNumber]
GO

CREATE   FUNCTION [dbo].[GetNumber] (@@s nvarchar(200))  
RETURNS nvarchar(200) AS  
BEGIN 
	declare @output nvarchar(200), @i int
	select @output = '', @i=1

	while @i<=len(@@s)
	begin
		if (substring(@@s,@i,1) LIKE'[0-9]')
			select @output = @output + substring(@@s,@i,1)
		else if (substring(@@s,@i,1) not in ('+','(',')','-',' '))
			break
		set @i=@i+1
	end
	return case @output when '' then null else @output end
END
GO

update A_ClientContacts 
set number = [dbo].[GetNumber](content)
where idcontact in (
select id from A_ClientContactTypes
where isphonenumber = 1 )
GO


------------------------------------------------------------
---------------- [W_Clients_GetByContact] ------------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_GetByContact]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Clients_GetByContact]
GO

CREATE  procedure [dbo].[W_Clients_GetByContact]
	@contact	nvarchar ( 255 )
as
begin

	--Declare @idclient uniqueidentifier
	--Set @idclient = '00000000-0000-0000-0000-000000000000'

	--Select @idclient = IdClient
	--From A_ClientContacts
	--Where ( Len ( Content ) >= 5 ) and (( Content like '%' + @contact ) or ( @contact like '%' + Content ))

	--if ( @@rowcount = 0 )
	--	return;

	--Select @id = cl.[Id], @name = cl.[Name]
	--From A_Clients cl
	--	Left join A_ClientContacts cc on cl.Id = cc.IdClient
	--Where cl.Id = @idclient
	--	And ( cl.OwnerId = '00000000-0000-0000-0000-000000000000' Or cl.OwnerId = @ownerid )		
		
	if (len(@contact)<5)	
	begin
		Select cl.[Id], cl.Name, cc.number, cc.comment, cc.id [idContact], cc.idContact [idType]
		into #tempcontacts
		From A_Clients cl
		left join A_ClientContacts	cc
		on cl.Id = cc.IdClient
		where (cl.isdeleted is null or cl.isdeleted = 0)
		and (cc.isdeleted is null or cc.isdeleted = 0)
		--where ( Len ( cc.number  ) = len(@contact))
		
		--select * from A_ClientContacts
		
		Select [Id], [Name], [comment],[idContact], [idType]
		from  #tempcontacts
		where ( number = @contact ) 
		drop table #tempcontacts
	end
	else
	begin
		Select cl.[Id], cl.Name, cc.number, cc.comment, cc.id [idContact], cc.idContact [idType]
		into #tempcontacts2
		From A_Clients cl
		left join A_ClientContacts	cc
		on cl.Id = cc.IdClient
		where ( Len ( cc.number  ) >= 5 )
		and (cl.isdeleted is null or cl.isdeleted = 0)
		and (cc.isdeleted is null or cc.isdeleted = 0)
		
		Select [Id], [Name], [comment],[idContact], [idType]
		from  #tempcontacts2
		where ( number = @contact ) 
		union all
		Select [Id], [Name], [comment],[idContact], [idType]
		from  #tempcontacts2
		where ( number like '%' + @contact ) or ( @contact like '%' + number )
		drop table #tempcontacts2
	end
end
GO

------------------------------------------------------------
----------- поддержка прав старым клиентом -----------------
------------------------------------------------------------
------------------------------------------------------------
--------- [A_Clients__GetFull_AllForUserFromGroup] ---------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Clients__GetFull_AllForUserFromGroup]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Clients__GetFull_AllForUserFromGroup]
GO

Create procedure [dbo].[A_Clients__GetFull_AllForUserFromGroup]
	@iduser		uniqueidentifier,
	@idgroup	uniqueidentifier
As
begin

	--security
	declare @authorizedusergroupid uniqueidentifier
	select @authorizedusergroupid = parentgroupid 
	from A_users
	where id = @iduser
	
	select distinct idclient 
	into #viewedclients	
	from W_ClientRights 
	where (idOwner = @iduser or idOwner = @authorizedusergroupid or idOwner = '00000000-0000-0000-0000-000000000000' and canedit = 1)
	
	if ( @idgroup = '00000000-0000-0000-0000-000000000000' )
	begin
		Select cl.[id], cl.[Name], cl.[Ownerid], cc.[Id]
      ,cc.[IdClient]
      ,cc.[IdContact]
      ,cc.[Content]
      ,cc.[IsDefaultPhone]
		From A_Clients cl
			Left join A_ClientContacts cc on cl.Id = cc.IdClient	
			inner join #viewedclients vc on vc.idclient = cl.id		
--		Where ( OwnerId = @iduser Or OwnerId = '00000000-0000-0000-0000-000000000000' )		
		Where ( cl.isdeleted is null or cl.isdeleted = 0)	
			and ( cc.isdeleted is null or cc.isdeleted = 0)		
	
		Order by cl.id
	end
	else
	begin
		Select cl.[id], cl.[Name], cl.[Ownerid] 
		,clgr.id, clgr.idclient, clgr.idgroup
		,cc.[Id]
		,cc.[IdClient]
		,cc.[IdContact]
		,cc.[Content]
		,cc.[IsDefaultPhone]
		From A_Clients cl
			Inner join A_Clients_Groups clgr on cl.Id = clgr.IdClient
			Left join A_ClientContacts cc on cl.Id = cc.IdClient
			inner join #viewedclients vc on vc.idclient = cl.id		
		Where --( OwnerId = @iduser Or OwnerId = '00000000-0000-0000-0000-000000000000' )And
			 clgr.IdGroup = @idgroup
			 and ( cl.isdeleted is null or cl.isdeleted = 0)
			 and ( cc.isdeleted is null or cc.isdeleted = 0)		
		
		Order by cl.id
	end	

end

GO

------------------------------------------------------------
--------- [dbo].[A_Clients_History_Add] ---------
------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Clients_History_Add]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Clients_History_Add]
GO

CREATE procedure [dbo].[A_Clients_History_Add]
	@id			uniqueidentifier,
	@idclient		uniqueidentifier,
	@creationdatetime	datetime,
	@content		nvarchar ( 1000 ),
	@iduser			uniqueidentifier
As
begin
	Insert 
	Into A_ClientHistory ( [Id], IdClient, CreationDateTime, Content, IdUser )
	Values ( @id, @idclient, @creationdatetime, @content, @iduser )
end
GO

------------------------------------------------------------
--------- [dbo].[A_Clients_History_Delete] ---------
------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Clients_History_Delete]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Clients_History_Delete]
GO

CREATE procedure [dbo].[A_Clients_History_Delete]
	@id	uniqueidentifier
As
begin
	Update A_ClientHistory
	set isdeleted = 1
	Where [Id] = @id
end
GO

------------------------------------------------------------
--------- [dbo].[A_Clients_History_GetForClient] ---------
------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Clients_History_GetForClient]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Clients_History_GetForClient]
GO

create procedure [dbo].[A_Clients_History_GetForClient]
	@idclient	uniqueidentifier,
	@startdatetime	datetime,
	@stopdatetime	datetime

As
begin
	Select ch.[Id]
      ,ch.[IdClient]
      ,ch.[CreationDateTime]
      ,ch.[Content]
      ,ch.[IdUser]
      ,IsNull ( u.Name, '' ) as UserName
	From A_ClientHistory ch
		Left join A_Users u on ch.IdUser = u.Id
	Where IdClient = @idclient
		And CreationDateTime >= @startdatetime
		And CreationDateTime <= @stopdatetime
		and (ch.isdeleted is null or ch.isdeleted = 0)
	Order by CreationDateTime Desc
end
GO


------------------------------------------------------------
------------- получение групп пользователей ----------------
------------------------------------------------------------
------------------------------------------------------------
------------- [W_Messages_GetUsersWithNumbers] -------------
------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_GetUsersWithNumbers]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_GetUsersWithNumbers]
GO

CREATE Procedure [dbo].[W_Messages_GetUsersWithNumbers]
as
begin
	select np.id [npid],np.prefix, u.id [userid], u.name , u.parentGroupId [idGroup]
	into #temp	
	from A_RuleRecords rr
	inner join
	A_NumberPlanAction as npa
	on rr.ruleid = npa.extraid and npa.numtype=0
	inner join
	A_NumberPlan as np
	on np.id=npa.numid
	right join
	A_Users as u
	on rr.reactid = u.id
	--order by np.prefix--name
	
	delete from #temp
	where prefix in (	select prefix
	from #temp
	group by prefix
	having count (*) > 1)
	
	select * from #temp
	
	drop table #temp
end

GO

------------------------------------------------------------
------------- Поддержка клиентов в статистике --------------
------------------------------------------------------------
------------------------------------------------------------
------------------ [W_Stat_MyCalls_Get] --------------------
------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_MyCalls_Get]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_MyCalls_Get]
GO

Create procedure [dbo].[W_Stat_MyCalls_Get]
	@media 		int, --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	@type 		int, --1 - входящий, 2 - исходящий, 3 - пропущенный, 10 - конф, 11 - селектор, 0 - все
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@iduser 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL,
	@first int= NULL,
	@count int= NULL
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
--declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @iduser uniqueidentifier, @comment 	nvarchar ( 4000 ),@showivr bit, @first int,@count int

--set dateformat ymd
--select @media = 0,@type = 0,
--	@iduser='64f1a6ea-3f07-4b42-8cad-19eb9e1b97cd',
--	@dstart = '2012-05-21',@dstop = '2012-05-21 23:59:59',
--	@number = '', 
--	@comment = '', @showivr=0,@first = 0,@count = 140

 create   table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					TimeAnswer DateTime, 
					TimeStop DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					IsRecorded int, 
					IdRecDir int, 
					ALineNum nvarchar ( 10 ) collate database_default, 
					BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier, 
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 100 ) collate database_default, 
					IsConf int, Director uniqueidentifier, 
					CTS DateTime,
					idclient uniqueidentifier
			
)

     
declare @filtercomment bit
set @filtercomment =  0 

Declare @id0 uniqueidentifier
Set @id0 = '00000000-0000-0000-0000-000000000000'

    -------------------------------------
    -- Коммутации -----------------------
    -------------------------------------

Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )
Select sc.Id, 
		sc.IdChain,
		null, 
		0, 
		sc.TimeStart, 
		sc.TimeAnswer, 
		sc.TimeStop, 
		sc.TimeStop - sc.TimeAnswer as Length, 
		'', 
		'', 
		IsRecorded, 
		IdRecDir, 
		ALineNum, 
		BLineNum, --ARecFile, BRecFile, 
		AUserId, 
		BUserId, 
		ALineId, 
		BLineId, 
		AOutNumber, 
		BOutNumber, 
		AStr, 
		BStr,
		0 as IsConf, 
		@id0 as Director, 
		sc.TimeStart as CTS
From A_Stat_Connections_1x1 sc --with ( TabLock )
Where sc.TimeStop is not null and
			TimeStart >= @dstart 
			and TimeStart < @dstop
			and (AUserId = @iduser  or  BUserId = @iduser)
			and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
--Order By TimeStart Desc

	-------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )

Select Idg, IdChain, 3, 3, 
TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
AOutNumber, AStr, 0, 0, 
ALineNum, BLineNum, 
AUserId, BUserId,
ALineId, BLineId,
AOutNumber, Number,
AStr, '',
0, @id0, TimeStart
From A_Stat_MissedCalls
Where ( BUserId = @iduser )
And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))

    -------------------------------------
    -- Конференции ----------------------
    -------------------------------------
   
    Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		    Select IdConn, 
			IdChain, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end,
			scc.TimeStart, 
			scc.TimeStart as TimeAnswer, 
			scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			 0,--case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, 
			LineNum, 
			sc.Room, 
			scc.IdUser, 
			@idconfuser,
			scc.IdLine, 
			IdConf,
			'', 
			'', 
			StrName, 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, 
			Director, 
			sc.TimeStart as CTS
			
		FROM A_Stat_Conference_Competitors scc	
			Inner join A_Stat_Conference sc with (index (idx_StatConf_IDConf))
			on sc.Id = scc.IdConf
			--Left join @A_Stat_Conference_tmp2 sct 
			--on sc.Id = sct.Id --фильтр по правам на прослушивание
		
		where  scc.TimeStart between @dstart and @dstop 
			and scc.IdUser = @iduser
 
	-----------------------------------
  	-- Преобразования -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @iduser
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @iduser
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @iduser and o.BUserId = u.Id ) or ( o.BUserId = @iduser and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name, idclient = c.Id
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		--and ( c.OwnerId = @iduser )

	--Update o
	--Set o.AbonentName = c.Name
	--From #output o, A_Clients c, A_ClientContacts cc
	--Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
	--	and ( c.OwnerId = @id0 )
	--	and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From #output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	--select  isnull(max (rownumber),0) 
	--from #output
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
(
	TimeStart deSC
)WITH FILLFACTOR = 100 ON [PRIMARY]

     -- Подготовка параметров
     
	Select			rownumber = identity(int,1,1),
					sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart, 
					--TimeAnswer, 
					--TimeStop, 
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					--ALineId, 
					--BLineId, 
					--ALineNum, 
					--BLineNum, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName, 
					IsRecorded, 
					IdRecDir, 
					IsConf, 
					Director, 
					CTS, 
					case When ( c.Id is null ) then 0 else 1 end as HasComment	,
					idclient
					into #out	
	From #output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where (( Media = @media ) or ( @media = 0 ) or ( Type >= 10 ))
	Order By TimeStart Desc
	select * from #out
	where rownumber between @first and @first + @count-1	
drop table #out
drop table #output
end
GO

------------------------------------------------------------
------------------ [W_Messages_GetUsers] -------------------
------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_GetUsers]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_GetUsers]
GO

Create Procedure [dbo].[W_Messages_GetUsers]
as
begin

	select u.id [userid], u.name 
	from A_users u

end
GO
