﻿If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnId' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnId] int default 0
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnString' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnString] nvarchar(1000) default ''
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnString' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnString] nvarchar(1000) default ''
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnMode' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnMode] int default 1
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    begin
      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbConnId = 0
      Where DbConnId is null

      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbConnString = ''
      Where DbConnString is null

      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbConnMode = 1
      Where DbConnMode is null
    end
    

if Exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_Lists' ))
	Drop view dbo.A_TaskManager_Lists
GO

Create View dbo.A_TaskManager_Lists 
as
 	Select * 
	From oktell_settings.dbo.A_TaskManager_Lists
GO



if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_Save' ))
	Drop procedure dbo.A_TaskManager_List_Save
GO

Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@getviewedfromtable bit = 1,
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 ),
	@dbconnid int = 0,
	@dbconnstring nvarchar(1000) = '',
	@dbconnmode int = 0
as
begin
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	-- если это локальная таблица, и изменено ее имя
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		Name 			= @name,
		Description 		= @description,
		ProjectId 		= @idproject,
		Type 			= @type,
		Query 			= @query,
		JoinedTable 		= @joinedtable,
		GetViewedFromTable	= @getviewedfromtable,
		ColumnId 		= @columnid,
		ColumnsPhone 		= @columnsphone,
		ColumnName 		= @columnname,
		ColumnsViewed 		= @columnsviewed,
		ColumnsViewedDescription = @columnsvieweddescription,
		ColumnsSqlType 		= @columnssqltype,
		ColumnsSqlTypeSize 	= @columnssqltypesize,
		DbConnId		= @dbconnid,
		DbConnString		= @dbconnstring,
		DbConnMode		= @dbconnmode
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, GetViewedFromTable, ColumnId, ColumnsPhone, ColumnName, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize, DbConnId, DbConnString, DbConnMode )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @getviewedfromtable, @columnid, @columnsphone, @columnname, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize, @dbconnid, @dbconnstring, @dbconnmode )
end
GO


if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_GetInfo' ))
	Drop procedure dbo.A_TaskManager_List_GetInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@id uniqueidentifier
as
begin

	Select Id, Name, Description, ProjectId, Type, 
		Query, JoinedTable, ColumnId, ColumnsPhone, 
		ColumnName, ColumnsViewed, ColumnsViewedDescription,
		ColumnsSqlType, ColumnsSqlTypeSize,
		GetViewedFromTable,
		DbConnId, DbConnString, DbConnMode
	From A_TaskManager_Lists
	Where Id = @id or ProjectId = @id
	Order by Name
end
GO



if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
	@taskid uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 200 ),
	@table nvarchar ( 200 ),
	@query nvarchar ( 4000 ) = '',
	@colphone nvarchar ( 100 ),
	@colid nvarchar ( 100 ),
	@checkcondition nvarchar ( 1000 )
as
begin

	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--проверку на наличие поля телефона нельзя провести в общем случае, так как таблица в другой базе может быть. Sysobjects другой.
	--if exists ( Select * From sysobjects
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tt' ) )
		drop table #tt
	Create table #tt ( cnt int )

	Set @sql = 'Select Count ( * ) From '
	if ( Len ( @query ) > 0 )
		set @sql = @sql + ' ( ' + @query + ' ) t '
	else
		set @sql = @sql + @table + ' t '
	Set @sql = @sql + '		
		Where (' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ') and ( ' + @checkcondition + ' )'
	
	Insert into #tt
		Exec sp_executesql @sql	

	declare @cnt int
	Select @cnt = cnt from #tt

	if ( @cnt = 0 )	begin

		-- С проверкой на размер поля-приемщика
		Set @sql = ' SET ROWCOUNT 1

			Declare @prec int

			Select @prec = prec 
			From syscolumns 
			Where id = object_id ( ''' + @table + ''' )

			Declare @newdata nvarchar(4000)

			Select @newdata = ' + @colphone + ' + '', ' + @number + ''' 
			From ' + @table + '
			Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			if ( Len ( @newdata ) <= IsNull ( @prec, 10000 ) ) begin

			   Update ' + @table + '
			   Set ' + @colphone + ' = ' + @colphone + ' + '', ' + @number + '''
			   Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			end

			SET ROWCOUNT 0'


		-- Просто. Свалимся, так свалимся....
		Set @sql = ' SET ROWCOUNT 1
			
			Update ' + @table + '
			Set ' + @colphone + ' = ' + @colphone + ' + '', ' + @number + '''
			Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			SET ROWCOUNT 0'
	

		exec sp_executesql @sql


		set @sql = '
			if not exists ( select id from ' + @tableidxn + ' Where Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ' and phone = ''' + @number + ''')
				Insert into ' + @tableidxn + ' 
				Values ( ' + cast ( @idinlist as nvarchar ( 10 ) ) + ', ''' + @number + ''' )'
		
		if exists ( Select * FROM sysobjects where id = object_id ( @tableidxn ) )
			exec sp_executesql @sql

		Select 1
	end
end
GO



if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_JoinedTable_GetParams' ))
	Drop procedure dbo.A_TaskManager_List_JoinedTable_GetParams
GO

Create procedure [dbo].[A_TaskManager_List_JoinedTable_GetParams]
	@idlist 	uniqueidentifier
as
begin
	
	Select JoinedTable, Query, ColumnId, ColumnsPhone, DbConnId, DbConnString, DbConnMode 
	FROM A_TaskManager_Lists
	Where Id = @idlist
end
GO
