﻿---------------------------------------------------------------------------
-------------- Добавление полей в таблицу W_Messages_Dialogs --------------
---------------------------------------------------------------------------
If exists ( Select * From sysobjects where id = object_id ( 'W_Messages_Dialogs' ))
  If not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'W_Messages_Dialogs' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'conftimestart' )
	Alter Table dbo.W_Messages_Dialogs
	Add [conftimestart] datetime default null
GO

Update dbo.W_Messages_Dialogs 
Set conftimestart = null
GO

----------

If exists ( Select * From sysobjects where id = object_id ( 'W_Messages_Dialogs' ))
  If not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'W_Messages_Dialogs' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'confname' )
	Alter Table dbo.W_Messages_Dialogs
	Add [confname] nvarchar(250) default null
GO

Update dbo.W_Messages_Dialogs 
Set confname = null
GO

---------------------------------------------------------------------------
---------------------- Триггер W_UpdateDialogTrigger ----------------------
---------------------------------------------------------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_UpdateDialogTrigger' ))
	Drop trigger dbo.W_UpdateDialogTrigger
GO

CREATE TRIGGER [dbo].[W_UpdateDialogTrigger] 
   ON [dbo].[A_UserMessages]
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	
	declare @message nvarchar(4000), @count int
	--@iduserA uniqueidentifier,
	--@iduserB uniqueidentifier,
	--@sentdate datetime, 
	
	
	--select 	@iduserA = iduserA,
	--@iduserB = iduserB,
	--@sentdate = sentdate
	--from inserted
	Select count ( * ) 
	From inserted i
	Where i.IsConf = 0

	if ( @@rowcount = 0 )
  	  return;
	
	select @message = substring (um.message, 0, 255)
	from A_UserMessages um, inserted i
	where um.iduserA = i.iduserA
		and um.iduserB = i.iduserB
		and um.sentdate = i.sentdate
	
	update W_Messages_Dialogs 
	set sentdate = i.sentdate, 
		lastmessage = @message,
		messagecount = md.messagecount+1,
		hasnew = 0,
		fromA = 1
	from inserted i, 
		W_Messages_Dialogs md
	where (md.iduserA = i.iduserA and md.iduserB = i.iduserB)
	
	
	
	if ((select count(*) from A_UserMessages um, inserted i where um.iduserA = i.iduserB and um.iduserB = i.iduserA and um.Viewed != 1) > 0)
	begin
		Update W_Messages_Dialogs 
		set hasnew = 1 from inserted i, W_Messages_Dialogs md where md.iduserA = i.iduserA and md.iduserB = i.iduserB and hasnew = 0
	end
	
	
	update W_Messages_Dialogs 
	set sentdate = i.sentdate, 
		lastmessage = @message,
		messagecount = md.messagecount+1,
		hasnew = 1,
		fromA = 0
	from inserted i, 
		W_Messages_Dialogs md
	where (md.iduserB = i.iduserA and md.iduserA = i.iduserB)
	
	if ( @@rowcount = 0 ) begin
	
		select @count = count (*)
		from A_UserMessages um,  inserted i
		where (um.iduserA = i.iduserA and um.iduserB = i.iduserB) or (um.iduserB = i.iduserA and um.iduserA = i.iduserB)
		
		declare @conftimestart datetime
		declare @confname nvarchar(250)
		select @conftimestart = TimeStart, @confname = Name from A_Stat_Conference sc, inserted i where sc.Id = i.iduserA or sc.Id = i.iduserB
		
		insert into W_Messages_Dialogs (iduserA, iduserB, sentdate, messagecount, lastmessage, hasnew, conftimestart, confname)--
		  select iduserA,
			iduserB,
			sentdate,
			@count,
			@message,
			0,
			@conftimestart,
			@confname
		from inserted
		
		insert into W_Messages_Dialogs (iduserB, iduserA, sentdate, messagecount, lastmessage, hasnew, conftimestart, confname)--
		  select iduserA,
			iduserB,
			sentdate,
			@count,
			@message,
			1,
			@conftimestart,
			@confname
		from inserted
	end

END
GO

---------------------------------------------------------------------------
-------------------------------- Процедуры --------------------------------
---------------------------------------------------------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Messages_GetDialogs' ))
	Drop procedure dbo.W_Messages_GetDialogs
GO

Create procedure [dbo].[W_Messages_GetDialogs]
	@authorizeduserid uniqueidentifier
	,@isconf bit
	,@first int = null, @count int = null
as
begin

--declare @authorizeduserid uniqueidentifier, @first int, @count int
--select @authorizeduserid = '1654740F-0600-493B-B8FD-B09AC9A5A99C',
--@first = 1, @count  = 20
	
	select [id] = identity (int,1,1) 
			,[idUserB]
			,sentdate
			,lastmessage
			,messagecount
			,hasnew
			,fromA
			,conftimestart
			,confname
	into #temp
	from W_Messages_Dialogs
	where iduserA = @authorizeduserid 
	--where (@isconf = 0 and iduserA = @authorizeduserid and conftimestart is null) or (@isconf = 1 and iduserA = @authorizeduserid and conftimestart is not null)
	order by sentdate desc

	
	

	if (@first is null or @count is null)
			select * 
			from #temp
			--order by sentdate desc
			where (@isconf = 0 and conftimestart is null) or (@isconf = 1 and conftimestart is not null)
	else
	select * 
	from #temp
	where id between @first and @first + @count - 1 and @isconf = 0 and conftimestart is null or id between @first and @first + @count - 1 and @isconf = 1 and conftimestart is not null
	--order by sentdate desc

	drop table #temp
	
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Messages_GetLastNByDate' ))
	Drop procedure dbo.W_Messages_GetLastNByDate
GO

Create Procedure [dbo].[W_Messages_GetLastNByDate]
	@authorizeduserid	uniqueidentifier,
	@iduserb	uniqueidentifier,
	@startdate	datetime,
	@count		int
as
begin
	Create table #temp  ( 
		Inc	int identity (1,1),
		Id	uniqueidentifier,
		IdUserA uniqueidentifier,
		IdUserB	uniqueidentifier,
		SentDate DateTime,
		Message text collate database_default,
		Viewed bit--,ViewedDate DateTime 
		)

		Insert into #temp
		Select top 100 Id, IdUserA, IdUserB, SentDate, Message, Viewed --Top 100
		FROM A_UserMessages 
		Where ( ( isConf = 0 and (( IdUserA = @authorizeduserid And IdUserB = @iduserb ) or ( IdUserA = @iduserb And IdUserB = @authorizeduserid )) ) or
			( IsConf = 1 and IdUserB = @iduserb ) )
			and SentDate < @startdate
		--Order By SentDate Desc
		
		select * 
		from #temp
		where Inc <= @count
		Order by SentDate desc
		
		
		select * from [dbo].[A_UserMessageFiles]
		where [idmessage] in (select Id 
		from #temp
		where Inc <= @count
		--Order by SentDate desc
		)
		
		drop table #temp
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_FavoriteSaveByUser' ))
	Drop procedure dbo.W_FavoriteSaveByUser
GO

Create Procedure [dbo].[W_FavoriteSaveByUser]
	@order int,
	@authorizeduserid uniqueidentifier,
	@id_favorite nvarchar (2000)
as
begin
	update W_Favorite
	set [order] = [order]+1
	where id_user = @authorizeduserid and [order] >= @order
	
	update W_Favorite
	set [order] = @order
	where id_user = @authorizeduserid and [id_favorite] = @id_favorite
	
	if (@@rowcount = 0)
	begin		
		insert into W_Favorite ([order], [id_user],	[id_favorite])
		values (@order, @authorizeduserid, @id_favorite)	
	end
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_FavoriteDeleteByUser' ))
	Drop procedure dbo.W_FavoriteDeleteByUser
GO

Create Procedure [dbo].[W_FavoriteDeleteByUser]
	@authorizeduserid uniqueidentifier,
	@id_favorite nvarchar (2000)
as
begin

	delete 
	from W_Favorite
	where id_user = @authorizeduserid and id_favorite = @id_favorite

end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Stat_MyCalls_Relative' ))
	Drop procedure dbo.W_Stat_MyCalls_Relative
GO

Create procedure [dbo].[W_Stat_MyCalls_Relative]
	@authorizeduserid 	uniqueidentifier,
	@abonent uniqueidentifier ,
	@number 	nvarchar ( 50 )
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
--declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @authorizeduserid uniqueidentifier,  @abonent uniqueidentifier 

--set dateformat ymd
--set @media = 0
--set @type = 0
--set @dstart = '2011-11-01'
--set @dstop = '2011-12-06'
--set @number = ''
--select @authorizeduserid = '7a6c312a-0028-4007-beee-e73f93f9cb96'	, 
--	@abonent = 'CE293C6A-E748-45D9-8DC1-ED1E34B759FC'

 create   table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier,
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 100 ) collate database_default
)
     
declare @filtercomment bit
set @filtercomment =  0 

    -----------------------------------------------------------
    ------------------------ Коммутации -----------------------
    -----------------------------------------------------------
if (@number ='')
begin
   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId, 
			ALineId, BLineId,
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc 
	Where (AUserId = @authorizeduserid  and  BUserId = @abonent)
	order by timestart desc 

   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId,
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc --with ( TabLock )
	Where (AUserId = @abonent  and  BUserId = @authorizeduserid)
	--and TimeStop is not null
	order by timestart desc 
	
end
	
else
	begin
   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select  top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId, 
			ALineId, BLineId,
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc 
	Where (Boutnumber = @number and AUserId = @authorizeduserid)
	order by timestart desc 

   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId,
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc --with ( TabLock )
	Where (Aoutnumber = @number  and  BUserId = @authorizeduserid)
	--and TimeStop is not null
	order by timestart desc 
end


	-------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
if (@number ='')
begin
	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)
	Select top 30 Idg, IdChain, 2, 0, 
	TimeStart, TimeStop - TimeStart, 
	AOutNumber, AStr,
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number
	From A_Stat_MissedCalls
	where (AUserId = @authorizeduserid  and  BUserId = @abonent) 
	order by timestart desc 
	
		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)
	Select top 30 Idg, IdChain, 3, 3, 
	TimeStart, TimeStop - TimeStart, 
	AOutNumber, AStr,
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number
	From A_Stat_MissedCalls
	where (AUserId = @abonent  and  BUserId = @authorizeduserid)
	order by timestart desc 
	
	--select * from #output
	
end
else
begin
	Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, Length,
			Number, AbonentName, 
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber)

	Select top 30 Idg, IdChain, 3, 3, 
	TimeStart, TimeStop - TimeStart, 
	AOutNumber, AStr,
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number
	From A_Stat_MissedCalls
	where ( BUserId = @authorizeduserid ) and ( AOutNumber = @number )
	order by timestart desc 
end

--	-----------------------------------
--  	-- Преобразования -----------------
--	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @authorizeduserid and o.BUserId = u.Id ) or ( o.BUserId = @authorizeduserid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @authorizeduserid )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = '00000000-0000-0000-0000-000000000000' )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
(
	TimeStart deSC
)WITH FILLFACTOR = 100 ON [PRIMARY]

     -- Подготовка параметров
     
	Select	top 30	sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart,  
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName	
	From #output sc
	Order By TimeStart Desc

drop table #output
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Stat_MyCalls_Get' ))
	Drop procedure dbo.W_Stat_MyCalls_Get
GO

Create procedure [dbo].[W_Stat_MyCalls_Get]
	@media 		int, --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	@type 		int, --1 - входящий, 2 - исходящий, 3 - пропущенный, 10 - конф, 11 - селектор, 0 - все
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@authorizeduserid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL,
	@first int= NULL,
	@count int= NULL
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
--declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @authorizeduserid uniqueidentifier, @comment 	nvarchar ( 4000 ),@showivr bit, @first int,@count int

--set dateformat ymd
--select @media = 0,@type = 0,
--	@authorizeduserid='64f1a6ea-3f07-4b42-8cad-19eb9e1b97cd',
--	@dstart = '2012-05-21',@dstop = '2012-05-21 23:59:59',
--	@number = '', 
--	@comment = '', @showivr=0,@first = 0,@count = 140

 create   table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					TimeAnswer DateTime, 
					TimeStop DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					IsRecorded int, 
					IdRecDir int, 
					ALineNum nvarchar ( 10 ) collate database_default, 
					BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier, 
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 100 ) collate database_default, 
					IsConf int, Director uniqueidentifier, 
					CTS DateTime,
					idclient uniqueidentifier
			
)

     
declare @filtercomment bit
set @filtercomment =  0 

Declare @id0 uniqueidentifier
Set @id0 = '00000000-0000-0000-0000-000000000000'

    -------------------------------------
    -- Коммутации -----------------------
    -------------------------------------

Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )
Select sc.Id, 
		sc.IdChain,
		null, 
		0, 
		sc.TimeStart, 
		sc.TimeAnswer, 
		sc.TimeStop, 
		sc.TimeStop - sc.TimeAnswer as Length, 
		'', 
		'', 
		IsRecorded, 
		IdRecDir, 
		ALineNum, 
		BLineNum, --ARecFile, BRecFile, 
		AUserId, 
		BUserId, 
		ALineId, 
		BLineId, 
		AOutNumber, 
		BOutNumber, 
		AStr, 
		BStr,
		0 as IsConf, 
		@id0 as Director, 
		sc.TimeStart as CTS
From A_Stat_Connections_1x1 sc --with ( TabLock )
Where sc.TimeStop is not null and
			TimeStart >= @dstart 
			and TimeStart < @dstop
			and (AUserId = @authorizeduserid  or  BUserId = @authorizeduserid)
			and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
--Order By TimeStart Desc

	-------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )

Select Idg, IdChain, 3, 3, 
TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
AOutNumber, AStr, 0, 0, 
ALineNum, BLineNum, 
AUserId, BUserId,
ALineId, BLineId,
AOutNumber, Number,
AStr, '',
0, @id0, TimeStart
From A_Stat_MissedCalls
Where ( BUserId = @authorizeduserid )
And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))

    -------------------------------------
    -- Конференции ----------------------
    -------------------------------------
   
    Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		    Select IdConn, 
			IdChain, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end,
			scc.TimeStart, 
			scc.TimeStart as TimeAnswer, 
			scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			 0,--case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, 
			LineNum, 
			sc.Room, 
			scc.IdUser, 
			@idconfuser,
			scc.IdLine, 
			IdConf,
			'', 
			'', 
			StrName, 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, 
			Director, 
			sc.TimeStart as CTS
			
		FROM A_Stat_Conference_Competitors scc	
			Inner join A_Stat_Conference sc with (index (idx_StatConf_IDConf))
			on sc.Id = scc.IdConf
			--Left join @A_Stat_Conference_tmp2 sct 
			--on sc.Id = sct.Id --фильтр по правам на прослушивание
		
		where  scc.TimeStart between @dstart and @dstop 
			and scc.IdUser = @authorizeduserid
 
	-----------------------------------
  	-- Преобразования -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @authorizeduserid and o.BUserId = u.Id ) or ( o.BUserId = @authorizeduserid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name, idclient = c.Id
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		--and ( c.OwnerId = @authorizeduserid )

	--Update o
	--Set o.AbonentName = c.Name
	--From #output o, A_Clients c, A_ClientContacts cc
	--Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
	--	and ( c.OwnerId = @id0 )
	--	and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From #output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	--select  isnull(max (rownumber),0) 
	--from #output
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
(
	TimeStart deSC
)WITH FILLFACTOR = 100 ON [PRIMARY]

     -- Подготовка параметров
     
	Select			rownumber = identity(int,1,1),
					sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart, 
					--TimeAnswer, 
					--TimeStop, 
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					--ALineId, 
					--BLineId, 
					--ALineNum, 
					--BLineNum, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName, 
					IsRecorded, 
					IdRecDir, 
					IsConf, 
					Director, 
					CTS, 
					case When ( c.Id is null ) then 0 else 1 end as HasComment	,
					idclient
					into #out	
	From #output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where (( Media = @media ) or ( @media = 0 ) or ( Type >= 10 ))
	Order By TimeStart Desc
	select * from #out
	where rownumber between @first and @first + @count-1	
drop table #out
drop table #output
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_UserNotifyLog_GetNewCount' ))
	Drop procedure dbo.W_UserNotifyLog_GetNewCount
GO

Create Procedure [dbo].[W_UserNotifyLog_GetNewCount]
	@authorizeduserid uniqueidentifier
	--,@dstart datetime,
	--@dstop datetime
as
begin
	Select count(*) [count]
	FROM A_User_NotifyLog 
	where ( IdUser = @authorizeduserid )  
	--and ( NotifyDateTime >= @dstart ) 
	--and ( NotifyDateTime < @dstop ) 
	and wasShown = 0
	and LogType = 262144
	--order by NotifyDateTime desc
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_UserNotifyLog_GetByDate' ))
	Drop procedure dbo.W_UserNotifyLog_GetByDate
GO

Create Procedure [dbo].[W_UserNotifyLog_GetByDate]
	@authorizeduserid uniqueidentifier,
	@dstart datetime,
	@dstop datetime
as
begin
	Select [ID]
      ,[NotifyDateTime]
      ,[LogType]
      ,[TextSender]
      ,[TextInfo]
      ,[WasShown]
      ,[OneOnScreen]
      ,[OneOnScreenId] 
	FROM A_User_NotifyLog 
	where ( IdUser = @authorizeduserid )  
	and ( NotifyDateTime >= @dstart ) 
	and ( NotifyDateTime < @dstop ) 
	order by NotifyDateTime desc
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_UserNotifyLog_GetUnshown' ))
	Drop procedure dbo.W_UserNotifyLog_GetUnshown
GO

Create Procedure [dbo].[W_UserNotifyLog_GetUnshown]
	@iduser uniqueidentifier
as
begin
	Select top 500 [ID]
      ,[NotifyDateTime]
      ,[LogType]
      ,[TextSender]
      ,[TextInfo]
      ,[WasShown]
      ,[OneOnScreen]
      ,[OneOnScreenId] 
	FROM A_User_NotifyLog 
	where ( IdUser = @iduser )  
	and wasShown = 0
	and LogType = 262144
	order by NotifyDateTime desc
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_UserNotifyLog_GetTypeList' ))
	Drop procedure dbo.W_UserNotifyLog_GetTypeList
GO

Create Procedure [dbo].[W_UserNotifyLog_GetTypeList]
	@authorizeduserid uniqueidentifier
as
begin
--select * from A_users
	Select distinct [TextSender]
	FROM A_User_NotifyLog 
where iduser = @authorizeduserid--'63843ac7-a9eb-4f95-8956-b2a7d66a292f'

end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Stat_GetJournal' ))
	Drop procedure dbo.W_Stat_GetJournal
GO

Create procedure [dbo].[W_Stat_GetJournal]
	@authorizeduserid uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@lentime datetime,
	@type int = -1,	
		
	@first int = 1, 
	@count int = 200,

	@idoperator uniqueidentifier = NULL, --Operator defined	
	@idclient uniqueidentifier = null,
	@idgroup uniqueidentifier = null,
	
	@showconference int = 1,	
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,

	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	
	@comment nvarchar ( 4000 ) = NULL

as
begin	

--exec W_Stat_GetJournal 
--@authorizeduserid='1654740F-0600-493B-B8FD-B09AC9A5A99C',
--@dstart = '2012-01-20 11:06',@dstop = '2012-01-30 17:26',
--@tstart='2006-07-26 00:00:00',@tstop='2006-07-26 23:59:59.997',
--@lentime='2006-07-26 00:00:01',@fromcc=0,
--@conntype=-1,@comment=N''

	--declare @authorizeduserid uniqueidentifier,
	--	@dstart datetime,
	--	@dstop datetime,
	--	@tstart datetime,
	--	@tstop datetime,
	--	@lentime datetime,
	--	@taskid uniqueidentifier, --Task defined
	--	@fromcc bit,
	--	@idoperator uniqueidentifier, --Operator defined
	--	@idgroup uniqueidentifier, 
	--	@idclient uniqueidentifier,
	--	@innerprefix nvarchar(100), --Internal Number defined
	--	@outnumber nvarchar(100),  --Out Number defined
	--	@type int,
	--	-- @showconference int = 1,
	--	@comment nvarchar ( 4000 ),
	--	@first int, 
	--	@count int
	--select	@authorizeduserid='1654740F-0600-493B-B8FD-B09AC9A5A99C',
	--		@dstart = '2012-01-30 15:16',@dstop = '2012-01-30 17:26',
	--		@lentime='2006-07-26 00:00:01',@fromcc=0,
	--		@type=-1,@comment=N'', @first = 1,@count = 50 

	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'
	
	Select top 0 rownumber = identity(int,1,1),
		*, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #t 
	From A_Stat_Connections_1x1
	
	Insert into #t Exec W_Stat_FillTempByFilter
		@authorizeduserid,
		@dstart,
		@dstop,
		@lentime,
		@taskid,
		@fromcc,
		@idoperator,
		@idgroup, 
		@idclient,
		@innerprefix,
		@outnumber,
		@type,
		1, -- show conference,
		@comment

	Select t.*, 
		Cast ( Cast ( TimeStop - TimeAnswer as float ) * 86400 as int ) as Length, 
		Cast ( Cast ( TimeAnswer - TimeStart as float ) * 86400 as int ) as AnswerLength
	From #t t
	where rownumber between @first and @first + @count-1	
	--Order By TimeStart --Desc
	
	drop table #t
	
end
GO

