﻿


-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_OperatorAdd' ))
	Drop procedure dbo.A_TaskManager_Task_OperatorAdd
GO

Create procedure dbo.A_TaskManager_Task_OperatorAdd
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier
as
begin

	Declare @cnt int, @maxpriority int
	
	Select @cnt = Count(*)
	From A_TaskManager_Operators 
	Where TaskId = @taskid
		And Operatorid = @operatorid
			
	if ( @cnt = 0 ) begin
	
		Select @maxpriority = Max(Priority)
		From A_TaskManager_Operators 
		Where TaskId = @taskid
		Group by TaskId
	
		Insert into A_TaskManager_Operators ( TaskId, OperatorId, IsGroup, Priority )
		Values ( @taskid, @operatorid, 0, @maxpriority + 1 )
		
	end
			
end
GO


-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_OperatorRemove' ))
	Drop procedure dbo.A_TaskManager_Task_OperatorRemove
GO

Create procedure dbo.A_TaskManager_Task_OperatorRemove
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier
as
begin
			
	Delete
	From A_TaskManager_Operators 
	Where TaskId = @taskid
		And Operatorid = @operatorid
			
end
GO


-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_GetOperators' ))
	Drop procedure dbo.A_TaskManager_Task_GetOperators
GO

Create Procedure [dbo].[A_TaskManager_Task_GetOperators]
	@taskid 	uniqueidentifier
as
begin

	Select OperatorId, IsGroup 
	From A_TaskManager_Operators 
	Where TaskId = @taskid 
	Order by IsGroup, Priority
	
end
GO


-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_ExtlineAdd' ))
	Drop procedure dbo.A_TaskManager_Task_ExtlineAdd
GO

Create procedure dbo.A_TaskManager_Task_ExtlineAdd
	@taskid uniqueidentifier,
	@lineid uniqueidentifier
as
begin
			
	Select TaskId, ExtLineId 
	From A_TaskManager_TaskExtLines 
	Where TaskId = @taskid
		And ExtLineId = @lineid
		
	if ( @@rowcount = 0 )
		Insert into A_TaskManager_TaskExtLines ( TaskId, ExtLineId )
		Values ( @taskid, @lineid )
			
end
GO



-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_ExtlineRemove' ))
	Drop procedure dbo.A_TaskManager_Task_ExtlineRemove
GO

Create procedure dbo.A_TaskManager_Task_ExtlineRemove
	@taskid uniqueidentifier,
	@lineid uniqueidentifier
as
begin
			
	Delete
	From A_TaskManager_TaskExtLines 
	Where TaskId = @taskid
		And ExtLineId = @lineid
			
end
GO


-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_GetExtLines' ))
	Drop procedure dbo.A_TaskManager_Task_GetExtLines
GO

Create Procedure [dbo].[A_TaskManager_Task_GetExtLines]
	@taskid 	uniqueidentifier
as
begin

	Select ExtLineId 
	From A_TaskManager_TaskExtLines 
	Where TaskId = @taskid	
	
end
GO
