﻿
Declare @change bit
Select @change = case when (DATA_TYPE = 'ntext') then 0 else 1 end
FROM INFORMATION_SCHEMA.COLUMNS 
where (table_name like 'A_Chat_Messages' )
	and (column_name like 'Text' )

if (( @change = 1 ) or ( @change is null )) begin
	IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Chat_Messages]') AND name = N'idx_A_Chat_Messages_IdDialog_DateUTC')
		DROP INDEX [A_Chat_Messages].[idx_A_Chat_Messages_IdDialog_DateUTC] 
end	
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Chat_Messages_Old' ))
	Drop table dbo.[A_Chat_Messages_Old]
GO


Declare @change bit
Select @change = case when (DATA_TYPE = 'ntext') then 0 else 1 end
FROM INFORMATION_SCHEMA.COLUMNS 
where (table_name like 'A_Chat_Messages' )
	and (column_name like 'Text' )

if (( @change = 1 ) or ( @change is null )) begin
	exec sp_rename A_Chat_Messages, [A_Chat_Messages_Old]
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Chat_Messages_Old' )) begin
	CREATE TABLE [dbo].[A_Chat_Messages](
		[IdMessage] [uniqueidentifier] NOT NULL,
		[IdDialog] [uniqueidentifier] NULL,
		[IdUser] [uniqueidentifier] NULL,
		[Text] [ntext] NULL,
		[DateUTC] [datetime] NULL
	) ON [PRIMARY]
end
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Chat_Messages_Old' )) begin
	CREATE NONCLUSTERED INDEX [idx_A_Chat_Messages_IdDialog_DateUTC] ON [dbo].[A_Chat_Messages] 
	(
		[IdDialog] ASC,
		[DateUTC] ASC
	) ON [PRIMARY]
end	
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Chat_Messages_Old' )) begin
	Declare @k int 
	Set @k = 0
	while ( @@ROWCOUNT > 0 ) begin
		Insert into A_Chat_Messages (IdMessage, IdDialog, IdUser, Text, DateUTC)
			Select Top 1000 IdMessage, IdDialog, IdUser, Text, DateUTC 
			FROM A_Chat_Messages_Old old
			Where Not exists ( Select IdMessage From A_Chat_Messages c Where c.IdMessage = old.IdMessage )
	end
end	
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Chat_Messages_Old' ))
	Drop table dbo.[A_Chat_Messages_Old]
GO