﻿IF OBJECT_ID ('dbo.A_DB_UpdateOwnerUser') IS NOT NULL
    DROP  procedure dbo.A_DB_UpdateOwnerUser
GO

CREATE procedure dbo.A_DB_UpdateOwnerUser
as
begin 

        Declare @oktelldb nvarchar(50), @oktellccdb nvarchar(50), @oktellsettingsdb nvarchar(50)
        Select @oktelldb = 'oktell', 
                @oktellccdb = 'oktell_cc_temp', 
                @oktellsettingsdb = 'oktell_settings'
        
        Declare @Statement nvarchar(4000),
            @set_owner nvarchar(4000),
            @user_name nvarchar(50) 
        
        Set @user_name = SYSTEM_USER
        
        Set @set_owner = N'    
                IF NOT EXISTS (select 1 from master..sysdatabases WHERE name = @db_name AND suser_sname(sid) = N''' + @user_name + '''  )
                BEGIN                               
                    IF EXISTS(SELECT 1 FROM sysusers WHERE suser_sname(sid) = N''' + @user_name + ''' AND [name] != ''dbo'')
                    BEGIN
                        SET @sql_sql = ''''
                        SELECT @sql_sql = @sql_sql + N''   REVOKE ALL TO '' + su.[name] + N''
                        EXEC sp_droprolemember ''''db_owner'''' , '''''' + su.[name] + ''''''
                        EXEC SP_DROPUSER '' + su.[name]  
                            FROM sysusers su 
                            WHERE suser_sname(su.sid) = N''' + @user_name + ''' AND su.[name] != ''dbo''
                        
                        EXEC sp_executesql @sql_sql 
                    END
                    
                    EXEC sp_changedbowner @loginame = N''' + @user_name + ''', @map = false
                END
                '
                
        Set @Statement = N'
            DECLARE @db_name nvarchar(50),
                @curr_user nvarchar(50),
                @sql_sql nvarchar(4000)
            
            USE ' + @oktelldb  + N'
            Set @curr_user = CURRENT_USER
            SET @db_name = ''' +@oktelldb + ''' ' + @set_owner + N'
            
            USE ' + @oktellccdb  +  N'
            Set @curr_user = CURRENT_USER
            SET @db_name = ''' +@oktellccdb + ''' ' + @set_owner + N'
             
            USE ' + @oktellsettingsdb  +  N'
            Set @curr_user = CURRENT_USER
            SET @db_name = ''' +@oktellsettingsdb + ''' ' + @set_owner

        ----- Проверка прав на возможность выполнения процедуры
        IF (SELECT IS_SRVROLEMEMBER('sysadmin')) = 1
            Exec sp_executesql @Statement 
        
        RETURN
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_InitOnStart' ))
	Drop procedure dbo.A_DB_InitOnStart
GO

Create procedure [dbo].[A_DB_InitOnStart]
As
begin
		-- On PBXStatusServer start (2)

		-----------------------------------------------------
		-- Проставляем отвалившихся пользователей -----------
		-----------------------------------------------------
		
		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		Declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0, 10104 --'Отвалился'
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task - проставляем в нуллы значения
		-----------------------------------------------------

		Update A_TaskManager_UserInTask with ( TabLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null )

		-----------------------------------------------------
		-- избавление от нуллов в таблице статусов операторов коллцентра, если сервак вырубили
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		-- очищаем монополии
		-----------------------------------------------------
		
		Delete From A_Monopoly
		Delete From A_MonopolyForTaskChanging
		Delete From C_MonopolyForTaskChanging /*obsolete*/

		-----------------------------------------------------
		-- Пустые входящие задачи, необработанные - ексепшны и положенные трубы
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		-- неиспользуемые таблицы локальных списков
		-----------------------------------------------------

		Declare @llid int
		Declare @llname nvarchar ( 1000 )
		Declare @ltid uniqueidentifier
		Declare @ltids nvarchar ( 50 )
		Declare @sql nvarchar ( 500 )
		
		Declare tcursor Cursor For
			Select name, Id  
			From sysobjects 
			Where ([type] = 'U') 
				and (name like 'A_TaskManager_LocalList%')
		
		Open tcursor
		Fetch Next From tcursor 
					Into @llname, @llid

		While (@@FETCH_STATUS = 0) begin
		
			Set @llname = 'dbo.[' + @llname + ']'

			-- по названиям (id в названии и Id списка совпадают) (недостаточно в связи с переменой имен - может много быть таблиц с одним ид. N-1 надо удалить)	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			-- по явным ссылкам через поле JoinedTable в списках
			If not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname ) begin
				set @sql = ' DROP TABLE ' + @llname
				exec sp_executesql @stmt = @sql
			end

			Fetch Next From tcursor 
						Into @llname, @llid
		end

		Close tcursor
		Deallocate tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		-- таблицы КЦ создать??
		--надо или нет обнулить счетчики текущих состояний для куба состояний?
		-- и саму таблицу тоже закрыть?
		-- вроде надо бы.. ничего не мешает, а от возможных глюков избавит..
		Exec dbo.A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
		
		Delete 
		From dbo.A_Registrar_BanList
		Where not (dtutccancel is null )
			and (DateDiff ( s, dtutc, GetUtcDate() ) > 180)
			
		-----------------------------------------------------
		exec dbo.A_DB_UpdateOwnerUser
		
end
GO